--[[ Umlauts & special characters list
	ä --> \195\164
	Ä --> \195\132
	ö --> \195\182
	Ö --> \195\150
	ü --> \195\188
	Ü --> \195\156
	ß --> \195\159

   à : \195\160    è : \195\168    ì : \195\172    ò : \195\178    ù : \195\185
   á : \195\161    é : \195\169    í : \195\173    ó : \195\179    ú : \195\186
   â : \195\162    ê : \195\170    î : \195\174    ô : \195\180    û : \195\187
      	 		   ë : \195\171    ï : \195\175
   æ : \195\166    ø : \195\184
   ç : \195\167                                    œ : \197\147
   Ä : \195\132    Ö : \195\150    Ü : \195\156    ß : \195\159
   ä : \195\164    ö : \195\182    ü : \195\188
   ã : \195\163    õ : \195\181  				   \195\177 : \195\177
]]
--The "lock" icon texturepath
--local lockIconPath = "FCOItemSaver/FCOIS.dds"
local lockIconPath = "/esoui/art/miscellaneous/status_locked.dds"
local lockIcon = "|t32:32:"..lockIconPath.."|t"

--Move the localization vars to the global data
local FCOIS = FCOIS

--Do not go on if libraries are not loaded properly
if not FCOIS.libsLoadedProperly then return end

--Local speed-ups of global number and other variables
local numLanguages                      = FCOIS.numVars.languageCount
local numFilterPanels                   = FCOIS.numVars.gFCONumFilterInventoryTypes
--local activeFilterPanelIds              = FCOIS.mappingVars.activeFilterPanelIds
local numFilterButtons                  = FCOIS.numVars.gFCONumFilters
local numMaxDynIcons                    = FCOIS.numVars.gFCOMaxNumDynamicIcons
local numNonDynIcons                    = (FCOIS.numVars.gFCONumFilterIcons - numMaxDynIcons)
local iconId2FCOISIconNr                = FCOIS.mappingVars.dynamicToIcon
local lockDynMenuEntryNr2FCOISIconId    = FCOIS.mappingVars.lockDynToIcon
local isDynamicIcon                     = FCOIS.mappingVars.iconIsDynamic
local iconNrToOrdinalStr                = FCOIS.mappingVars.iconNrToOrdinalStr
--
local invAddButtonVars = FCOIS.invAdditionalButtonVars
--Additional inventory "flag" icon
local addInvFlagIcon                    = zo_iconTextFormatNoSpace(invAddButtonVars.texNormal, 24, 24, "", nil)

local maxLevel = FCOIS.mappingVars.maxLevel

--The localized text strings
FCOIS.localizationVars.localizationAll = {
	--English
    [FCOIS_CON_LANG_EN] = {
		-- Options menu
        ["options_description_lam_menu_is_loading"] = "|cFF0000!!!ATTENTION!!!\n\nThe FCOIS settings menu is currently being build. Please wait and do not change any settings until this icon vanished!\n\nESO could be laggy for a few seconds.\nAs soon as all settings are build this icon will vanish and you can start to change the settings.",
        ["options_description"] = "FCOItemSaver helps you to manage your items by help of icons. In addition it lets you hide/view and protect those items",
		["options_header1"] 			 		 = "General settings",
    	["options_language"] 					 = "Language",
		["options_language_TT"] 			 = "Choose the language",
		["options_language_use_client"] 		 = "Use client language",
		["options_language_use_client_TT"]  = "Always let the addon use the game client's language.",
		["options_language_dropdown_selection1"] = "English",
		["options_language_dropdown_selection2"] = "German",
		["options_language_dropdown_selection3"] = "French",
		["options_language_dropdown_selection4"] = "Spanish",
        ["options_language_dropdown_selection5"] = "Italian",
        ["options_language_dropdown_selection6"] = "Japanese",
        ["options_language_dropdown_selection7"] = "Russian",
		["options_language_description1"]		 = "CAUTION: Changing the language/save option will reload the user interface!",
        ["options_savedvariables"]				 = "Save settings",
        ["options_savedvariables_TT"]       = "Save the addon settings for all your characters of your account, or single for each character",
        ["options_savedVariables_dropdown_selection1"] = "Each character",
        ["options_savedVariables_dropdown_selection2"] = "Account wide",
        ["options_savedVariables_dropdown_selection3"] = "All accounts the same",
        ["options_savedVariables_dropdown_selection4"] = "All servers & accounts the same",
        ["options_header_copy_sv"]              =   "Copy & Delete SavedVariables (all settings)",
        ["options_description_copy_sv_server"]  = "|cff0000Before copy or delete of SavedVariables (this will copy all settings, not only the marker icons at your items!) please LOGOUT and COPY THE SavedVariables FILE 'FCOItemSaver.lua' AS A BACKUP! Click on the '|c5959D5Feedback|r|cff0000' link above and then on the 'FAQ' button for an explanation how to do this.|r\n\nCopy savedvariables from a server to another. Choose the account or character below. Copying or deleting a total server is not possible!",
        ["options_copy_sv_source_server"]       =   "Source server",
        ["options_copy_sv_target_server"]        =   "Target server",
        --["options_copy_sv_to_server"]           =   "Copy to server",
        --["options_copy_sv_to_server_TT"]   =   "Copy the SavedVariables from the chosen source server to the chosen target sever.Copying from a source to the same target server is not possible!\nIf you are using account wide setings, or all accounts use the same settings, all data will be transfered.\nIf you are using character settings only your currently logged in character will be transfered.\n\nAttention: Existing target data will be overwritten!",
        ["options_copy_sv_to_server_warning"]   =   "Do you realy want to copy the SavedVariables?\nExisting target data will be overwritten!\n\nIf you are logged in to the target server your UI will reload afterwards!",
        ["question_copy_sv_server_reloadui"]    = "Copied SavedVariables from server \"<<C:1>>\" to server \"<<C:2>>\", using accountwide settings: <<3>>.\n\nAs the target server is your currently logged in server:\nDo you want to reload the UI now?",
        ["question_delete_sv_server_reloadui"]   = "Deleted SavedVariables from server \"<<C:1>>\", using accountwide settings: <<2>>.\n\nAs the target server is your currently logged in server:\nDo you want to reload the UI now?",
        --["options_delete_sv_on_server"]           =   "Delete target server",
        --["options_delete_sv_on_server_TT"]   =   "Delete the SavedVariables on the target server.\nIf you are logged in to the target server with the chosen target account and character your UI will reload afterwards!\n\nAttention: Existing target data will be deleted without any backup!",

        ["options_description_copy_sv_account"]  = "This option is only available with a chosen server. |c75daffPlease read the tooltips of the account copy&delete buttons!|r",
        ["options_copy_sv_source_account"]       =   "Source account",
        ["options_copy_sv_target_account"]        =   "Target account",
        ["options_copy_sv_to_account"]           =   "Copy to account",
        ["options_copy_sv_to_account_TT"]   =   "Copy the SavedVariables from the chosen source server and source account to the chosen target server and target account. Source and target servers can be the same, but source and target accounts cannot be the same!\n\nOr copy the source server & account & character to a destination server & account. Source & target server & account can be the same in that case.\n\nAttention: Existing target data will be overwritten!",
        ["options_copy_sv_to_account_warning"]   =   "Do you realy want to copy the SavedVariables?\nExisting target data will be overwritten!\n\nIf you are logged in to the target server with the chosen target account your UI will reload afterwards!",
        ["question_copy_sv_account_reloadui"]           = "Copied SavedVariables from server \"<<C:1>>\" account \"<<C:2>>\" to server \"<<C:3>>\" account \"<<C:4>>\", using accountwide settings: <<5>>.\n\nAs the target server is your currently logged in server:\nDo you want to reload the UI now?",

        ["options_copy_sv_to_allserversallaccount"]      =   "Copy to \'All the same\'",
        ["options_copy_sv_to_allserversallaccount_TT"]   =   "Copy the SavedVariables from the chosen source server and source account to the \'All servers & accounts the same\' settings.\n\nAttention: Existing target data will be overwritten!",
        ["options_copy_sv_to_allserversallaccount_warning"]  =  "Do you realy want to copy the SavedVariables?\nExisting target data will be overwritten!\n\nYour UI will reload afterwards!",
        ["question_copy_sv_allserversallaccount_reloadui"]   = "Copied SavedVariables from server \"<<C:1>>\" account \"<<C:2>>\" to \'All servers & accounts the same\', using accountwide settings: <<3>>.\n\nDo you want to reload the UI now?",
        ["options_delete_sv_allserversallaccount"]           = "Delete \'All the same\'",
        ["options_delete_sv_allserversallaccount_TT"]        = "Delete the SavedVariables for \'All servers and accounts the same\'.\nYour UI will reload afterwards!\n\nAttention: Existing data will be deleted without any backup!",

        ["question_delete_sv_account_reloadui"]   = "Deleted SavedVariables from server \"<<C:1>>\" account \"<<C:2>>\", using accountwide settings: <<3>>.\n\nAs the target server is your currently logged in server:\nDo you want to reload the UI now?",
        ["options_delete_sv_account"]           =   "Delete target account",
        ["options_delete_sv_account_TT"]   =   "Delete the SavedVariables on the target server and target account.\nIf you are logged in to the target server with the chosen target account and character your UI will reload afterwards!\n\nAttention: Existing target account data will be deleted without any backup!",

        ["question_copy_sv_account_to_char_reloadui"]  = "Copied SavedVariables from server \"<<C:1>>\" account \"<<C:2>>\" to server \"<<C:3>>\" account \"<<C:4>>\" character \"<<C:5>>\", using accountwide settings: <<6>>.\n\nAs the target server is your currently logged in server:\nDo you want to reload the UI now?",
        ["question_copy_sv_char_to_account_reloadui"]  = "Copied SavedVariables from server \"<<C:1>>\" account \"<<C:2>>\" character \"<<C:3>>\" to server \"<<C:4>>\" account \"<<C:5>>\", using accountwide settings: <<6>>.\n\nAs the target server is your currently logged in server:\nDo you want to reload the UI now?",
        ["options_copy_sv_account_to_char"] = "Copy account->char",
        ["options_copy_sv_char_to_account"] = "Copy char->account",

        ["options_description_copy_sv_character"]  = "This option is only available with a chosen account name (not 'All accounts the same'). You need to have saved settings with the 'Each character' mode before in order to select these character names from the source character dropdown below. |c75daffPlease read the tooltips of the character copy&delete buttons!|r",
        ["options_copy_sv_source_character"]       =   "Source character",
        ["options_copy_sv_target_character"]        =   "Target character",
        ["options_copy_sv_to_character"]           =   "Copy to character",
        ["options_copy_sv_to_character_TT"]   =   "Copy the SavedVariables from the chosen source server and source account and source character to the chosen target server and target account and target character. Source and target servers can be the same, source and target account can also be the same, but source and target characters cannot be the same!\nYou need to had enabled the 'Each character' save mode in the 'General settings'->'Save settings' option before in order to select the character names, which have been logged in afterwards to create the settings with this option enabled, from the source character dropdown below.\n\nOr copy the source server & account to a destination server & account & character. Source & target server & account can be the same in that case.\n\nAttention: Existing target data will be overwritten!",
        ["options_copy_sv_to_character_warning"]   =   "Do you realy want to copy the SavedVariables?\nExisting target data will be overwritten!\n\nIf you are logged in to the target server with the chosen target account and character your UI will reload afterwards!",
        ["question_copy_sv_character_reloadui"]   = "Copied SavedVariables from server \"<<C:1>>\" account \"<<C:2>>\" character \"<<C:3>>\" to server \"<<C:4>>\" account \"<<C:5>>\" character \"<<C:6>>\", using accountwide settings: <<7>>.\n\nAs the target server is your currently logged in server:\nDo you want to reload the UI now?",
        ["question_delete_sv_character_reloadui"]   = "Deleted SavedVariables from server \"<<C:1>>\" account \"<<C:2>>\" character \"<<C:3>>\", using accountwide settings: <<4>>.\n\nAs the target server is your currently logged in server:\nDo you want to reload the UI now?",
        ["options_delete_sv_character"]           =   "Delete target character",
        ["options_delete_sv_character_TT"]   =   "Delete the character SavedVariables on the target server, target account and target character.\nIf you are logged in to the target server with the chosen target account and character your UI will reload afterwards!\n\n\nAttention: Existing target character data of the target account will be deleted without any backup!",

        ["options_hint_backup_savedvariables_file_title"] = "Backup SavedVariables!",
        ["options_hint_backup_savedvariables_file"] = "Please logout and create a\nbackup of your file 'FCOItemSaver.lua'\n in the SavedVariables folder, before\n working with the SavedVariable copy/delete options!\n\nIf you already created a backup file please press teh button \'Abort\' below and retry the same copy/delete option.\nThis dialog will not be shown anymore then.",

        ["options_header_uniqueids"]           = "Unique Item ID",
        ["options_description_uniqueids"]   = "Your ingame items got an ID. This ID is the same if some of the item's base data equals: like the name, level, quality (e.g. a lockpick and a stolen lockpick got the same ID). These non-unique ID (named \'ItemInstanceId') is the standard behaviour of FCO ItemSaver to mark and remember the marked items!\n\nBut each item also got a unique ID too (named \'UniqueId'). Additional to the normal itemInstance ID's differences the unique item ID is not the same, if the item is enchanted, got a different style, trait, if it's stolen, etc. Unique item IDs enable you to mark these items differently but it will need you to mark each of the items you haven't marked already in the past with a given combination of the before mentioned criteria.\n\nYou are able to choose here between the non-unique ItemInstanceId, and some types of uniqueIds, to save the marker icons on your items. |c75daffPlease read the tooltip (open the dropdown box->move the mouse above the entries) of the dropdown box \'Type of unique ID\'' entries for the info about the different unique IDs. You need to enable the checkbox \'Use unique item IDs\' in order to be able to open the dropdownbox.|r\n\n|cFF0000Caution: Changing this option will reload te UI! You are able to define your uniqueId type below after that reload.|r",
        ["options_use_uniqueids"]           = "Use unique item IDs",
        ["options_use_uniqueids_TT"]        = "Enabled:\nUse uniqueIds.\n\nSee tooltip of option\"Unique Item ID\" for further details!\n\n\nDisabled:\nUse the normal itemIds and mark all items with the same base data the same.\n\nAttention: Your already marked items will be saved for the used ID save method. Switching the modes will show you the saved marker icons again, but they will NOT be synchronized between itemId and uniqueIds!\n\n|cFF0000Caution: Changing this option will reload the user interface automatically!|r",
        ["options_migrate_uniqueids"]           = "Migrate>uniqueId",
        ["options_migrate_uniqueids_TT"]   = "Migrate the marked items from the non-unique to the unique IDs.\nThis will mark all the same icons that you have marked with the non-unique settings before.\nThis way all items are still saved and you only need to remove/change the marker icons.\n\n|cFF0000This option will be disabled until you have enabled the unique IDs AND you have done a reload of the user interface!\nCome back here and click this button afterwards!|r",
        ["options_migrate_ids_migration_log"] = "|c75daffUsing the migration will reload the User-Interface automatically 3 seconds after the migration IF any marker icon was migrated! Else you'll see the log directly in the chat.\nAfter that reloadUI you'll get the migration log presented in the chat once.|r",
        ["options_migrate_ids_migration_log_dialog"] = "|c75daffUsing the migration will reload the User-Interface\n automatically 3 seconds after the migration,\nIF any marker icon was migrated!\nElse you'll see the log directly in the chat.\nAfter that reloadUI you'll get the migration log\n presented once in the chat.|r",
        ["options_migrate_uniqueids_warning"]   = "This will migrate all non-unique ID markers to the unique IDs, for the same items.\nExisting marker icons will be kept and only new marker icons are added!\n\nThis migration cannot be undone! You'll need to remove the marked icons manually again.",
        ["options_migrate_uniqueids_dialog"]   = "Migrate marked items from non-unique to unique now?\n This will only add marker icons.\nNo marker icons will be removed.",
        ["options_migrate_nonuniqueids_dialog"] = "Migrate marked items from unique to non-unique now?\n This will only add marker icons.\nNo marker icons will be removed.",
        ["options_migrate_unique_inv_scan_not_done"]   = "You've changed the item ID mode for the item markers to unique item IDs.\nThe inventory scan for Automatic markings was not run once!\n\nPlease use the migration popup dialog or go to the settings and migrate your marker icons NOW, if you want to.",
        ["options_migrate_start"] = "Migration started: <<1>>",
        ["options_migrate_results"] = "> <<1[No icon/1 icon/$d icons]>> migrated for <<2[no item/1 item/$d items]>>.",
        ["options_migrate_end"] = "Migration end: <<1>>",
        ["options_migrate_bag_type_" .. tostring(BAG_WORN)] = GetString(SI_BINDING_NAME_TOGGLE_CHARACTER),
        ["options_migrate_bag_type_" .. tostring(BAG_COMPANION_WORN)] = GetString(SI_CRAFT_ADVISOR_TOOLTIP_EQUIP_TAB) .. " - " .. GetString(SI_COLLECTIBLECATEGORYTYPE27),
        ["options_migrate_bag_type_" .. tostring(BAG_BACKPACK)] = "Backpack",
        ["options_migrate_bag_type_" .. tostring(BAG_BANK)] = GetString(SI_GAMEPAD_BANK_CATEGORY_HEADER),
        ["options_migrate_bag_type_" .. tostring(BAG_GUILDBANK)] = GetString(SI_GAMEPAD_GUILD_BANK_CATEGORY_HEADER),
        ["options_migrate_bag_type_" .. tostring(BAG_BUYBACK)] = GetString(SI_ITEMFILTERTYPE8),
        ["options_migrate_bag_type_" .. tostring(BAG_VIRTUAL)] = GetString(SI_NOTIFICATIONTYPE15),
        ["options_migrate_bag_type_" .. tostring(BAG_SUBSCRIBER_BANK)] = GetString(SI_ESO_PLUS_TITLE) .. " " .. GetString(SI_GAMEPAD_BANK_CATEGORY_HEADER),
        ["options_migrate_bag_type_" .. tostring(BAG_HOUSE_BANK_ONE)] = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " 1",
        ["options_migrate_bag_type_" .. tostring(BAG_HOUSE_BANK_TWO)] = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " 2",
        ["options_migrate_bag_type_" .. tostring(BAG_HOUSE_BANK_THREE)] = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " 3",
        ["options_migrate_bag_type_" .. tostring(BAG_HOUSE_BANK_FOUR)] = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " 4",
        ["options_migrate_bag_type_" .. tostring(BAG_HOUSE_BANK_FIVE)] = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " 5",
        ["options_migrate_bag_type_" .. tostring(BAG_HOUSE_BANK_SIX)] = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " 6",
        ["options_migrate_bag_type_" .. tostring(BAG_HOUSE_BANK_SEVEN)] = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " 7",
        ["options_migrate_bag_type_" .. tostring(BAG_HOUSE_BANK_EIGHT)] = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " 8",
        ["options_migrate_bag_type_" .. tostring(BAG_HOUSE_BANK_NINE)] = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " 9",
        ["options_migrate_bag_type_" .. tostring(BAG_HOUSE_BANK_TEN)] = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " 10",

        ["options_migrate_iteminstanceids"]     = "Migrate>ItemInstanceID",
        ["options_migrate_iteminstanceids_TT"]   = "Migrate the marked items from the unique to the non-unique IDs.\nThis will mark all the same icons that you have marked with the unique settings before.\nThis way all items are still saved and you only need to remove/change the marker icons.\n\n|cFF0000This option will be disabled until you have enabled the unique IDs AND you have done a reload of the user interface!\nCome back here and click this button afterwards!|r",
        ["options_migrate_iteminstanceids_warning"]   = "This will migrate all unique ID markers to the non-unique IDs, for the same items.\nExisting marker icons will be kept and only new marker icons are added!\n\nThis migration cannot be undone! You'll need to remove the marked icons manually again.",
        ["options_migrate_uniqueId_to_uniqueId"]        = "Migration of unique IDs type: %s to uniqueIds type: %s",
        ["options_migrate_uniqueId_to_non_uniqueId"]    = "Migration of unique IDs type: %s to non-uniqueIds",
        ["options_migrate_non_uniqueId_to_uniqueId"]    = "Migration of non-unique ID to unique ID type: %s",

        ["options_header_ZOsLock"]                  = "ZOs ingame item lock",
		["options_use_ZOs_lock_functions"] 			= "Enable ingame item lock "..lockIcon,
		["options_use_ZOs_lock_functions_TT"]	= "Enable/Disable the ingame item lock functionality provided be ZOs.\nIs this setting disabled then the lock icon " ..lockIcon .." will be hidden in the context menus and inventories.",
        ["options_scan_ZOs_lock_functions"]			= "TESO "..lockIcon.."->FCOIS "..lockIcon,
        ["options_scan_ZOs_lock_functions_TT"] = "Transfer the items that you got locked with the ingame lock funcitonality (gray lock icon) to the FCOItemSaver icon 1. This will unmark the ingame marker and mark the same item with FCOIS \'lock\' marker icon.\nIf you want to migrate your house bank bags as well be sure to be inside one of your houses at the time you start the migration!\n\nItems will be scanned in packages of 50 items so the server will not kick you for spam. Please wait for it to finish and check the chat messages.",
        ["options_scan_ZOs_lock_functions_warning"]	= "Do you really want to remove the ingame locks on your items and transfer them to FCOItemSaver's \'lock\' marker icon?\n\nItems will be scanned in packages of 50 items so the server will not kick you for spam. Please wait for it to finish and check the chat messages.",
		["options_header_icon_options"]		 	 = "Icon position, sort, etc.",
		["options_header_marking_options"]		 = "Marks",
        ["options_header_crafting"]              = GetString(SI_SKILLTYPE8),
		["options_remove_all_markers_with_shift_rightclick"]	= "Remove all: <mod. key> + |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t",
		["options_remove_all_markers_with_shift_rightclick_TT"]	= "Remove all markers from an item as you right click |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t the item while holding the <modifier key> (defined next to this setting) pressed.\n\nIf you <modifier key> + right click it again the last marker icons will be restored for that item!\n\nThis will only work until your next reload of the UI/logout!\n\nIf an item got an undo entry and you manually add/remove a marker icon the undo entry will be deleted!",
		["options_modifier_key"]			= "Modifier key",
        ["options_modifier_key_TT"]         = "The modifier key ALT, SHIFT, CTRL or COMMAND (only on MAC!)",
        ["KEY_SHIFT"] = "Shift",
        ["KEY_ALT"] = "Alt",
        ["KEY_CTRL"] = "CTRL",
        ["KEY_COMMAND"] = "Command (only MAC!)",
        ["options_undo_add_context_menu_entry"]                = "Remove all/undo context menu entry",
        ["options_undo_add_context_menu_entry_TT"]             = "Add a context menu entry for the marker icons remove all/undo.",
        ["options_undo_add_context_menu_entry_tooltip"]        = "SHIFT: Show tooltip at undo context menu entry",
        ["options_undo_add_context_menu_entry_tooltip_TT"]     = "Press and hold the SHIFT key while moving the mouse above the undo context menu entry to show the last marked icons",
        ["options_undo_use_different_filterpanels"]            = "Save undo for each filter panel",
        ["options_undo_use_different_filterpanels_TT"]         = "Save the undo marker icons separately for each filter panel (e.g. inventory, bank, mail, etc.).\nDeactivated the marker icons will be saved the same for each filter panel and you are able to undo them everywhere.",
        ["options_research_filter"]		 		 = "Allow 'Reserve research' items",
        ["options_research_filter_TT"]		 = "Allow 'Reserve research' items to be selected in the research popup, at crafting station's research panel",
        ["options_icons_description"]       = "This submenu contains the settings for the marker icons of this addon.\nThere are 3 types of marker icons:\n1. Normal\n2. Gear sets\n3. Dynamic\nPlease find a description in each submenu.\n\nHints:\n-If marker icon text is shown red in dropdown boxes of the FCOIS settings it means they are currently disabled.\nEach marker icon is protected until you define an exception (see submenu \'Protection (Anti-methods)\') for normal icons, or inside the dynamic icon settings.",
		["options_icons_dynamic"]				 = "Dynamic icons",
        ["options_icons_dynamic_usable"]				 =  "Dynamic icons - Total usable",
        ["options_icons_dynamic_usable_TT"]				 =  "Set the total number of usable dynamic icons here.",
        ["options_icons_dynamic_usable_warning"]		 =  "Dynamic icons are the non-standard marker icons of this addon, changeable not only in color/texture/size/position and name, but also in what they should protect and how they should behave. Each of the dynamic icons can be totally set up according to your needs.\n\nChange the total number of dynamic icons usable with this slider. The lower the value the better the performance of the settings and the context menus.\n[|cFF0000ATTENTION|r]The user interface will reload directly after changing this value!\nPlease have a look at the context menu submenu settings after the reloadUI as well (if used).",
        ["options_icons_dynamic_gear"]			 = "Dynamic gear sets",
		["options_icons_non_gear"]				 = "Normal icons",
        ["options_icons_non_gear_sets_description"] = "Normal icons are the standard marker icons of this addon, only changeable in color/texture/size/position, meant to be used for fixed reasons like protecting items generally, sell them, deconstruct or improve them.\nThis standard marker icons need to be enabled if you want to use some special features like Automatic markings (see the automatic mark settings submenu).\nIf a setting entry is not usable try to enable the matching standard icon here.",
        ["options_icons_gear_sets_description"]     = "Gear set icons are the 5 standard marker icons of this addon, only changeable in color/texture/size/position and name, meant to be used for your equipment.\nIf you need more gear marker icons change one of the dynamic icons and set it up to be used as a gear set.",
		["options_icons_gears"]				 	 = "Gear sets",
		["options_icons_gear1"]					 = "Gear 1",
		["options_icons_gear2"]					 = "Gear 2",
		["options_icons_gear3"]					 = "Gear 3",
		["options_icons_gear4"]					 = "Gear 4",
		["options_icons_gear5"]					 = "Gear 5",
        ["options_header_color"]				 = "Icons",
        ["options_icon_none"]                   = "- No icon -",
        ["options_icon_offset_left"]            = "Offset left",
        ["options_icon_offset_left_TT"]         = "Offset of the icon inside the inventories, on the x axis (from left)",
        ["options_icon_scale"]                  = "Scale %",
        ["options_icon_scale_TT"]               = "Scale the size of the icons in %",
        ["options_icon_offset_top"]             = "Offset top",
        ["options_icon_offset_top_TT"]          = "Offset of the icon inside the inventories, on the y axis (from top)",
        ["options_icon1_color"]					 = "Lock",
        ["options_icon1_color_TT"]			 = "Color for the lock filter icon",
        ["options_icon2_color"]					 = "Color",
        ["options_icon2_color_TT"]			 = "Color for the gear 1 filter icon",
        ["options_icon3_color"]					 = "Research",
        ["options_icon3_color_TT"]			 = "Color for the research filter",
        ["options_icon4_color"]					 = "Color",
        ["options_icon4_color_TT"]			 = "Color for the gear 2 filter icon",
        ["options_icon5_color"]					 = "Selling",
        ["options_icon5_color_TT"]			 = "Color for the sell filter icon",
        ["options_icon1_texture"]				 = "Icon",
        ["options_icon1_texture_TT"]		 = "Icon for the lock filter",
        ["options_icon1_size"]				 	 = "Size",
        ["options_icon1_size_TT"]			 = "Size of the icon for the lock filter",
        ["options_icon2_texture"]				 = "Icon",
        ["options_icon2_texture_TT"]		 = "Icon for the gear 1 filter",
        ["options_icon2_size"]				 	 = "Size",
        ["options_icon2_size_TT"]			 = "Size of the icon for the gear 1 filter",
        ["options_icon3_texture"]				 = "Icon",
        ["options_icon3_texture_TT"]		 = "Icon for the research filter",
        ["options_icon3_size"]				 	 = "Size",
        ["options_icon3_size_TT"]			 = "Size of the icon for the research filter",
        ["options_icon4_texture"]				 = "Icon",
        ["options_icon4_texture_TT"]		 = "Icon for the gear 2 filter",
        ["options_icon4_size"]				 	 = "Size",
        ["options_icon4_size_TT"]			 = "Size of the icon for the gear 2 filter",
        ["options_icon5_texture"]				 = "Icon",
        ["options_icon5_texture_TT"]		 = "Icon for the sell filter",
        ["options_icon5_size"]				 	 = "Size",
        ["options_icon5_size_TT"]			 = "Size of the icon for the sell filter",
        ["options_icon6_color"]					 = "Color",
        ["options_icon6_color_TT"]			 = "Color for the gear 3 filter icon",
        ["options_icon6_texture"]				 = "Icon",
        ["options_icon6_texture_TT"]		 = "Icon for the gear 3 filter",
        ["options_icon6_size"]				 	 = "Size",
        ["options_icon6_size_TT"]			 = "Size of the icon for the gear 3 filter",
        ["options_icon7_color"]					 = "Color",
        ["options_icon7_color_TT"]			 = "Color for the gear 4 filter icon",
        ["options_icon7_texture"]				 = "Icon",
        ["options_icon7_texture_TT"]		 = "Icon for the gear 4 filter",
        ["options_icon7_size"]				 	 = "Size",
        ["options_icon7_size_TT"]			 = "Size of the icon for the gear 4 filter",
        ["options_icon8_color"]					 = "Color",
        ["options_icon8_color_TT"]			 = "Color for the gear 5 filter icon",
        ["options_icon8_texture"]				 = "Icon",
        ["options_icon8_texture_TT"]		 = "Icon for the gear 5 filter",
        ["options_icon8_size"]				 	 = "Size",
        ["options_icon8_size_TT"]			 = "Size of the icon for the gear 5 filter",
		["options_icon2_name"]					 = "Gear 1",
		["options_icon2_name_TT"]			 = "Your chosen name for the gear 1 icon",
		["options_icon4_name"]					 = "Gear 2",
		["options_icon4_name_TT"]			 = "Your chosen name for the gear 2 icon",
		["options_icon6_name"]					 = "Gear 3",
		["options_icon6_name_TT"]			 = "Your chosen name for the gear 3 icon",
		["options_icon7_name"]					 = "Gear 4",
		["options_icon7_name_TT"]			 = "Your chosen name for the gear 4 icon",
		["options_icon8_name"]					 = "Gear 5",
		["options_icon8_name_TT"]			 = "Your chosen name for the gear 5 icon",
        ["options_icon2_activate_text"]			 = "Activate gear 1",
        ["options_icon4_activate_text"]			 = "Activate gear 2",
        ["options_icon6_activate_text"]			 = "Activate gear 3",
        ["options_icon7_activate_text"]			 = "Activate gear 4",
        ["options_icon8_activate_text"]			 = "Activate gear 5",
		["options_icon1_TT"]				 = "Show tooltip",
		["options_icon1_tooltip_TT"]		 = "Show tooltip at the lock symbol",
		["options_icon2_TT"]				 = "Show tooltip",
		["options_icon2_tooltip_TT"]		 = "Show tooltip at the gear 1 symbol",
		["options_icon3_TT"]				 = "Show tooltip",
		["options_icon3_tooltip_TT"]		 = "Show tooltip at the research symbol",
		["options_icon4_TT"]				 = "Show tooltip",
		["options_icon4_tooltip_TT"]		 = "Show tooltip at the gear 2 symbol",
		["options_icon5_TT"]				 = "Show tooltip",
		["options_icon5_tooltip_TT"]		 = "Show tooltip at the selling symbol",
		["options_icon6_TT"]				 = "Show tooltip",
		["options_icon6_tooltip_TT"]		 = "Show tooltip at the gear 3 symbol",
		["options_icon7_TT"]				 = "Show tooltip",
		["options_icon7_tooltip_TT"]		 = "Show tooltip at the gear 4 symbol",
		["options_icon8_TT"]				 = "Show tooltip",
		["options_icon8_tooltip_TT"]		 = "Show tooltip at the gear 5 symbol",
		["options_icon9_TT"]				 = "Show tooltip",
		["options_icon9_tooltip_TT"]		 = "Show tooltip at the deconstruction symbol",
		["options_icon10_TT"]				 = "Show tooltip",
		["options_icon10_tooltip_TT"]		 = "Show tooltip at the improvement symbol",
		["options_tooltipatchar"]		 		 = "Tooltip at character window",
		["options_tooltipatchar_TT"]		 = "Show the tooltip at the character window too",
        ["options_icon9_color"]					 = "Deconstruction",
        ["options_icon9_color_TT"]			 = "Color for the deconstruction filter icon",
        ["options_icon9_texture"]				 = "Icon",
        ["options_icon9_texture_TT"]		 = "Icon for the deconstruction filter",
        ["options_icon9_size"]				 	 = "Size",
        ["options_icon9_size_TT"]			 = "Size of the icon for the deconstruction filter",
		["options_icon9_tooltip_text"]			 = "Marked for deconstruction",
        ["options_icon10_color"]				 = "Improvement",
        ["options_icon10_color_TT"]		 = "Color for the improvement filter icon",
        ["options_icon10_texture"]				 = "Icon",
        ["options_icon10_texture_TT"]		 = "Icon for the improvement filter",
        ["options_icon10_size"]				 	 = "Size",
        ["options_icon10_size_TT"]			 = "Size of the icon for the improvement filter",
		["options_icon10_tooltip_text"]			 = "Marked for improvement",
        ["options_icon11_TT"]				 = "Show tooltip",
        ["options_icon11_tooltip_TT"]		 = "Show tooltip at the 'Sell at guild store' icon",
        ["options_icon11_color"]				 = "Sell at guild store",
        ["options_icon11_color_TT"]		 = "Color for the 'Sell at guild store' filter icon",
        ["options_icon11_texture"]				 = "Icon",
        ["options_icon11_texture_TT"]		 = "Icon for the 'Sell at guild store' filter",
        ["options_icon11_size"]				 	 = "Size",
        ["options_icon11_size_TT"]			 = "Size of the 'Sell at guild store' filter icon",
        ["options_icon11_tooltip_text"]			 = "Marked for 'Sell at guild store'",
        ["options_icon11_only_unbound"]			 = "Only unbound",
        ["options_icon11_only_unbound_TT"]	 = "Allows to mark only unbound items for selling in guildstore",
        ["options_icon12_TT"]				 = "Show tooltip",
        ["options_icon12_tooltip_TT"]		 = "Show tooltip at intricate icon",
        ["options_icon12_color"]				 = "Intricate",
        ["options_icon12_color_TT"]		 = "Color for the intricate filter icon",
        ["options_icon12_texture"]				 = "Icon",
        ["options_icon12_texture_TT"]		 = "Icon for the intricate filter",
        ["options_icon12_size"]				 	 = "Size",
        ["options_icon12_size_TT"]			 = "Size of the intricate filter icon",
        ["options_icon12_tooltip_text"]			 = "Marked as intricate",
		["options_icon_mark_as_gear"]			= "Enable as gear set",
		["options_icon_mark_as_gear_TT"]	= "Enable this marker icon so it can be used as a gear set",
        ["filter_lockdyn_all"]				 	 = "Lock / Dynamic icons",
        ["filter_lockdyn_1"]					 = "Lock icon",
		["options_icon1_activate_text"]			 = "Activate lock",
		["options_icon3_activate_text"]			 = "Activate research",
		["options_icon5_activate_text"]			 = "Activate sell",
		["options_icon9_activate_text"]			 = "Activate deconstruction",
		["options_icon10_activate_text"]		 = "Activate improvement",
		["options_icon11_activate_text"]		 = "Activate sell in guild store",
		["options_icon12_activate_text"]		 = "Activate intricate",
		["options_icon_activate_text_TT"]	 = "Activate the icon in the context menus. If the setting is disabled the icon will be hidden in the context menu.",

		["options_icon1_tooltip_text"]			 = "Locked",
		["options_icon_gear_tooltip_text"]		 = "Belongs to gear: ",
		["options_icon_gears_tooltip_text"]		 = "Belongs to gears: ",
		["options_icon3_tooltip_text"]			 = "Marked for research",
		["options_icon5_tooltip_text"]			 = "Marked for selling",

		["options_header_keybind_options"]		= "Keybindings",
		["options_icon_cycle_on_keybind"]		= "Cycle marker icons with standard",
		["options_icon_cycle_on_keybind_TT"] = "If enabled you cycle the marker icons forwards, from the \'lock\' to the last dynamic marker icon, if you press the keybind key for the \'standard\' keybind.\n\nIf this option is activated the different enabled marker icons will be cycled from the 'lock' symbol to the last one. Current markers will be removed and only the new marker will be set.\nIf this option is deactivated only the standard marker symbol (choose it at the keybindings settings) will be enabled/disabled for the current item.",
		["options_icon_standard_on_keybind"]	= "Standard icon (mark on keybind)",
		["options_icon_standard_on_keybind_TT"] = "The standard icon which will be marked if you use the keybind for 'standard marker icon'.\nIf the setting \'Cycle marker icons with standard\' is enabled this setting here will be disabled.",
        ["options_keybind_move_item_to_junk_enabled"] = "Move to junk",
        ["options_keybind_move_item_to_junk_enabled_TT"] = "Activate keybind to move selected item to junk.",
        ["options_keybind_move_item_to_junk_add_sell_icon"] = "Junk: Auto. mark w/ sell icon",
        ["options_keybind_move_item_to_junk_add_sell_icon_TT"] = "Remove all marker icons on the item which get's moved to junk via keybind, and apply the sell marker icon.",
        ["options_keybind_enable_chording"]     = "Enable keybind modifier keys (SHIFT/CTRL/ALT)",
        ["options_keybind_enable_chording_TT"]  = "Enable the modifier keys SHIFT/CTRL/ALT at the control settings for keybindings.",

		["options_header_sort_order"]			= "Icons sort order",
		["options_icon_sort_order_TT"]     = "Select the icon from the dropdown list which you would like to show at the sort position (number to the left) in the context menu.",
        ["options_icon_sort_order_warning"]		= "The sort order of the icons in the context menus:\nATTENTION: Each icon must be assigned to only 1 number! If any icon is assigned more than once the standard sorting will be used and your sorting WONT be used!",
        ["options_icon_sort_order_add_inv_button_flag_too"] = "Sort add. inventory "..addInvFlagIcon.." context menu",
        ["options_icon_sort_order_add_inv_button_flag_too_TT"] = "Sort the additional inventory \'flag\' ("..addInvFlagIcon..") button context menu entries too.\nIf submenus for the gear and/or dynamic icons are used this will sort the normal, gear set and dynamic icons for each submenu alone, depending on your chosen sort order.",
        ["options_header_sort_order_output"] =      "Icon output order",
        ["options_header_sort_order_output_TT"] =   "Select the icon from the dropdown list which you would like to show at the sort position (number to the left) at the output (e.g. inventory rows). The icons will be created from last to first and will overlay each other with your chosen order.\nIf you update the order it may not update already created marker icons at the inventories. You might have to change inventory filters, or even do a reloadUI, to update the icons.",

		["options_gear_disable_research_check"] 		= "Disable \'armor/weapon check\'",
		["options_gear_disable_research_check_TT"] = "Disable the check for this icon if the item is researchable (weapon/armor only). This enables you to use this icon for non-researchable items too.",
        ["options_gear_enable_as_gear"] 		        = "Enable as gear",
        ["options_gear_enable_as_gear_TT"]         = "Enable this icon as a gear icon.",
        ["options_header_character"]			 = "Character window",
		["options_header_character_armor_type"]	 = "Armor type",
        ["options_show_armor_type_icon"]		 = "Show armor type icon",
        ["options_show_armor_type_icon_TT"] = "Show an icon for the equipped armor type, next to the item (above the player doll)",
		["options_show_armor_type_header_text"]	 = "Show armor type header info",
		["options_show_armor_type_header_text_TT"] = "Show the amount of worn light, medium and heavy armor parts as a text at the top of the armor character section",
		["options_armor_type_icon_character_pos_x"]	 = "Armor type icon position X",
		["options_armor_type_icon_character_pos_x_TT"]	= "Choose the horizontal position of the armor type icon, relativ to the upper right corner of the armor part",
		["options_armor_type_icon_character_pos_y"]	 = "Armor type icon position Y",
		["options_armor_type_icon_character_pos_y_TT"]	= "Choose the vertical position of the armor type icon, relativ to the upper right corner of the armor part",
		["options_armor_type_icon_character_light_color"]= "Armor type icon color (light)",
		["options_armor_type_icon_character_light_color_TT"]	= "Choose the color of the light armor type icon",
		["options_armor_type_icon_character_medium_color"]= "Armor type icon color (medium)",
		["options_armor_type_icon_character_medium_color_TT"]	= "Choose the color of the medium armor type icon",
		["options_armor_type_icon_character_heavy_color"]= "Armor type icon color (heavy)",
		["options_armor_type_icon_character_heavy_color_TT"]	= "Choose the color of the heavy armor type icon",
		["options_armor_type_icon_light_short"]		= "L",
		["options_armor_type_icon_medium_short"]	= "M",
		["options_armor_type_icon_heavy_short"]		= "H",

        ["options_header_context_menu"]			 = "Context menus",
        ["options_header_context_menu_inventory"] = "In the inventories",
        ["options_header_context_menu_filter_buttons"] = "Filter buttons",
        ["options_context_menu_filter_buttons_max_icons"]           = "Show submenu: marker icon count",
        ["options_context_menu_filter_buttons_max_icons_TT"]   = "If the filter button context menu is enabled and if this number of marker icons, related to this filter button, are enabled:\nShow a sub menu to shorten the filter button context menu.\n\nThe value 0 disables the submenu!",
        ["options_use_subcontextmenu"]			 = "Use submenu in context menu",
        ["options_use_subcontextmenu_TT"]	 = "With this setting enabled the possible FCOIS options for the item will bw shown beyond a 'FCOItemSaver' submenu inside the context menu. With this option disabled all possible FCOIS options for this item are shown directly inside the context menu.",
        ["options_header_context_menu_divider"] = "FCOIS divider row",
        ["options_header_context_menu_divider_TT"] = "The FCOIS divider row will only be shown if the normal submenu in the inventory context menu is not enabled!",
		["options_show_contextmenu_divider"]	 = "Show context menu divider",
		["options_show_contextmenu_divider_TT"] = "Show an informative divider above the FCOItemSaver context menu entries to divide the item's standard options from the FCOIS options",
		["options_contextmenu_divider_opens_settings"] = "Divider shows settings",
		["options_contextmenu_divider_opens_settings_TT"] = "If you click the divider the FCOItemSaver settings panel will be opened",
		["options_contextmenu_divider_clears_all_markers"] = "Divider clears all icons",
		["options_contextmenu_divider_clears_all_markers_TT"] = "If you click the divider the current item#s icons will be unmarked (a second click on the divider will remark the last used icons of this item)",
		["options_contextmenu_leading_spaces"]				= "Entries use leading spaces",
		["options_contextmenu_leading_spaces_TT"]		= "The contextmenu entries for FCOIS should use this amount of leading spaces to indent the entries for a better readability.",
		["options_contextmenu_use_custom_marked_normal_color"]			= "Colorized entries for marked",
		["options_contextmenu_use_custom_marked_normal_color_TT"]	= "Show context menu entries for those, which are currently active (marked items, e.g. 'Lock') with a different color",
		["options_contextmenu_custom_marked_normal_color"]				= "Color for marked entries",
		["options_contextmenu_custom_marked_normal_color_TT"]		= "The color which will be used to show the currently active/marked entries in the context menu",

        ["options_header_filter_buttons_position"]	= "Filter button positions",
        ["options_header_pos"]			 = "Icon positions & size",
        ["options_pos_inventories"]		 = "In inventories",
        ["options_pos_inventories_TT"]	 = "The x-axis position of the symbols inside the inventories",
        ["options_pos_crafting"]		 	= "At crafting stations",
        ["options_pos_crafting_TT"]	= "The x-axis position of the symbols inside the crafting station panel's inventory",
        ["options_pos_character_x"]		 = "X - In character window",
        ["options_pos_character_x_TT"]	 = "The x-axis position of the symbols inside the character window",
        ["options_pos_character_y"]		 = "Y - In character window",
        ["options_pos_character_y_TT"]	 = "The y-axis position of the symbols inside the character window",
        ["options_size_character"]		 = "Size - In character window",
        ["options_size_character_TT"]	 = "The size of the symbols inside the character window",
        ["options_header_split_filters"]		 = "Split filter buttons",
        ["options_header_filters"]		         = "Filters",
        ["options_split_filters"]				 = "Split filter buttons",
        ["options_split_filters_TT"]		 = "Allows you to enable/disable individual filters for your inventory, vendor, bank, guild bank, guild store, crafting stations, enchanting station, mail and trade panels.\n\nYou'll have to use the same filter button & state at each inventory/panel, if this option is disabled!",
	    ["options_enable_filter_in_inventory"]	 = "Enable filters in inventory",
	    ["options_enable_filter_in_inventory_TT"]	 = "Enables you to hide the marked items inside your inventory too",
		["options_enable_filter_in_craftbag"]			= "Enable filters in Crafting bag",
		["options_enable_filter_in_craftbag_TT"]	= "Enables you to hide the marked items inside your crafting bag too",
        ["options_enable_filter_in_bank"]		 = "Enable filter inside bank",
        ["options_enable_filter_in_bank_TT"]		 = "Enables you to hide the marked items inside your bank too",
        ["options_enable_filter_in_guildbank"]	 = "Enable filter inside guild bank",
        ["options_enable_filter_in_guildbank_TT"]	 = "Enables you to hide the marked items inside your guild bank too",
        ["options_enable_filter_in_tradinghouse"]= "Enable filter inside guild shop",
        ["options_enable_filter_in_tradinghouse_TT"]= "Enables you to hide the marked items inside your guild shop too",
        ["options_enable_filter_in_trade"]		 = "Enable filter during trading",
        ["options_enable_filter_in_trade_TT"]		 = "Enables you to hide the marked items during trading with other players",
        ["options_enable_filter_in_mail"]		 = "Enable filter during mail creation",
        ["options_enable_filter_in_mail_TT"]		 = "Enables you to hide the marked items during creation of mails",
        ["options_enable_filter_in_deconstruction"]		 = "Enable filter at deconstruction",
        ["options_enable_filter_in_deconstruction_TT"]		 = "Enables you to hide the marked items during deconstruction at crafting stations",
        ["options_enable_filter_in_improvement"]		 = "Enable filter at improvement",
        ["options_enable_filter_in_improvement_TT"]		 = "Enables you to hide the marked items during improvement at crafting stations",
        ["options_enable_filter_in_jewelry_refinement"]				= "Enable filter at jewelry refinement",
        ["options_enable_filter_in_jewelry_refinement_TT"]	 	= "Enables you to hide the marked items during jewelry refinement at crafting stations",
        ["options_enable_filter_in_jewelry_deconstruction"]		    = "Enable filter at jewelry deconstruction",
        ["options_enable_filter_in_jewelry_deconstruction_TT"]	= "Enables you to hide the marked items during jewelry deconstruction at crafting stations",
        ["options_enable_filter_in_jewelry_improvement"]		    = "Enable filter at jewelry improvement",
        ["options_enable_filter_in_jewelry_improvement_TT"]	= "Enables you to hide the marked items during jewelry improvement at crafting stations",
        ["options_enable_filter_in_research"]				        = "Enable filter at research",
        ["options_enable_filter_in_reasearch_TT"]	 	        = "Enables you to hide the marked items during research at crafting stations",
        ["options_enable_filter_in_jewelry_research"]			    = "Enable filter at jewelry research",
        ["options_enable_filter_in_jewelry_reasearch_TT"]	 	= "Enables you to hide the marked items during jewelry research at crafting stations",
        ["options_enable_filter_in_store"]		 = "Enable filter at vendor",
        ["options_enable_filter_in_store_TT"]		 = "Enables you to hide the marked items at selling to a vendor",
        ["options_enable_filter_in_enchanting"]		 = "Enable filter during enchanting",
        ["options_enable_filter_in_enchanting_TT"]		 = "Enables you to hide the marked items during enchanting creation & deconstruction",
        ["options_enable_filter_in_fence"]		 = "Enable filter at fence",
        ["options_enable_filter_in_fence_TT"]		 = "Enables you to hide the marked items at selling to a fence",
        ["options_enable_filter_in_launder"]		 = "Enable filter at laundring",
        ["options_enable_filter_in_launder_TT"]		 = "Enables you to hide the marked items at laundring at a fence",
        ["options_enable_filter_in_alchemy"]		 = "Enable filter at alchemy station",
        ["options_enable_filter_in_alchemy_TT"]		 = "Enables you to hide the marked items during creation of potions at an alchemy station",
        ["options_header_deactivated_symbols"]						= "Deactivated icons",
        ["options_deactivated_symbols_apply_anti_checks"]			= "Apply anti-checks",
        ["options_deactivated_symbols_apply_anti_checks_TT"]	= "Also apply the normal anti-destroy/anti-deconstruct/anti-* checks for items marked with a disabled (and thus not visible) marker icon.\nTo unmark the item with the marker icon you still need to activate the symbol again!",
        ["options_header_repair"] = GetString(SI_STORE_MODE_REPAIR),
        ["options_header_enchant"] = GetString(SI_ITEMTYPEDISPLAYCATEGORY15),
		["options_allow_marked_repair"] = "Block marked repair kits",
		["options_allow_marked_repair_TT"] = "Do not allow to use marked repair kits to repair your equipment.\nYou are still able to remove the marker icon in the repair dialog to allow the repair with that repair item!",
		["options_allow_marked_enchant"] = "Block marked glyphs",
		["options_allow_marked_enchant_TT"] = "Do not allow to use marked glyphs to enchant your equipment.\nYou are still able to remove the marker icon in the enchant dialog to allow the enchanting with that glyph!",
        ["options_enable_filtered_item_count"]	        = "Count of shown items at 'NAME'",
        ["options_enable_filtered_item_count_TT"]	= "Show the count of actually shown items in front of the sort header entry 'NAME' after each change of a filter",
		--Other options
        ["options_header_marking_undo"]         = "Undo",
		["options_header_items"]				= "Automatic marking",
		["options_header_items_prevent"]		= "Automatic marking - Prevent",
		["options_header_items_demark"]			= "Automatic De-Marking",
        ["options_remark_on_enchant"]           = "After enchanting",
        ["options_remark_on_enchant_TT"]        = "Automatically re-mark items with their same marker icons, after they got enchanted.",
        ["options_remark_on_improvement"]           = "After improvement",
        ["options_remark_on_improvement_TT"]        = "Automatically re-mark items with their same marker icons, after they got improved.",
        ["options_header_items_remark"]			 = "Automatic Re-Marking",
        ["options_header_items_demark_all"]	    = "De-mark all others",
        ["options_header_items_mark_new"]	            =   "New",
        ["options_enable_auto_mark_new_items"]          =   "Mark new items",
        ["options_enable_auto_mark_new_items_TT"]  =   "Automatically mark new items with a chosen marker icon",
        ["options_auto_mark_new_items_icon"]            =   "New marker icon",
        ["options_auto_mark_new_items_icon_TT"]    =   "The marker icon for new items",
        ["options_enable_auto_mark_ornate_items"] = "Mark ornate items",
        ["options_enable_auto_mark_ornate_items_TT"] =  "Automatically mark ornate items for selling",
        ["options_auto_mark_ornate_items_icon"] = "Ornate mark icon",
        ["options_auto_mark_ornate_items_icon_TT"] = "Icon for ornate items which will be automatically marked for selling",
        ["options_enable_auto_mark_ornate_items_in_chat"] = "Show items in chat",
        ["options_enable_auto_mark_ornate_items_in_chat_TT"] =  "Show automatically marked ornate items in the chat",
        ["options_enable_auto_mark_intricate_items"] = "Mark intricate items",
        ["options_enable_auto_mark_intricate_items_TT"] =  "Automatically mark intricate items",
        ["options_auto_mark_intricate_items_icon"] = "Intricate mark icon",
        ["options_auto_mark_intricate_items_icon_TT"] = "Icon for intricate items which will be automatically marked",
        ["options_enable_auto_mark_intricate_items_in_chat"] = "Show items in chat",
        ["options_enable_auto_mark_intricate_items_in_chat_TT"] =  "Show automatically marked intricate items in the chat",
        ["options_enable_auto_mark_research"] = GetString(SI_SMITHING_TAB_RESEARCH),
        ["options_enable_auto_mark_wasted_research_scrolls"] = "Wasted research scrolls",
        ["options_enable_auto_mark_wasted_research_scrolls_TT"] = "Automatically mark research scrolls that would get wasted on usage because their time reduction will be more than your research slots got time left.\n\nNeeds the addon 'DetailedResearchScrolls' enabled!",
        ["options_enable_auto_mark_research_items"] = "Mark researchable items",
        ["options_enable_auto_mark_research_items_TT"] = "Automatically mark researchable items",
        ["options_enable_auto_mark_research_items_hint"]    = "Needed addon is chosen from the dropbox in the settings",
        ["options_enable_auto_mark_research_items_hint_logged_in_char"] = "Only applies for the following addons:\n\nCraftStore FixedAndImproved\n\nOther addons got their own settings to define the characters to track!\nAnd the ESO base game will ALWAYS ONLY check the currently logged in character.",
        ["options_enable_auto_mark_research_items_in_chat"] = "Show items in chat",
        ["options_enable_auto_mark_research_items_in_chat_TT"] =  "Show automatically marked researchable items in the chat",
        ["options_auto_mark_research_items_icon"] = "Research mark icon",
        ["options_auto_mark_research_items_icon_TT"] = "Icon for researchable items which will be automatically marked",
		["options_enable_auto_mark_non_sets"]			= "Mark non set parts",
		["options_enable_auto_mark_non_sets_TT"]	= "Automatically mark no set armor/weapon/jewelry parts",
		["options_enable_auto_mark_unknown_set_collection_items"]		= "Mark unknown set collection items",
		["options_enable_auto_mark_unknown_set_collection_items_TT"]    = "Automatically mark set armor/weapon/jewelry items which are unknown in the set collection item book",
		["options_enable_auto_mark_known_set_collection_items"]		    = "Mark known set collection items",
		["options_enable_auto_mark_known_set_collection_items_TT"]      = "Automatically mark set armor/weapon/jewelry items which are known in the set collection item book",
		["options_enable_auto_mark_sets"]			= "Mark set parts",
		["options_enable_auto_mark_sets_TT"]	= "Automatically mark set armor/weapon/jewelry parts",
		["options_enable_auto_mark_check_all_icons"]			= "Check all other markers",
		["options_enable_auto_mark_check_all_icons_TT"]	= "Check all the other marker icons upon automatic item marking.\nIf any of the other markers are already set the automatic item marking won't be applied!",
		["options_enable_auto_mark_sets_all_gear_marker_icons"]			= "Check all gear markers",
		["options_enable_auto_mark_sets_all_gear_marker_icons_TT"]	= "Check all the gear marker icons upon automatic set part marking. If any of the gear markers are already set the automatic set part marking won't be applied!",
		["options_enable_auto_mark_sets_sell_icon"]			= "Check sell/sell in guild store",
		["options_enable_auto_mark_sets_sell_icon_TT"]	= "Check the sell and sell in guild store marker icons upon automatic set part marking. If any of them was already set the automatic set part marking won't be applied!",
		["options_header_non_wished"]                                           = "Non-desired traits",
        ["options_enable_auto_mark_sets_non_wished"]							= "Mark non-desired",
		["options_enable_auto_mark_sets_non_wished_TT"]					= "Automatically mark the non-desired (items without your marked traits) set parts with another marker icon",
		["options_enable_auto_mark_sets_non_wished_icon"]						= "Non-desired marker icon",
		["options_enable_auto_mark_sets_non_wished_icon_TT"]				= "Choose your marker icon for the non-desired (items without your marked traits) set parts.\n\nStandard icon: 'Deconstruction'",
        ["options_enable_auto_mark_sets_non_wished_checks"]		= "\"Non desired\" checks",
        ["options_enable_auto_mark_sets_non_wished_checks_TT"]= "Non desired set items will be checked according to this setting.",
		["options_enable_auto_mark_sets_non_wished_quality"]					= "Quality threshold <=",
		["options_enable_auto_mark_sets_non_wished_quality_TT"]			= "Non-desired set parts will be marked with the non-desired marker icon if their quality equals/is lower this chosen quality.",
        ["options_enable_auto_mark_sets_non_wished_level"]                      = "Level threshold <",
        ["options_enable_auto_mark_sets_non_wished_level_TT"]              = "Set parts will be marked with the non-desired marker icon if their level is below this chosen level.",
        ["options_enable_auto_mark_sets_non_wished_sell_others"]                = "Sell non-matching",
        ["options_enable_auto_mark_sets_non_wished_sell_others_TT"]        = "All other not-matching (to the chosen non-desired settings) non-desired set parts will be marked to be sold.",
        ["options_enable_auto_mark_sets_non_wished_char_below_level_50"]    = "Char. level <" ..maxLevel,
        ["options_enable_auto_mark_sets_non_wished_char_below_level_50_TT"] = "Mark all set items with the non-desired marker icon (and do not apply any other desired or non-desired checks!) if the currently logged in character is still below level " ..maxLevel .." AND the item's level is below the maximum possible level, or it equals the maximum possible level but is below the maximum possible champion points level.\nThis will give you the possibility to mark all items for e.g. deconstruction if you level a new character.",
        ["options_enable_auto_mark_sets_in_chat"] = "Show set parts in chat",
        ["options_enable_auto_mark_sets_in_chat_TT"] =  "Show automatically marked set items in the chat",
        ["options_enable_auto_mark_sets_already_bound"]         = "Mark already bound",
        ["options_enable_auto_mark_sets_already_bound_TT"] = "Mark the set parts that are already bound to your account with a small icon at the top-right edge of the set item's image",
        ["options_header_exclude_sets"] = "Excluded sets",
        ["options_exclude_automark_sets_list"] = "Excluded sets",
        ["options_exclude_automark_sets_list_TT"] = "If setting is enabled use the list of excluded sets:\n\nLeft: All sets available\nRight: Excluded sets\nExcluded sets will not be checked for Automatic markings.\nMove the sets from left to right to exclude them, and to the left to include them into scans again.",
        ["options_exclude_automark_sets_included"] = "Included sets",
		["options_auto_mark_sets_icon"]			= "Set part icon",
		["options_auto_mark_sets_icon_TT"]	= "Icon for the automatically marked set parts",
		["options_header_settracker"]								= "Set Tracker",
        ["options_header_traits"]                               = "Trait",
        ["options_auto_mark_traits_with_set_too"]               = "Mark with Set marking too",
        ["options_auto_mark_traits_with_set_too_TT"]       = "Automatically mark set items with the trait marker icon even if the set marker icon was set before. If you disable this option the trait marker icons won't be applied to already automatically marked set items.",
        ["options_auto_mark_traits_only"]               = "Only trait markers",
        ["options_auto_mark_traits_only_TT"]       = "Only set the trait marker icons and not the set marker icon if the trait marker icon for the item's trait is configured.",
		["options_auto_mark_settrackersets"]						= "Automatically mark 'SetTracker' sets",
		["options_auto_mark_settrackersets_TT"]				= "Automatically mark items tracked with 'SetTracker' with one of the FCOIS marker icons",
		["options_auto_mark_settrackersets_to_fcois_icon"]			= "SetTracker index <<1>>: FCOIS icon",
		["options_auto_mark_settrackersets_to_fcois_icon_TT"]	= "Specify the icon of FCOItemSaver here which you want to use for each 'SetTracker' tracked state/sets.",
		["options_auto_mark_settrackersets_show_tooltip_on_FCOIS_marker"]		  = "Show set note as tooltip",
		["options_auto_mark_settrackersets_show_tooltip_on_FCOIS_marker_TT"] = "Show the SetTracker set note (if it was created) text inside the tooltip of FCOItemSaver marker icons in your inventories.",
		["options_auto_mark_settrackersets_inv"]			= "Mark in inventory",
		["options_auto_mark_settrackersets_inv_TT"]	= "Mark items in your inventory",
		["options_auto_mark_settrackersets_worn"]			= "Mark worn",
		["options_auto_mark_settrackersets_worn_TT"]	= "Mark your currently worn items",
		["options_auto_mark_settrackersets_bank"]			= "Mark in bank",
		["options_auto_mark_settrackersets_bank_TT"]	= "Mark items in your bank",
		["options_auto_mark_settrackersets_guildbank"]			= "Mark in guild bank",
		["options_auto_mark_settrackersets_guildbank_TT"]	= "Mark items in your guild banks",
		["options_auto_mark_settrackersets_rescan"]				= "Rescan & mark again",
		["options_auto_mark_settrackersets_rescan_TT"]		= "At login/reloadui: Rescan your above chosen inventories for Set Tracker set parts and remark them if you have removed the FCOIS marker icon, but the set part is still tracked with Set Tracker.",
		["options_enable_auto_mark_sets_settracker_icons"]			= "Only w/o SetTracker sets",
		["options_enable_auto_mark_sets_settracker_icons_TT"]	= "Check all the marker icons on SetTracker set items upon automatic set part marking. If any of the SetTracker set parts got a mark already the automatic set part marking won't be applied!",
		["options_enable_auto_mark_recipes"]			= "Mark unknown recipes",
		["options_enable_auto_mark_recipes_TT"]	= "Automatically mark unknown recipes with the chosen icon",
		["options_enable_auto_mark_known_recipes"]		= "Mark known recipes with icon",
		["options_enable_auto_mark_known_recipes_TT"]	= "Automatically mark known recipes with a marker icon.",
        ["options_auto_mark_addon"]             =   "Addon to use",
        ["options_auto_mark_addon_TT"]     =   "Addon to use for the automatic marking of <<1>>",
		["options_auto_mark_recipes_icon"]				=	"Recipe icon (%s)",
		["options_auto_mark_recipes_icon_TT"]		=	"Icon for the automatically marked %s recipes",
		["options_auto_mark_crafted_items_icon"]		=	"Crafted items icon",
		["options_auto_mark_crafted_items_icon_TT"]=	"Icon for the automatically marked crafted items",
		["options_enable_auto_mark_recipes_in_chat"]	= "Show recipes in chat",
		["options_enable_auto_mark_recipes_in_chat_TT"] = "Show automatically marked unknown recipes in the chat",
		["options_auto_mark_recipes_this_char"]			= "Only for this character",
		["options_auto_mark_recipes_this_char_TT"]	= "If you enable this setting the (un)known recipes will only be checked for the currently loggedin character!\n\nIf this setting is disabled the (un)known recipes will be checked for other (non-logged in) characters too, and the marker icon will be added to the recipe, if\n-you are using the account wide settings of FCOIS\n-and if the following rules apply:\n\n[Chosen recipe addon: \'SousChef\']\n-The setting \'List Characters Who Know Recipe\' must be enabled in the SousChef settings\n-Recipe checks will be done for the 'Main Provisioner Character' chosen in the SousChef settings only. A check for all of your characters is currently not possible via the addon SousChef!.\n\n[Chosen recipe addon: \'CraftStoreFixedAndImproved\']\nIf the main crafting character is chosen (via right mouse button |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t at the CraftStore character list popup):\nOnly this char will be checked.\nElse all your characters will be checked.",
		["options_enable_auto_mark_recipes_hint"]		= "This option needs the selected recipe addon activated.\n\n[SousChef]\nPlease enable the option 'List Characters Who Know Recipe' in the SousChef settings!",
		["options_auto_mark_crafted_items"] 			= "Mark crafted items",
		["options_auto_mark_crafted_items_TT"] 	= "If you enable this setting the addon will automatically mark your crafted items at a crafting station with the 'lock' icon.",
		["options_auto_mark_crafted_items_sets"] 			= "Only mark set parts",
		["options_auto_mark_crafted_items_sets_TT"] 	= "If you enable this option the automatic item marking for crafted items will only mark crafted set parts.",
		["options_header_anti_destroy"] = "Protection (Anti-methods)",
        ["options_enable_block_deconstruction"]  = "Deactivate deconstruction",
        ["options_enable_block_deconstruction_TT"]  = "Deactivate deconstruction of marked items inside the crafting stations",
        ["options_enable_block_jewelry_deconstruction"]  = "Deactivate jewelry deconstruction",
        ["options_enable_block_jewelry_deconstruction_TT"]  = "Deactivate jewelry deconstruction of marked items inside the crafting stations",
        ["options_enable_block_deconstruction_exception_intricate"]  = "Allow deconstruction of intricate items",
        ["options_enable_block_deconstruction_exception_intricate_TT"]  = "Allows the deconstruction for items marked as 'Intricate'",
        ["options_enable_block_deconstruction_exception_deconstruction"]  = "Allow deconstruction of deconstruction items",
        ["options_enable_block_deconstruction_exception_deconstruction_TT"]  = "Allows the deconstruction for items marked as 'Deconstruction'",
        ["options_enable_block_deconstruction_exception_deconstruction_all_markers"]  = "Allow deconstruction (ignore other markers)",
        ["options_enable_block_deconstruction_exception_deconstruction_all_markers_TT"]  = "Allows the deconstruction for items marked as 'Deconstruction' even if the item is marked with any of the other item markers.\n\nAttention: This will destroy your items marked for deconstruction even if it would still be a set part you'd like to keep and you've marked it with a gear set e.g.",
        ["options_enable_block_destroying"]  = "Prevent destroying",
        ["options_enable_block_destroying_TT"]  = "Prevent destroying marked items",
        ["options_enable_block_sending_mail"]  = "Prevent sending by mail",
        ["options_enable_block_sending_mail_TT"]  = "Prevent sending marked items by mail",
        ["options_enable_block_trading"]  = "Prevent trading",
        ["options_enable_block_trading_TT"]  = "Prevent trading marked items with other players",
        ["options_enable_block_selling"]  = "Prevent selling",
        ["options_enable_block_selling_TT"]  = "Prevent selling marked items to a vendor",
        ["options_enable_block_selling_guild_store"]  = "Prevent selling at guild store",
        ["options_enable_block_selling_guild_store_TT"]  = "Prevent listing marked items at a guild store",
        ["options_enable_block_fence_selling"]    = "Prevent fence selling",
        ["options_enable_block_fence_selling_TT"]    = "Prevent selling marked items to a fence",
        ["options_enable_block_launder_selling"]    = "Prevent laundering",
        ["options_enable_block_launder_selling_TT"]    = "Prevent laundering marked items to a fence",
        ["options_demark_all_deconstruct"]	= "Unmark all on 'Deconstruction'",
        ["options_demark_all_deconstruct_TT"] = "Demark all other marker icons if you mark an item for deconstruction",
        ["options_demark_all_selling"]	= "Unmark all on 'Sell'",
        ["options_demark_all_selling_TT"] = "Demark all other marker icons if you mark an item for selling",
        ["options_demark_all_selling_guild_store"]	= "Unmark all on 'Sell in guild store'",
        ["options_demark_all_selling_guild_store_TT"] = "Demark all other marker icons if you mark an item for selling in the guild store",
        ["options_demark_all_others"]	    = "Unmark all others",
        ["options_demark_all_others_TT"]    = "Demark all other marker icons if you mark an item with this marker icon",
        ["options_demark_all_others_except_non_dynamic"]	    = "Exclude: Normal icons",
        ["options_demark_all_others_except_non_dynamic_TT"]    = "Exclude normal marker icons from the automatic demarkin",
        ["options_demark_all_others_except_dynamic"]	    = "Exclude: Dynamic icons",
        ["options_demark_all_others_except_dynamic_TT"]    = "Exclude dynamic marker icons from the automatic demarking",
        ["options_demark_sell_on_others"]                       = "Demark 'Sell'",
        ["options_demark_sell_on_others_TT"]               = "Demark 'sell' if you mark an item with any other marker icon",
        ["options_demark_sell_guild_store_on_others"]           = "Demark 'Sell in guild store'",
        ["options_demark_sell_guild_store_on_others_TT"]   = "Demark 'selling in the guild store' if you mark an item with any other marker icon",
        ["options_demark_deconstruction_on_others"]           = "Demark 'Deconstruction'",
        ["options_demark_deconstruction_on_others_TT"]   = "Demark 'Deconstruction' if you mark an item with any other marker icon",
        ["options_demark_on_others_exclusion_dynamic"]      = "Exception: Dynamic icons",
        ["options_demark_on_others_exclusion_dynamic_TT"]   = "Demark dthe marker icon only if not a dynamic icon will be applied",
		["options_block_selling_exception"]			= "Allow to sell marked 'Sell' items",
		["options_block_selling_exception_TT"] = "Allow to sell items you have marked for selling at stores. This will enable you to filter just the marked for selling icons and sell them easily!",
		["options_block_selling_exception_ornate"] = "Allow to sell marked ornate",
		["options_block_selling_exception_ornate_TT"] = "Allow to sell items you have marked as ornate. This will enable you to filter just the marked ornate icons and sell them easily!",
		["options_block_selling_exception_intricate"] = "Allow to sell marked intricate",
		["options_block_selling_exception_intricate_TT"] = "Allow to sell items you have marked as intricate",
		["options_block_selling_exception_guild_store"] = "Allow to sell in guild store",
		["options_block_selling_exception_guild_store_TT"] = "Allow to sell 'Marked for guild store' items inside the guild store",
        ["options_enable_block_improvement"]  = "Prevent improvement",
        ["options_enable_block_improvement_TT"]  = "Prevent improvement of marked items at a crafting station",
        ["options_enable_block_jewelry_improvement"]  = "Prevent jewelry improvement",
        ["options_enable_block_jewelry_improvement_TT"]  = "Prevent jewelry improvement of marked items at a crafting station",
        ["options_enable_block_improvement_exception_improvement"]  = "Allow improvement of improved items",
        ["options_enable_block_improvement_exception_improvement_TT"]  = "Allow to improve items marked for 'Improvement' at the crafting stations",
		["options_enable_block_creation"] 			= "Prevent rune creation",
		["options_enable_block_creation_TT"]	= "Prevent rune creation with marked items at an enchanting table",
		["options_enable_block_extraction"]			= "Prevent rune extraction",
		["options_enable_block_extraction_TT"]	= "Prevent rune extraction from marked items at an enchanting table",
        ["options_enable_block_alchemy_destroy"]  = "Prevent alchemy destroying",
        ["options_enable_block_alchemy_destroy_TT"]  = "Prevent destroying marked items at an alchemy station",
		["options_enable_block_autoloot_container"]			= "Disable autoloot of containers",
		["options_enable_block_autoloot_container_TT"]	= "Disables the automatic looting of all contents from a container, if you have enabled 'Always take all' (autoloot) at the ESO standard settings.\n\nIf this setting is enabled you are not allowed to open a marked container. Please also have a look at the addon 'Container Peek' which provides a great benefit for containers & autpoloot!",
		["options_enable_block_marked_recipes"]			= "Block usage of marked recipes",
		["options_enable_block_marked_recipes_TT"]	= "Prevent using your marked recipes so you do not accidently read them if they are marked with an icon",
		["options_enable_block_marked_disable_with_flag"]			= "Disable temporarily with "..addInvFlagIcon.."",
		["options_enable_block_marked_disable_with_flag_TT"]	= "Disable the anti-use/-read/take/etc. feature temporarily by right-clicking |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t the inventory's additional options \'flag\' ("..addInvFlagIcon..") icon",
        ["options_header_junk"] = GetString(SI_ITEMFILTERTYPE9),
        ["options_header_additional_inv_flag_context_menu"]   = "Additional "..addInvFlagIcon.." context menu",
        ["options_remove_context_menu_mark_as_junk"] = "Remove '" .. GetString(SI_ITEM_ACTION_MARK_AS_JUNK) .. "' context menu",
        ["options_remove_context_menu_mark_as_junk_TT"] = "Remove context menu entry '" .. GetString(SI_ITEM_ACTION_MARK_AS_JUNK) .. "' for marked items",
        ["options_junk_item_marked_to_be_sold"]          = "Allow junk (marked to be sold)",
        ["options_junk_item_marked_to_be_sold_TT"]  = "Alow items to be junked if \'only\' the sell marker icon is set on them.",
        ["options_dont_unjunk_on_normal_mark"]                = "Don't unjunk on normal mark",
        ["options_dont_unjunk_on_normal_mark_TT"]        = "Do not unjunk junk items if you mark then with the context menu or keybind.\nProtected items, after setting a marker icon, will be automatically unjunked, if you deactivate this option.",
        ["options_dont_unjunk_on_bulk_mark"]                = "Don't unjunk on bulk mark",
        ["options_dont_unjunk_on_bulk_mark_TT"]        = "Do not unjunk junk items if you bulk mark then with the additional inventory \'flag\' ("..addInvFlagIcon..") context menu buttons.",
        ["options_dont_unjunk_item_marked_to_be_sold"]          = "Don't unjunk marked to be sold",
        ["options_dont_unjunk_item_marked_to_be_sold_TT"]  = "Do not unjunk junk items if they are \'only\' marked to be sold.",
		["options_enable_block_motifs"] = "Block usage of marked motifs",
	  	["options_enable_block_motifs_TT"] = "Prevent using your marked motifs so you do not accidently read them if they are marked with an icon",
        ["options_header_motifs"] = "Style-Motifs",
        ["options_header_food"] = "Food & Potions",
		["options_enable_block_potions"] = "Block usage of marked potions",
	  	["options_enable_block_potions_TT"] = "Prevent using your marked potions so you do not accidently drink them if they are marked with an icon",
		["options_enable_block_food"] = "Block usage of marked food",
	  	["options_enable_block_food_TT"] = "Prevent using your markedfood so you do not accidently eat it if it's marked with an icon",
        ["options_header_guild_bank"] = "Guild banks",
        ["options_enable_block_guild_bank_without_withdraw"] = "Prevent deposit  w/o withdraw rights",
		["options_enable_block_guild_bank_without_withdraw_TT"] = "Prevent the deposit of any item (even unmarked) if you do not have the rights to withdraw the item from this guild bank again",
        ["options_auto_reenable_block_guild_bank_without_withdraw"]  = "Reactivate Anti-Guild Bank automatically",
        ["options_auto_reenable_block_guild_bank_without_withdraw_TT"]  = "Reactivates the Anti-Guild Bank deposit w/o withdraw rights protection automatically if you close the guild bank.\n\nYou are able to deactivate the prevention method at the inventory's context buton menu (small \'flag\' ("..addInvFlagIcon..") symbol at the top left)!",
        ["options_auto_reenable_block_deconstruction"]  = "Reactivate Anti-Deconstruction automatically",
        ["options_auto_reenable_block_deconstruction_TT"]  = "Reactivates the Anti-Deconstruction protection automatically if you close the crafting station.\n\nYou are able to deactivate the prevention method at the inventory's context buton menu (small \'flag\' ("..addInvFlagIcon..") symbol at the top left)!",
        ["options_auto_reenable_block_jewelry_deconstruction"]  = "Reactivate Anti-Jewelry deconstruction automatically",
        ["options_auto_reenable_block_jewelry_deconstruction_TT"]  = "Reactivates the Anti-Jewelry deconstruction protection automatically if you close the crafting station.\n\nYou are able to deactivate the prevention method at the inventory's context buton menu (small \'flag\' ("..addInvFlagIcon..") symbol at the top left)!",
        ["options_auto_reenable_block_destroying"]  = "Reactivate Anti-Destroy automatically",
        ["options_auto_reenable_block_destroying_TT"]  = "Reactivates the Anti-Destroy protection automatically if you close the inventory/bank/guild bank.\n\nYou are able to deactivate the prevention method at the inventory's context buton menu (small \'flag\' ("..addInvFlagIcon..") symbol at the top left)!",
        ["options_auto_reenable_block_sending_mail"]  = "Reactivate Anti-Mail automatically",
        ["options_auto_reenable_block_sending_mail_TT"]  = "Reactivates the Anti-Mail protection automatically if you close the mail inventory.\n\nYou are able to deactivate the prevention method at the inventory's context buton menu (small \'flag\' ("..addInvFlagIcon..") symbol at the top left)!",
        ["options_auto_reenable_block_trading"]  = "Reactivate Anti-Trade automatically",
        ["options_auto_reenable_block_trading_TT"]  = "Reactivates the Anti-Trade protection automatically if you close the trade inventory.\n\nYou are able to deactivate the prevention method at the inventory's context buton menu (small \'flag\' ("..addInvFlagIcon..") symbol at the top left)!",
        ["options_auto_reenable_block_selling"]  = "Reactivate Anti-Sell automatically",
        ["options_auto_reenable_block_selling_TT"]  = "Reactivates the Anti-Sell protection automatically if you close the vendor.\n\nYou are able to deactivate the prevention method at the inventory's context buton menu (small \'flag\' ("..addInvFlagIcon..") symbol at the top left)!",
        ["options_auto_reenable_block_selling_guild_store"]  = "Reactivate guild store Anti-Sell automatically",
        ["options_auto_reenable_block_selling_guild_store_TT"]  = "Reactivates the Anti-Sell protection automatically if you close the guild store.\n\nYou are able to deactivate the prevention method at the inventory's context buton menu (small \'flag\' ("..addInvFlagIcon..") symbol at the top left)!",
        ["options_auto_reenable_block_fence_selling"]  = "Reactivate fence Anti-Sell automatically",
        ["options_auto_reenable_block_fence_selling_TT"]  = "Reactivates the Anti-Sell protection at a fence automatically if you close the fence store.\n\nYou are able to deactivate the prevention method at the inventory's context buton menu (small \'flag\' ("..addInvFlagIcon..") symbol at the top left)!",
        ["options_auto_reenable_block_launder_selling"]  = "Reactivate fence Anti-Launder automatically",
        ["options_auto_reenable_block_launder_selling_TT"]  = "Reactivates the Anti-Launder protection at a fence automatically if you close the fence store.\n\nYou are able to deactivate the prevention method at the inventory's context buton menu (small \'flag\' ("..addInvFlagIcon..") symbol at the top left)!",
        ["options_auto_reenable_block_improvement"]  = "Reactivate Anti-Improvement automatically",
        ["options_auto_reenable_block_improvement_TT"]  = "Reactivates the Anti-Improvement protection automatically if you close the crafting station.\n\nYou are able to deactivate the prevention method at the inventory's context buton menu (small \'flag\' ("..addInvFlagIcon..") symbol at the top left)!",
        ["options_auto_reenable_block_jewelry_improvement"]  = "Reactivate Anti-Jewelry improvement automatically",
        ["options_auto_reenable_block_jewelry_improvement_TT"]  = "Reactivates the Anti-Jewelry improvement protection automatically if you close the crafting station.\n\nYou are able to deactivate the prevention method at the inventory's context buton menu (small \'flag\' ("..addInvFlagIcon..") symbol at the top left)!",
		["options_auto_reenable_block_creation"] 			= "Reactivate Anti-Rune creation automatically",
		["options_auto_reenable_block_creation_TT"]	= "Reactivates the Anti-Rune creation protection automatically if you close the enchantment table.\n\nYou are able to deactivate the prevention method at the inventory's context buton menu (small \'flag\' ("..addInvFlagIcon..") symbol at the top left)!",
		["options_auto_reenable_block_extraction"]			= "Reactivate Anti-Rune extraction automatically",
		["options_auto_reenable_block_extraction_TT"]	= "Reactivates the Anti-Rune extraction protection automatically if you close the enchantment table.\n\nYou are able to deactivate the prevention method at the inventory's context buton menu (small \'flag\' ("..addInvFlagIcon..") symbol at the top left)!",
        ["options_auto_reenable_block_alchemy_destroy"]  = "Reactivate Alchemy Anti-Destroy automatically",
        ["options_auto_reenable_block_alchemy_destroy_TT"]  = "Reactivates the Alchemy Anti-Destroy protection automatically if you close the alchemy station.\n\nYou are able to deactivate the prevention method at the inventory's context buton menu (small \'flag\' ("..addInvFlagIcon..") symbol at the top left)!",

        ["options_header_equipment"] 			 = "Equipment",
        ["options_equipment_markall_gear"] 		 = "Allow mark all as gear",
        ["options_equipment_markall_gear_TT"] = "Allow to mark all equipped items as gear at once, if you mark any equipped item with a gear marker icon",
        ["options_equipment_markall_gear_add_weapons"] 		 = "Mark weapons too",
        ["options_equipment_markall_gear_add_weapons_TT"] = "Automatically mark the weapons too",
        ["options_equipment_markall_gear_add_jewelry"] 		 = "Mark jewelry too",
        ["options_equipment_markall_gear_add_jewelry_TT"] = "Automatically mark the jewelry too",
        ["options_header_filter_buttons"]	= "Filter buttons",
        ["options_filter_button_set_all_equal"]         = "Set all equal",
        ["options_filter_button_set_all_equal_TT"] = "This will set all the filter button positions and sizes to an equal value which you need to choose in the first submenu \"" .. GetString(SI_INVENTORY_MENU_INVENTORY) .. "\"",
        ["options_add_inv_flag_button_set_all_equal_TT"] = "This will set all the additional inventory context menu \'flag\' ("..addInvFlagIcon..") button positions and sizes to an equal value which you need to choose in the first submenu \"" .. GetString(SI_INVENTORY_MENU_INVENTORY) .. "\"",
        ["options_filter_buttons_show_TT"] = "Show tooltip",
        ["options_filter_buttons_show_tooltip_TT"] = "Show a tooltip upon mouse over/clicking a filter button",
		["options_filter_buttons_context_menu_show_TT"] = "Show filter context menu tooltips",
		["options_filter_buttons_context_menu_show_tooltip_TT"] = "Show a tooltip identifying each entry of the filter context menus",
        ["options_filter_buttons_save_for_character"]    = "Filter button state saved for each character",
        ["options_filter_buttons_save_for_character_TT"] = "Enabled: Save the filter button state for each character individually even if account wide settings are enabled.\n\nThis setting will be disabled if account wide settings are disabled!",
        ["options_filter_button_settings"] =                        "Filter settings",
        ["options_filter_button_settings_filterWithLogicalAND"] =   "Logical conj. (Un-/Checked): OR/AND",
        ["options_filter_button_settings_filterWithLogicalAND_and"] = "and",
        ["options_filter_button_settings_filterWithLogicalAND_or"] = "or",
        ["options_filter_button_settings_logical_conjunctions"] = "Logical conjunctions",

        ["options_header_filter_chat"] 			= "Filter & Chat",
        ["options_chat_filter_status"]			= "Filter status in chat",
        ["options_chat_filter_status_TT"] 	= "Show the filter status in chat, if changed?",
		["options_header_destroy"]				= "Destroy",
		["options_header_deconstruction"]		= "Deconstruction",
		["options_header_research"]				= "Research",
		["options_header_improvement"]			= "Improvement",
		["options_header_mail"]					= "Mail",
		["options_header_trade"]				= "Trade",
		["options_header_rune_creation"]		= "Rune creation",
		["options_header_rune_extraction"]		= "Glyph extraction",
		["options_header_sell"]					= "Sell",
		["options_header_sell_at_guild_store"]	= "Sell at guild store",
		["options_header_fence"]				= "Fence",
		["options_header_launder"]				= "Launder",
		["options_header_alchemy_destroy"]		= "Alchemy",
		["options_header_recipes"]				= "Recipes",
		["options_header_containers"]			= "Containers",
		["options_header_anti_output_options"]	= "Output options",
        --Additional buttons
        ["options_header_additional_buttons"]						 = "Additional buttons",
        ["options_additional_buttons_FCOIS_settings"] 				 = "FCO settings in main menu",
        ["options_additional_buttons_FCOIS_settings_TT"] 		 = "Show an additonal button for the FCOItemSaver settings inside the main menu of the game (right to the help button).\n\n[Attention] The button will only be shown if the addon settings button of the addon 'Votans Settings Menu' is not shown!",
        ["options_additional_buttons_FCOIS_additional_options"] 		= "Addit. options in inventories ("..addInvFlagIcon..")",
        ["options_additional_buttons_FCOIS_additional_options_TT"] = "Show an additional button for more options (mark all/unmark all/undo last change) in the inventories.\nThe button will be shown as a small \'flag\' ("..addInvFlagIcon..") symbol at the top-left edge of the inventories and it will show a context menu if you left click |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_LMB.dds|t it.\nIf you right click |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t it it will change the protective state (anti-* setting) of the currently shown panel.",
        ["options_additional_buttons_FCOIS_additional_options_colorize"] 		= "Protection state as color at "..addInvFlagIcon,
        ["options_additional_buttons_FCOIS_additional_options_colorize_TT"]     = "Colors the additional inventory options \'flag\' ("..addInvFlagIcon..") button green/red if the protective functionality for the currently shown panel is enabled/disabled.",
        ["options_additional_buttons_FCOIS_additional_options_offsets"]         = "Add. inv. "..addInvFlagIcon.." button offsets",
        ["options_additional_buttons_FCOIS_additional_options_offsetx"]         = "Offset X",
        ["options_additional_buttons_FCOIS_additional_options_offsetx_TT"] = "Move the additional inventory \'flag\' ("..addInvFlagIcon..") button on the x axis. Standard value is 0.",
        ["options_additional_buttons_FCOIS_additional_options_offsety"]         = "Offset Y",
        ["options_additional_buttons_FCOIS_additional_options_offsety_TT"] = "Move the additional inventory \'flag\' ("..addInvFlagIcon..") button on the y axis. Standard value is 0.",
        ["button_FCOIS_settings_TT"]							 = "Show FCOItemSaver settings",
		--Anti equip
		["options_header_anti_equip"]					= "Anti equip",
		["options_askBeforeEquipBoundItems"]			= "Ask before binding items",
		["options_askBeforeEquipBoundItems_TT"]	= "Shows a confirmation dialog if you try to bind an item to your account",
		["options_anti_equip_question"]					= "Bind <<!A:1>> \nto your account?",
		--Stolen
        ["options_header_stolen"]				 = "Stolen",
		["options_show_stolen_icon"]			 = "Show stolen items filter",
		["options_show_stolen_icon_TT"]     = "Show an additional filter icon in the inventories for stolen items. It will always be shown to the right of the last active filter icon (standard: Coins icon).",
        --Other options
		["options_split_lockdyn_filter"]		 = "Split lock icon & show dynamic icons",
        ["options_split_lockdyn_filter_TT"] = "Split the 1st filter button up into the lock icon & additional dynamically configurable icons. If you right-click |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t the 1st filter button in the inventories it'll show a dropdown menu where you can choose each icon individually, which you wish to filter. The entry * will select all entries again.",
        ["options_split_gearsets_filter"]		 = "Split gear sets (1/2/3/4/5) filter button",
        ["options_split_gearsets_filter_TT"]= "Split the gear sets filter button. If you right-click |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t the gear sets filter button in the inventories it'll show a dropdown menu where you can choose each gear set individually, which you wish to filter. The entry * will select all entries again.",
        ["options_split_resdecimp_filter"]		 	 = "Split research (decon./improve) filter button",
        ["options_split_resdecimp_filter_TT"]= "Split the research filter icon button. If you right-click |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t the research filter button in the inventories it'll show a dropdown menu where you can choose if you wish to filter research, deconstruction or improvement icons. The entry * will select all entries again.",
        ["options_split_sellguildint_filter"]		 = "Split sell (at guild store/intricate) filter button",
        ["options_split_sellguildint_filter_TT"]= "Split the sell filter icon. If you right-click |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t the sell filter button in the inventories it'll show a dropdown menu where you can choose if you wish to filter sellable, sellable at guild store or intricate icons. The entry * will select all entries again.",
        --Right click item menu
        ["rightclick_menu_remove_all"]           = "Remove all icons",
        ["rightclick_menu_restore_last"]         = "Restore (%s) removed icons",
        ["rightclick_menu_lock"]       	 		 = "Lock",
        ["rightclick_menu_unlock"]         	     = "Unlock",
        ["rightclick_menu_add_gear1"]        	 = "Add to gear 1",
        ["rightclick_menu_add_all_gear1"]        = "Add all to gear 1",
        ["rightclick_menu_remove_gear1"]         = "Remove from gear 1",
        ["rightclick_menu_remove_all_gear1"]     = "Remove all from gear 1",
        ["rightclick_menu_add_gear2"]       	 = "Add to gear 2",
        ["rightclick_menu_add_all_gear2"]        = "Add all to gear 2",
        ["rightclick_menu_remove_gear2"]         = "Remove from gear 2",
        ["rightclick_menu_remove_all_gear2"]     = "Remove all from gear 2",
        ["rightclick_menu_add_gear3"]        	 = "Add to gear 3",
        ["rightclick_menu_add_all_gear3"]        	 = "Add all to gear 3",
        ["rightclick_menu_remove_gear3"]         = "Remove from gear 3",
        ["rightclick_menu_remove_all_gear3"]         = "Remove all from gear 3",
        ["rightclick_menu_add_gear4"]        	 = "Add to gear 4",
        ["rightclick_menu_add_all_gear4"]        	 = "Add all to gear 4",
        ["rightclick_menu_remove_gear4"]         = "Remove from gear 4",
        ["rightclick_menu_remove_all_gear4"]         = "Remove all from gear 4",
        ["rightclick_menu_add_gear5"]        	 = "Add to gear 5",
        ["rightclick_menu_add_all_gear5"]        	 = "Add all to gear 5",
        ["rightclick_menu_remove_gear5"]         = "Remove from gear 5",
        ["rightclick_menu_remove_all_gear5"]         = "Remove all from gear 5",
        ["rightclick_menu_mark_analysis"]        = "Reserve research",
        ["rightclick_menu_demark_analysis"]      = "Abort research",
        ["rightclick_menu_mark_sell"]        	 = "Mark for selling",
        ["rightclick_menu_demark_sell"]          = "Unmark selling",
        ["rightclick_menu_mark_sell_in_guild_store"]    = "Mark selling at guild store",
        ["rightclick_menu_demark_sell_in_guild_store"]  = "Unmark selling at guild store",
        ["rightclick_menu_mark_intricate"]      = "Mark as intricate",
        ["rightclick_menu_demark_intricate"]    = "Unmark as intricate",
        ["rightclick_menu_mark_deconstruction"]  = "Mark for deconstruction",
        ["rightclick_menu_demark_deconstruction"]= "Unmark deconstruction",
        ["rightclick_menu_mark_improvement"]     = "Mark for improvement",
        ["rightclick_menu_demark_improvement"]   = "Unmark improvement",
        ["rightclick_menu_add_start_gear"]       = "Add to ",
        ["rightclick_menu_add_all_start_gear"]   = "Add all to ",
        ["rightclick_menu_remove_start_gear"]    = "Remove from ",
        ["rightclick_menu_remove_all_start_gear"]= "Remove all from ",
		["rightclick_menu_add_dynamic"]		 	 = "+",
		["rightclick_menu_remove_dynamic"]		 = "-",
		--Button context menu
		["button_context_menu_TT"]			 = "Additional options",
        ["button_context_menu_lock_all"]	 	 = "Lock all",
        ["button_context_menu_unlock_all"]	 	 = "Unlock all",
        ["button_context_menu_research_all"]	 = "+ Research",
        ["button_context_menu_dont_research_all"]= "- Research",
        ["button_context_menu_deconstruct_all"]	 	= "+ Deconstruction",
        ["button_context_menu_dont_deconstruct_all"]= "- Deconstruction",
        ["button_context_menu_improve_all"]	 		= "+ Improvement",
        ["button_context_menu_dont_improve_all"]	= "- Improvement",
        ["button_context_menu_sell_all"]	 	 = "+ Selling",
        ["button_context_menu_dont_sell_all"]	 = "- Selling",
        ["button_context_menu_sell_all_in_guild_store"]	 	= "+ Sell at guild store",
        ["button_context_menu_dont_sell_all_in_guild_store"]= "- Sell at guild store",
        ["button_context_menu_mark_all_as_intricate"]       = "+ Intricate",
        ["button_context_menu_unmark_all_as_intricate"]     = "- Intricate",
        ["button_context_menu_remove_all_gears"] = "Remove all gears",
        ["button_context_menu_demark_all"]	 	 = "Remove all marks",
        ["button_context_menu_undo"]	 		 = "< Undo last change",
        ["button_context_menu_addAllToJunk"]     = "~> Add all to junk ~",
        ["button_context_menu_removeAllFromJunk"]= "<~ Remove all from junk",
		["button_context_menu_toggle_anti_destroy_on"] = "Activate 'Anti-Destroy'",
		["button_context_menu_toggle_anti_destroy_off"] = "Deactivate 'Anti-Destroy'",
		["button_context_menu_toggle_anti_improve_on"] = "Activate 'Anti-Improve'",
		["button_context_menu_toggle_anti_improve_off"] = "Deactivate 'Anti-Improve'",
		["button_context_menu_toggle_anti_deconstruct_on"] = "Activate 'Anti-Deconstruct'",
		["button_context_menu_toggle_anti_deconstruct_off"] = "Deactivate 'Anti-Deconstruct'",
		["button_context_menu_toggle_anti_create_on"] = "Activate 'Anti-Creation'",
		["button_context_menu_toggle_anti_create_off"] = "Deactivate 'Anti-Creation'",
		["button_context_menu_toggle_anti_extract_on"] = "Activate 'Anti-Extraction'",
		["button_context_menu_toggle_anti_extract_off"] = "Deactivate 'Anti-Extraction'",
		["button_context_menu_toggle_anti_mail_on"] = "Activate 'Anti-Mail'",
		["button_context_menu_toggle_anti_mail_off"] = "Deactivate 'Anti-Mail'",
		["button_context_menu_toggle_anti_sell_on"] = "Activate 'Anti-Sell'",
		["button_context_menu_toggle_anti_sell_off"] = "Deactivate 'Anti-Sell'",
		["button_context_menu_toggle_anti_fence_sell_on"] = "Activate fence 'Anti-Sell'",
		["button_context_menu_toggle_anti_fence_sell_off"] = "Deactivate fence 'Anti-Sell'",
		["button_context_menu_toggle_anti_launder_sell_on"] = "Activate fence 'Anti-Launder'",
		["button_context_menu_toggle_anti_launder_sell_off"] = "Deactivate fence 'Anti-Launder'",
		["button_context_menu_toggle_anti_trade_on"] = "Activate 'Anti-Trade'",
		["button_context_menu_toggle_anti_trade_off"] = "Deactivate 'Anti-Trade'",
        ["button_context_menu_toggle_anti_alchemy_on"] = "Activate 'Anti-Alchemy'",
        ["button_context_menu_toggle_anti_alchemy_off"] = "Dectivate 'Anti-Alchemy'",
        ["button_context_menu_toggle_anti_guild_bank_deposit_without_withdraw_rights_on"] = "Activate 'Anti-Deposit w/o withdraw rights'",
        ["button_context_menu_toggle_anti_guild_bank_deposit_without_withdraw_rights_off"] = "Deactivate 'Anti-Deposit w/o withdraw rights'",
        ["button_context_menu_toggle_anti_refine_on"] 		= "Activate 'Anti-Refine'",
        ["button_context_menu_toggle_anti_refine_off"]		= "Deactivate 'Anti-Refine'",
        ["button_context_menu_gear_sets_all"]	 	 = "*",
        ["button_context_menu_gear_sets_all_TT"]= "All gear sets",
        ["button_context_menu_all_markers_TT"]	 = "All markers",
		["options_enable_filter_in_refinement"]				= "Enable filter at refinement",
		["options_enable_filter_in_refinement_TT"]	 	= "Enables you to hide the marked items during refinement at crafting stations",
		["refinement_not_allowed"]							= "Refinement not allowed:",
		["options_enable_block_refinement"]                 = "Deactivate refinement",
		["options_enable_block_refinement_TT"]         = "Deactivate refinement of marked items inside the crafting stations",
        ["options_enable_block_jewelry_refinement"]                 = "Deactivate jewelry refinement",
        ["options_enable_block_jewelry_refinement_TT"]         = "Deactivate jewelry refinement of marked items inside the crafting stations",
        ["research_not_allowed"]							= "Research not allowed:",
        ["options_enable_block_research"]                   = "Deactivate research",
        ["options_enable_block_research_TT"]           = "Deactivate research of marked items inside the crafting stations",
        ["options_enable_block_jewelry_research"]              = "Deactivate jewelry research",
        ["options_enable_block_jewelry_research_TT"]           = "Deactivate research of marked items inside the jewelry crafting stations",
		["options_header_refinement"]                       = "Refinement",
		["options_auto_reenable_block_refinement"]          = "Reactivate Anti-Refinement automatically",
		["options_auto_reenable_block_refinement_TT"]  = "Reactivates the Anti-Refinement protection automatically if you close the crafting station.\n\nYou are able to deactivate the prevention method at the inventory's context buton menu (small \'flag\' ("..addInvFlagIcon..") symbol at the top left)!",
        ["options_auto_reenable_block_jewelry_refinement"]          = "Reactivate Anti-Jewelry refinement automatically",
        ["options_auto_reenable_block_jewelry_refinement_TT"]  = "Reactivates the Anti-Jewelry refinement protection automatically if you close the crafting station.\n\nYou are able to deactivate the prevention method at the inventory's context buton menu (small \'flag\' ("..addInvFlagIcon..") symbol at the top left)!",
		["options_prevent_auto_marking_if_this_icon_set"]    = "Prevent auto-marking with others",
		["options_prevent_auto_marking_if_this_icon_set_TT"] = "Prevent the automatic marking of items with any marker icon if this icon is set",
        ["options_auto_remove_if_banked"]                   = "Auto-remove if banked",
		["options_auto_remove_if_banked_TT"]                = "Automatically remove this icon if the item will be put into the bank",
        ["options_auto_remove_if_guild_banked"]             = "Auto-remove if guild-banked",
		["options_auto_remove_if_guild_banked_TT"]          = "Automatically remove this icon if the item will be put into a guild bank",
        ["options_prevent_auto_marking_deconstruction"] 	= "Prevent auto-marking again (Deconstruction)",
		["options_prevent_auto_marking_deconstruction_TT"] = "Prevent the automatic marking of items with any marker icon if the 'marked for deconstruction' icon was set",
		["options_prevent_auto_marking_sell"] 	= "Prevent auto-marking again (Sell)",
		["options_prevent_auto_marking_sell_TT"] = "Prevent the automatic marking of items with any marker icon if the 'sell' icon was set" ,
        ["options_prevent_auto_marking_sell_guild_store"] 	= "Prevent auto-marking again (Sell in guild store)",
        ["options_prevent_auto_marking_sell_guild_store_TT"] = "Prevent the automatic marking of items with any marker icon if the 'sell in guild store' icon was set",
        --Chat commands
        ["chatcommands_info"]					 = "|c00FF00FCO|cFFFF00Item Saver|cFFFFFF Set icons for your items to save & filter them",
        ["chatcommands_help"]					 = "|cFFFFFF'help' / 'list'|cFFFF00: Shows this information about the addon. Type |cFFFFFF'donate' / 'feedback' / 'bug' / 'msg'|cFFFF00 to show the feedback window|r",
        ["chatcommands_status"] 				 = "|cFFFFFF'status' / ''|cFFFF00: Shows actually enabled filters",
        ["chatcommands_filter1"]				 = "|cFFFFFF'filter1'|cFFFF00: Show/Hide category 1 (lock symbol) items",
        ["chatcommands_filter2"]				 = "|cFFFFFF'filter2'|cFFFF00: Show/Hide category 2 (helmet symbol) items",
        ["chatcommands_filter3"]				 = "|cFFFFFF'filter3'|cFFFF00: Show/Hide category 3 (research symbol) items",
        ["chatcommands_filter4"]				 = "|cFFFFFF'filter4'|cFFFF00: Show/Hide category 4 (coins symbol) items",
        ["chatcommands_filter"]				 	 = "|cFFFFFF'filter'|cFFFF00: Show/Hide category 1 - 4 items" ,
        ["chatcommands_filteron"]				 = "|cFFFFFF'alloff'|cFFFF00: Show categories 1 to 4 items",
        ["chatcommands_filteroff"]				 = "|cFFFFFF'allon'|cFFFF00: Hide categories 1 to 4 items",
        ["chatcommands_filtershow"]				 = "|cFFFFFF'allshow'|cFFFF00: Only show marked items of categories 1 to 4 ",
		["chatcommands_split_filter"]			 = "|cFFFFFF'split'|cFFFF00: Enable/Disable individual filters at inventory, vendor, guild bank, guild store, bank, crafting stations, enchanting station, mail and trade panels",
        ["chatcommands_filterpanels"]			 = "|c990000Possible |cFFFFFF<filterPanel>|cFFFF00:",
        ["chatcommands_filtervalues"]			 = "|c990000Possible |cFFFFFF<filterValue>|cFFFF00: |cFFFFFFtrue|cFFFF00 / |cFFFFFFfalse|cFFFF00 / |cFFFFFFshow",
        ["chatcommands_filter1_new"]			 = "|cFFFFFF'filter1 <filterPanel> <filterValue>'|cFFFF00: Hide |cFFFFFF<true>|cFFFF00 / show |cFFFFFF<false>|cFFFF00 / only show marked |cFFFFFF<show>|cFFFF00 items of catergory 1 (lock symbol) at panel |cFFFFFF<filterPanel>",
        ["chatcommands_filter2_new"]			 = "|cFFFFFF'filter2 <filterPanel> <filterValue>'|cFFFF00: Hide |cFFFFFF<true>|cFFFF00 / show |cFFFFFF<false>|cFFFF00 / only show marked |cFFFFFF<show>|cFFFF00 items of catergory 2 (helmet symbol) at panel |cFFFFFF<filterPanel>",
        ["chatcommands_filter3_new"]			 = "|cFFFFFF'filter3 <filterPanel> <filterValue>'|cFFFF00: Hide |cFFFFFF<true>|cFFFF00 / show |cFFFFFF<false>|cFFFF00 / only show marked |cFFFFFF<show>|cFFFF00 items of catergory 3 (research symbol) at panel |cFFFFFF<filterPanel>",
        ["chatcommands_filter4_new"]			 = "|cFFFFFF'filter4 <filterPanel> <filterValue>'|cFFFF00: Hide |cFFFFFF<true>|cFFFF00 / show |cFFFFFF<false>|cFFFF00 / only show marked |cFFFFFF<show>|cFFFF00 items of catergory 4 (coins symbol) at panel |cFFFFFF<filterPanel>",
        ["chatcommands_filter_new"]				 = "|cFFFFFF'filter <filterPanel> <filterValue>'|cFFFF00: Hide |cFFFFFF<true>|cFFFF00 / show |cFFFFFF<false>|cFFFF00 / only show marked |cFFFFFF<show>|cFFFF00 items of catergory 1 to 4 at panel |cFFFFFF<filterPanel>",
        ["chatcommands_filteron_new"]			 = "|cFFFFFF'allon <filterPanel>'|cFFFF00: Hide categories 1 to 4 at panel |cFFFFFF<filterPanel>",
        ["chatcommands_filteroff_new"]			 = "|cFFFFFF'alloff <filterPanel>'|cFFFF00: Show categories 1 to 4 at panel |cFFFFFF<filterPanel>",
        ["chatcommands_filtershow_new"]			 = "|cFFFFFF'allshow <filterPanel>'|cFFFF00: Only show marked items of the categories 1 to 4 at panel |cFFFFFF<filterPanel>",
        ["chatcommands_debug"]					 = "|cFFFFFF'debug'|cFFFF00: Enable/Disable debug messages. |c990000[Attention]|cFFFF00 This will  flood your local chat!",
        ["chatcommands_status_info"]             = "|c00FF00FCO|cFFFF00Item Saver|cFFFFFF Activated filters:",
        ["chatcommands_status_nofilters"]        = "|c00FF00FCO|cFFFF00Item Saver|cFF0000 No filters activated",
        ["chatcommands_status_filter1"]          = "Lock filter: ON",
        ["chatcommands_status_filter2"]          = "Gear filter: ON",
        ["chatcommands_status_filter3"]          = "Research filter: ON",
        ["chatcommands_status_filter4"]          = "Sell filter: ON",
        ["chatcommands_debug_on"]				 = "Debug: ON",
        ["chatcommands_debug_off"]				 = "Debug: OFF",
        ["chatcommands_deepdebug_on"]			 = "Deep debug: ON",
        ["chatcommands_deepdebug_off"]			 = "Deep debug: OFF",
		["chatcommands_debugdepth"]				 = "Debug depth: ",
        --Filters
        ["filter1_off"] 						 = "Lock filter OFF",
        ["filter1_on"] 						 	 = "Lock filter ON",
	    ["filter1_onlyfiltered"] 				 = "Lock filter SHOWS ONLY FILTERED",
        ["filter1_split_off"] 					 = "Filter OFF",
        ["filter1_split_on"] 					 = "Filter ON",
	    ["filter1_split_onlyfiltered"] 			 = "Filter SHOWS ONLY FILTERED",
        ["filter2_off"] 						 = "Gear filter OFF",
        ["filter2_on"] 						 	 = "Gear filter ON",
	    ["filter2_onlyfiltered"] 				 = "Gear filter SHOWS ONLY FILTERED",
        ["filter3_off"] 						 = "Research/Deconstruction/Improvement filter OFF",
        ["filter3_on"] 						 	 = "Research/Deconstruction/Improvement filter ON",
	    ["filter3_onlyfiltered"] 				 = "Research/Deconstruction/Improvement filter SHOWS ONLY FILTERED",
        ["filter3_split_off"] 					 = "Filter OFF",
        ["filter3_split_on"] 					 = "Filter ON",
	    ["filter3_split_onlyfiltered"] 			 = "Filter SHOWS ONLY FILTERED",

        ["filter4_off"] 						 = "Sell/Sell at guild store/Intricate filter OFF",
        ["filter4_on"] 						 	 = "Sell/Sell at guild store/Intricate filter ON",
        ["filter4_onlyfiltered"] 				 = "Sell/Sell at guild store/Intricate filter SHOWS ONLY FILTERED",
        ["filter4_split_off"] 					 = "Filter OFF",
        ["filter4_split_on"] 			     	 = "Filter ON",
	    ["filter4_split_onlyfiltered"] 			 = "Filter SHOWS ONLY FILTERED",

        ["filter_ABORT"] 						 = "Not enabled in settings!",
		["filter_inventory"]	= "[Player inventory] ",
		["filter_craftbag"]		= "[Crafting bag] ",
		["filter_guildbank"]	= "[Guild bank] ",
		["filter_guildstore"]	= "[Guild store] ",
		["filter_bank"]			= "[Bank] ",
        ["filter_house_bank"]	= "[House bank] ",
		["filter_alchemy"]		= "[Alchemy] ",
        ["filter_refinement"]		= "[Refinement] ",
		["filter_deconstruction"]	= "[Deconstruction] ",
		["filter_improvement"]	= "[Improvement] ",
        ["filter_jewelry_refinement"]		= "[Jewelry refinement] ",
        ["filter_jewelry_deconstruction"]	= "[Jewelry deconstruction] ",
        ["filter_jewelry_improvement"]	    = "[Jewelry improvement] ",
        ["filter_research"]		= "[Research] ",
        ["filter_jewelry_research"]		= "[Jewelry research] ",
		["filter_enchantingstation_extraction"] = "[Enchanting extraction] ",
		["filter_enchantingstation_creation"] = "[Enchanting creation] ",
		["filter_store"] = "[Store] ",
		["filter_fence"] = "[Fence] ",
		["filter_launder"] = "[Launder] ",
		["filter_mail"] = "[Mail] ",
		["filter_trade"] = "[Trading] ",
        ["filter_gears_all"]					 = "All gear sets",
        ["filter_resdecimp_all"]				 = "Research/Deconstruction/Improvement",
        ["filter_resdecimp_1"]					 = "Research",
        ["filter_resdecimp_2"]					 = "Deconstruction",
        ["filter_resdecimp_3"]					 = "Improvement",
        ["filter_sellguildint_all"]				 = "Sell/Sell at guild store/Intricate",
        ["filter_sellguildint_1"]				 = "Sell",
        ["filter_sellguildint_2"]				 = "Sell at guild store",
        ["filter_sellguildint_3"]				 = "Intricate",
		--Messages to chat
		["show_anti_messages_in_chat"] 	  		 = "Show warning in chat",
		["show_anti_messages_in_chat_TT"] 	 = "Show a warning message with the item name inside the chat window",
		["show_anti_messages_as_alert"] 		 = "Show warning as alert",
		["show_anti_messages_as_alert_TT"]	 = "Show a warning message with the item name at the alert window & play a deny sound",
		["deconstruction_not_allowed"]			 = "Deconstruction not allowed:",
		["destroying_not_allowed"]			     = "Destroying not allowed:",
        ["sendbymail_not_allowed"]				 = "Sending not allowed:",
        ["trading_not_allowed"]				     = "Trading not allowed:",
        ["selling_not_allowed"]				     = "Selling not allowed:",
        ["fence_selling_not_allowed"]			 = "Selling at fence not allowed:",
        ["launder_selling_not_allowed"]			 = "Laundering at fence not allowed:",
        ["improvement_not_allowed"]			     = "Improvement not allowed:",
		["enchanting_creation_not_allowed"] 	 = "Creation/Deconstruction not allowed:",
		["enchanting_extraction_not_allowed"] 	 = "Extraction not allowed:",
		["guild_store_sell_not_allowed"]		 = "Selling at guild store not allowed:",
        ["alchemy_destroy_not_allowed"]			 = "Destroying alchemy item not allowed:",
		["container_autoloot_not_allowed"]		 = "Autoloot of container not allowed:",
		["recipe_usage_not_allowed"]			 = "Reading recipe not allowed:",
		["motif_usage_not_allowed"]			 	 = "Reading style-motif not allowed:",
		["potion_usage_not_allowed"]		 	 = "Drinking potion not allowed:",
		["food_usage_not_allowed"]			 	 = "Eating food not allowed:",
        ["crown_item_usage_not_allowed"]         = "Using " .. GetString(SI_ITEMTYPE57) .. " not allowed:",
        ["marked"]								 = "Marked [",
        ["set_collection_part_known_found"]      = "] as known set-collection item",
        ["set_collection_part_unknown_found"]    = "] as unknown set-collection item",
        ["ornate_item_found"]    				 = "] as ornate",
        ["intricate_item_found"]    			 = "] as intricate",
		["research_item_found"]                  = "] as researchable",
        ["researchScroll_item_found"]            = "] as wasted research scroll",
        ["set_part_found"]						 = "] as set part",
		["set_part_non_wished_found"]			 = "] as non-desired set part",
		["quality_item_found"]                  = "] because of item's quality",
		["known_recipe_found"]				= "] as known recipe",
		["unknown_recipe_found"]				= "] as unknown recipe",
        ["options_enable_auto_mark_quality_items"] = "Mark items with quality",
        ["options_enable_auto_mark_quality_items_TT"] =  "Automatically mark items with icon if there quality equals the selected quality",
        ["options_enable_auto_mark_higher_quality_items"] = "Mark higher quality too",
        ["options_enable_auto_mark_higher_quality_items_TT"] =  "Automatically mark items with a higher quality than the selected above?",
        ["options_enable_auto_mark_quality_items_in_chat"] = "Show items in chat",
        ["options_enable_auto_mark_quality_items_in_chat_TT"] =  "Show automatically marked items by quality in the chat",
		["options_auto_mark_quality_icon_no_armor"]			= "No armor, jewelry & weapons",
		["options_auto_mark_quality_icon_no_armor_TT"]	= "Do not automatically mark armor, jewelry and weapons with the quality marker.",
        ["options_quality"] 		    = GetString(SI_MASTER_WRIT_DESCRIPTION_QUALITY),
        ["options_level"] 		        = GetString(SI_ITEM_FORMAT_STR_LEVEL),
        ["options_all"] 		        = GetString(SI_BUFFS_OPTIONS_ALL_ENABLED),
        ["options_any"] 		        = "Any of them (single check)",
		["options_quality_OFF"] 		= "-DISABLED-",
		["options_quality_trash"] 		= "Trash",
		["options_quality_normal"] 		= "Normal",
		["options_quality_magic"] 		= "Magic",
		["options_quality_arcane"] 		= "Arcane",
		["options_quality_artifact"] 	= "Artifact",
		["options_quality_legendary"] 	= "Legendary",
		--Key bindings
		["SI_BINDING_NAME_FCOISFILTER1"]		 = "Change Filter 1",
		["SI_BINDING_NAME_FCOISFILTER2"]		 = "Change Filter 2",
		["SI_BINDING_NAME_FCOISFILTER3"]		 = "Change Filter 3",
		["SI_BINDING_NAME_FCOISFILTER4"]	 	 = "Change Filter 4",
        ["SI_BINDING_NAME_FCOIS_SETTINGS_MENU"]  = "FCOItemSaver settings",
		["SI_BINDING_NAME_FCOIS_MARK_ITEM_WITH_STANDARD_ICON"] = "Mark with standard icon",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_CYCLE_UP"]   = "Mark with next icon",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_CYCLE_DOWN"] = "Mark with previous icon",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_1"]  	 = "Mark with 'lock' icon",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_3"]  	 = "Mark with 'research' icon",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_5"]  	 = "Mark with 'sell' icon",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_9"]  	 = "Mark with 'deconstruction' icon",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_10"]  	 = "Mark with 'improvement' icon",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_11"]  	 = "Mark with 'sell in guild store' icon",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_12"]  	 = "Mark with 'intricate' icon",
        ["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_1"]  	 = "Mark with gear set 1",
        ["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_2"]  	 = "Mark with gear set 2",
        ["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_3"]  	 = "Mark with gear set 3",
        ["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_4"]  	 = "Mark with gear set 4",
        ["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_5"]  	 = "Mark with gear set 5",
        ["SI_BINDING_NAME_FCOIS_JUNK_ALL_SELL"]      = "%s->Junk",
        ["SI_BINDING_NAME_FCOIS_JUNK_AND_MARK_SELL_ITEM"] = "Junk",
        ["SI_BINDING_NAME_FCOIS_REMOVE_ALL_MARKER_ICONS_AND_UNDO"] = "Remove all markers/undo",
        ["options_keybind_move_marked_for_sell_to_junk_enabled"]    = "Enable 'Sell marked->Junk' keybind",
        ["options_keybind_move_marked_for_sell_to_junk_enabled_TT"] = "Enable a keybind in the inventories to move all items marked for sell to the junk.",
        ["fcois_junked_item_count"] = "Junked %s item(s)",
        ["fcois_unjunked_item_count"] = "Unjunked %s item(s)",
        --Error messages
        ["error_gamepad_mode_not_supported"]	= "FCOItemSaver does not support the gamepad mode! Please change the mode to keyboard at the settings.",

        --Crown Store items
        ["options_header_crownstore"]                    = GetString(SI_ITEMTYPE57), --Crown item
        ["options_enable_block_crownstoreitems"]         = "Block usage of " .. GetString(SI_ITEMTYPE57),
        ["options_enable_block_crownstoreitems_TT"] = "Block the usage of " .. GetString(SI_ITEMTYPE57) .. " which are marked with a marker icon",
        --Transmutation / Retrait
        ["options_header_transmutation"]          = GetString(SI_RETRAIT_STATION_ITEM_TO_RETRAIT_HEADER), --Transmutation
        ["filter_retrait"]                        = "[Retrait]",
        ["filter_companion_inventory"]            = "[" .. GetString(SI_UNIT_FRAME_NAME_COMPANION) .." inventory]",
        ["retrait_not_allowed"]                   = GetString(SI_RETRAIT_STATION_PERFORM_RETRAIT) .. " not allowed:",
        ["button_context_menu_toggle_anti_retrait_on"]  = "Activate 'Anti-Retrait'",
        ["button_context_menu_toggle_anti_retrait_off"] = "Deactivate 'Anti-Retrait'",
        ["options_enable_block_retrait"]          = "Deactivate retrait",
        ["options_enable_block_retrait_TT"]  = "Deactivate retraiting of marked items inside the transmutation stations",
        ["options_enable_filter_in_retrait"]		 = "Enable filter at ".. GetString(SI_RETRAIT_STATION_ITEM_TO_RETRAIT_HEADER).." station",
        ["options_enable_filter_in_retrait_TT"] = "Enables you to hide the marked items at a " .. GetString(SI_RETRAIT_STATION_ITEM_TO_RETRAIT_HEADER).. " station",
        ["options_enable_filter_in_companion_inventory"]	= "Enable filter at ".. GetString(SI_UNIT_FRAME_NAME_COMPANION).." inventory",
        ["options_enable_filter_in_companion_inventory_TT"] = "Enables you to hide the marked items at a " .. GetString(SI_UNIT_FRAME_NAME_COMPANION).. " inventory",
        --Master Writs
        ["options_auto_mark_crafted_writ_items"] 			= "Mark crafted writ items",
        ["options_auto_mark_crafted_writ_items_TT"] 	= "If you enable this setting the addon will automatically mark your crafted writ items, which you craft with the addon \'Dolgubons Lazy Writ Creator\', at a crafting station with the chosen icon from below.",
        ["options_auto_mark_crafted_writ_items_icon"]		=	"Crafted writ items icon",
        ["options_auto_mark_crafted_writ_items_icon_TT"]=	"Icon for the automatically marked crafted writ items",
        ["options_auto_mark_crafted_masterwrit_items_icon"]		=	"Crafted master writ items icon",
        ["options_auto_mark_crafted_masterwrit_items_icon_TT"]=	"Icon for the automatically marked crafted master writ items",
        --Allowed crafting types for automatic craft markers
        ["options_auto_mark_crafted_items_panel_alchemy"]               = GetString(SI_ITEMFILTERTYPE16),
        ["options_auto_mark_crafted_items_panel_alchemy_TT"]       = GetString(SI_ITEMFILTERTYPE16),
        ["options_auto_mark_crafted_items_panel_blacksmithing"]         = GetString(SI_ITEMFILTERTYPE13),
        ["options_auto_mark_crafted_items_panel_blacksmithing_TT"] = GetString(SI_ITEMFILTERTYPE13),
        ["options_auto_mark_crafted_items_panel_clothier"]              = GetString(SI_ITEMFILTERTYPE14),
        ["options_auto_mark_crafted_items_panel_clothier_TT"]      = GetString(SI_ITEMFILTERTYPE14),
        ["options_auto_mark_crafted_items_panel_enchanting"]            = GetString(SI_ITEMFILTERTYPE17),
        ["options_auto_mark_crafted_items_panel_enchanting_TT"]    = GetString(SI_ITEMFILTERTYPE17),
        ["options_auto_mark_crafted_items_panel_provisioning"]          = GetString(SI_ITEMFILTERTYPE18),
        ["options_auto_mark_crafted_items_panel_provisioning_TT"]  = GetString(SI_ITEMFILTERTYPE18),
        ["options_auto_mark_crafted_items_panel_woodworking"]           = GetString(SI_ITEMFILTERTYPE15),
        ["options_auto_mark_crafted_items_panel_woodworking_TT"]   = GetString(SI_ITEMFILTERTYPE15),
        ["options_auto_mark_crafted_items_panel_jewelry"]               = GetString(SI_ITEMFILTERTYPE24),
        ["options_auto_mark_crafted_items_panel_jewelry_TT"]       = GetString(SI_ITEMFILTERTYPE24),

        --Transmutation geode container opening
        ["options_enable_block_transmutation_dialog_title"]                = "Transmutation crystals",
        ["options_enable_block_transmutation_dialog_question"]             = "Do you really want to loot more crystals?\nYou already got <<1>>/<<2>>",
        ["options_enable_block_transmutation_dialog_max_withdraw"]         = "Ask if transmutation crystals are near max",
        ["options_enable_block_transmutation_dialog_max_withdraw_TT"] = "Show a dialog asking you if the current transmutation crystal count is near the maximum value, and if you try to loot more crystals.\nIf you loot more crystals then the maximum the rest will be deleted!",
        --Context menu entries: Start with icon, color it like icon color and set icon size
        ["options_contextmenu_leading_icon"]                = "Show leading icon",
        ["options_contextmenu_leading_icon_TT"]        = "Show the context menu's entry with the marker icon",
        ["options_contextmenu_use_icon_color"]              = "Use icon color",
        ["options_contextmenu_use_icon_color_TT"]      = "Use the icon's color fo the context menu entry.\nThe custom color you have choosen will be still applied to marked entries!",
        ["options_contextmenu_leading_icon_size"]           = "Icon size",
        ["options_contextmenu_leading_icon_size_TT"]   = "Change the size of the context menu icon",
        ["options_contextmenu_show_menu_item_tooltip"] = "Show menu item tooltip",
        ["options_contextmenu_show_menu_item_tooltip_TT"] = "Show a tooltip at each menu item this addon adds to context menus.",
        ["options_contextmenu_show_menu_item_tooltip_protected_panels"] = "Tooltip: Protected panels",
        ["options_contextmenu_show_menu_item_tooltip_protected_panels_TT"] = "Add information about the protected panels to the menu item tooltip.",
        ["options_contextmenu_entries_enable_tooltip"]              = "Show tooltip at entry",
        ["options_contextmenu_entries_enable_tooltip_TT"]           = "Show a tooltip at the context menu entries.",
        ["options_contextmenu_entries_enable_tooltip_only_SHIFTkey"]              = "Only if SHIFT key is pressed",
        ["options_contextmenu_entries_enable_tooltip_only_SHIFTkey_TT"]           = "Show a tooltip only if you press and hold the SHIFT key as you move the mouse above the context menu entries.",
        ["options_contextmenu_entries_tooltip_protectedpanels"]     = "Show protected-state of panel",
        ["options_contextmenu_entries_tooltip_protectedpanels_TT"]  = "Show the protected-state of the item at the currently active filter panel id.\n\n|c00FF00Green|r/checkmark icon: Protected\n|cFF0000Red|r/X icon: Not protected",
        ["protection_at_panel"]                             = "Protection at panel",
        --Enable/Disable icons
        ["options_header_enable_disable"]                   = "Enable / Disable",
        --Context menus should use submenus for dynamic icons
        ["options_contextmenu_use_dyn_submenu"]             = "Use submenu: Dynamic icons",
        ["options_contextmenu_use_dyn_submenu_TT"]     = "Use a submenu for the dynamic icons in context menus, if the enabled dynamic icons count equals or is higher than this value.\nThe value 0 disables the context-submenu for the dynamic icons.",
        --Backup & restore
        ["options_header_backup_and_restore_and_delete"] = "Backup & Restore & Delete",
        ["options_backup_marker_icons"]                 = "Backup",
        ["options_backup_marker_icons_TT"]         = "Backup your marker icons now.",
        ["options_restore_marker_icons"]                = "Restore",
        ["options_restore_marker_icons_TT"]        = "Restore the saved marker icons now.",
        ["options_backup_marker_icons_warning"]         = "Backup now?\nYour marker icons will be saved with their IDs to the saved variables. Both marker icon types (non-unique and unique) will be saved.\n\n!!! Attention !!!\nGuild banks: Unfortunately the guild banks cannot be saved in real time so please open ALL your guild banks once so they are up2date. Otherwise the items cannot be read properly. If someone changes the guild banks after you have opened them the addon is not able to recognize this.\n\nHouse: You need to be in any of your houses in order to backup the house bank items too.\nIf you are not in any of your houses the addon is not able to access the house banks and will skip the marked items in there!\n\nIf you own an house and are currently not in it the addon will ask you for a teleport next!",
        ["options_restore_marker_icons_warning"]        = "Restore now?\nThe saved data will be loaded and the marker icons set again. Both marker icon types (non-unique and unique) will be restored.\n\n!!! Attention !!!\nGuild banks: Unfortunately the guild banks cannot be restored in real time so please open ALL your guild banks once so they are up2date. Otherwise the items cannot be saved properly. If someone changes the guild banks after you have opened them the addon is not able to recognize this.\n\nHouse: You need to be in any of your houses in order to restore the house bank items too.\nIf you are not in any of your houses the addon is not able to access the house banks and will skip the marked items in there!\n\nIf you own an house and are currently not in it the addon will ask you for a teleport next!",
        ["options_backup_ask_before_teleport_to_own_house"] = "If you want to backup your house storage you need to be in one of your houses.\nTeleport there now?\n\n" .. GetString(SI_DIALOG_CONFIRM) ..": Will teleport you to your house.\n".. GetString(SI_DIALOG_CANCEL) .. ": Will start the backup without house banks.",
        ["options_backup_details"]                      = "Show details",
        ["options_backup_details_TT"]              = "Show details about the backuped data in the chat",
        ["options_backup_apiversion"]                   = "API version",
        ["options_backup_apiversion_TT"]           = "The API version for the backup. The backup will be saved below this API version and can be saved from this API version again.\nMust be a 6 digit number!",
        ["options_backup_clear"]                        = "Clear existing backup",
        ["options_backup_clear_TT"]                = "If the backup with the specified API version exists already it will be cleared before the new backup with the same API version.",
        ["options_restore_details"]                     = "Show details",
        ["options_restore_details_TT"]             = "Show details about the restored data in the chat",
        ["options_restore_apiversion"]                  = "Restorable API versions",
        ["options_restore_apiversion_TT"]          = "The saved API version of the backups, which can be restored.",
        ["options_restore_marker_icons_delete_selected"] = "Delete selected backup",
        ["options_restore_marker_icons_delete_selected_TT"] = "Delete the selected backup from the restorable backups.\n\nAttention: After deleting the backup you are not able to restore it anymore!",
        ["options_restore_marker_icons_delete_selected_warning"] = "Attention: This will delete the selected backup!",
        ["options_restore_marker_icons_delete_selected_warning2"] = "Backup will be deleted and cannot be restored afterwards.\n\nAre you realy sure?",

        ["options_delete_marker_icons_header"] =    "Delete",
        ["options_delete_marker_icons_desc"] =      "Saved marker icons at the items will be deleted. They will be deleted from the currently set (server/account/character/all the same) SavedVariables settings (see \'General settings\').\nThe icon dropdown will control which marker icon will be deleted (use the -ALL- entry to delete all of them).\nThe marker icon type defines which subtable of the SavedVariables will be deleted (non-unique/unique).\nThe Delete button is only enabled if there is at least 1 marked item saved for the chose marker icon, or if you have chosen -ALL- icons.\n\nNon-unique and ZOs unique marker icons cannot be deleted separatley as they are combined in the same SavedVariables subtable.",
        ["options_delete_marker_icons"] =           "Choose marker icon type",
        ["options_delete_marker_icons_TT"] =        "Choose the marker icon type which should be deleted.",
        ["options_delete_marker_icons_button"] =    "Delete marker icons",
        ["options_delete_marker_icons_button_TT"] = "Delete the selected marker icons",
        ["options_delete_marker_icons_warning"] =   "Attention: This will delete the selected marker icons! The UI will be reloaded after deletion of markers.\n\nWatch the chat for error messages!",
        ["options_delete_marker_icons_warning2"] =  "Marker icons will be deleted and cannot be restored afterwards.\n\nAre you realy sure?",

        --Feedback
        ["feedbackSendNote"]                    =   "Send mail",
        ["feedbackSendGold"]                    =   "Send e.g. <<1>> gold",
        ["feedbackOpenAddonAuthorWebsite"]      =   "Author portal",
        ["feedbackOpenAddonFAQ"]                =   "FAQ",
        ["feedbackInfo"]                        =   "Open the FAQ (question and answers), author panel (features/bugs) or send an ingame mail if you found a bug, have a request or wish to donate ingame.",
        --SavedVariables
        ["options_migrate_settings_ask_before_to_server"] = "Your SavedVariables were migrated to server dependent settings.\nDo you want to reload the UI now to store the dta on the disk?\nIf you choose to abort the non-server data will be kept as they are and after the next ReloadUI/login you will see this reminder box again!\n-VERY IMPORTANT-\nPlease be sure you have a backup of your SavedVariables file \"FCOItemSaver.lua\" before you continue!\n\nAfter the ReloadUI you are able to copy the server settings to other servers via the FCOIS settings menu.",
        ["options_logged_in_char"]          = "Only logged in char",
        ["options_logged_in_char_TT"]  = "Only for the currently logged in character",
        ["options_other_addons"]       = "Other AddOns",
        ["options_preview"]             = "Preview",
        --Vendor buy, buyback and repair
        ["button_context_menu_toggle_anti_buy_on"]      = "Activate 'Anti-Buy'",
        ["button_context_menu_toggle_anti_buy_off"]     = "Deactivate 'Anti-Buy'",
        ["button_context_menu_toggle_anti_buyback_on"]  = "Activate 'Anti-Buyback'",
        ["button_context_menu_toggle_anti_buyback_off"] = "Deactivate 'Anti-Buyback'",
        ["button_context_menu_toggle_anti_repair_on"]   = "Activate 'Anti-Repair'",
        ["button_context_menu_toggle_anti_repair_off"]  = "Deactivate 'Anti-Repair'",
        ["filter_buy"]      = "["..GetString(SI_DIALOG_PURCHASE).."] ",
        ["filter_buyback"]  = "["..GetString(SI_ITEMFILTERTYPE8).."] ",
        ["filter_repair"]   = "["..GetString(SI_ITEM_ACTION_REPAIR).."] ",
        ["LAM_settings_are_currently_build"] = "                   - Please wait-\nSettings are currently build...",
        ["options_non_unique_id"]               = "Non-unique ID",
        ["options_use_uniqueids_type"]          = "Type of unique ID",
        ["options_use_uniqueids_type_TT"]       = "Choose which type of the unique ID you want to use. The default type is the ZOs base game type. An alternative are the FCOIS own created uniqueIds, see checkboxes to define the parts of the self-created uniqueId below.\nPlease read the tooltips of this dropdownbox entries for more information!\n\n|cFF0000Caution: Changing this setting will automatically reload the user interface (/reloadui)!|r",
        ["options_unique_id_base_game"]         = "Use ZOs unique ID",
        ["options_unique_id_base_game_TT"]      = "If you enable this type of unique ID, FCOIS will simply use the base game's given unique ID.\nThe unique ID of ZOs is really unique, means exactly the same items are still different as their unique ID differs. This will result in marker icons not applied automatically to the exactly same items.\n\nThis will only apply to weapons and armor. All other items are handled as non-unique items!",
        ["options_uniqe_id_by_FCOIS"]           = "Use FCOIS unique ID",
        ["options_uniqe_id_by_FCOIS_TT"]        = "If you enable this type of unique ID, FCOIS will create an unique ID on it's own.\nThe unique ID is based on the item's itemInstanceId or itemId, level, quality, trait, style, enchantment, stolen state, crafted state.\nThis allows the addon to detect and mark the exactly same items properly with the same marker icons.\n\nYou are able to select below via the checkboxes which criteria should be used to build the uniqueIDs for you. In addition you are able to select the item types which should be used for the uniqueIds (standard item types are weapons and armor). E.g. a potion could aso be distinguished via it's level, is crafted flag and crafter name. But some items like crafting materials always only provide the level 1 so it does not make sense to use a uniqueId on them.\n\nImportant: If you change one of the criteria of the unique IDs here your visual marker icons using these criteria will be hidden (but still saved in the SavedVariables). They will automatically show like saved again as you enable these criteria in the settings again.",
        ["options_unique_id_by_FCOIS_info"]     = "You are able to select below via the checkboxes which criteria should be used to build the uniqueIDs for you. In addition you are able to select the item types which should be used for the uniqueIds (standard item types are weapons and armor). E.g. a potion could aso be distinguished via it's level, is crafted flag and crafter name. But some items like crafting materials always only provide the level 1 so it does not make sense to use a uniqueId on them.\n\nImportant: If you change one of the criteria of the unique IDs here your visual marker icons using these criteria will be hidden (but still saved in the SavedVariables). They will automatically show like saved again as you enable these criteria in the settings again.",
        ["options_unique_id_parts_header"]      = "Parts of the unique ID",
        ["options_unique_id_part_itemId"]       = "Item ID", -- Item ID
        ["options_unique_id_part_level"]        = GetString(SI_TRADINGHOUSEFEATURECATEGORY2), -- Level
        ["options_unique_id_part_quality"]      = GetString(SI_TRADINGHOUSEFEATURECATEGORY5), -- Quality
        ["options_unique_id_part_trait"]        = GetString(SI_SMITHING_HEADER_TRAIT), -- Trait
        ["options_unique_id_part_enchantment"]  = GetString(SI_ITEM_FORMAT_STR_ENCHANT_HEADER), -- Enchantment
        ["options_unique_id_part_style"]        = GetString(SI_SMITHING_HEADER_STYLE), -- Style
        ["options_unique_id_part_stolen"]       = GetString(SI_GAMEPAD_ITEM_STOLEN_LABEL), -- Stolen
        ["options_unique_id_part_crafted"]      = GetString(SI_ITEM_FORMAT_STR_CRAFTED), -- Crafted
        ["options_unique_id_part_crafted_by"]   = GetString(SI_ITEM_FORMAT_STR_CRAFTED) .. " by", -- Crafted by
        ["options_unique_id_part_crownItem"]    = GetString(SI_ITEMTYPE57),
        ["options_header_migration"]            = "Migration",
        ["options_header_migration_ids"]        = "(Non-)Unique ID migration",
        --Migrate ZOs locks to FCOIS locks
        ["migrate_ZOs_locks_to_FCOIS_locks_start"]              = "[FCOIS]Scan inventories for ZOs locked items: START",
        ["migrate_ZOs_locks_to_FCOIS_locks_bagId"]              = ">Scanning bag ID: %s",
        ["migrate_ZOs_locks_to_FCOIS_locks_migrated_at_bag"]    = ">>migrated at the bag %s: %s",
        ["migrate_ZOs_locks_to_FCOIS_locks_end"]                = "[FCOIS]Scan inventories for ZOs locked items: FINISHED - migrated/scanned total: %s / %s",

        ["options_header_set_collections"]              = "Set collections",
        ["options_enable_auto_mark_sets_collection"]    = "Automatic \'Set collection\' marking",
        ["options_enable_auto_mark_sets_collection_TT"] = "Enable automatic \'Set collection\' marker icons",
        ["options_only_current_account"]                = "Only current account",
        ["options_only_current_account_TT"]             = "Only use currently logged in account for the checks",
        ["options_auto_mark_sets_collection_addon"]     = "Addon for \'Set collection\' checks",
        ["options_auto_mark_sets_collection_addon_TT"]  = "Choose the addon which should be used for the automatic set collection checks (known/unknown collected set items).\nThe ESO standard is not able to support other accounts as the currently logged in!",
        ["options_auto_mark_sets_collection_known_icon"]    = "Known set collection item icon",
        ["options_auto_mark_sets_collection_known_icon_TT"] = "Choose the icon for known set collection items.",
        ["options_auto_mark_sets_collection_unknown_icon"]    = "Unknown set collection item icon",
        ["options_auto_mark_sets_collection_unknown_icon_TT"] = "Choose the icon for unknown set collection items.",

        ["options_description_automatic_marks"] = "Automatics Markings applies icons markers automatically to your items, depending on your defined criteria. E.g. mark set items which got a desired trait (precise, divine, ...) with a desired marker icon, and mark all others with the sell/deconstruct icon. Or mark unknown recipies. The Automatic markings may depend on other addons which you may need to install and setup.\nAutomatic markings will be internally checked and applied at each login/reloadui/zone change with loading screen for all items in all of your inventories!\nYou are also able to manually trigger them via the additional inventory \'flag\' "..addInvFlagIcon.." icons at the inventories -> sub context menu \'Automatic markings\'. Attention: Triggering it from the flag icon will ONLY apply the markings to the currently visible (filtered) items, and not all of your selected inventories (see submenu \'Inv. bags to scan\') and items!\n\nPlease read the tooltips of each setting in the Automatic markings submenus carefully!\n\nThe order of verification and applied Automatic markings is as follows::\n1) Set items\n2) Set collections\n3) Ornate\n4) Intricate\n5) Research\n6) Research scrolls\n7) Unknown recipes\n8) Known recipes\n9) Quality\nCrafted and new Automatic markings are special and will only be applied as the item is crafted by you or a new item enters your inventory.",
        ["options_known"] = "known",
        ["options_bags_to_scan"]                        = "Inv. bags to scan",
        ["options_bags_to_scan_automatic_marks_TT"]     = "Inventory bags to scan for automatic marking as a ReloadUI/zone change with loading screen is done/items get into your inventory (loot).\nManually triggered automatic markings via the add. inv. "..addInvFlagIcon.." context menu will only scan the currently visible items at the currently opened inventory, and as you manually trigger them they will scan the currently visible bag even if it is disabled below!",
        ["options_bags_to_scan_order"]                  = "Scan order",
        ["options_bags_to_scan_order_TT"]               = "Choose the scan order for the inventory bags. Automatic markings scans will be processed and marked for the enabled \'Inv. bags to scan\' according to your scan order [from top 1) to bottom n)].",
        ["options_scan_automatic_marks_now"]            = "Scan autom. mark.",
        ["options_scan_automatic_marks_now_TT"]         = "Scan the chosen invenories now for the automatic markings that can be applied",
        ["options_scan_automatic_marks_scan_bag"]           = ">>>Scanning \'%s\' for Automatic Markings...",
        ["options_scan_automatic_marks_scan_bag_finished"]  = "Scan of \'%s\' was finished<<<",
        ["options_bags_to_scan_chat_output"]             = "Show bag scan chat output",
        ["options_bags_to_scan_chat_output_TT"]          = "Show a chat output of each scanned bag, as the scanning of the bag starts and ends. Marked items will be shown in the chat depending on each markings-submenu settings, independent on this setting here.",
        ["reloadui"] = "CAUTION: The user interface will be reloaded in %s seconds!",

        ["options_auto_bind_missing_set_collection_pieces"] = "Auto bind missing pieces",
        ["options_auto_bind_missing_set_collection_pieces_TT"] = "Auto bind missing set collection pieces to your account.\nIf \'Unknown set collection marker icon\' is enabled: Bound items will still get the \'unknown marker icon\' applied so you are able to filter them acordingly, except for if you enable the setting \'Mark as known then\'.\nOnly works with vanilla ESO missing set collection piece detection, or LibMultiAccountSets, and only with the logged in account!\n\nThis will be done each time the automatic set collection piece marks get applied (manually or upon looting items).\n\n|cFF0000Attention:|r There will be NO security dialog asking up in front if the item should be bound!",
        ["options_auto_bind_missing_set_collection_pieces_markKnown"] = "Mark as known then",
        ["options_auto_bind_missing_set_collection_pieces_markKnown_TT"] = "Mark the new bound items as known set collection pieces.\nOnly works if the known automatic set item collection pieces marking is enabled.",
        ["options_auto_bind_missing_set_collection_pieces_to_chat"] = "Show in chat",
        ["options_auto_bind_missing_set_collection_pieces_to_chat_TT"] = "Show the items that were auto bound in the chat",
        ["chat_output_missing_set_collection_piece_was_bound"] = "Missing set collection piece was bound: %s",

        ["options_dropdown_none"] = "- None -",
        ["options_dropdown_all"]  = "- ALL -",

        ["options_automark_itemcooldowntracker_header"] = "Item Cooldown Tracker",
        ["options_automark_itemcooldowntracker"]        = "Mark \'Item Cooldown Tracker\' tracked",
        ["options_automark_itemcooldowntracker_TT"]     = "Automatically mark items tracked via \'Item Cooldown Tracker\' with a marker icon.",
        ["options_automark_itemcooldowntracker_icon_TT"] = "Choose the marker icon that should be applied on items that are tracked via \'Item Cooldown Tracker\'.",

        --LibShifterBoxes
        --[FCOIS_UNIQUEID_ITEMTYPES]
        ["LIBSHIFTERBOX_FCOIS_UNIQUEID_ITEMTYPES_TITLE_LEFT"]   = "Item types (all)",
        ["LIBSHIFTERBOX_FCOIS_UNIQUEID_ITEMTYPES_TITLE_RIGHT"]  = "Chosen for FCOIS unique ID",
        ["LIBSHIFTERBOX_FCOIS_UNIQUEID_ITEMTYPES_RIGHT_NON_EMPTY"]  = "UniqueId itemTypes cannot be empty!\nPlease add at least one supported itemType, or the default values weapons and armor will be automatically pre-set again!"
    },
--==============================================================================
	--German / Deutsch
    [FCOIS_CON_LANG_DE] = {
        -- Options menu
        ["options_description_lam_menu_is_loading"] = "|cFF0000!!!ACHTUNG!!!\n\nDas FCOIS Einstellungsmenü wird gerade geladen. Bitte warten und keine Einstellungen verändern bis dieses Symbol verschwindet!\n\nESO kann für einige Sekunden schlecht reagieren.\nSobald alle Einstellungen erstellt wurden verschwindet dieses Symbol und Sie können mit den Einstellungen arbeiten.",
        ["options_description"] 				 = "FCOItemSaver verschafft Ihnen mit Hilfe von Symbolen einen Überblick über Ihre Gegenstände und lässt Sie diese bequem ein-/ausblenden & absichern",
        ["options_header1"] 			 		 = "Generelle Einstellungen",
        ["options_language"] 					 = "Sprache",
        ["options_language_TT"] 			 = "Wählen Sie die Sprache aus",
        ["options_language_use_client"] 		 = "Benutze Spiel Sprache",
        ["options_language_use_client_TT"]  = "Lässt das AddOn immer die Sprache des Spiel Clients nutzen.",
        ["options_language_dropdown_selection1"] = "Englisch",
        ["options_language_dropdown_selection2"] = "Deutsch",
        ["options_language_dropdown_selection3"] = "Französisch",
        ["options_language_dropdown_selection4"] = "Spanisch",
        ["options_language_dropdown_selection5"] = "Italienisch",
        ["options_language_dropdown_selection6"] = "Japanisch",
        ["options_language_dropdown_selection7"] = "Russisch",
        ["options_language_description1"]		 = "ACHTUNG: Veränderungen der Sprache/der Speicherart laden die Benutzeroberfläche neu!",
        ["options_savedvariables"]				 = "Einstellungen speichern",
        ["options_savedvariables_TT"]       = "Die Einstellungen dieses Addons werden für alle Charactere Ihres Accounts, oder für jeden Character einzeln gespeichert",
        ["options_savedVariables_dropdown_selection1"] = "Jeder Charakter",
        ["options_savedVariables_dropdown_selection2"] = "Ganzer Account",
        ["options_savedVariables_dropdown_selection3"] = "Alle Accounts gleich",
        ["options_savedVariables_dropdown_selection4"] = "Alle Server & Accounts gleich",

        ["options_header_copy_sv"]              =   "Kopiere & Lösche SavedVariables (alle Einstellungen)",
        ["options_copy_sv_source_server"]       =   "Quell-Server",
        ["options_copy_sv_target_server"]        =  "Ziel-Server",
        ["options_description_copy_sv_server"]  = "|cff0000Vor dem Kopieren/Löschen von SavedVariables (dies wird alle Einstellungen kopieren, nicht nur die Markierungen an deinen Gegenständen!) LOG DICH bitte AUS und KOPIERE die SavedVariables DATEI 'FCOItemSaver.lua' ALS BACKUP! Klicke auf den '|c5959D5Feedback|r|cff0000' Link oben und dann auf den 'FAQ' Knopf, um eine Erklärung zu erhalten, wie du die Backup Datei erstellen kannst.|r\n\nKopiere SavedVariables von einem Server zu einem anderen. Wählen den Account oder Charakter weiter unten aus. Kopieren oder Löschen der Daten eines gesamten Servers ist nicht möglich!",
        --["options_copy_sv_to_server"]           =   "Copy to server",
        --["options_copy_sv_to_server_TT"]   =   "Copy the SavedVariables from the chosen source server to the chosen target sever. Copying from a source to the same target server is not possible!\nIf you are using account wide setings, or all accounts use the same settings, all data will be transfered.\nIf you are using character settings only your currently logged in character will be transfered.\n\nAttention: Existing target data will be overwritten!",
        ["options_copy_sv_to_server_warning"]   =   "Willst du wirklich die SavedVariables kopieren?\nExistierende Ziel-Daten werden überschrieben!\n\nWenn du auf dem Ziel-Server eingeloggt bist wird deine Benutzeroberfläche im Anschluß neu laden!",
        ["question_copy_sv_server_reloadui"]    = "SavedVariables wurden von Server \"<<C:1>>\" zu Server \"<<C:2>>\" kopiert, Accountweite Einstellungen: <<3>>.\n\nDa du aktuell auf dem Ziel-Server eingeloggt bist:\nBenutzeroberfläche neu laden?",
        ["question_delete_sv_server_reloadui"]   = "SavedVariables von Server \"<<C:1>>\" gelöscht, Accountweite Einstellungen: <<2>>.\n\nDa du aktuell auf dem Ziel-Server eingeloggt bist:\nBenutzeroberfläche neu laden?",
        --["options_delete_sv_on_server"]           =   "Delete target server",
        --["options_delete_sv_on_server_TT"]   =   "Delete the SavedVariables on the target server.\nIf you are logged in to the target server with the chosen target account and character your UI will reload afterwards!\n\nAttention: Existing target data will be deleted without any backup!",

        ["options_description_copy_sv_account"]  = "Diese Option ist nur verfügbar, wenn ein Server gewählt wurde. |c75daffBitte lies die Tooltips an den Account kopieren/löschen Knöpfen!|r",
        ["options_copy_sv_source_account"]       =   "Quell-Account",
        ["options_copy_sv_target_account"]        =   "Ziel-Account",
        ["options_copy_sv_to_account"]           =   "Kopiere zu Account",
        ["options_copy_sv_to_account_TT"]   =   "Kopiere die SavedVariables vom ausgewählten Quell-Server und Quell-Account zum gewählten Ziel-Server und Ziel-Account. Quell- und Ziel-Server können identisch sein, aber Quell- und Ziel-Account müssen unterschiedlich sein.\n\nOder kopiere einen Quell-Server & Quell-Account & Quell-Charakter->zu einem Ziel-Server & Ziel-Account. Quell- und Ziel-Server, sowie Quell- und Ziel-Account, können dabei dann identisch sein.\n\nAchtung: Existierende Ziel-Daten werden überschrieben!",
        ["options_copy_sv_to_account_warning"]   =   "Willst du wirklich die SavedVariables kopieren?\nExistierende Ziel-Daten werden überschrieben!\n\nWenn du auf dem Ziel-Server mit dem Ziel-Account eingeloggt bist, wird die Benutzeroberfläche im Anschluss neugeladen werden!",
        ["question_copy_sv_account_reloadui"]           = "SavedVariables von Server \"<<C:1>>\" Account \"<<C:2>>\" zu Server \"<<C:3>>\" Account \"<<C:4>>\" kopiert, Accountweite Einstellungen: <<5>>.\n\nDa du aktuell auf dem Ziel-Server eingeloggt bist:\nBenutzeroberfläche neu laden?",
        ["question_delete_sv_account_reloadui"]   = "SavedVariables von Server \"<<C:1>>\" Account \"<<C:2>>\" gelöscht, Accountweite Einstellungen: <<3>>.\n\nDa du aktuell auf dem Ziel-Server eingeloggt bist:\nBenutzeroberfläche neu laden?",
        ["options_delete_sv_account"]           =   "Lösche Ziel-Account",
        ["options_delete_sv_account_TT"]   =   "Löscht die SavedVariables auf dem Ziel-Server und Ziel-Account.\nWenn du auf dem Ziel-Server mit dem Ziel-Account und Ziel-Charakter eingeloggt bist, wird die Benutzeroberfläche im Anschluss neugeladen werden!\n\nAchtung: Existierende Ziel-Daten werden ohne Backup gelöscht!",

        ["options_copy_sv_to_allserversallaccount"]      =   "Koiere zu \'Alle gleich\'",
        ["options_copy_sv_to_allserversallaccount_TT"]   =   "Kopiere die SavedVariables vom ausgwählten Quell-Server zu den \'Alle Server & Accounts gleich\' Einstellungen.\n\nAchtung: Existierende Ziel-Daten werden überschrieben!",
        ["options_copy_sv_to_allserversallaccount_warning"]  =  "Willst du wirklich die SavedVariables kopieren?\nExistierende Ziel-Daten werden überschrieben!\n\nDeine Benutzeroberfläche lädt im Anschluss neu!",
        ["question_copy_sv_allserversallaccount_reloadui"]   = "SavedVariables von Server \"<<C:1>>\" Account \"<<C:2>>\" zu \'Alle Server & Accounts gleich\' kopiert, Accountweite Einstellungen: <<3>>.\n\nSoll die Benutzeroberfläche neu geladen werden?",
        ["options_delete_sv_allserversallaccount"]           = "Lösche \'Alle gleich\'",
        ["options_delete_sv_allserversallaccount_TT"]        = "Löscht die SavedVariables für \'Alle Server & Accounts gleich\'.\nDeine Benutzeroberfläche lädt im Anschluss neu!\n\nAchtung: Existierende Daten werden ohne Backup gelöscht!",

        ["options_description_copy_sv_character"]  = "Diese Option ist nur verfügbar, wenn ein Account ausgewählt wurde (außer 'Alle Accounts gleich'). Du musst in der Vergangenheit bereits Charaktere mit der Einstellung 'Jeder Charakter' gespeichert haben, um diese Charaktere in der Quell-Charakter Liste weiter unten auswählen zu können. |c75daffBitte lies die Tooltips der Kopieren/Löschen Knöpfe!|r",
        ["options_copy_sv_source_character"]       =   "Quell-Charakter",
        ["options_copy_sv_target_character"]        =   "Ziel-Charakter",
        ["options_copy_sv_to_character"]           =   "Kopiere zu Charakter",
        ["options_copy_sv_to_character_TT"]   =   "Kopiere die SavedVariables vom ausgewählten Quell-Server und Quell-Account und Quell-Charakter zum ausgewählten Ziel-Server, Ziel-Account und Ziel-Charakter. Quell- und Ziel-Server sowie Quell- und Ziel-Account können dabei identisch sein, jedoch müssen Quell- und Ziel-Charakter unterschiedlich sein!\nDu musst in der Vergangenheit in den 'Generellen Einstellungen' die Option 'Einstellungen speichern' mit der Auswahl 'Jeder Charakter' aktiviert haben, damit die mit dieser Einstellung bereits eingeloggten Charaktere in der Quell-Charakter Liste ausgewählt werden können!\n\nOder kopiere einen Quell-Server & Quell-Account zu einem Ziel-Server & Ziel-Account & Ziel-Charakter. Quell- und Ziel-Server, sowie Quell- und Ziel-Account, können dabei dann identisch sein.\n\nAchtung: Existierende Ziel-Daten werden überschrieben!",
        ["options_copy_sv_to_character_warning"]   =   "Willst du wirklich die SavedVariables kopieren?\nExistierende Ziel-Daten werden überschrieben!\n\nWenn du auf dem Ziel-Server mit dem Ziel-Account und Ziel-Charakter eingeloggt bist wird deine Benutzeroberfläche im Anschluß neu laden!",
        ["question_copy_sv_character_reloadui"]   = "SavedVariables von Server \"<<C:1>>\" Account \"<<C:2>>\" Charakter \"<<C:3>>\" zu Server \"<<C:4>>\" Account \"<<C:5>>\" Charakter \"<<C:6>>\" kopiert, Accountweite Einstellungen: <<7>>.\n\nDa du aktuell auf dem Ziel-Server eingeloggt bist:\nBenutzeroberfläche neu laden?",
        ["question_delete_sv_character_reloadui"]   = "SavedVariables von Server \"<<C:1>>\" Account \"<<C:2>>\" Charakter \"<<C:3>>\" gelöscht, Accountweite Einstellungen: <<4>>.\n\nDa du aktuell auf dem Ziel-Server eingeloggt bist:\nBenutzeroberfläche neu laden?",
        ["options_delete_sv_character"]           =   "Lösche Ziel-Charakter",
        ["options_delete_sv_character_TT"]   =   "Löscht den Ziel-Charakter in den SavedVariables auf dem Ziel-Server, Ziel-Account.\nWenn du auf dem Ziel-Server mit dem Ziel-Account und Ziel-Charakter eingeloggt bist wird deine Benutzeroberfläche im Anschluß neu laden!\n\n\nAchtung: Existierende Ziel-Daten werden gelöscht!",

        ["question_copy_sv_account_to_char_reloadui"]  = "SavedVariables vom Server \"<<C:1>>\" Account \"<<C:2>>\" zum Server \"<<C:3>>\" Account \"<<C:4>>\" Charakter \"<<C:5>>\" kopiert, Accountweite Einstellungen: <<6>>.\n\nDa du aktuell auf dem Ziel-Server eingeloggt bist:\nBenutzeroberfläche neu laden?",
        ["question_copy_sv_char_to_account_reloadui"]  = "SavedVariables vom Server \"<<C:1>>\" Account \"<<C:2>>\" Charakter \"<<C:3>>\" zum Server \"<<C:4>>\" Account \"<<C:5>>\" kopiert, Accountweite Einstellungen: <<6>>.\n\nDa du aktuell auf dem Ziel-Server eingeloggt bist:\nBenutzeroberfläche neu laden?",
        ["options_copy_sv_account_to_char"] = "Kopiere Account->Char",
        ["options_copy_sv_char_to_account"] = "Kopiere Char->Account",


        ["options_hint_backup_savedvariables_file_title"] = "Backup SavedVariables!",
        ["options_hint_backup_savedvariables_file"] = "Bitte logge dich aus und erstelle\n ein Backup von deiner 'FCOItemSaver.lua'\n SavedVariables Datei, bevor du mit den\n SavedVariable Kopier/Löschen Optionen arbeitest!\n\nHast du bereits ein Backup erstellt, dann drücke bitte jetzt den Knopf \'Abbrechen\' und führe die Aktion erneut aus.\nDieser Dialog wird dann nicht mehr angezeigt!",

        ["options_header_uniqueids"]           = "Eindeutige Gegenstand ID",
        ["options_description_uniqueids"]       = "Deine Gegenstände im Spiel besitzen eine ID. Diese ID ist für alle Gegenstände mit ähnlichen Grunddaten identisch (nicht-eindeutige ID), z.B. Name, Level und Qualität. Ein Dietrich und ein gestohlener Dietrich z.B. wären solche identischen Grunddaten Gegenstände. Diese nicht-eindeutigen IDs verwendet FCO ItemSaver als Standard, um die Markierungen an Gegenständen zu setzen und sich zu merken (die sogenannte \'ItemInstanceId\')!\n\nJeder Gegenstand besitzt aber auch noch eine eindeutige ID (die sogenannte \'UniqueId\'). Bei dieser werden Verzauberungen, Level, Stil, Trait, etc. diese eindeutige ID verändern! Eindeutige Gegenstand IDs erlauben es dir daher Gegenstände mit ähnlichen Grunddaten unterschiedlich zu markieren, aber dies verlangt, dass du eben alle diese eindeutigen Gegenstände wieder neu markieren musst, wenn sie in einer noch nicht markierten Kombination in dein Inventar gelangen.\n\nDu hast hier die nicht eindeutige ItemInstance-ID, sowie mehrere Typen der Unique-IDs zur Auswahl, um die Markierungen an deinen Gegenständen zu speichern. |c75daffBitte lies die Tooltips der Einträge (Aufklappbox aufklappen -> Maus über die Einträge bewegen) in der Aufklappbox \'Typ der eindeutigen ID\', um die Unterschiede der eindeutigen IDs zu erfahren. Du musst den Haken bei \'Nutze eindeutige Gegenstands IDs\' setzen, damit die Aufklappbox eingabebereit wird.|r\n\n|cFF0000Achtung: Das Verändern dieser Option lädt die Benutzeroberfläche neu (/reloadui)! Danach kannst du hier drunter deinen EindeutigenID Typ bestimmen.|r",
        ["options_use_uniqueids"]               = "Nutze eindeutige Gegenstands IDs",
        ["options_use_uniqueids_TT"]       = "Aktiviert:\nNutze eindeutige Gegenstand IDs.\n\nDeaktiviert:\nNutze die nicht-eindeutigen Gegenstand IDs und markiere alle Gegenstände mit denselben Grunddaten identisch (itemInstanceId).\n\nAchtung: Deine bereits markierten Gegenstände werden gesichert und wenn du zwischen den eindeutigen und nicht-eindeutigen Gegenstand IDs umschaltest, sind die Markierungen weiterhin vorhanden, und werden bei einem Wechsel dieser Einstellung wieder angezeigt. Die itemInstanceIds und EindeutigenIds können jedoch NICHT synchronisiert werden!\n\n|cFF0000Achtung: Die Benutzeroberfläche wird automatisch neuladen (/reloadui), wenn du diese Option verändert hast!|r",
        ["options_migrate_uniqueids"]           = "Migriere>EindeutigeID",
        ["options_migrate_uniqueids_TT"]   = "Migriere die markierten Gegenstände von den nicht-eindeutigen zu den eindeutigen IDs.\nDies wird alle die Gegenstände mit denselben Markierungs-Symbolen markieren, welche du vorher mit den nicht-eindeutigen Einstellungen bereits markiert hattest.\nSo werden alle Gegenstände weiterhin gesichert und du musst die Markierungen nur ändern/entfernen.\n\n|cFF0000Diese Option ist solange deaktiviert, bis du die eindeutigen Gegenstand IDs aktiviert hast UND du die Benutzeroberfläche neugeladen (/reloadui) hast!\nNutze anschließend das Migrations Popup, oder komme hierhin zurück, um die Migration zu starten.|r",
        ["options_migrate_ids_migration_log"] = "|c75daffNach der Migration wird die Benutzeroberfläche automatisch, nach 3 Sekunden, neu geladen WENN ein Markierungssymbol migriert wurde! Ansonsten siehst du den Log direkt im Chat.\nNach diesem Neuladen bekommst du das Migrations Log im Chat einmalig angezeigt.|r",
        ["options_migrate_ids_migration_log_dialog"] = "|c75daffNach der Migration wird die Benutzeroberfläche\n automatisch, nach 3 Sekunden, neu geladen WENN\n ein Markierungssymbol migriert wurde!\nAnsonsten siehst du\n den Log direkt im Chat.\nNach diesem Neuladen bekommst du das Migrations\nLog einmalig im Chat angezeigt.|r",
        ["options_migrate_uniqueids_warning"]   = "Dies migriert alle Markierungen deiner nicht-eindeutigen Gegenstand IDs zu den eindeutigen IDs derselben Gegenständen.\nExistierende Markierungen werden dabei nicht entfernt und neue werden lediglich hinzugefügt!\n\nDiese Migration ist nicht umkehrbar! Du musst die migrierten Markierungen anschließend selbst wieder entfernen.",
        ["options_migrate_unique_inv_scan_not_done"]   = "Du hast den Gegenstand Markierungs-Modus auf eindeutige IDs geändert.\nDie automatischen Markierungen werden daher 1x nicht durchgeführt, damit du die Migration deiner alten Markierungen nun starten kannst, wenn du möchtest!",
        ["options_migrate_start"] = "Migration gestartet: <<1>>",
        ["options_migrate_results"] = "> Es <<1[wurde kein Symbol/wurde 1 Symbol/wurden $d Symbole]>> bei <<2[keinem Gegenstand/1 Gegenstand/$d Gegenständen]>> migriert.",
        ["options_migrate_end"] = "Migration beendet: <<1>>",
        ["options_migrate_bag_type_" .. tostring(BAG_WORN)] = GetString(SI_BINDING_NAME_TOGGLE_CHARACTER),
        ["options_migrate_bag_type_" .. tostring(BAG_COMPANION_WORN)] = GetString(SI_CRAFT_ADVISOR_TOOLTIP_EQUIP_TAB) .. " - " .. GetString(SI_COLLECTIBLECATEGORYTYPE27),
        ["options_migrate_bag_type_" .. tostring(BAG_BACKPACK)] = "Rucksack",
        ["options_migrate_bag_type_" .. tostring(BAG_BANK)] = GetString(SI_GAMEPAD_BANK_CATEGORY_HEADER),
        ["options_migrate_bag_type_" .. tostring(BAG_GUILDBANK)] = GetString(SI_GAMEPAD_GUILD_BANK_CATEGORY_HEADER),
        ["options_migrate_bag_type_" .. tostring(BAG_BUYBACK)] = GetString(SI_ITEMFILTERTYPE8),
        ["options_migrate_bag_type_" .. tostring(BAG_VIRTUAL)] = GetString(SI_NOTIFICATIONTYPE15),
        ["options_migrate_bag_type_" .. tostring(BAG_SUBSCRIBER_BANK)] = GetString(SI_ESO_PLUS_TITLE) .. " " .. GetString(SI_GAMEPAD_BANK_CATEGORY_HEADER),
        ["options_migrate_bag_type_" .. tostring(BAG_HOUSE_BANK_ONE)] = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " 1",
        ["options_migrate_bag_type_" .. tostring(BAG_HOUSE_BANK_TWO)] = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " 2",
        ["options_migrate_bag_type_" .. tostring(BAG_HOUSE_BANK_THREE)] = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " 3",
        ["options_migrate_bag_type_" .. tostring(BAG_HOUSE_BANK_FOUR)] = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " 4",
        ["options_migrate_bag_type_" .. tostring(BAG_HOUSE_BANK_FIVE)] = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " 5",
        ["options_migrate_bag_type_" .. tostring(BAG_HOUSE_BANK_SIX)] = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " 6",
        ["options_migrate_bag_type_" .. tostring(BAG_HOUSE_BANK_SEVEN)] = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " 7",
        ["options_migrate_bag_type_" .. tostring(BAG_HOUSE_BANK_EIGHT)] = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " 8",
        ["options_migrate_bag_type_" .. tostring(BAG_HOUSE_BANK_NINE)] = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " 9",
        ["options_migrate_bag_type_" .. tostring(BAG_HOUSE_BANK_TEN)] = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " 10",
        ["options_migrate_uniqueids_dialog"]   = "Migriere jetzt markierte nicht-eindeutige Gegenstände\nzu eindeutigen?\n\nEs werden nur Markierungen hinzugefügt.\nEs werden keine Markierungen entfernt.",
        ["options_migrate_nonuniqueids_dialog"]   = "Migriere jetzt markierte eindeutige Gegenstände\nzu nicht-eindeutigen?\n\nEs werden nur Markierungen hinzugefügt.\nEs werden keine Markierungen entfernt.",
        ["options_migrate_iteminstanceids"]     = "Migriere>ItemInstanceID",
        ["options_migrate_iteminstanceids_TT"]  = "Migriere die markierten Gegenstände von den eindeutigen zu den nicht-eindeutigen IDs.\nDies wird alle die Gegenstände mit denselben Markierungs-Symbolen markieren, welche du vorher mit den eindeutigen Einstellungen bereits markiert hattest.\nSo werden alle Gegenstände weiterhin gesichert und du musst die Markierungen nur ändern/entfernen.\n\n|cFF0000Diese Option ist solange deaktiviert, bis du die nicht-eindeutigen Gegenstand IDs aktiviert hast UND du die Benutzeroberfläche neugeladen (/reloadui) hast!\nNutze anschließend das Migrations Popup, oder komme hierhin zurück, um die Migration zu starten.|r",
        ["options_migrate_iteminstanceids_warning"]   = "Dies migriert alle Markierungen deiner eindeutigen Gegenstand IDs zu den nicht-eindeutigen Ids derselben Gegenstände.\nExistierende Markierungen werden dabei nicht entfernt und neue werden lediglich hinzugefügt!\n\nDiese Migration ist nicht umkehrbar! Du musst die migrierten Markierungen anschließend selbst wieder entfernen.",
        ["options_migrate_uniqueId_to_uniqueId"]        = "Migration des eindeutigen ID Typs: %s zum eindeutigen ID Typ: %s",
        ["options_migrate_uniqueId_to_non_uniqueId"]    = "Migration des eindeutigen ID Tys %s zu nicht-eindeutigen IDs",
        ["options_migrate_non_uniqueId_to_uniqueId"]    = "Migration der nicht-eindeutigen IDs zur eindeutigen ID des Typs: %s",

        ["options_header_ZOsLock"]                  = "ZOs Gegenstand-Sperre",
        ["options_use_ZOs_lock_functions"] 			= "Aktiviere TESO Gegenstand-Sperre " ..lockIcon,
        ["options_use_ZOs_lock_functions_TT"]	= "Aktiviere/Deaktiviere die vom Spiel-Programmierer ZOs mitgebrachte Gegenstand Sperre (graues Schloss Symbol "..lockIcon..").\nIst diese Option deaktiviert so wird der Eintrag im Kontextmenü, als auch die Symbole, in den Inventaren versteckt.",
        ["options_scan_ZOs_lock_functions"]			= "TESO "..lockIcon.."->FCOIS "..lockIcon,
        ["options_scan_ZOs_lock_functions_TT"]      = "Transferiert die Gegenstände, welche im Spiel mit der standard Gegenstandssperre (graues Schloss) geschützt wurden zur FCOItemSaver \'Schloß\' Markierung. D.h. die bisher durch das Spiel markierten, und dadurch geschützten, Gegenstände verlieren die Spiel-Markierung und werden auf das FCOIS Symbol 1 (Schloss Symbol) gewechselt, so dass diese Gegenstände nun durch FCOIS umfangreicher geschützt werden.\nBitte beachte, dass du dich in deinem Haus befinden musst, wenn du die Haus Banken mit migrieren möchtest!\n\nGegenstände werden in 50er Paketen gescannt. Dies dauert etwas. Bitte beachte den Chat!",
        ["options_scan_ZOs_lock_functions_warning"]	= "Wollen Sie wirklich den Gegenstands-Schutz vom Standard Schloss Symbol zum FCOItemSaver \'Schloss\' Symbol übertragen?\n\nGegenstände werden in 50er Paketen gescannt. Dies dauert etwas. Bitte beachte den Chat!",
        ["options_header_icon_options"]		 	 = "Symbol Position, Sortierung, etc.",
        ["options_header_marking_options"]		 = "Markierungen",
        ["options_header_crafting"]              = GetString(SI_SKILLTYPE8),
        ["options_remove_all_markers_with_shift_rightclick"]	= "Alle entfernen: <Mod. Taste> + |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t",
        ["options_remove_all_markers_with_shift_rightclick_TT"]	= "Entferne alle Markierungen von einem Gegenstand, wenn du diesen mit der rechten Maustaste |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t anklickst während du die <Modifikator Taste> gedrückt hältst.\nWenn du die rechte Maustaste + <Modifikator Taste> erneut auf diesem Gegenstand drückst werden die letzten Markierungen wieder hergestellt.\n\nDies funktioniert nur bis zum nächsten Neuladen der Benutzeroberfläche/Logout!\n\nWenn manuelle Markierungen auf einem Gegenstand gesetzt/entfernt werden, der einen Undo Eintrag besitzt, so wird dieser Undo Eintrag geleert!",
        ["options_modifier_key"]			= "Modifikator Taste",
        ["options_modifier_key_TT"]         = "Die Modifikator Taste ALT, UMSCHALTEN, STRG or COMMAND (nur auf MAC!)",
        ["KEY_SHIFT"] = "Umschalten/Shift",
        ["KEY_ALT"] = "Alt",
        ["KEY_CTRL"] = "Steuerung/STRG",
        ["KEY_COMMAND"] = "Command (Nur MAC!)",
        ["options_undo_add_context_menu_entry"]                = "Entferne alle/Rückgängig Kontextmenü Eintrag",
        ["options_undo_add_context_menu_entry_TT"]             = "Zeige einen \'Entferne alle\' bzw. \'Wiederherstellen\' Kontextmenü Einrag bei den Markierungssymbolen an.",
        ["options_undo_add_context_menu_entry_tooltip"]        = "SHIFT: Zeige Tooltip am Rückgängig Kontextmenü Eintrag",
        ["options_undo_add_context_menu_entry_tooltip_TT"]     = "Drücke und halte die SHIFT Taste, um einen Tooltip mit den zuletzt markierten Symbolen anzuzeigen.",
        ["options_undo_use_different_filterpanels"]                     = "Sichere Undo für jeden Filter Panel",
        ["options_undo_use_different_filterpanels_TT"]             = "Sichert die Undo Markierungen für jeden Filter Panel (Inventar, Bank, Mail, etc.) verschieden.\nDeaktiviert werden die Markierungen für alle gleich gesichert und sind somit überall gleich wiederherstellbar.",
        ["options_research_filter"]		 		 = "Erlaube 'Zur Analyse vorgemerkt'",
        ["options_research_filter_TT"]		 = "Erlaubt 'Zur Analyse vorgemerkte' Gegenstände dennoch im Handwerk Analyse Fenster auszuwählen",
        ["options_icons_description"]       = "In diesem Untermenü können Sie die Markierungssymbole des AddOns konfigurieren.\nEs gibt 3 Typen von Symbolen:\n1. Normal\n2. Ausrüstung Sets\n3. Dynamische\nDeren Untermenü zeigt weitere Beschreibungen an.\n\nHinweise:\n-Wenn Markierungssymbol Text rot in Auswahllisten angezeigt wird, so ist dieses Symbol aktuell deaktiviert.\n-Jedes Markierungssymbol ist zunächst geschützt bis eine Ausnahme (Siehe Untermenü \'Schutz (Anti-Methoden)\') für normale Symbole aktiviert wird, bzw. dynamische Symbole je Symbol anders konfiguriert werden.",
        ["options_icons_non_gear_sets_description"] = "Normale Symbole sind die Standard Symbole dieses AddOns, welche nur in Farbe/Textur/Größe/Postion verändert werden können. Dieses sind für feste Gegebenheiten vorgesehen wie z.B. gegen Verkauf, Zerlegen, Aufwerten beschützen.\nDiese Standard Symbole müssen aktiviert sein wenn Sie z.B. Automatische Markierungen (die Einstellungen finden Sie im Automatische Markierungen Untermenü) nutzen möchte, welche von dem entsprechenden Symbol abhängig sind.\nWenn eine Einstellungsoption nicht aktivierbar ist, versuchen Sie hier das entsprechende Standard Symbol zu aktivieren.",
        ["options_icons_gear_sets_description"]     = "Ausrüstungs Sets sind die 5 Standard Symbole dieses AddOns, welche in Farbe/Textur/Größe/Postion und Name verändert werden können. Diese sind für Ihre Ausrüstung vorgesehen.\nWenn Sie mehr Ausrüstungs Set Symbole benötigen können Sie eines der dynamischen Symbole zu einem Ausrüstung Set Symbol umfunktionieren.",
        ["options_icons_dynamic"]				 = "Dynamische Symbole",
        ["options_icons_dynamic_usable"]				 =  "Dynamische Symbole - Gesamt verwendbar",
        ["options_icons_dynamic_usable_TT"]				 =  "Setze die Anzahl Dynamische Symbole, welche durch das AddOn maximal verwendet werden darf.",
        ["options_icons_dynamic_usable_warning"]		 =  "Dynamische Symbole sind die nicht-standard Markierungen dieses AddOns welche nicht nur die Farbe/Textur/Größe/Position und Name verändern können, sondern sogar je Symbol individuell die Beschütz (Anti-*)- und weitere Einstellungen verändern können. Jedes der dynamischen Symbolen kann genau für Ihre Belange eingestellt werden.\n\nVerändern sie hier die maximal verwendbaren Dynamischen Symbole. Je niederiger der Wert, so besser die Einstellungs- und Kontextmenü Performance.\n[|cFF0000ACHTUNG|r]Die Benutzeroberfläche wird direkt neu geladen, wenn diese Option verändert wird.\nBitte schauen Sie danach auch in den Kontextmenü Einstellugen nach den dynamischen Untermenüs, und passen diese an (sofern benötigt).",

        ["options_icons_dynamic_gear"]			 = "Dynamische Ausrüstungs Sets",
        ["options_icons_non_gear"]				 = "Normale Symbole",
        ["options_icons_gears"]				 	 = "Ausrüstung Sets",
        ["options_icons_gear1"]					 = "Set 1",
        ["options_icons_gear2"]					 = "Set 2",
        ["options_icons_gear3"]					 = "Set 3",
        ["options_icons_gear4"]					 = "Set 4",
        ["options_icons_gear5"]					 = "Set 5",
        ["options_icon_none"]                   = "- Kein Symbol -",
        ["options_icon_offset_left"]            = "Abstand links",
        ["options_icon_offset_left_TT"]         = "Abstand des Symbols in den Inventaren, auf der X-Achse (von links)",
        ["options_icon_scale"]                  = "Skalierung %",
        ["options_icon_scale_TT"]               = "Skalierung der Symbolgröße in %",
        ["options_icon_offset_top"]             = "Abstand oben",
        ["options_icon_offset_top_TT"]          = "Abstand des Symbols in den Inventaren, auf der Y-Achse (von oben)",
        ["options_header_color"]				 = "Symbole",
        ["options_icon1_color"]					 = "Schloß Filter",
        ["options_icon1_color_TT"]			 = "Farbe für das Symbol der Schloß Filter Markierungen",
        ["options_icon1_texture"]				 = "Symbol",
        ["options_icon1_texture_TT"]		 = "Symbol für die Schloß Filter Markierungen",
        ["options_icon1_size"]				 	 = "Größe",
        ["options_icon1_size_TT"]			 = "Größe des Symboles für die Schloß Filter Markierungen",
        ["options_icon2_color"]					 = "Farbe",
        ["options_icon2_color_TT"]			 = "Farbe für das Symbol der Gear 1 Filter Markierungen",
        ["options_icon2_texture"]				 = "Symbol",
        ["options_icon2_texture_TT"]		 = "Symbol für die Gear 1 Filter Markierungen",
        ["options_icon2_size"]				 	 = "Größe",
        ["options_icon2_size_TT"]			 = "Größe des Symboles für die Gear 1 Filter Markierungen",
        ["options_icon3_color"]					 = "Analyse",
        ["options_icon3_color_TT"]			 = "Farbe für das Symbol der Analyse Filter Markierungen",
        ["options_icon3_texture"]				 = "Symbol",
        ["options_icon3_texture_TT"]		 = "Symbol für die Analyse Filter Markierungen",
        ["options_icon3_size"]				 	 = "Größe",
        ["options_icon3_size_TT"]			 = "Größe des Symboles für die Analyse Filter Markierungen",
        ["options_icon4_color"]					 = "Farbe",
        ["options_icon4_color_TT"]			 = "Farbe für das Symbol der Gear 2 Filter Markierungen",
        ["options_icon4_texture"]				 = "Symbol",
        ["options_icon4_texture_TT"]		 = "Symbol für die Gear 2 Filter Markierungen",
        ["options_icon4_size"]				 	 = "Größe",
        ["options_icon4_size_TT"]			 = "Größe des Symboles für die Gear 2 Filter Markierungen",
        ["options_icon5_color"]					 = "Verkauf",
        ["options_icon5_color_TT"]			 = "Farbe für das Symbol der Verkaufs Filter Markierungen",
        ["options_icon5_texture"]				 = "Symbol",
        ["options_icon5_texture_TT"]		 = "Symbol für die Verkaufs Filter Markierungen",
        ["options_icon5_size"]				 	 = "Größe",
        ["options_icon5_size_TT"]			 = "Größe des Symboles für die Verkaufs Filter Markierungen",
        ["options_icon6_color"]					 = "Farbe",
        ["options_icon6_color_TT"]			 = "Farbe für das Symbol der Gear 3 Filter Markierungen",
        ["options_icon6_texture"]				 = "Symbol",
        ["options_icon6_texture_TT"]		 = "Symbol für die Gear 3 Filter Markierungen",
        ["options_icon6_size"]				 	 = "Größe",
        ["options_icon6_size_TT"]			 = "Größe des Symboles für die Gear 3 Filter Markierungen",
        ["options_icon7_color"]					 = "Farbe",
        ["options_icon7_color_TT"]			 = "Farbe für das Symbol der Gear 4 Filter Markierungen",
        ["options_icon7_texture"]				 = "Symbol",
        ["options_icon7_texture_TT"]		 = "Symbol für die Gear 4 Filter Markierungen",
        ["options_icon7_size"]				 	 = "Größe",
        ["options_icon7_size_TT"]			 = "Größe des Symboles für die Gear 4 Filter Markierungen",
        ["options_icon8_color"]					 = "Farbe",
        ["options_icon8_color_TT"]			 = "Farbe für das Symbol der Gear 5 Filter Markierungen",
        ["options_icon8_texture"]				 = "Symbol",
        ["options_icon8_texture_TT"]		 = "Symbol für die Gear 5 Filter Markierungen",
        ["options_icon8_size"]				 	 = "Größe",
        ["options_icon8_size_TT"]			 = "Größe des Symboles für die Gear 5 Filter Markierungen",
        ["options_icon2_name"]					 = "Gear 1",
        ["options_icon2_name_TT"]			 = "Ihr gewählter Name für das Gear 1 Symbol",
        ["options_icon4_name"]					 = "Gear 2",
        ["options_icon4_name_TT"]			 = "Ihr gewählter Name für das Gear 2 Symbol",
        ["options_icon6_name"]					 = "Gear 3",
        ["options_icon6_name_TT"]			 = "Ihr gewählter Name für das Gear 3 Symbol",
        ["options_icon7_name"]					 = "Gear 4",
        ["options_icon7_name_TT"]			 = "Ihr gewählter Name für das Gear 4 Symbol",
        ["options_icon8_name"]					 = "Gear 5",
        ["options_icon8_name_TT"]			 = "Ihr gewählter Name für das Gear 5 Symbol",
        ["options_icon2_activate_text"]				 = "Ausrüstung Set 1 aktivieren",
        ["options_icon4_activate_text"]				 = "Ausrüstung Set 2 aktivieren",
        ["options_icon6_activate_text"]				 = "Ausrüstung Set 3 aktivieren",
        ["options_icon7_activate_text"]				 = "Ausrüstung Set 4 aktivieren",
        ["options_icon8_activate_text"]				 = "Ausrüstung Set 5 aktivieren",
        ["options_icon1_TT"]				 = "Tooltip anzeigen",
        ["options_icon1_tooltip_TT"]		 = "Tooltip beim Schloß Symbol anzeigen",
        ["options_icon2_TT"]				 = "Tooltip anzeigen",
        ["options_icon2_tooltip_TT"]		 = "Tooltip beim Gear 1 Symbol anzeigen",
        ["options_icon3_TT"]				 = "Tooltip anzeigen",
        ["options_icon3_tooltip_TT"]		 = "Tooltip beim Analyse Symbol anzeigen",
        ["options_icon4_TT"]				 = "Tooltip anzeigen",
        ["options_icon4_tooltip_TT"]		 = "Tooltip beim Gear 2 Symbol anzeigen",
        ["options_icon5_TT"]				 = "Tooltip anzeigen",
        ["options_icon5_tooltip_TT"]		 = "Tooltip beim Verkaufs Symbol anzeigen",
        ["options_icon6_TT"]				 = "Tooltip anzeigen",
        ["options_icon6_tooltip_TT"]		 = "Tooltip beim Gear 3 Symbol anzeigen",
        ["options_icon7_TT"]				 = "Tooltip anzeigen",
        ["options_icon7_tooltip_TT"]		 = "Tooltip beim Gear 4 Symbol anzeigen",
        ["options_icon8_TT"]				 = "Tooltip anzeigen",
        ["options_icon8_tooltip_TT"]		 = "Tooltip beim Gear 5 Symbol anzeigen",
        ["options_icon9_TT"]				 = "Tooltip anzeigen",
        ["options_icon9_tooltip_TT"]		 = "Tooltip beim Verwerten Symbol anzeigen",
        ["options_icon10_TT"]				 = "Tooltip anzeigen",
        ["options_icon10_tooltip_TT"]		 = "Tooltip beim Aufwerten Symbol anzeigen",
        ["options_tooltipatchar"]		 		 = "Tooltip im Charakterfenster",
        ["options_tooltipatchar_TT"]		 = "Zeige den Tooltip auch im Charakter Fenster an",
        ["options_icon9_color"]					 = "Verwerten",
        ["options_icon9_color_TT"]			 = "Farbe für das Symbol der Verwerten Filter Markierungen",
        ["options_icon9_texture"]				 = "Symbol",
        ["options_icon9_texture_TT"]		 = "Symbol für die Verwerten Filter Markierungen",
        ["options_icon9_size"]				 	 = "Größe",
        ["options_icon9_size_TT"]			 = "Größe des Symbols für die Verwerten Filter Markierungen",
        ["options_icon9_tooltip_text"]			 = "Markiert für das Verwerten",
        ["options_icon10_color"]				 = "Aufwerten",
        ["options_icon10_color_TT"]		 = "Farbe für das Symbol der Aufwerten Filter Markierungen",
        ["options_icon10_texture"]				 = "Symbol",
        ["options_icon10_texture_TT"]		 = "Symbol für die Aufwerten Filter Markierungen",
        ["options_icon10_size"]				 	 = "Größe",
        ["options_icon10_size_TT"]			 = "Größe des Symbols für die Aufwerten Filter Markierungen",
        ["options_icon10_tooltip_text"]			 = "Markiert für das Aufwerten",
        ["options_icon11_TT"]				 = "Tooltip anzeigen",
        ["options_icon11_tooltip_TT"]		 = "Tooltip beim Verkauf im Gildenladen Symbol anzeigen",
        ["options_icon11_color"]				 = "Verkauf im Gildenladen",
        ["options_icon11_color_TT"]		 = "Farbe für das Symbol der Verkauf im Gildenladen Filter Markierungen",
        ["options_icon11_texture"]				 = "Symbol",
        ["options_icon11_texture_TT"]		 = "Symbol für die Verkauf im Gildenladen Markierungen",
        ["options_icon11_size"]				 	 = "Größe",
        ["options_icon11_size_TT"]			 = "Größe des Symbols für die Verkaufen im Gildenladen Filter Markierungen",
        ["options_icon11_tooltip_text"]			 = "Markiert für den Verkauf im Gildenladen",
        ["options_icon11_only_unbound"]			 = "Nur ungebundene",
        ["options_icon11_only_unbound_TT"]	 = "Es können nur ungebundene Gegenstände zum Verkauf im Gildenladen markiert werden",
        ["options_icon12_TT"]				 = "Tooltip anzeigen",
        ["options_icon12_tooltip_TT"]		 = "Tooltip beim Aufwendig Symbol anzeigen",
        ["options_icon12_color"]				 = "Aufwendig",
        ["options_icon12_color_TT"]		 = "Farbe für das Symbol der Aufwendig Filter Markierungen",
        ["options_icon12_texture"]				 = "Symbol",
        ["options_icon12_texture_TT"]		 = "Symbol für die Aufwendig Markierungen",
        ["options_icon12_size"]				 	 = "Größe",
        ["options_icon12_size_TT"]			 = "Größe des Symbols für die Aufwendig Filter Markierungen",
        ["options_icon12_tooltip_text"]			 = "Markiert als Aufwendig",
        ["options_icon_mark_as_gear"]			= "Nutze als Ausrüstungs Set",
        ["options_icon_mark_as_gear_TT"]	= "Verwendet dieses Markierungssymbol als Ausrüstungs Set.",

        ["filter_lockdyn_all"]				 	 = "Schloss / Dynamische Symbole",
        ["filter_lockdyn_1"]					 = "Schloss Symbol",

        ["options_icon1_activate_text"]			 = "Schloss aktivieren",
        ["options_icon3_activate_text"]			 = "Analyse aktivieren",
        ["options_icon5_activate_text"]			 = "Verkauf aktivieren",
        ["options_icon9_activate_text"]			 = "Verwerten aktivieren",
        ["options_icon10_activate_text"]		 = "Aufwerten aktivieren",
        ["options_icon11_activate_text"]		 = "Verkauf im Gildenladen aktivieren",
        ["options_icon12_activate_text"]		 = "Aufwendig aktivieren",
        ["options_icon_activate_text_TT"]	 = "Aktiviert das Symbol in den Kontextmenüs. Ist die Option ausgeschaltet wird das Symbol im Kontextmenü ausgeblendet.",

        ["options_icon1_tooltip_text"]			 = "Gesperrt",
        ["options_icon_gear_tooltip_text"]		 = "Gehört zu Gear: ",
        ["options_icon_gears_tooltip_text"]		 = "Gehört zu Gears: ",
        ["options_icon3_tooltip_text"]			 = "Markiert für die Analyse",
        ["options_icon5_tooltip_text"]			 = "Markiert für den Verkauf",

        ["options_header_keybind_options"]		= "Tastenkombinationen (Keybinds)",
        ["options_icon_cycle_on_keybind"]		= "Wechsle Symbole durch mit Standard",
        ["options_icon_cycle_on_keybind_TT"]    = "Wechsel die Markierungs Symbole nacheinander mit der \'Standard\' Tastenkombination durch.\n\nWenn diese Option aktiviert ist werden alle aktiven Symbole, vom \'Schloss\' bis zum letzten dynamischen, durchgewechselt.\nIst diese Option deaktiviert wird lediglich das Standard Symbol (Auswählen in den Tastenkombinationen Einstellungen) für den aktuellen Gegenstand gesetzt.",
        ["options_icon_standard_on_keybind"]	= "Standard Symbol (Markierung durch Taste)",
        ["options_icon_standard_on_keybind_TT"] = "Das Standard Symbol, welches gesetzt wird, wenn die Tastenkombination für 'Mit Standard Symbol markieren' benutzt wird.\nIst die Option \'Wechsle Symbole durch mit Standard\' aktiviert so ist diese Auswahl hier nicht aktiv.",
        ["options_keybind_move_item_to_junk_enabled"] = "Zum Trödel schieben",
        ["options_keybind_move_item_to_junk_enabled_TT"] = "Tastenkombination aktivieren: Den ausgewählten Gegenstand zum Trödel veschieben.",
        ["options_keybind_move_item_to_junk_add_sell_icon"] = "Trödel: Auto. Verkaufen Symbol",
        ["options_keybind_move_item_to_junk_add_sell_icon_TT"] = "Automatisch alle Markierungen entfernen und das Verkaufen Symbol auf dem Gegenstand setzen, welcher per Tastenkombination zum Trödel verschoben wird.",
        ["options_keybind_enable_chording"]     = "Aktiviere Tastenkomb. Tasten (SHIFT/STRG/ALT)",
        ["options_keybind_enable_chording_TT"]  = "Aktiviere die zusätzlichen Tasten SHIFT/STRG/ALT für Tastenkombinationen in den Steuerung Optionen.",


        ["options_header_sort_order"]			= "Symbol Sortier Reihenfolge",
        ["options_icon_sort_order_TT"]     = "Selektiere das Symbol aus der Auswahlliste welches du an der Position (Nummer, welche links angezeigt wird) im Kontextmenü sehen möchtest.",
        ["options_icon_sort_order_warning"]		= "Die Sortier Reihenfolge für die Kontexmenüs:\nACHTUNG: Jedes Symbol darf nur einer Nummer zugewiesen werden! Sind Symbole mehrfach vergeben wird Ihre Sortierreihenfolge NICHT berücksichtigt und die Standard Sortierreihenfolge wird verwendet!",
        ["options_icon_sort_order_add_inv_button_flag_too"] = "Sortiere Inventar "..addInvFlagIcon.." Kontextmenü",
        ["options_icon_sort_order_add_inv_button_flag_too_TT"] = "Sortiere auch das zusätzliche Inventar \'Flaggen\' ("..addInvFlagIcon..") Kontextmenü.\nWenn Untermenüs für Normale, Gear Sets und Dynamische Symbole verwendet werden, dann werden diese jeweils in sich sortiert (nach den Vorgaben in diesen Sortier Einstellungen).",
        ["options_header_sort_order_output"] =      "Symbol Ausgabe Sortierung",
        ["options_header_sort_order_output_TT"]   = "Selektiere das Symbol aus der Auswahlliste welches du bei der Ausgabe (z.B. in Inventarzeilen) an der Position (Nummer, welche links angezeigt wird) sehen möchtest. Die Symbole werden von der letzten bis zur ersten Position erstellt und überlagern sich entsprechend in deiner gewählten Reihenfolge.\nNach einer Änderung der Reihenfolge werden sich bereits erstellte Markierungssymbole ggf. nicht direkt aktualisieren. Dazu müssen Inventar Filter verändert werden, oder sogar die Benutzeroberfläche neu geladen werden.",

        ["options_gear_disable_research_check"] 		= "Deaktiviere \'Nur Rüstung/Waffen\'",
        ["options_gear_disable_research_check_TT"] = "Deaktiviert die Prüfung auf Rüstung/Waffen bei diesem Symbol, damit das Symbol auch für nicht-analysierbare Gegenstände gesetzt werden kann.",
        ["options_gear_enable_as_gear"] 		        = "Aktiviere als Gear Set",
        ["options_gear_enable_as_gear_TT"]         = "Aktiviere dieses Symbol als Gear Set.",
        ["options_header_character"]			 = "Charakter Fenster",
        ["options_header_character_armor_type"]	 = "Rüstungsart",
        ["options_show_armor_type_icon"]		 = "Zeige Rüstungsart Symbol",
        ["options_show_armor_type_icon_TT"] = "Zeigt je ausgerüstetem Rüstungsteil die Art der Rüstung als Symbol an, direkt neben dem Rüstungsteil (an der Spieler Puppe)",
        ["options_show_armor_type_header_text"]	 = "Zeige Rüstungsart Überschrift",
        ["options_show_armor_type_header_text_TT"] = "Zeigt die Anzahl der getragenen leichten, mittleren und schweren Rüstungsteile als Text in der Charakter Fenster Rüstungs Überschrift an",
        ["options_armor_type_icon_character_pos_x"]	 = "Rüstungsart Symbol Position X",
        ["options_armor_type_icon_character_pos_x_TT"]	= "Wähle die X-Achsen Position für das Rüstungsart Symbol im Charakter Fenster, relativ zur oben rechten Ecke des jeweiligen Rüstungsteils, aus",
        ["options_armor_type_icon_character_pos_y"]	 = "Rüstungsart Symbol Position Y",
        ["options_armor_type_icon_character_pos_y_TT"]	= "Wähle die Y-Achsen Position für das Rüstungsart Symbol im Charakter Fenster, relativ zur oben rechten Ecke des jeweiligen Rüstungsteils, aus",
        ["options_armor_type_icon_character_light_color"]= "Rüstungsart Symbol Farbe (Leicht)",
        ["options_armor_type_icon_character_light_color_TT"]	= "Wähle die Farbe für das leichte Rüstungsart Symbol aus",
        ["options_armor_type_icon_character_medium_color"]= "Rüstungsart Symbol Farbe (Mittel)",
        ["options_armor_type_icon_character_medium_color_TT"]	= "Wähle die Farbe für das mittlere Rüstungsart Symbol aus",
        ["options_armor_type_icon_character_heavy_color"]= "Rüstungsart Symbol Farbe (Schwer)",
        ["options_armor_type_icon_character_heavy_color_TT"]	= "Wähle die Farbe für das schwere Rüstungsart Symbol aus",
        ["options_armor_type_icon_light_short"]		= "L",
        ["options_armor_type_icon_medium_short"]	= "M",
        ["options_armor_type_icon_heavy_short"]		= "S",

        ["options_header_context_menu"]			 = "Kontextmenüs",
        ["options_header_context_menu_inventory"] = "Im Inventar",
        ["options_header_context_menu_filter_buttons"] = "Filter Knöpfe",
        ["options_context_menu_filter_buttons_max_icons"]           = "Zeige Untermenü: ab Anzahl Symbole",
        ["options_context_menu_filter_buttons_max_icons_TT"]   = "Wenn die Kontextmenüs für Filter Knöpfe aktiviert sind und diese Anzahl der zugeordneten Markierungssymbole im Kontextmenü aktiviert sind:\nDann wird ein Untermenü im Kontextmenü erstellt, um das Kontextmenü zu verkürzen.\n\nDer Wert 0 aktiviert das Untermenü!",
        ["options_use_subcontextmenu"]			 = "Untermenü im Kontextmenü verwenden",
        ["options_use_subcontextmenu_TT"]	 = "Ist diese Option an wird das Kontextmenü einen 'FCOItemSaver' Untermenü Punkt enthalten, unter welchem alle FCOIS Optionen für den Gegegstand auswählbar sind. Ist diese Option aus werden alle FCOIS Optionen für den Gegenstand direkt im Kontextmenü angezeigt.",
        ["options_header_context_menu_divider"] = "FCOIS Trenner Zeile",
        ["options_header_context_menu_divider_TT"] = "Die FCOIS Trenner Zeile wird nur dann angezeigt, wenn das generelle Untermenü im Inventar Kontextmenü deaktiviert ist!",
        ["options_show_contextmenu_divider"]	 = "Füge Kontextmenü Trenner hinzu",
        ["options_show_contextmenu_divider_TT"] = "Zeigt einen informativen Trenner zwischen den Standard Gegenstand Optionen im Kontextmenü, und den FCOItemSaver Kontextmenü Einträgen an",
        ["options_contextmenu_divider_opens_settings"] = "Trenner öffnet Einstellungen",
        ["options_contextmenu_divider_opens_settings_TT"] = "Ein Klick auf den Trenner im Kontextmenü öffnet die FCOItemSaver Einstellungen",
        ["options_contextmenu_divider_clears_all_markers"] = "Trenner entfernt alle Symbole",
        ["options_contextmenu_divider_clears_all_markers_TT"] = "Ein Klick auf den Trenner im Kontextmenü entfernt alle Markierungen/Symbole bei diesem Gegenstand (erneut auf den Trenner klicken, um die letzten Symbole wieder herzustellen)",
        ["options_contextmenu_leading_spaces"]				= "Einträge mit führ. Leerzeichen",
        ["options_contextmenu_leading_spaces_TT"]		= "Die Kontextmenü Einträge sollen mit dieser Anzahl führenden Leerzeichen eingerückt werden, um die Lesbarkeit zu erhöhen.",
        ["options_contextmenu_use_custom_marked_normal_color"]			= "Farblich markierte Einträge",
        ["options_contextmenu_use_custom_marked_normal_color_TT"]	= "Stellt die gerade aktiven (markierte Gegenstände, z.B. durch 'Gesperrt') Kontextmenü Einträge farblich anders dar",
        ["options_contextmenu_custom_marked_normal_color"]				= "Farbe für markierte Einträge",
        ["options_contextmenu_custom_marked_normal_color_TT"]		= "Die Farbe, in welcher die Kontextmenü Einträge für markierte Gegenstände dargestellt werden.",

        ["options_header_filter_buttons_position"]	= "Filter Knopf Positionen",
        ["options_header_pos"]			 = "Symbol Positionen & Größe",
        ["options_pos_inventories"]		 = "In den Inventaren",
        ["options_pos_inventories_TT"]	 = "Die X-Achsen Position der Symbole in den Inventaren",
        ["options_pos_crafting"]		 	= "In Handwerksstationen",
        ["options_pos_crafting_TT"]	= "Die X-Achsen Position der Symbole in den Inventaren der Handwerksstationen",
        ["options_pos_character_x"]		 = "X - Im Charakter Fenster",
        ["options_pos_character_x_TT"]	 = "Die X-Achsen Position der Symbole im Charakter Fenster",
        ["options_pos_character_y"]		 = "Y - Im Charakter Fenster",
        ["options_pos_character_y_TT"]	 = "Die Y-Achsen Position der Symbole im Charakter Fenster",
        ["options_size_character"]		 = "Größe - Im Charakter Fenster",
        ["options_size_character_TT"]	 = "Die Größe der Symbole im Charakter Fenster.",
        ["options_header_split_filters"]		 = "Filter Knöpfe aufteilen",
        ["options_header_filters"]		         = "Filter",
        ["options_split_filters"]				 = "Filterknöpfe nicht verbinden",
        ["options_split_filters_TT"]		 = "Erlaubt es die Filter im Inventar, Verkäufer, Bank, Gilden Bank, Gildenladen, Handwerksstationen, Verzauberungstisch, Mail und Handel einzeln zu setzen.\n\nIst diese Option deaktiviert werden die Filterknöpfe in allen Inventaren identisch gesteuert!",
        ["options_enable_filter_in_inventory"]	 = "Filter im Inventar aktivieren",
        ["options_enable_filter_in_inventory_TT"]	 = "Ermöglicht es dir die markierten Gegenstände auch in deinem Inventar zu verstecken",
        ["options_enable_filter_in_craftbag"]			= "Filter im Handwerksbeutel aktivieren",
        ["options_enable_filter_in_craftbag_TT"]	= "Ermöglicht es dir die markierten Gegenstände auch in deinem Handwerksbeutel zu verstecken",
        ["options_enable_filter_in_bank"]		 = "Filter in Bank aktivieren",
        ["options_enable_filter_in_bank_TT"]		 = "Ermöglicht es dir die markierten Gegenstände auch in deiner Bank zu verstecken",
        ["options_enable_filter_in_guildbank"]	 = "Filter in Gildenbank aktivieren",
        ["options_enable_filter_in_guildbank_TT"]	 = "Ermöglicht es dir die markierten Gegenstände auch in deiner Gilden Bank zu verstecken",
        ["options_enable_filter_in_tradinghouse"]= "Filter im Gildenladen aktivieren",
        ["options_enable_filter_in_tradinghouse_TT"]= "Ermöglicht es dir die markierten Gegenstände auch in deinem Gildenladen zu verstecken",
        ["options_enable_filter_in_trade"]		 = "Filter beim Handeln aktivieren",
        ["options_enable_filter_in_trade_TT"]		 = "Ermöglicht es dir die markierten Gegenstände auch beim Handeln mit Spielern zu verstecken",
        ["options_enable_filter_in_mail"]		 = "Filter bei Nachrichten aktivieren",
        ["options_enable_filter_in_mail_TT"]		 = "Ermöglicht es dir die markierten Gegenstände auch beim Nachrichten Erstellen zu verstecken",
        ["options_enable_filter_in_deconstruction"]		 = "Filter beim Verwerten aktivieren",
        ["options_enable_filter_in_deconstruction_TT"]		 = "Ermöglicht es dir die markierten Gegenstände auch beim Verwerten an einer Handwerksstation zu verstecken",
        ["options_enable_filter_in_improvement"]		 = "Filter beim Aufwerten aktivieren",
        ["options_enable_filter_in_improvement_TT"]		 = "Ermöglicht es dir die markierten Gegenstände auch beim Aufwerten an einer Handwerksstation zu verstecken",
        ["options_enable_filter_in_jewelry_refinement"]				= "Filter beim Schmuck Veredeln aktivieren",
        ["options_enable_filter_in_jewelry_refinement_TT"]	 	= "Ermöglicht es dir die markierten Gegenstände auch beim Schmuck Veredeln an einer Handwerksstation zu verstecken",
        ["options_enable_filter_in_jewelry_deconstruction"]		 = "Filter beim Schmuck Verwerten aktivieren",
        ["options_enable_filter_in_jewelry_deconstruction_TT"]		 = "Ermöglicht es dir die markierten Gegenstände auch beim Schmuck Verwerten an einer Handwerksstation zu verstecken",
        ["options_enable_filter_in_jewelry_improvement"]		 = "Filter beim Schmuck Aufwerten aktivieren",
        ["options_enable_filter_in_jewelry_improvement_TT"]		 = "Ermöglicht es dir die markierten Gegenstände auch beim Schmuck Aufwerten an einer Handwerksstation zu verstecken",
        ["options_enable_filter_in_research"]				        = "Filter bei der Analyse aktivieren",
        ["options_enable_filter_in_reasearch_TT"]	 	        = "Ermöglicht es dir die markierten Gegenstände auch beim Analysieren an einer Handwerksstation zu verstecken",
        ["options_enable_filter_in_jewelry_research"]			    = "Filter bei der Schmuck Analyse aktivieren",
        ["options_enable_filter_in_jewelry_reasearch_TT"]	 	= "Ermöglicht es dir die markierten Gegenstände auch beim Schmuck Analysieren an einer Handwerksstation zu verstecken",
        ["options_enable_filter_in_store"]		 = "Filter beim Verkauf aktivieren",
        ["options_enable_filter_in_store_TT"]		 = "Ermöglicht es dir die markierten Gegenstände auch beim Verkauf bei einem Händler zu verstecken",
        ["options_enable_filter_in_enchanting"]		 = "Filter beim Verzaubern aktivieren",
        ["options_enable_filter_in_enchanting_TT"]		 = "Ermöglicht es dir die markierten Gegenstände auch beim Erstellen und Verwerten am Verzauberungstisch zu verstecken",
        ["options_enable_filter_in_fence"]		 = "Filter beim Hehler aktivieren",
        ["options_enable_filter_in_fence_TT"]		 = "Ermöglicht es dir die markierten Gegenstände auch beim Verkauf bei einem Hehler zu verstecken",
        ["options_enable_filter_in_launder"]		 = "Filter bei Geldwäsche aktivieren",
        ["options_enable_filter_in_launder_TT"]		 = "Ermöglicht es dir die markierten Gegenstände auch bei der Geldwäsche beim Hehler zu verstecken",
        ["options_header_deactivated_symbols"]						= "Deaktivierte Symbole",
        ["options_deactivated_symbols_apply_anti_checks"]			= "Wende Anti-Überprüfungen an",
        ["options_deactivated_symbols_apply_anti_checks_TT"]	= "Es werden für Gegenstände, welche mit einem zur Zeit deaktivierten (und damit nicht sichtbarem) Symbol markiert wurden, ebenfalls die normalen Anti-Zerstören/Anti-Verwerten/Anti-* Überprüfungen durchgeführt!\nSollten Sie eine deaktivierte Markierung entfernen möchten, so müssen Sie das deaktivierte Symbol zunächst wieder aktivieren.",
        ["options_header_repair"] = GetString(SI_STORE_MODE_REPAIR),
        ["options_header_enchant"] = GetString(SI_ITEMTYPEDISPLAYCATEGORY15),
        ["options_allow_marked_repair"] = "Deaktiviere Reperatur Set",
        ["options_allow_marked_repair_TT"] = "Verhindere, dass mit einem Symbol markierte Reperaturmaterialien für die Reperatur deiner Ausrüstung verwendet werden können.\nDu kannst das Symbol im Reperatur Dialog jederzeit entfernen, um das Reperaturwerkzeug zu erlauben.",
		["options_allow_marked_enchant"] = "Deaktiviere Glyphen Verzaubern",
		["options_allow_marked_enchant_TT"] = "Verhindere, dass mit einem Symbol markierte Glyphen für das Verzaubern deiner Ausrüstung verwendet werden können.\nDu kannst das Symbol im Verzaubern Dialog jederzeit entfernen, um die Glyphe zum Verzaubern zu erlauben.",
        ["options_enable_filtered_item_count"]	        = "Anzahl angezeigte Gegenstände vor 'NAME'",
        ["options_enable_filtered_item_count_TT"]	= "Bei jeder Veränderung der Filter wird die Anzahl der aktuell angezeigten Gegenstände vor der Sortier Überschrift 'Name' angezeigt",
        --Other options
        ["options_header_marking_undo"]          = "Undo",
        ["options_header_items"]				 = "Automatische Markierung",
        ["options_header_items_prevent"]		 = "Automatische Markierung - Verhindern",
        ["options_header_items_demark"]			 = "Automatische De-Markierung",
        ["options_header_items_remark"]			 = "Automatische Re-Markierung",
        ["options_remark_on_enchant"]           = "Nach dem Verzaubern",
        ["options_remark_on_enchant_TT"]        = "Automatisch Gegenstände wieder mit denselben Markierungssymbolen markieren, nach dem Verzaubern.",
        ["options_remark_on_improvement"]           = "Nach dem Aufwerten",
        ["options_remark_on_improvement_TT"]        = "Automatisch Gegenstände wieder mit denselben Markierungssymbolen markieren, nach dem Aufwerten.",
        ["options_header_items_demark_all"]	    = "De-markiere alle anderen",
        ["options_header_items_mark_new"]	            =   "Neu",
        ["options_enable_auto_mark_new_items"]          =   "Neue Gegenstände",
        ["options_enable_auto_mark_new_items_TT"]  =   "Automatisch neue Gegenstände mit einem gewählten Symbol markieren",
        ["options_auto_mark_new_items_icon"]            =   "Neuer Gegenstand Symbol",
        ["options_auto_mark_new_items_icon_TT"]    =   "Das Markierungssymbol für neue Gegenstände",
        ["options_enable_auto_mark_ornate_items"] = "Wertvolle Gegenstände",
        ["options_enable_auto_mark_ornate_items_TT"] =  "Automatisch Gegenstände mit höherem Verkaufspreis zum Verkauf markieren",
        ["options_auto_mark_ornate_items_icon"] = "Verkaufspreis Markierungs Icon",
        ["options_auto_mark_ornate_items_icon_TT"] = "Das Symbol, mit welchem Items mit erhöhtem Verkaufspreis autmoatisch markiert werden sollen",
        ["options_enable_auto_mark_intricate_items"] = "Aufwendige Gegenstände",
        ["options_enable_auto_mark_intricate_items_TT"] =  "Automatisch Aufwendige Gegenstände (Handwerk) markieren",
        ["options_auto_mark_intricate_items_icon"] = "Aufwendiger Gegenstand Symbol",
        ["options_auto_mark_intricate_items_icon_TT"] = "Das Symbol, mit welchem Gegenstände mit erhöhtem Aufwand autmoatisch markiert werden sollen",
        ["options_enable_auto_mark_intricate_items_in_chat"] = "Gegenstand im Chat auflisten",
        ["options_enable_auto_mark_intricate_items_in_chat_TT"] =  "Gegenstände mit erhöhtem Aufwand (Handwerk) im Chat auflisten",
        ["options_enable_auto_mark_wasted_research_scrolls"] = "Verschwendete Analyse Schriftrollen",
        ["options_enable_auto_mark_wasted_research_scrolls_TT"] = "Markiert automatisch die Analyse Handwerksschriften welche eine größere Reduzierung an Analyse-Zeit ergeben würden, als die Restzeit der aktuell analysierten Slots beträgt.\n\nBenötigt das AddOn 'DetailedResearchScrolls' aktiviert!",
        ["options_auto_mark_research_items_icon"] = "Analyse Markierungs Icon",
        ["options_auto_mark_research_items_icon_TT"] = "Das Icon, mit welchem analysierbare Gegenstände autmoatisch markiert werden sollen",
        ["options_enable_auto_mark_recipes"]			= "Unbekannte Rezepte markieren",
        ["options_enable_auto_mark_recipes_TT"]	= "Markiert automatisch unbekannte Rezepte mit dem gewählten Symbol",
        ["options_enable_auto_mark_known_recipes"]		= "Bekannte Rezepte markieren",
        ["options_enable_auto_mark_known_recipes_TT"]	= "Markiert automatisch bekannte Rezepte.",
        ["options_enable_auto_mark_recipes_in_chat"]	= "Rezept im Chat auflisten",
        ["options_enable_auto_mark_recipes_in_chat_TT"] = "Listet automatisch markierte, unbekannte Rezepte im Chat auf",
        ["options_auto_mark_addon"]             =   "Zu verwendendes Addon",
        ["options_auto_mark_addon_TT"]     =   "Addon, welches für die automatischen <<1>> Markierungen verwendet werden soll",
        ["options_auto_mark_recipes_this_char"]			= "Nur für diesen Charakter",
        ["options_auto_mark_recipes_this_char_TT"]	= "Wenn Sie diese Option aktivieren werden nur für den aktuell eingeloggten Charakter (un)bekannte Rezepte markiert!\n\nWenn diese Option deaktiviert wird, werden die (un)bekannten Rezepte für andere Charaktere ebenfalls markiert, sofern:\n-Die Accountweiten Einstellungen von FCOIS verwendet werden\n-Die folgenden Punkte zum gewählten Rezept AddOn zutreffen:\n\n[Gewähltes Rezept AddOn: \'SousChef\']\n-Die SousChef Einstellung \'Charakter Rezeptsammlung in Kurzinfos auflisten\' muss aktiviert sein\n-Nur der in den SousChef Einstelungen gewählte 'Haupt Koch Charakter' wird geprüft. Eine Prüfung aller anderen Charaktere ist aktuell nicht möglich mit dem AddOn SousChef!\n\n[Gewähltes Rezept AddOn: \'CraftStoreFixedAndImproved\']\nWenn auf dem CraftStore Charakter Auswahl Popup (mit der rechten Maustaste) ein Haupt Handwerks Charakter gewählt wurde:\nEs wird nur dieser Charakter geprüft.\nAnsonsten werden alle anderen Charaktere geprüft.",
        ["options_enable_auto_mark_recipes_hint"]		= "Diese Option ist nur aktiv, wenn das gewählte Rezepte Addon aktiviert wurde.\n\n[SousChef]\nIn den SousChef Einstellungen muss insbesondere die Option 'Charakter Rezeptsammlung in Kurzinfos auflisten' aktiviert werden!",
        ["options_auto_mark_crafted_items"] 			= "Markiere hergestellte Gegenstände",
        ["options_auto_mark_crafted_items_TT"] 	= "Wenn Sie diese Option aktivieren werden, nach dem Herstellen (Crafting) von Gegenständen, Gegenstände automatich mit dem 'Schloß' Symbol markiert.",
        ["options_auto_mark_crafted_items_sets"] 			= "Nur Set Teile markieren",
        ["options_auto_mark_crafted_items_sets_TT"] 	= "Mit dieser Option aktiviert werden nur selbst hergestellte Set Teile automatisch markiert",
        ["options_header_anti_destroy"] = "Schutz (Anti-Methoden)",
        ["options_enable_block_deconstruction"]  = "Deaktiviere Verwerten",
        ["options_enable_block_deconstruction_TT"]  = "Deaktiviert das Verwerten von markierten Gegenständen in Handwerksstationen",
        ["options_enable_block_jewelry_deconstruction"]  = "Deaktiviere Schmuck Verwerten",
        ["options_enable_block_jewelry_deconstruction_TT"]  = "Deaktiviert das Verwerten von markierten Schmuck Gegenständen in Handwerksstationen",
        ["options_enable_block_deconstruction_exception_intricate"]  = "Erlaube Verwerten für Aufwendige Items",
        ["options_enable_block_deconstruction_exception_intricate_TT"]  = "Erlaubt das Verwerten von als 'Aufwendig' markierten Gegenständen",
        ["options_enable_block_deconstruction_exception_deconstruction"]  = "Erlaube Verwerten für Verwerten Items",
        ["options_enable_block_deconstruction_exception_deconstruction_TT"]  = "Erlaubt das Verwerten von für 'Verwerten' markierten Gegenständen",
        ["options_enable_block_deconstruction_exception_deconstruction_all_markers"]  = "Erlaube Verwerten (ignoriere andere Markierungen)",
        ["options_enable_block_deconstruction_exception_deconstruction_all_markers_TT"]  = "Erlaube Verwerten von für 'Verwerten' markierten Gegenständen und ignoriere dabei, wenn der Gegenstand noch mit anderen Markierungen gesichert ist.\n\nAchtung: Das führt z.B. dazu, dass ein Gegenstand verwertet wird, wenn du diesen zum 'Verwerten' markiert hast, auch wenn du es noch als Set Teil z.B. behalten wolltest und eine Setteil Markierung darauf aktiv ist.",
        ["options_enable_block_destroying"]  = "Deaktiviere Zerstören",
        ["options_enable_block_destroying_TT"]  = "Deaktiviert das Zerstören von markierten Gegenständen",
        ["options_enable_block_sending_mail"]  = "Deaktiviere Mail",
        ["options_enable_block_sending_mail_TT"]  = "Deaktiviert das Versenden von markierten Gegenständen per Nachricht",
        ["options_enable_block_trading"]  = "Deaktiviere Handel",
        ["options_enable_block_trading_TT"]  = "Deaktiviert den Handel von markierten Gegenständen mit anderen Spielern",
        ["options_enable_block_selling"]  = "Deaktiviere Verkauf",
        ["options_enable_block_selling_TT"]  = "Deaktiviert den Verkauf von markierten Gegenständen bei einem Händler",
        ["options_enable_block_selling_guild_store"]  = "Deaktiviere Listen/Verkauf im Gildenladen",
        ["options_enable_block_selling_guild_store_TT"]  = "Deaktiviere das Listen/Verkaufen von markierten Gegenständen im Gildenladen",
        ["options_enable_block_fence_selling"]    = "Deaktiviere Verkauf beim Hehler",
        ["options_enable_block_fence_selling_TT"]    = "Deaktiviert den Verkauf von markierten Gegenständen beim Hehler",
        ["options_enable_block_launder_selling"]    = "Deaktiviere Geldwäsche beim Hehler",
        ["options_enable_block_launder_selling_TT"]    = "Deaktiviert die Geldwäsche beim Hehler",
        ["options_block_selling_exception"]			= "Erlaube Verkauf von 'Verkaufen' Items",
        ["options_block_selling_exception_TT"] = "Erlaubt den verkauf von Items, welche zum Verkauf markiert wurden",
        ["options_block_selling_exception_ornate"] = "Erlaube Verkauf von wertvollen Items",
        ["options_block_selling_exception_ornate_TT"] = "Erlaubt den Verkauf von Items, welche als wertvoll markiert wurden",
        ["options_block_selling_exception_intricate"] = "Erlaube Verkauf von aufwendigen Items",
        ["options_block_selling_exception_intricate_TT"] = "Erlaubt den Verkauf von Items, welche als aufwendig markiert wurden",
        ["options_block_selling_exception_guild_store"] = "Erlaube Verkauf 'Im Gildenl. verk.' im Gildenladen",
        ["options_block_selling_exception_guild_store_TT"] = "Erlaube Verkauf von 'Im Gildenladen verkaufen' markierten Gegenständen im Gildenladen",
        ["options_demark_all_selling"]	= "Demarkiere alle bei 'Verkauf'",
        ["options_demark_all_selling_TT"] = "Entferne alle anderen Markierungen, wenn ein Gegenstand mit 'Verkauf' markiert wird",
        ["options_demark_all_selling_guild_store"]	= "Demarkiere alle bei 'Im Gildenl. verk.'",
        ["options_demark_all_selling_guild_store_TT"] = "Entferne alle anderen Markierungen, wenn ein Gegenstand mit 'Verkauf im Gildenladen' markiert wird",
        ["options_demark_all_deconstruct"]	= "Demarkiere alle bei 'Verwerten'",
        ["options_demark_all_deconstruct_TT"] = "Entferne alle anderen Markierungen, wenn ein Gegenstand mit 'Verwerten' markiert wird",
        ["options_demark_all_others"]	    = "Demarkiere alle anderen",
        ["options_demark_all_others_TT"]    = "Entferne alle anderen Markierungen, wenn ein Gegenstand mit diesem Symbol markiert wird",
        ["options_demark_all_others_except_non_dynamic"]	    = "Ausnahme: Normale Symbole",
        ["options_demark_all_others_except_non_dynamic_TT"]    = "Schließe normale Symbole von der automatischen De-Markierung aus",
        ["options_demark_all_others_except_dynamic"]	    = "Ausnahme: Dynamische Symbole",
        ["options_demark_all_others_except_dynamic_TT"]    = "Schließe dynamische Symbole von der automatischen De-Markierung aus",
        ["options_demark_sell_on_others"]                       = "Demarkiere 'Verkauf'",
        ["options_demark_sell_on_others_TT"]               = "Entferne 'Verkauf' Markierung, wenn eine andere Markierung gesetzt wird",
        ["options_demark_sell_guild_store_on_others"]           = "Demarkiere 'Verkauf in Gildenladen'",
        ["options_demark_sell_guild_store_on_others_TT"]   = "Entferne 'Verkauf im Gildenladen' Markierung, wenn eine andere Markierung gesetzt wird",
        ["options_demark_deconstruction_on_others"]           = "Demarkiere 'Verwerten'",
        ["options_demark_deconstruction_on_others_TT"]   = "Entferne 'Verwerten' Markierung, wenn eine andere Markierung gesetzt wird",
        ["options_demark_on_others_exclusion_dynamic"]      = "Ausnahme: Dynamische Symbole",
        ["options_demark_on_others_exclusion_dynamic_TT"]   = "Entferne die Markierung nur dann, wenn nicht ein Dynamisches Symbol gesetzt wird",
        ["options_enable_block_improvement"]  = "Deaktiviere Aufwerten",
        ["options_enable_block_improvement_TT"]  = "Deaktiviert das Aufwerten von markierten Gegenständen an einer Handwerksstation",
        ["options_enable_block_jewelry_improvement"]  = "Deaktiviere Schmuck Aufwerten",
        ["options_enable_block_jewelry_improvement_TT"]  = "Deaktiviert das Aufwerten von markierten Schmuck Gegenständen an einer Handwerksstation",
        ["options_enable_block_improvement_exception_improvement"]  = "Erlaube Aufwerten von Aufwerten Items",
        ["options_enable_block_improvement_exception_improvement_TT"]  = "Erlaubt das Aufwerten von Items, welche als 'Aufwerten' markiert wurden",
        ["options_enable_block_creation"] 			= "Deaktiviere Runen Erstellung",
        ["options_enable_block_creation_TT"]	= "Deaktiviert die Erstellung von Runen am Verzauberungs Tisch mit markierten Gegenständen",
        ["options_enable_block_extraction"]			= "Deaktiviere Runen Extrahierung",
        ["options_enable_block_extraction_TT"]	= "Deaktiviert die Extrahierung von Runen am Verzauberungs Tisch aus markierten Gegenständen",
        ["options_auto_reenable_block_deconstruction"]  = "Reaktiviere Anti-Verwerten automatisch",
        ["options_auto_reenable_block_deconstruction_TT"]  = "Reaktiviert den Anti-Verwerten Schutz automatisch, wenn die Handwerksstation geschlossen wird",
        ["options_auto_reenable_block_jewelry_deconstruction"]  = "Reaktiviere Anti-Schmuck Verwerten automatisch",
        ["options_auto_reenable_block_jewelry_deconstruction_TT"]  = "Reaktiviert den Anti-Schmuck Verwerten Schutz automatisch, wenn die Handwerksstation geschlossen wird",
        ["options_auto_reenable_block_destroying"]  = "Reaktiviere Anti-Zerstören automatisch",
        ["options_auto_reenable_block_destroying_TT"]  = "Reaktiviert den Anti-Zerstören Schutz automatisch, wenn das Inventar/Bank/Gilden-Bank geschlossen werden",
        ["options_auto_reenable_block_sending_mail"]  = "Reaktiviere Anti-Mail automatisch",
        ["options_auto_reenable_block_sending_mail_TT"]  = "Reaktiviert den Anti-Mail Schutz automatisch, wenn das Mail Inventar geschlossen wird",
        ["options_auto_reenable_block_trading"]  = "Reaktiviere Anti-Handel automatisch",
        ["options_auto_reenable_block_trading_TT"]  = "Reaktiviert den Anti-Handel Schutz automatisch, wenn das Handel Inventar geschlossen wird",
        ["options_auto_reenable_block_selling"]  = "Reaktiviere Anti-Verkauf automatisch",
        ["options_auto_reenable_block_selling_TT"]  = "Reaktiviert den Anti-Verkauf Schutz automatisch, wenn das Verkäufer Inventar geschlossen wird",
        ["options_auto_reenable_block_selling_guild_store"]  = "Reaktiviere Gildenladen Anti-Verkauf automatisch",
        ["options_auto_reenable_block_selling_guild_store_TT"]  = "Reaktiviert den Anti-Verkauf Schutz automatisch, wenn das Gildenladen Inventar geschlossen wird",
        ["options_auto_reenable_block_fence_selling"]  = "Reaktiviere Hehler Anti-Verkauf automatisch",
        ["options_auto_reenable_block_fence_selling_TT"]  = "Reaktiviert den Hehler Anti-Verkauf Schutz automatisch, wenn das Hehler Inventar geschlossen wird",
        ["options_auto_reenable_block_launder_selling"]  = "Reaktiviere Hehler Anti-Geldwäsche automatisch",
        ["options_auto_reenable_block_launder_selling_TT"]  = "Reaktiviert den Hehler Anti-Geldwäsche Schutz automatisch, wenn das Hehler Inventar geschlossen wird",
        ["options_auto_reenable_block_improvement"]  = "Reaktiviere Anti-Aufwerten automatisch",
        ["options_auto_reenable_block_improvement_TT"] = "Reaktiviert den Anti-Aufwerten Schutz automatisch, wenn die Handwerksstation geschlossen wird",
        ["options_auto_reenable_block_jewelry_improvement"]  = "Reaktiviere Anti-Schmuck Aufwerten automatisch",
        ["options_auto_reenable_block_jewelry_improvement_TT"] = "Reaktiviert den Anti-Schmuck Aufwerten Schutz automatisch, wenn die Handwerksstation geschlossen wird",
        ["options_auto_reenable_block_creation"] 			= "Reaktiviere Anti-Runen Erstellung automatisch",
        ["options_auto_reenable_block_creation_TT"]	= "Reaktiviert den Anti-Runen Erstellung Schutz automatisch, wenn der Verzauberungstisch geschlossen wird",
        ["options_auto_reenable_block_extraction"]			= "Reaktiviere Anti-Runen Extrahierung automatisch",
        ["options_auto_reenable_block_extraction_TT"]	= "Reaktiviert den Anti-Runen Extrahierung Schutz automatisch, wenn der Verzauberungstisch geschlossen wird",

        ["options_enable_filter_in_alchemy"]		 = "Filter am Alchemietisch aktivieren",
        ["options_enable_filter_in_alchemy_TT"]		 = "Ermöglicht es dir die markierten Gegenstände auch beim Erstellen von Tränken am Alchemietisch zu verstecken",
        ["options_enable_block_alchemy_destroy"]  = "Deaktiviere Alchemie Zerstören",
        ["options_enable_block_alchemy_destroy_TT"]  = "Deaktiviert das Zerstören von markierten Gegenständen am Alchemietisch",
        ["options_auto_reenable_block_alchemy_destroy"]  = "Reaktiviere Alchemie Anti-Zerstören automatisch",
        ["options_auto_reenable_block_alchemy_destroy_TT"]  = "Reaktiviert automatisch den Alchemie Anti-Zerstören Schutz, wenn der Alchemietisch verlassen wird",
        ["options_enable_block_autoloot_container"]			= "Deaktiviere Behälter Auto-Loot",
        ["options_enable_block_autoloot_container_TT"]	= "Deaktiviert das automatische Looten von allen Gegenständen aus einem Behälter, wenn in den ESO Standard Optionen 'Immer alles einsammeln' aktiviert wurde.\n\nIst diese Option aktiviert kann ein markierter Behalter nicht geöffnet werden! Bitte schauen Sie sich das Addon 'Container Peek' an, welches eine zusätzliche Lösung hierfür anbietet!",
        ["options_enable_block_marked_recipes"]			= "Verhindere Rezept Einlesen",
        ["options_enable_block_marked_recipes_TT"]	= "Verhindert, dass mit einem Symbol markierte Rezepte eingelesen werden können",
        ["options_header_additional_inv_flag_context_menu"]   = "Zusätzl. Inventar "..addInvFlagIcon.." Kontextmenü",
        ["options_remove_context_menu_mark_as_junk"] = "Entferne '" .. GetString(SI_ITEM_ACTION_MARK_AS_JUNK) .. "' Kontextmenü",
        ["options_remove_context_menu_mark_as_junk_TT"] = "Entferne den Kontextmenü Eintrag '" .. GetString(SI_ITEM_ACTION_MARK_AS_JUNK) .. "' für markierte Gegenstände",
        ["options_junk_item_marked_to_be_sold"]          = "Erlaubt Trödel (zum Verkauf markiert)",
        ["options_junk_item_marked_to_be_sold_TT"]  = "Erlaubt es Gegenstände in den Trödel zu senden, wenn \'nur\' die Verkauf Markierung gesetzt wurde.",
        ["options_dont_unjunk_on_normal_mark"]                = "Belasse Trödel bei normaler Markierung",
        ["options_dont_unjunk_on_normal_mark_TT"]        = "Belasse Trödel Gegenstände im Trödel wenn diese normal mit dem Kontextmenü oder der Tastenkombination markiert werden.\nIst diese Option deaktiviert, so werden geschützte Gegenstände automatisch aus dem Trödel wieder herausgenommen (nach einer gesetzten Markierung).",
        ["options_dont_unjunk_on_bulk_mark"]                = "Belasse Trödel bei Massenmarkierung",
        ["options_dont_unjunk_on_bulk_mark_TT"]        = "Belasse Trödel Gegenstände im Trödel, wenn diese per zusätzlichem Inventar \'Flaggen\' ("..addInvFlagIcon..") Kontexmenü mit einer Massenmarkierung markiert werden.",
        ["options_dont_unjunk_item_marked_to_be_sold"]          = "Belasse im Trödel (zum Verkauf markiert)",
        ["options_dont_unjunk_item_marked_to_be_sold_TT"]  = "Belasse Gegenstände im Trödel, wenn diese \'nur\' zum Verkauf markiert wurden.",
        ["options_enable_block_motifs"] = "Verhindere Stil-Motiv Einlesen",
        ["options_enable_block_motifs_TT"] = "Verhindere, dass mit einem Symbol markierte Stil-Motive eingelesen werden können",
        ["options_header_motifs"] = "Stil-Motive",
        ["options_header_food"] = "Nahrung & Getränke",
        ["options_enable_block_potions"] = "Verhindere Tränke trinken",
        ["options_enable_block_potions_TT"] = "Verhindere, dass mit einem Symbol markierte Tränke getrunken werden können",
        ["options_enable_block_food"] = "Verhindere Nahrung essen",
        ["options_enable_block_food_TT"] = "Verhindere, dass mit einem Symbol markierte Nahrung gegessen werden kann",
        ["options_header_guild_bank"] = "Gildenbank",
        ["options_enable_block_guild_bank_without_withdraw"] = "Verhindere Einlagern ohne Entnahme Rechte",
        ["options_enable_block_guild_bank_without_withdraw_TT"] = "Verhindere das Einlagern von Gegenständen (auch nicht markierte), wenn du keine Berechtigung besitzt Gegenstände wieder aus dieser Gildenbank zu entnehmen",
        ["options_auto_reenable_block_guild_bank_without_withdraw"]  = "Reaktiviere Anti-Einlagern ohne Entnahmen Rechte automatisch",
        ["options_auto_reenable_block_guild_bank_without_withdraw_TT"]  = "Reaktiviert den Anti-Einlagern ohne Entnahmen Rechte Schutz automatisch, wenn die Gilden Bank geschlossen wird",
        ["options_enable_block_marked_disable_with_flag"]			= "Deaktiviere temporär mit "..addInvFlagIcon.." Symbol",
        ["options_enable_block_marked_disable_with_flag_TT"]	= "Deaktiviert die Anti-Benutzen/-Lesen/-Nehmen/-etc. Optionen temporär, wenn im Inventar auf das zusätzliche Optionen Flaggen ("..addInvFlagIcon..") Symbol rechts |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t geklickt wird",
        ["options_header_equipment"] 			 = "Ausrüstung",
        ["options_equipment_markall_gear"] 		 = "Alles gleichzeitig markieren",
        ["options_equipment_markall_gear_TT"] = "Erlaubt es alle getragene Ausrüstung gleichzeitig als Gear zu markieren, wenn ein getragener Gegenstand als Gear markiert wird",
        ["options_equipment_markall_gear_add_weapons"] 		 = "Waffen mit markieren",
        ["options_equipment_markall_gear_add_weapons_TT"] = "Die Waffen werden automatisch mit markiert",
        ["options_equipment_markall_gear_add_jewelry"] 		 = "Schmuck mit markieren",
        ["options_equipment_markall_gear_add_jewelry_TT"] = "Der Schmuck wird automatisch mit markiert",
        ["options_enable_auto_mark_research_items"] = "Analysierbare Items",
        ["options_enable_auto_mark_research_items_TT"] = "Markiert automatisch analysierbare items",
        ["options_enable_auto_mark_research_items_hint"]    = "Benötigtes Addon wird in der Auswahlliste in den Einstellungen ausgewählt",
        ["options_enable_auto_mark_research_items_hint_logged_in_char"] = "Betrifft nur die folgenden AddOns:\n\nCraftStore FixedAndImproved\n\nAndere AddOns haben ihre eigenen Einstellungen, um die zu prüfenden Charaktere festzulegen.\nUnd die ESO Standard Funktionalität verwendet IMMER NUR den aktuell eingeloggten Charakter.",
        ["options_enable_auto_mark_ornate_items_in_chat"] = "Gegenstand im Chat auflisten",
        ["options_enable_auto_mark_ornate_items_in_chat_TT"] =  "Gegenstände mit erhöhtem Verkaufspreis im Chat auflisten",
        ["options_enable_auto_mark_research_items_in_chat"] = "Gegenstand im Chat auflisten",
        ["options_enable_auto_mark_research_items_in_chat_TT"] =  "Gegenstände mit analysierbarem Trait im Chat auflisten",
        ["options_enable_auto_mark_non_sets"]			= "Keine Set Teile",
        ["options_enable_auto_mark_non_sets_TT"]	= "Markiert automatisch Waffen/Rüstung/Schmuck welche keine Set Teile sind",
        ["options_enable_auto_mark_unknown_set_collection_items"]		= "Unbekannte Set Sammlung",
        ["options_enable_auto_mark_unknown_set_collection_items_TT"]    = "Markiert automatisch Waffen/Rüstung/Schmuck, welche Teil eines Sets, und in der Set Sammlung nicht bekannt sind",
        ["options_enable_auto_mark_known_set_collection_items"]		    = "Bekannte Set Sammlung",
        ["options_enable_auto_mark_known_set_collection_items_TT"]      = "Markiert automatisch Waffen/Rüstung/Schmuck, welche Teil eines Sets, und in der Set Sammlung bekannt sind",
        ["options_enable_auto_mark_sets"]			= "Set Teile",
        ["options_enable_auto_mark_sets_TT"]	= "Markiert automatisch Waffen/Rüstung/Schmuck, welche Teil eines Sets sind",
        ["options_enable_auto_mark_check_all_icons"]			= "Prüfe alle Anderen",
        ["options_enable_auto_mark_check_all_icons_TT"]	= "Überprüft ob bereits eines der anderen Markierungs Symbole als Markierung existiert, wenn der Gegenstand automatisch markiert werden soll.\nIst bereits eine der Markierungen gesetzt, so wird keine weitere automatische Markierung gesetzt!",
        ["options_enable_auto_mark_sets_all_gear_marker_icons"]			= "Prüfe Ausrüstungs Set Markierung",
        ["options_enable_auto_mark_sets_all_gear_marker_icons_TT"]	= "Überprüft alle Ausrüstungs Set Markierungen, wenn das Set Teil automatisch markiert werden soll. Ist bereits eine der Ausrüstungs Set Markierungen gesetzt, so wird keine weitere automatische Set Markierung gesetzt!",
        ["options_enable_auto_mark_sets_sell_icon"]			= "Prüfe Verkauf/Gildenverkauf Markierung",
        ["options_enable_auto_mark_sets_sell_icon_TT"]	= "Überprüft ob bereits eine Verkauf oder Verkauf im Gildenladen Markierung existiert, wenn das Set Teil automatisch markiert werden soll. Ist bereits eine der Verkauf Markierungen gesetzt, so wird keine weitere automatische Set Markierung gesetzt!",
        ["options_header_non_wished"]                               = "Nicht-Gewünschte Eigenschaften",
        ["options_enable_auto_mark_sets_non_wished"]				= "Nicht-Gewünschte markieren",
        ["options_enable_auto_mark_sets_non_wished_TT"]		= "Markiert automatisch die nicht-gewünschten (deren Trait nicht zu der Auswahl passt) Setteile mit einem anderen Symbol",
        ["options_enable_auto_mark_sets_non_wished_icon"]			= "Nicht-Gewünschte Symbol",
        ["options_enable_auto_mark_sets_non_wished_icon_TT"]	= "Wählen Sie ihr Symbol für die nicht-gewünschten (deren Trait nicht zu der Auswahl passt) Setteile.\n\nStandard Symbol: 'Verwerten'",
        ["options_enable_auto_mark_sets_non_wished_checks"]		= "\"Nicht gewünschte\" Prüfungen",
        ["options_enable_auto_mark_sets_non_wished_checks_TT"]= "Nicht-Gewünschte Set Teile werden so geprüft wie es in dieser Einstellung ausgewählt wurde.",
        ["options_enable_auto_mark_sets_non_wished_quality"]		= "Qualität Schwelle <=",
        ["options_enable_auto_mark_sets_non_wished_quality_TT"]= "Nicht-Gewünschte Set Teile werden mit dem Nicht-Gewünschte Symbol markiert wenn die Qualität des Set Teils gleich/kleiner dieser ausgewählten Qualität ist.",
        ["options_enable_auto_mark_sets_non_wished_level"]          = "Level Schwelle <",
        ["options_enable_auto_mark_sets_non_wished_level_TT"]  = "Set Teile werden mit dem Nicht-Gewünschte Symbol markiert wenn ihr Level unter diesem ausgewählten Level ist.",
        ["options_enable_auto_mark_sets_non_wished_sell_others"]            = "Verkaufe alle anderen",
        ["options_enable_auto_mark_sets_non_wished_sell_others_TT"]    = "Alle anderen Nicht-Gewünschte Gegenstände werden für den Verkauf markiert.",
        ["options_enable_auto_mark_sets_non_wished_char_below_level_50"]    = "Char. Level <"  ..maxLevel,
        ["options_enable_auto_mark_sets_non_wished_char_below_level_50_TT"] = "Markier alle SetItems als nicht-gewünscht (und führe keine weiteren Prüfungen durch!) wenn der aktuell eingeloggte Charakter noch unter Level " ..maxLevel.. " ist UND der Gegenstand nicht das maximale Level, oder doch das maximale Level aber nicht das aktuell mögliche maximale ChampionLevel, besitzt.\nDies gibt dir die Möglichkeit die Niedrig-Level SetTeile zum Verwerten markieren zu lassen.",
        ["options_enable_auto_mark_sets_in_chat"] = "Set Teile im Chat auflisten",
        ["options_enable_auto_mark_sets_in_chat_TT"] =  "Set Teile im Chat auflisten",
        ["options_enable_auto_mark_sets_already_bound"]         = "Markiere bereits gebundene",
        ["options_enable_auto_mark_sets_already_bound_TT"] = "Markiere bereits an deinen Account gebundene Setteile mit einem kleinen Symbol an der oberen rechten Ecke des Setteil Bilds",

        ["options_header_exclude_sets"] = "Ausgeschlossene Sets",
        ["options_exclude_automark_sets_list"] = "Ausgeschlossene Sets",
        ["options_exclude_automark_sets_list_TT"] = "Mit aktivierter Option wird die Liste der ausgeschlossenen Sets verwendet:\n\nLinks: Alle vefügbaren Sets\nRechts: Ausgeschlossene Sets.\nAusgeschl. Sets werden bei automatischen Set Markierungen übersprungen.\nBewege die Sets von links nach rechts, um diese auszuschließen, oder nach links, um diese wieder mit zu scannen.",
        ["options_exclude_automark_sets_included"] = "Eingeschlossene Sets",

        ["options_auto_mark_sets_icon"]			= "Set Teile Symbol",
        ["options_auto_mark_sets_icon_TT"]	= "Symbol für die automatisch markierten Set Teile",
        ["options_header_settracker"]							= "Set Tracker",
        ["options_header_traits"]                               = "Eigenschaften",
        ["options_auto_mark_traits_with_set_too"]               = "Auch mit Set Markierung setzen",
        ["options_auto_mark_traits_with_set_too_TT"]       = "Markiere einen Set Gegenstand zusätzlich zu der automatischen Set Markierung. Ist diese Option aus wird die Eigenschaftsmarkierung nicht gesetzt, wenn die Set Markierung bereits gesetzt ist.",
        ["options_auto_mark_traits_only"]                       = "Nur Eingenschaften setzen",
        ["options_auto_mark_traits_only_TT"]               = "Setze die Eigenschaftsmarkierungssymbole aber nicht die Set Markierung wenn für die Eigenschaft des Gegenstandes eine Markierung aktiviert ist.",
        ["options_auto_mark_settrackersets"]					= "'SetTracker' Sets",
        ["options_auto_mark_settrackersets_TT"]			= "Markiere automatisch die Gegestände, welche mit dem Addon 'SetTracker' verfolgt werden, mit einem FCOIS Symbol.",
        ["options_auto_mark_settrackersets_inv"]				= "Markiere in Inventar",
        ["options_auto_mark_settrackersets_inv_TT"]		= "Markiere Set Teile in deinem Inventar",
        ["options_auto_mark_settrackersets_worn"]				= "Markiere Getragene",
        ["options_auto_mark_settrackersets_worn_TT"]		= "Markiere deine momentan getragenen Set Teile",
        ["options_auto_mark_settrackersets_bank"]				= "Markiere in Bank",
        ["options_auto_mark_settrackersets_bank_TT"]		= "Markiere Set Teile in deiner Bank",
        ["options_auto_mark_settrackersets_guildbank"]			= "Markiere in Gildenbank",
        ["options_auto_mark_settrackersets_guildbank_TT"]	= "Markiere Set Teile in deinen Gildenbanken",
        ["options_auto_mark_settrackersets_rescan"]				= "Rescan & markiere erneut",
        ["options_auto_mark_settrackersets_rescan_TT"]		= "Beim Login/Oberfläche neuladen: Scanne die oben ausgewählten Inventare erneut nach mit Set Tracker verfolgten Setteilen und markiere diese automatisch, wenn kein FCOIS Symbol mehr gesetzt ist.",
        ["options_auto_mark_settrackersets_to_fcois_icon"]		= "SetTracker index <<1>>: FCOIS Symbol",
        ["options_auto_mark_settrackersets_to_fcois_icon_TT"]	= "Gebe das FCOItemSaver Symbol an, welches du für jedes 'SetTracker' verfolgte Set benutzen möchtest.",
        ["options_auto_mark_settrackersets_show_tooltip_on_FCOIS_marker"]		  = "Zeige Set Notiz als Tooltip",
        ["options_auto_mark_settrackersets_show_tooltip_on_FCOIS_marker_TT"] = "Zeige die SetTracker Set Notiz (sofern gegeben) in dem FCOItemSaver Tooltip für die Markierungs Symbole.",
        ["options_enable_auto_mark_sets_settracker_icons"]			= "Nur ohne SetTracker Sets",
        ["options_enable_auto_mark_sets_settracker_icons_TT"]	= "Überprüfe alle Markierungs Symbole von verfolgten SetTracker Sets, wenn die automatische Set Markierung gesetzt werden soll. Wenn eine der SetTracker Markierungen bereits gesetzt wurde wird keine zusätzliche Set Markierung hinzugefügt!",
        ["options_auto_mark_recipes_icon"]				=	"Rezepte Symbol (%s)",
        ["options_auto_mark_recipes_icon_TT"]		=	"Symbol für die automatisch markierten %s Rezepte",
        ["options_auto_mark_crafted_items_icon"]		=	"Herg. Gegenst. Symbol",
        ["options_auto_mark_crafted_items_icon_TT"]=	"Symbol für die automatisch markierten hergestellten Gegenstände",
        ["options_header_filter_buttons"]	= "Filter Knöpfe",
        ["options_filter_button_set_all_equal"]         = "Setze alle gleich",
        ["options_filter_button_set_all_equal_TT"] = "Dies setzt die Einstellungen der Filter Knöpfe alle gleich auf den Wert, welchen du im 1. Untermenü Eintrag \"" .. GetString(SI_INVENTORY_MENU_INVENTORY) .. "\" ausgewählt hast!",
        ["options_add_inv_flag_button_set_all_equal_TT"] = "Dies setzt die Einstellungen der zusätzlichen Inventar Kontextmenü \'Flaggen\' ("..addInvFlagIcon..") Knöpfe alle gleich auf den Wert, welchen du im 1. Untermenü Eintrag \"" .. GetString(SI_INVENTORY_MENU_INVENTORY) .. "\" ausgewählt hast!",
        ["options_filter_buttons_show_TT"] = "Tooltip anzeigen",
        ["options_filter_buttons_show_tooltip_TT"] = "Beim Klicken/Bewegen über den Filter Knopf einen Tooltip anzeigen",
        ["options_filter_buttons_context_menu_show_TT"] = "Filter Kontextmenü Tooltip zeigen",
        ["options_filter_buttons_context_menu_show_tooltip_TT"] = "Zeigt einen Tooltip für jeden Eintrag in den Filter Knopf Kontextmenüs",
        ["options_filter_buttons_save_for_character"]    = "Filter Knopf Status für jeden Charakter speichern",
        ["options_filter_buttons_save_for_character_TT"] = "Aktiviert: Speichere den Status jedes Filter Knopfes individuell pro Charakter, auch wenn Account Weite Einstellungen aktiviert sind.\n\nSind die Pro Charakter Einstellungen aktiviert so ist diese Option deaktiviert!",
        ["options_filter_button_settings"] =                        "Filter Einstellungen",
        ["options_filter_button_settings_filterWithLogicalAND"] =   "Logische Verb. (De-/Aktiv): ODER/UND",
        ["options_filter_button_settings_filterWithLogicalAND_and"] = "und",
        ["options_filter_button_settings_filterWithLogicalAND_or"] = "oder",
        ["options_filter_button_settings_logical_conjunctions"] = "Wenn das Kontextmenü an den Filter Knöpfen aktiviert ist kann dort unter \'Filter Einstellungen\' die \'Logische Verbindung\' des gelben (NUR MARKIERTE ANZEIGEN) Filter Status (rote und grüne Filter Status verhalten sich bei UND und ODER identisch!) eingestellt werden:\nCheckbox aktiv: Logisches UND\nCheckbox deaktiviert: Logisches ODER\n\nLogisches UND bedeutet, dass die Prüfungen der Filter \'alle zusammen\' wahr sein müssen (z.B. ein Gegenstand muss mit dem Schloss UND dem Intrikat Symbol markiert sein).\nLogisches ODER bedeutet, dass die Prüfungen der Filter \'jeder für sich\' wahr sein muss (z.B. ein Gegenstand muss mit dem Schloss ODER dem Intrikat Symbol markiert sein).",

        ["options_header_filter_chat"] 			= "Filter & Chat",
        ["options_chat_filter_status"]			= "Filter Status im Chat zeigen",
        ["options_chat_filter_status_TT"] 	= "Soll der Filter Status im Chat angezeigt werden, wenn dieser sich verändert?",
        ["options_header_destroy"]				= "Zerstören",
        ["options_header_deconstruction"]		= "Verwerten",
        ["options_header_research"]				= "Analyse",
        ["options_header_improvement"]			= "Aufwerten",
        ["options_header_mail"]					= "Mail",
        ["options_header_trade"]				= "Handel",
        ["options_header_rune_creation"]		= "Runen Erstellung",
        ["options_header_rune_extraction"]		= "Glyphen Extrahierung",
        ["options_header_sell"]					= "Verkauf",
        ["options_header_sell_at_guild_store"]	= "Verkauf im Gildenladen",
        ["options_header_fence"]				= "Hehler",
        ["options_header_launder"]				= "Geldwäsche",
        ["options_header_alchemy_destroy"]		= "Alchemie",
        ["options_header_recipes"]				= "Rezepte",
        ["options_header_containers"]			= "Behälter",
        ["options_header_anti_output_options"]	= "Ausgabe Optionen",
        --Additional buttons
        ["options_header_additional_buttons"]						 = "Zusätzliche Knöpfe",
        ["options_additional_buttons_FCOIS_settings"] 				 = "FCO Einstellungen im Hauptmenu",
        ["options_additional_buttons_FCOIS_settings_TT"] 		 = "Zeigt einen Knopf für die FCOItemSaver Einstellungen im Hauptmenü an (rechts vom Hilfe Knopf).\n\n[Achtung] Der Knopf wird nur angezeigt, wenn der Einstellungsknopf im Addon 'Votans Settings Menu' nicht geladen ist!",
        ["options_additional_buttons_FCOIS_additional_options"] 		= "Zusätzl. Optionen in Inventaren ("..addInvFlagIcon..")",
        ["options_additional_buttons_FCOIS_additional_options_TT"] = "Zeigt einen Knopf für zusätzliche Optionen (Alle markieren/Alle demarkieren/Rückgängig machen) in den Inventaren an.\nDer Knopf wird als kleine \'Flagge\' ("..addInvFlagIcon..") links oben im Inventar angezeigt und öffnet ein Kontextmenü, wenn man mit der Maus links |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_LMB.dds|t darauf klickt.\nKlickt man rechts |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t darauf so wechselt der Schutz-Status (Anti-* Schutz) des aktuell angezeigten Panels.",
        ["options_additional_buttons_FCOIS_additional_options_colorize"] 		= "Schutz Status als Farbe am "..addInvFlagIcon.." Knopf",
        ["options_additional_buttons_FCOIS_additional_options_colorize_TT"] = "Färbt den zusätzliche Inventar Optionen \'Flagge\' ("..addInvFlagIcon..") Knopf in den Inventaren grün/rot ein, wenn die Anti-* Schutz Funktionalität für das aktuelle Panel an-/ausgeschaltet ist.",
        ["options_additional_buttons_FCOIS_additional_options_offsets"]         = "Zusätzl. Inv. "..addInvFlagIcon.." Knopf Offsets",
        ["options_additional_buttons_FCOIS_additional_options_offsetx"]         = "Position X",
        ["options_additional_buttons_FCOIS_additional_options_offsetx_TT"] = "Verschiebe den zusätzliche Optionen "..addInvFlagIcon.." Knopf auf der X Achse. Standard Wert ist 0.",
        ["options_additional_buttons_FCOIS_additional_options_offsety"]         = "Position Y",
        ["options_additional_buttons_FCOIS_additional_options_offsety_TT"] = "Verschiebe den zusätzliche Optionen "..addInvFlagIcon.." Knopf auf der Y Achse. Standard Wert ist 0.",
        ["button_FCOIS_settings_TT"]							 = "FCOItemSaver Einstellungen anzeigen",
        --Anti equip
        ["options_header_anti_equip"]					= "Anti Equip",
        ["options_askBeforeEquipBoundItems"]			= "Vor dem Binden fragen",
        ["options_askBeforeEquipBoundItems_TT"]	= "Zeigt einen Bestätigungs Dialog an, bevor Items an deinen Account gebunden werden",
        ["options_anti_equip_question"]					= "Soll <<!A:1>> an \ndeinen Account gebunden werden?",
        --Stolen
        ["options_header_stolen"]				 = "Gestohlen",
        ["options_show_stolen_icon"]			 = "Zeige Filter für gestohlene Items",
        ["options_show_stolen_icon_TT"]     = "Zeigt einen zusätzlichen Filter Knopf für gestohlene Icons im Inventar an. Dieser wird immer rechts vom letzten aktiven Filter angezeigt (Standard: Münzen Symbol)",
        --Other options
        ["options_split_lockdyn_filter"]		 = "Schloss & dynamische Symbole aufteilen",
        ["options_split_lockdyn_filter_TT"] = "Teilt den Schloss Filter Knopf in den Inventaren auf. Bei einem Klick mit der rechten Maustaste |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t auf den Schloss Filter Knopf wird ein Kontextmenü anzeigt, aus welchem das einzeln zu filternde Symbol ausgewählt werden kann. Der Eintrag * wählt alle möglichen Einträge aus!",
        ["options_split_gearsets_filter"]		 = "Ausrüstungs Sets (1/2/3/4/5) Filterknopf aufteilen",
        ["options_split_gearsets_filter_TT"]= "Teilt den Gear Sets Filter Knopf in den Inventaren auf. Bei einem Klick mit der rechten Maustaste |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t auf den Gear Filter Knopf wird ein Kontextmenü anzeigt, aus welchem das einzeln zu filternde Ausrüstungs Set ausgewählt werden kann. Der Eintrag * wählt alle möglichen Einträge aus!",
        ["options_split_resdecimp_filter"]		 	 = "Analyse (Ver-/Aufwerten) Filterknopf aufteilen",
        ["options_split_resdecimp_filter_TT"]= "Teilt den Analyse Filter Knopf in den Inventaren auf. Bei einem Klick mit der rechten Maustaste |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t auf den Analyse Filter Knopf wird ein Kontextmenü anzeigt, aus welchem entweder Analyse, Verwerten oder Aufwerten einzeln ausgewählt werden kann. Der Eintrag * wählt alle möglichen Einträge aus!",
        ["options_split_sellguildint_filter"]		 = "Verkauf (Gildenladen/Aufwendig) Filterknopf auft.",
        ["options_split_sellguildint_filter_TT"]= "Teilt den Verkauf Filter Knopf in den Inventaren auf. Bei einem Klick mit der rechten Maustaste |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t auf den Verkauf Filter Knopf wird ein Kontextmenü anzeigt, aus welchem entweder Verkauf, Verkauf im Gildenladen oder Aufwendige Gegenstände einzeln ausgewählt werden kann. Der Eintrag * wählt alle möglichen Einträge aus!",
        --Right click item menu
        ["rightclick_menu_remove_all"]           = "Entferne alle Symbole",
        ["rightclick_menu_restore_last"]         = "Stelle (%s) Symbole wieder her",
        ["rightclick_menu_lock"]       	 		 = "Sperre setzen",
        ["rightclick_menu_unlock"]         	     = "Sperre entfernen",
        ["rightclick_menu_add_gear1"]        	 = "Zu Gear 1 hinzufügen",
        ["rightclick_menu_add_all_gear1"]        = "Alle zu Gear 1 hinzufügen",
        ["rightclick_menu_remove_gear1"]         = "Aus Gear 1 entfernen",
        ["rightclick_menu_remove_all_gear1"]     = "Alles aus Gear 1 entfernen",
        ["rightclick_menu_add_gear2"]       	 = "Zu Gear 2 hinzufügen",
        ["rightclick_menu_add_all_gear2"]        = "Alle zu Gear 2 hinzufügen",
        ["rightclick_menu_remove_gear2"]         = "Aus Gear 2 entfernen",
        ["rightclick_menu_remove_all_gear2"]     = "Alle aus Gear 2 entfernen",
        ["rightclick_menu_add_gear3"]        	 = "Zu Gear 3 hinzufügen",
        ["rightclick_menu_add_all_gear3"]        = "Alle zu Gear 3 hinzufügen",
        ["rightclick_menu_remove_gear3"]         = "Aus Gear 3 entfernen",
        ["rightclick_menu_remove_all_gear3"]     = "Alles aus Gear 3 entfernen",
        ["rightclick_menu_add_gear4"]        	 = "Zu Gear 4 hinzufügen",
        ["rightclick_menu_add_all_gear4"]        = "Alle zu Gear 4 hinzufügen",
        ["rightclick_menu_remove_gear4"]         = "Aus Gear 4 entfernen",
        ["rightclick_menu_remove_all_gear4"]     = "Alles aus Gear 4 entfernen",
        ["rightclick_menu_add_gear5"]        	 = "Zu Gear 5 hinzufügen",
        ["rightclick_menu_add_all_gear5"]        = "Alle zu Gear 5 hinzufügen",
        ["rightclick_menu_remove_gear5"]         = "Aus Gear 5 entfernen",
        ["rightclick_menu_remove_all_gear5"]     = "Alles aus Gear 5 entfernen",
        ["rightclick_menu_mark_analysis"]        = "Analyse vormerken",
        ["rightclick_menu_demark_analysis"]      = "Analyse zurücknehmen",
        ["rightclick_menu_mark_sell"]        	 = "Zum Verkauf vormerken",
        ["rightclick_menu_demark_sell"]          = "Verkauf zurücknehmen",

        ["rightclick_menu_mark_sell_in_guild_store"]    = "Zum Verkauf im Gildenladen vormerken",
        ["rightclick_menu_demark_sell_in_guild_store"]  = "Verkauf im Gildenladen zurücknehmen",
        ["rightclick_menu_mark_intricate"]      = "Als aufwendig markieren",
        ["rightclick_menu_demark_intricate"]    = "Aufwendig zurücknehmen",

        ["rightclick_menu_mark_deconstruction"]  = "Verwerten vormerken",
        ["rightclick_menu_demark_deconstruction"]= "Verwerten zurücknehmen",
        ["rightclick_menu_mark_improvement"]     = "Aufwerten vormerken",
        ["rightclick_menu_demark_improvement"]   = "Aufwerten zurücknehmen",
        ["rightclick_menu_add_start_gear"]       = "Hinzufügen zu ",
        ["rightclick_menu_add_all_start_gear"]   = "Alle hinzufügen zu ",
        ["rightclick_menu_remove_start_gear"]    = "Entfernen aus ",
        ["rightclick_menu_remove_all_start_gear"]= "Alle entfernen aus ",
        --Button context menu
        ["button_context_menu_TT"]			 = "Zusätzliche Optionen",
        ["button_context_menu_lock_all"]	 	 = "Alle sperren",
        ["button_context_menu_unlock_all"]	 	 = "Alle entsperren",
        ["button_context_menu_research_all"]	 = "+ Analyse",
        ["button_context_menu_dont_research_all"]= "- Analyse",
        ["button_context_menu_deconstruct_all"]	 	= "+ Verwerten",
        ["button_context_menu_dont_deconstruct_all"]= "- Verwerten",
        ["button_context_menu_improve_all"]	 		= "+ Aufwerten",
        ["button_context_menu_dont_improve_all"]	= "- Aufwerten",
        ["button_context_menu_sell_all"]	 	 = "+ Verkauf",
        ["button_context_menu_dont_sell_all"]	 = "- Verkauf",

        ["button_context_menu_sell_all_in_guild_store"]	 	= "+ Verkauf im Gildenladen",
        ["button_context_menu_dont_sell_all_in_guild_store"]= "- Verkauf im Gildenladen",
        ["button_context_menu_mark_all_as_intricate"]       = "+ Aufwendig",
        ["button_context_menu_unmark_all_as_intricate"]     = "- Aufwendig",

        ["button_context_menu_undo"]	 		 = "< Änderung rückgängig machen",
        ["button_context_menu_addAllToJunk"]     = "~> Alle als Trödel markieren",
        ["button_context_menu_removeAllFromJunk"]= "<~ Alle vom Trödel entfernen",

        ["button_context_menu_remove_all_gears"] = "Entferne alle Gear Sets",
        ["button_context_menu_demark_all"]	 	 = "Entferne alle Markierungen",
        ["button_context_menu_toggle_anti_destroy_on"] = "Aktiviere 'Anti-Zerstören'",
        ["button_context_menu_toggle_anti_destroy_off"] = "Deaktiviere 'Anti-Zerstören'",
        ["button_context_menu_toggle_anti_improve_on"] = "Aktiviere 'Anti-Aufwerten'",
        ["button_context_menu_toggle_anti_improve_off"] = "Deaktiviere 'Anti-Aufwerten'",
        ["button_context_menu_toggle_anti_deconstruct_on"] = "Aktiviere 'Anti-Verwerten'",
        ["button_context_menu_toggle_anti_deconstruct_off"] = "Deaktiviere 'Anti-Verwerten'",
        ["button_context_menu_toggle_anti_create_on"] = "Aktiviere 'Anti-Erstellen'",
        ["button_context_menu_toggle_anti_create_off"] = "Deaktiviere 'Anti-Erstellen'",
        ["button_context_menu_toggle_anti_extract_on"] = "Aktiviere 'Anti-Extrahieren'",
        ["button_context_menu_toggle_anti_extract_off"] = "Deaktiviere 'Anti-Extrahieren'",
        ["button_context_menu_toggle_anti_mail_on"] = "Aktiviere 'Anti-Mail'",
        ["button_context_menu_toggle_anti_mail_off"] = "Deaktiviere 'Anti-Mail'",
        ["button_context_menu_toggle_anti_sell_on"] = "Aktiviere 'Anti-Verkauf'",
        ["button_context_menu_toggle_anti_sell_off"] = "Deaktiviere 'Anti-Verkauf'",
        ["button_context_menu_toggle_anti_fence_sell_on"] = "Aktiviere Hehler 'Anti-Verkauf'",
        ["button_context_menu_toggle_anti_fence_sell_off"] = "Deaktiviere Hehler 'Anti-Verkauf'",
        ["button_context_menu_toggle_anti_launder_sell_on"] = "Aktiviere Hehler 'Anti-Wäsche'",
        ["button_context_menu_toggle_anti_launder_sell_off"] = "Deaktiviere Hehler 'Anti-Wäsche'",
        ["button_context_menu_toggle_anti_trade_on"] = "Aktiviere 'Anti-Handel'",
        ["button_context_menu_toggle_anti_trade_off"] = "Deaktiviere 'Anti-Handel'",
        ["button_context_menu_toggle_anti_alchemy_on"] = "Aktiviere 'Anti-Alchemie'",
        ["button_context_menu_toggle_anti_alchemy_off"] = "Deaktiviere 'Anti-Alchemie'",
        ["button_context_menu_toggle_anti_guild_bank_deposit_without_withdraw_rights_on"] = "Aktiviere 'Anti-Einlagern o. Entn. Rechte'",
        ["button_context_menu_toggle_anti_guild_bank_deposit_without_withdraw_rights_off"] = "Deaktiviere 'Anti-Einlagern o. Entn. Rechte'",

        ["button_context_menu_gear_sets_all"]	 	 = "*",
        ["button_context_menu_gear_sets_all_TT"]= "Alle Gear Sets",
        ["button_context_menu_all_markers_TT"]	 = "Alle Markierungen",
        ["options_enable_filter_in_refinement"]				= "Filter beim Veredeln aktivieren",
        ["options_enable_filter_in_refinement_TT"]	 	= "Ermöglicht es dir die markierten Gegenstände auch beim Veredeln an einer Handwerksstation zu verstecken",
        ["refinement_not_allowed"]							= "Veredeln nicht erlaubt:",
        ["research_not_allowed"]							= "Analyse nicht erlaubt:",
        ["button_context_menu_toggle_anti_refine_on"] 		= "Aktiviere 'Anti-Veredeln'",
        ["button_context_menu_toggle_anti_refine_off"]		= "Deaktiviere 'Anti-Veredeln'",
        ["options_enable_block_refinement"]             	= "Deaktiviere Veredeln",
        ["options_enable_block_refinement_TT"]     	= "Deaktiviert das Veredeln von markierten Gegenständen in Handwerksstationen",
        ["options_enable_block_jewelry_refinement"]             	= "Deaktiviere Schmuck Veredeln",
        ["options_enable_block_jewelry_refinement_TT"]     	= "Deaktiviert das Veredeln von markierten Schmuck Gegenständen in Handwerksstationen",
        ["options_enable_block_research"]                   = "Deaktiviere Analyse",
        ["options_enable_block_research_TT"]           = "Deaktiviert das Analysieren von markierten Gegenständen in Handwerksstationen",
        ["options_enable_block_jewelry_research"]             	= "Deaktiviere Schmuck Analyse",
        ["options_enable_block_jewelry_research_TT"]     	= "Deaktiviert das Analysieren von markierten Schmuck Gegenständen in Handwerksstationen",
        ["options_header_refinement"]                       = "Veredeln",
        ["options_auto_reenable_block_refinement"]          = "Reaktiviere Anti-Veredeln automatisch",
        ["options_auto_reenable_block_refinement_TT"]  = "Reaktiviert den Anti-Veredeln Schutz automatisch, wenn die Handwerksstation geschlossen wird.",
        ["options_auto_reenable_block_jewelry_refinement"]          = "Reaktiviere Anti-Schmuck Veredeln automatisch",
        ["options_auto_reenable_block_jewelry_refinement_TT"]  = "Reaktiviert den Anti-Schmuck Veredeln Schutz automatisch, wenn die Handwerksstation geschlossen wird.",
        ["options_prevent_auto_marking_deconstruction"] 	= "Verhindere Auto-Mark. (Verwerten)",
        ["options_prevent_auto_marking_deconstruction_TT"] = "Verhindert das erneute automatische Markieren von Gegenständen, wenn der Gegenstand mit dem 'Markiert zum Verwerten' Symbol markiert wurde.",
        ["options_prevent_auto_marking_if_this_icon_set"]    = "Verhindere Auto-Mark. mit anderen",
        ["options_prevent_auto_marking_if_this_icon_set_TT"] = "Verhindert das erneute automatische Markieren von Gegenständen, wenn der Gegenstand mit diesem Symbol markiert wurde.",
        ["options_auto_remove_if_banked"]                   = "Auto-Entfernen: Einl. Bank",
        ["options_auto_remove_if_banked_TT"]                = "Automatisch diese Markierung entfernen, wenn der Gegenstand in der Bank eingelagert wird",
        ["options_auto_remove_if_guild_banked"]             = "Auto-Entfernen: Einl. Gilden Bank",
        ["options_auto_remove_if_guild_banked_TT"]          = "Automatisch diese Markierung entfernen, wenn der Gegenstand in einer Gilden Bank eingelagert wird",
        ["options_prevent_auto_marking_sell"] 	            = "Verhindere Auto-Mark. (Verkauf)",
        ["options_prevent_auto_marking_sell_TT"]            = "Verhindert das erneute automatische Markieren von Gegenständen, wenn der Gegenstand mit dem 'Verkaufen' Symbol markiert wurde.",
        ["options_prevent_auto_marking_sell_guild_store"] 	= "Verhindere Auto-Mark. (Verkauf Gildenladen)",
        ["options_prevent_auto_marking_sell_guild_store_TT"] = "Verhindert das erneute automatische Markieren von Gegenständen, wenn der Gegenstand mit dem 'Verkaufen im Gildenladen' Symbol markiert wurde.",
        --Chat commands
        ["chatcommands_info"]					 = "|c00FF00FCO|cFFFF00Item Saver|cFFFFFF Symbole für Inventar/Bank-Gegenstände setzen und diese filtern",
        ["chatcommands_help"]					 = "|cFFFFFF'hilfe' / 'liste'|cFFFF00: Zeigt diese Information zum Addon an. Gib |cFFFFFF'feedback' / 'spende' / 'bug' / 'nachricht'|cFFFF00 ein um das Feedback Fenster anzuzeigen|r",
        ["chatcommands_status"] 				 = "|cFFFFFF'status' / ''|cFFFF00: Zeigt die aktuell aktivierten Filter an",
        ["chatcommands_filter1"]				 = "|cFFFFFF'filter1'|cFFFF00: Kategorie 1 (Schloss Symbol)",
        ["chatcommands_filter2"]				 = "|cFFFFFF'filter2'|cFFFF00: Kategorie 2 (Rüstungs Symbole)",
        ["chatcommands_filter3"]				 = "|cFFFFFF'filter3'|cFFFF00: Kategorie 3 (Analyse Symbol)",
        ["chatcommands_filter4"]				 = "|cFFFFFF'filter4'|cFFFF00: Kategorie 4 (Verkaufs Symbol)",
        ["chatcommands_filter"]				 	 = "|cFFFFFF'filtern'|cFFFF00: Kategorien 1 bis 4 anzeigen/ausblenden",
        ["chatcommands_filteron"]				 = "|cFFFFFF'allean'|cFFFF00: Kategorien 1 bis 4 anzeigen",
        ["chatcommands_filteroff"]				 = "|cFFFFFF'alleaus'|cFFFF00: Kategorien 1 bis 4 ausblenden",
        ["chatcommands_filtershow"]				 = "|cFFFFFF'allezeigen'|cFFFF00: Nur markierte Items der Kategorien 1 bis 4 anzeigen",
        ["chatcommands_split_filter"]			 = "|cFFFFFF'split'|cFFFF00: Filter individuell in Inventar, Verkäufer, Bank, Gilden Bank, Gilden Laden, Handwerksstationen, Verzauberungstisch, Mail und Handel einschalten/ausschalten",
        ["chatcommands_filterpanels"]			 = "|c990000Mögliche |cFFFFFF<filterPanel>|cFFFF00:",
        ["chatcommands_filtervalues"]			 = "|c990000Mögliche |cFFFFFF<filterValue>|cFFFF00: |cFFFFFFan|cFFFF00 / |cFFFFFFaus|cFFFF00 / |cFFFFFFzeigen",
        ["chatcommands_filter1_new"]			 = "|cFFFFFF'filter1 <filterPanel> <filterValue>'|cFFFF00: Kategorie 1 (Schloss Symbol) im Fenster |cFFFFFF<filterPanel>|cFFFF00 ausblenden |cFFFFFF<an>|cFFFF00 / anzeigen |cFFFFFF<aus>|cFFFF00 / nur Markierte anzeigen |cFFFFFF<zeigen>",
        ["chatcommands_filter2_new"]			 = "|cFFFFFF'filter2 <filterPanel> <filterValue>'|cFFFF00: Kategorie 2 (Rüstungs Symbole) im Fenster |cFFFFFF<filterPanel>|cFFFF00 ausblenden |cFFFFFF<an>|cFFFF00 / anzeigen |cFFFFFF<aus>|cFFFF00 / nur Markierte anzeigen |cFFFFFF<zeigen>",
        ["chatcommands_filter3_new"]			 = "|cFFFFFF'filter3 <filterPanel> <filterValue>'|cFFFF00: Kategorie 3 (Analyse Symbol) im Fenster |cFFFFFF<filterPanel>|cFFFF00 ausblenden |cFFFFFF<an>|cFFFF00 / anzeigen |cFFFFFF<aus>|cFFFF00 / nur Markierte anzeigen |cFFFFFF<zeigen>",
        ["chatcommands_filter4_new"]			 = "|cFFFFFF'filter4 <filterPanel> <filterValue>'|cFFFF00: Kategorie 4 (Münzen Symbol) im Fenster |cFFFFFF<filterPanel>|cFFFF00 ausblenden |cFFFFFF<an>|cFFFF00 / anzeigen |cFFFFFF<aus>|cFFFF00 / nur Markierte anzeigen |cFFFFFF<zeigen>",
        ["chatcommands_filter_new"]				 = "|cFFFFFF'filtern <filterPanel> <filterValue>'|cFFFF00: Kategorien 1 bis 4 im Fenster |cFFFFFF<filterPanel>|cFFFF00 ausblenden |cFFFFFF<an>|cFFFF00 / anzeigen |cFFFFFF<aus>|cFFFF00 / nur Markierte anzeigen |cFFFFFF<zeigen>",
        ["chatcommands_filteron_new"]			 = "|cFFFFFF'allean <filterPanel>'|cFFFF00: Kategorien 1 bis 4 im Fenster |cFFFFFF<filterPanel>|cFFFF00 ausblenden",
        ["chatcommands_filteroff_new"]			 = "|cFFFFFF'alleaus <filterPanel>'|cFFFF00: Kategorien 1 bis 4 im Fenster |cFFFFFF<filterPanel>|cFFFF00 anzeigen",
        ["chatcommands_filtershow_new"]			 = "|cFFFFFF'allezeigen <filterPanel>'|cFFFF00: Nur markierte Items der Kategorien 1 bis 4 im Fenster |cFFFFFF<filterPanel>|cFFFF00 anzeigen",
        ["chatcommands_debug"]					 = "|cFFFFFF'debug'|cFFFF00: Aktiviere/Deaktive Debug Nachrichten. |c990000[Achtung]|cFFFF00 Ihr lokaler Chat wird mit Nachrichten überschwemmt!",
        ["chatcommands_status_info"]             = "|c00FF00FCO|cFFFF00Item Saver|cFFFFFF Aktivierte Filter:",
        ["chatcommands_status_nofilters"]        = "|c00FF00FCO|cFFFF00Item Saver|cFF0000 Keine Filter aktiv",
        ["chatcommands_status_filter1"]          = "Schloß Filter: AN",
        ["chatcommands_status_filter2"]          = "Gear Filter: AN",
        ["chatcommands_status_filter3"]          = "Analyse Filter: AN",
        ["chatcommands_status_filter4"]          = "Verkaufs Filter: AN",
        ["chatcommands_debug_on"]				 = "Debug: AN",
        ["chatcommands_debug_off"]				 = "Debug: AUS",
        ["chatcommands_deepdebug_on"]			 = "Deep debug: AN",
        ["chatcommands_deepdebug_off"]			 = "Deep debug: AUS",
        --Filters
        ["filter1_off"] 						 = "Schloß Filter AUS",
        ["filter1_on"] 						 	 = "Schloß Filter AN",
        ["filter1_onlyfiltered"] 				 = "Schloß Filter ZEIGT NUR GEFILTERTE",
        ["filter1_split_off"] 					 = "Filter AUS",
        ["filter1_split_on"] 					 = "Filter AN",
        ["filter1_split_onlyfiltered"] 			 = "Filter ZEIGT NUR GEFILTERTE",
        ["filter2_off"] 						 = "Gear Filter AUS",
        ["filter2_on"] 						 	 = "Gear Filter AN",
        ["filter2_onlyfiltered"] 				 = "Gear Filter ZEIGT NUR GEFILTERTE",
        ["filter3_off"] 						 = "Analyse/Verwerten/Aufwerten Filter AUS",
        ["filter3_on"] 						 	 = "Analyse/Verwerten/Aufwerten Filter AN",
        ["filter3_onlyfiltered"] 				 = "Analyse/Verwerten/Aufwerten Filter ZEIGT NUR GEFILTERTE",
        ["filter3_split_off"] 					 = "Filter AUS",
        ["filter3_split_on"] 					 = "Filter AN",
        ["filter3_split_onlyfiltered"] 			 = "Filter ZEIGT NUR GEFILTERTE",

        ["filter4_off"] 						 = "Verkauf/Gildenladen Verkauf/Aufwendig Filter AUS",
        ["filter4_on"] 						 	 = "Verkauf/Gildenladen Verkauf/Aufwendig Filter AN",
        ["filter4_onlyfiltered"] 				 = "Verkauf/Gildenladen Verkauf/Aufwendig Filter ZEIGT NUR GEFILTERTE",
        ["filter4_split_off"] 					 = "Filter AUS",
        ["filter4_split_on"] 					 = "Filter AN",
        ["filter4_split_onlyfiltered"] 			 = "Filter ZEIGT NUR GEFILTERTE",

        ["filter_ABORT"] 						 = "In den Einstellungen deaktiviert!",
        ["filter_inventory"]	= "[Inventar] ",
        ["filter_craftbag"]		= "[Handwerksbeutel] ",
        ["filter_guildbank"]	= "[Gilden Bank] ",
        ["filter_guildstore"]	= "[Gilden Laden] ",
        ["filter_bank"]			= "[Bank] ",
        ["filter_house_bank"]	= "[Haus Bank] ",
        ["filter_alchemy"]		= "[Alchemie] ",
        ["filter_refinement"]		= "[Veredeln] ",
        ["filter_deconstruction"]	= "[Verwerten] ",
        ["filter_improvement"]	= "[Aufwerten] ",
        ["filter_jewelry_refinement"]		= "[Schmuck Veredeln] ",
        ["filter_jewelry_deconstruction"]	= "[Schmuck Verwerten] ",
        ["filter_jewelry_improvement"]	    = "[Schmuck Aufwerten] ",
        ["filter_research"]		= "[Analyse] ",
        ["filter_jewelry_research"]		= "[Schmuck Analyse] ",
        ["filter_enchantingstation_extraction"] = "[Verzauberung Verwerten] ",
        ["filter_enchantingstation_creation"] = "[Verzauberung Herstellen] ",
        ["filter_store"] = "[Verkäufer] ",
        ["filter_fence"] = "[Hehler] ",
        ["filter_launder"] = "[Geldwäsche] ",
        ["filter_mail"] = "[Mail] ",
        ["filter_trade"] = "[Handel] ",
        ["filter_gears_all"]					 = "Alle Gear Sets",
        ["filter_resdecimp_all"]				 = "Analyse/Verwerten/Aufwerten",
        ["filter_resdecimp_1"]					 = "Analyse",
        ["filter_resdecimp_2"]					 = "Verwerten",
        ["filter_resdecimp_3"]					 = "Aufwerten",

        ["filter_sellguildint_all"]				 = "Verkauf/Gildenladen Verkauf/Aufwendig",
        ["filter_sellguildint_1"]				 = "Verkauf",
        ["filter_sellguildint_2"]				 = "Gildenladen Verkauf",
        ["filter_sellguildint_3"]				 = "Aufwendig",

        --Messages to chat
        ["show_anti_messages_in_chat"] 	  		 = "Warnung im Chat anzeigen",
        ["show_anti_messages_in_chat_TT"] 	 = "Zeigt eine Warnung und den Gegenstand Namen im Chat Fenster an",
        ["show_anti_messages_as_alert"] 		 = "Warnung im Fehler Fenster anzeigen",
        ["show_anti_messages_as_alert_TT"]	 = "Zeigt eine Warnung  und den Gegenstand Namen im Fehler Fenster an & spielt den Abgelehnt Sound ab",
        ["deconstruction_not_allowed"]			 = "Verwerten nicht erlaubt:",
        ["destroying_not_allowed"]			     = "Zerstören nicht erlaubt:",
        ["sendbymail_not_allowed"]				 = "Versand nicht erlaubt:",
        ["trading_not_allowed"]				     = "Handel nicht erlaubt:",
        ["selling_not_allowed"]				     = "Verkauf nicht erlaubt:",
        ["fence_selling_not_allowed"]			 = "Hehler-Verkauf nicht erlaubt:",
        ["launder_selling_not_allowed"]			 = "Geldwäsche nicht erlaubt:",
        ["improvement_not_allowed"]			     = "Aufwerten nicht erlaubt:",
        ["enchanting_creation_not_allowed"] 	 = "Erstellen/Zerstören nicht erlaubt:",
        ["enchanting_extraction_not_allowed"] 	 = "Extraktion nicht erlaubt:",
        ["guild_store_sell_not_allowed"]		 = "Verkauf im Gildenladen nicht erlaubt:",
        ["alchemy_destroy_not_allowed"]			 = "Alchemie Zerstören nicht erlaubt:",
        ["container_autoloot_not_allowed"]		 = "Autoloot des Behälters nicht erlaubt:",
        ["recipe_usage_not_allowed"]			 = "Rezept Einlesen nicht erlaubt:",
        ["motif_usage_not_allowed"]			 	 = "Stil-Motiv Einlesen nicht erlaubt:",
        ["potion_usage_not_allowed"]		 	 = "Trank trinken nicht erlaubt:",
        ["food_usage_not_allowed"]			 	 = "Nahrung essen nicht erlaubt:",
        ["crown_item_usage_not_allowed"]         = GetString(SI_ITEMTYPE57) .. " benutzen nicht erlaubt:",
        ["marked"]								 = "Markierung für [",
        ["set_collection_part_known_found"]      = "] als bekannter Set-Sammlung Gegenstand gesetzt",
        ["set_collection_part_unknown_found"]    = "] als unbekannter Set-Sammlung Gegenstand gesetzt",
        ["ornate_item_found"]    				 = "] als höherer Verkaufspreis gesetzt",
        ["intricate_item_found"]                 = "] als aufwendig gesetzt",
        ["research_item_found"]                  = "] als analysierbar gesetzt",
        ["researchScroll_item_found"]            = "] als vergeudete Analyse Schriftrolle markiert",
        ["set_part_found"]						 = "] als Set Teil gesetzt",
        ["set_part_non_wished_found"]			 = "] als nicht-gewünschtes Set Teil gesetzt",
        ["quality_item_found"]                  = "] durch die Qualität gesetzt",
        ["known_recipe_found"]				= "] als bekanntes Rezept gesetzt",
        ["unknown_recipe_found"]				= "] als unbekanntes Rezept gesetzt",
        ["options_enable_auto_mark_quality_items"] = "Qualität",
        ["options_enable_auto_mark_quality_items_TT"] =  "Automatisch Items mit Symbol markieren, wenn ihre Qualität gleich dieses eingestellten Wertes ist",
        ["options_enable_auto_mark_higher_quality_items"] = "Auch höhere Qualität markieren",
        ["options_enable_auto_mark_higher_quality_items_TT"] =  "Automatisch Items markieren, deren Qualität höher als die oben eingestellte Qualität ist?",
        ["options_enable_auto_mark_quality_items_in_chat"] = "Gegenstand im Chat auflisten",
        ["options_enable_auto_mark_quality_items_in_chat_TT"] =  "Markierte Gegenstände, mit ausgewählter Qualität, im Chat auflisten",
        ["options_auto_mark_quality_icon_no_armor"]			= "Keine Rüstung, Schmuck & Waffen",
        ["options_auto_mark_quality_icon_no_armor_TT"]	= "Rüstungen, Schmuck und Waffen werden nicht automatisch mit dem Qualität Symbol markiert.",
        ["options_any"] 		        = "Irgendeine Option (einzeln geprüft)",
        ["options_quality_OFF"] 		= "-DEAKTIVIERT-",
        ["options_quality_trash"] 		= "Tr\195\182del",
        ["options_quality_normal"] 		= "Normal",
        ["options_quality_magic"] 		= "Magisch",
        ["options_quality_arcane"] 		= "Arkan",
        ["options_quality_artifact"] 	= "Artefakt",
        ["options_quality_legendary"] 	= "Legendär",
        --Key bindings
        ["SI_BINDING_NAME_FCOISFILTER1"] 		 = "Filter 1 ändern",
        ["SI_BINDING_NAME_FCOISFILTER2"] 		 = "Filter 2 ändern",
        ["SI_BINDING_NAME_FCOISFILTER3"] 		 = "Filter 3 ändern",
        ["SI_BINDING_NAME_FCOISFILTER4"] 		 = "Filter 4 ändern",
        ["SI_BINDING_NAME_FCOIS_SETTINGS_MENU"]  = "FCOItemSaver Einstellungen",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_WITH_STANDARD_ICON"] = "Markie mit Standard Symbol",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_CYCLE_UP"]   = "Markiere mit nächstem Symbol",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_CYCLE_DOWN"] = "Markiere mit vorherigem Symbol",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_1"]  	 = "'Schloss' Symbol markieren",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_3"]  	 = "'Analyse' Symbol markieren",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_5"]  	 = "'Verkauf' Symbol markieren",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_9"]  	 = "'Verwerten' Symbol markieren",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_10"]  	 = "'Aufwerten' Symbol markieren",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_11"]  	 = "'Verkauf im Gildenladen' Symbol markieren",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_12"]  	 = "'Aufwendig' Symbol markieren",
        ["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_1"]  	 = "Gear Set 1 markieren",
        ["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_2"]  	 = "Gear Set 2 markieren",
        ["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_3"]  	 = "Gear Set 3 markieren",
        ["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_4"]  	 = "Gear Set 4 markieren",
        ["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_5"]  	 = "Gear Set 5 markieren",
        ["SI_BINDING_NAME_FCOIS_JUNK_ALL_SELL"]      = "%s->Trödel",
        ["SI_BINDING_NAME_FCOIS_JUNK_AND_MARK_SELL_ITEM"] = "Trödel",
        ["SI_BINDING_NAME_FCOIS_REMOVE_ALL_MARKER_ICONS_AND_UNDO"] = "Markierungen entfernen/Rückgängig",
        ["options_keybind_move_marked_for_sell_to_junk_enabled"]    = "Aktiviere 'Verkauf markierte->Trödel' Taste",
        ["options_keybind_move_marked_for_sell_to_junk_enabled_TT"] = "Aktiviere die Tastenkombination in den Inventaren mit der alle zum Verkauf markierte Gegenstände zum Trödel verschoben werden.",
        ["fcois_junked_item_count"] = "%s Gegenstände zum Trödel bewegt",
        ["fcois_unjunked_item_count"] = "%s Gegenstände vom Trödel weg bewegt",
        --Error messages
        ["error_gamepad_mode_not_supported"]	= "FCOItemSaver unterstützt den Gamepad Modus nicht! Bitte wechsel in den Optionen zum Tastatur Modus.",

        --Crown Store items
        ["options_header_crownstore"]                    = GetString(SI_ITEMTYPE57), --Crown item
        ["options_enable_block_crownstoreitems"]         = "Verhindere Nutzung von " .. GetString(SI_ITEMTYPE57),
        ["options_enable_block_crownstoreitems_TT"] = "Verhindert, dass mit einem Symbol markierte " .. GetString(SI_ITEMTYPE57) .. " benutzt werden können.",
        --Transmutation / Retrait
        ["options_header_transmutation"]          = GetString(SI_RETRAIT_STATION_ITEM_TO_RETRAIT_HEADER), --Transmutation
        ["filter_retrait"]                        = "[Transmutation]",
        ["filter_companion_inventory"]            = "[" .. GetString(SI_UNIT_FRAME_NAME_COMPANION) .." Inventar]",
        ["retrait_not_allowed"]                   = GetString(SI_RETRAIT_STATION_PERFORM_RETRAIT) .. " nicht erlaubt:",
        ["button_context_menu_toggle_anti_retrait_on"]  = "Aktiviere 'Anti-Retrait'",
        ["button_context_menu_toggle_anti_retrait_off"] = "Deaktiviere 'Anti-Retrait'",
        ["options_enable_block_retrait"]          = "Deaktiviere Retrait",
        ["options_enable_block_retrait_TT"]  = "Deaktiviert das Retraiting (Neu Vergeben von Eigenschaften auf Gegenständen) von markierten Gegenständen an den Transmutation Stationen",
        ["options_enable_filter_in_retrait"]		 = "Filter in " .. GetString(SI_RETRAIT_STATION_ITEM_TO_RETRAIT_HEADER) .. " Station aktivieren",
        ["options_enable_filter_in_retrait_TT"] = "Ermöglicht es dir die markierten Gegenstände auch in der " .. GetString(SI_RETRAIT_STATION_ITEM_TO_RETRAIT_HEADER) .. " Station zu verstecken",
        ["options_enable_filter_in_companion_inventory"]	= "Filter in ".. GetString(SI_UNIT_FRAME_NAME_COMPANION).." Inventar",
        ["options_enable_filter_in_companion_inventory_TT"] = "Ermöglicht es dir die markierten Gegenstände auch in dem " .. GetString(SI_UNIT_FRAME_NAME_COMPANION).. " Inventar zu verstecken",
        --Master Writs
        ["options_auto_mark_crafted_writ_items"] 			= "Markiere hergestellte Schrieb Gegenstände",
        ["options_auto_mark_crafted_writ_items_TT"] 	= "Wenn Sie diese Option aktivieren werden, nach dem Herstellen (Crafting) von Gegenständen aus Schrieben, welche mit dem AddOn \'Dolgubons Lazy Writ Creator\' hergestellt wurden, diese automatisch mit dem unten gewählten Symbol markiert.",
        ["options_auto_mark_crafted_writ_items_icon"]		=	"Schrieb herg. Gegenst. Symbol",
        ["options_auto_mark_crafted_writ_items_icon_TT"]=	"Symbol für die automatisch markierten hergestellten Gegenstände für Schriebe",
        ["options_auto_mark_crafted_masterwrit_items_icon"]		=	"Meister Schrieb herg. Gegenst. Symbol",
        ["options_auto_mark_crafted_masterwrit_items_icon_TT"]=	"Symbol für die automatisch markierten hergestellten Gegenstände für Meister Schriebe",
        --Transmutation geode container opening
        ["options_enable_block_transmutation_dialog_title"]                = "Transmutationskristalle",
        ["options_enable_block_transmutation_dialog_question"]             = "Willst du wirklich noch mehr Kristalle hinzufügen??\nDu besitzt bereits <<1>>/<<2>>",
        ["options_enable_block_transmutation_dialog_max_withdraw"]         = "Frage wenn Kristalle fast am Maximalwert sind",
        ["options_enable_block_transmutation_dialog_max_withdraw_TT"] = "Zeige einen Frage Dialog an, wenn deine Transmuationskristalle sich bereits nah dem Maximum befinden.\nWenn du dann noch weitere Kristalle lootest und es am Ende mehr als er erlaubte Maximalwert sind, so verfallen die Überschüssigen!",
        --Context menu entries: Start with icon, color it like icon color and set icon size
        ["options_contextmenu_leading_icon"]                = "Zeige Symbol",
        ["options_contextmenu_leading_icon_TT"]        = "Zeige das Markierungssymbol als Beginn des Kontextmenü Eintrages an",
        ["options_contextmenu_use_icon_color"]              = "Benutze Symbol Farbe",
        ["options_contextmenu_use_icon_color_TT"]      = "Nutze die Farbe des Markierungssymbol für den Kontextmenü Eintrag.\nDeine ausgewählte Farbe für bereits markierte Einträge wird auch weiterhin angewendet!",
        ["options_contextmenu_leading_icon_size"]           = "Symbol Größe",
        ["options_contextmenu_leading_icon_size_TT"]   = "Ändere die Symbol Größe für den Kontextmenü Eintrag",
        ["options_contextmenu_show_menu_item_tooltip"] = "Kontextmenü Eintrag Tooltip",
        ["options_contextmenu_show_menu_item_tooltip_TT"] = "Zeige einen Tooltip an jedem Kontextmenü Eintrag an, den dieses AddOn hinzufügt.",
        ["options_contextmenu_show_menu_item_tooltip_protected_panels"] = "Tooltip: Schutz-Status je Panel",
        ["options_contextmenu_show_menu_item_tooltip_protected_panels_TT"] = "Füge Informationen zu dem Status des Schutzes je Filter-Panel im Kontextmenü Eintrag Tooltip an.",
        ["options_contextmenu_entries_enable_tooltip"]              = "Zeige Tooltip am Eintrag",
        ["options_contextmenu_entries_enable_tooltip_TT"]           = "Zeige einen Tooltip am Kontext-Menü Eintrag an.",
        ["options_contextmenu_entries_enable_tooltip_only_SHIFTkey"]              = "Nur mit SHIFT Taste gedrückt",
        ["options_contextmenu_entries_enable_tooltip_only_SHIFTkey_TT"]           = "Zeige den Tooltip nur dann, wenn die SHIFT (Großschreiben) Taste gedrückt bleibt während du die Maus über den Kontextmenü Eintrag bewegst.",
        ["options_contextmenu_entries_tooltip_protectedpanels"]     = "Zeige Schutz-Status im Tooltip",
        ["options_contextmenu_entries_tooltip_protectedpanels_TT"]  = "Zeige den aktuellen Schutz-Status, der Symbole am aktuell geöffneten Filter Panel, im Kontext-Menü Eintrag Tooltip an.\n\n|c00FF00Grün|r/Haken Symbol: Geschützt\n|cFF0000Rot|r/X Symbol: Nicht geschützt",
        ["protection_at_panel"]                             = "Schutz-Status je Panel",
        --Enable/Disable icons
        ["options_header_enable_disable"]                   = "Aktivieren / Deaktivieren",
        --Context menus should use submenus for dynamic icons
        ["options_contextmenu_use_dyn_submenu"]             = "Nutze Untermenü: Dynamische Symbole",
        ["options_contextmenu_use_dyn_submenu_TT"]     = "Nutze ein Untermenü für die dynamischen Symbole in den Kontextmenüs wenn die Anzahl der aktivierten dynamischen Symbole größer oder gleich diesem Wert ist.\nDer Wert 0 deaktiviert das Kontext-Untermenü für die dynamischen Symbole.",
        --Backup & restore
        ["options_header_backup_and_restore_and_delete"] = "Sicherung & Wiederherstellung & Löschen",
        ["options_backup_marker_icons"]                 = "Sicherung",
        ["options_backup_marker_icons_TT"]         = "Sichere deine Markierungen an den Gegenständen nun.",
        ["options_restore_marker_icons"]                = "Wiederherstellung",
        ["options_restore_marker_icons_TT"]        = "Stelle deine Markierungen an den Gegenständen wieder her.",
        ["options_backup_marker_icons_warning"]         = "Sicherung ausführen?\nDeine Markierungen an den Gegenständen werden mit ihrer ID gesichert. Beide ID Typen (nicht-einzigartig und einzigartig) werden gespeichert.\n\n!!! Achtung !!!\nGilden Banken: Du musst alle deine Gilden Banken einmal geöffnet haben damit die Gegenstände gesichert werden können. Erst dann kennt das Addon diese. Wenn jemand nach dem Öffnen allerdings die Gegenstände entnimmt oder hinzufügt dann wird das Addon dies nicht bemerken!\n\nHaus: Du musst dich in deinem Haus befinden, wenn du die Hausbank Gegenstände auch mit sichern möchtest.\nWenn du nicht in deinem Haus bist hat das Addon keinen Zugriff auf deine Hausbank und wird diese Gegenstände überspringen!\n\nFalls du ein Haus besitzt und dich momentan nicht in diesem befindest wird das Addon dich im nächsten Schritt fragen, ob du dorthin reisen möchtest!",
        ["options_restore_marker_icons_warning"]        = "Wiederherstellung ausführen?\nDie gesicherten Markierungen werden wieder hergestellt. Beide ID Typen (nicht-einzigartig und einzigartig) werden geladen.\n\n!!! Achtung !!!\nGilden Banken: Du musst alle deine Gilden Banken einmal geöffnet haben damit die Gegenstände wieder markiert werden können. Erst dann kennt das Addon diese. Wenn jemand nach dem Öffnen allerdings die Gegenstände entnimmt oder hinzufügt dann wird das Addon dies nicht bemerken!\n\nHaus: Du musst dich in deinem Haus befinden, wenn du die Hausbank Gegenstände auch widerherstellen möchtest!.\nWenn du nicht in deinem Haus bist hat das Addon keinen Zugriff auf deine Hausbank und wird diese Gegenstände überspringen!\n\nFalls du ein Haus besitzt und dich momentan nicht in diesem befindest wird das Addon dich im nächsten Schritt fragen, ob du dorthin reisen möchtest!",
        ["options_backup_ask_before_teleport_to_own_house"] = "Wenn du deine Haus Bank mit sichern möchtest musst du dich in einem der Häuser befinden.\nNun dorthin teleportieren?\n\n" .. GetString(SI_DIALOG_CONFIRM) .. ": Wird dich teleportieren.\n".. GetString(SI_DIALOG_CANCEL) ..": Startet das Backup ohne Haus Bank.",
        ["options_backup_details"]                      = "Zeige Details",
        ["options_backup_details_TT"]              = "Zeige Details über die gesicherten Gegenstände im Chat",
        ["options_backup_apiversion"]                   = "API Version",
        ["options_backup_apiversion_TT"]           = "Die API Version für das Backup. Unter dieser Nummer wird das Backup abgespeichert und kann später mit dieser Nummer widerhergestellt werden.\n\nDie Version muss eine 6-stellige Zahl sein!",
        ["options_backup_clear"]                        = "Existierendes Backup löschen",
        ["options_backup_clear_TT"]                = "Wenn mit der angegebenen API Version bereits ein Backup existiert so wird dieses zunächst gelöscht und dann neu erstellt.",
        ["options_restore_details"]                     = "Zeige Details",
        ["options_restore_details_TT"]             = "Zeige Details über die widerhergestellten Gegenstände im Chat an",
        ["options_restore_apiversion"]                  = "Widerherstellbare API Versionen",
        ["options_restore_apiversion_TT"]          = "Die gespeicherten API Versionen, welche widerhergestellt werden können.",
        ["options_restore_marker_icons_delete_selected"] = "Lösche Backup",
        ["options_restore_marker_icons_delete_selected_TT"] = "Lösche das ausgewählte Backup aus den wiederherstellbaren Backups.\n\nVorsicht: Nach dem Löschen kann dieses nicht wiederhergestellt werden!",
        ["options_restore_marker_icons_delete_selected_warning"] = "Vorsicht: Dies löscht das ausgewählte Backup!",
        ["options_restore_marker_icons_delete_selected_warning2"] = "Backup wird gelöscht und kann nicht wiederhergestellt werden!\n\nBist du wirklich sicher?",

        ["options_delete_marker_icons_header"] =    "Löschen",
        ["options_delete_marker_icons_desc"] =      "Es werden die Markierungen an den Gegenständen gelöscht. Dabei werden die aktuell verwendeten SavedVariables (siehe \'Generelle Einstellungen\') verwendet (d.h. Server/Account/Character/alle gleich)!\nEs wird dabei die Markierung gelöscht, welche in der Symbol Aufklappliste ausgewählt wurde. Der Eintrag -ALLE- löscht alle Symbole!\nDer Markierungstyp gibt an, in welcher SavedVariables Tabelle die Markierungssymbole gelöscht werden (non-unique, unique).\nDer Löschen Knopf ist nur auswählbar, wenn mindestens 1 Markierung im gewählten ID Typ existiert, oder - ALLE - Markierungssymbole ausgewählt wurden!\n\nNicht-eindeutige und ZOs eindeutige Ids können nicht getrennt voneinander gelöscht werden, da diese sich dieselbe SavedVariables Tabelle teilen.",
        ["options_delete_marker_icons"] =           "Markierungstyp auswählen",
        ["options_delete_marker_icons_TT"] =        "Wähle den Markierungstyp aus, welcher gelöscht werden soll.",
        ["options_delete_marker_icons_button"] =    "Markierungen löschen",
        ["options_delete_marker_icons_button_TT"] = "Die ausgewählten Markierungen löschen",
        ["options_delete_marker_icons_warning"] =   "Vorsicht: Dies löscht die ausgewählten Markierungen! Die Benutzeroberfläche wird neugeladen wenn Markierungen gelöscht werden.\nAchte auf den Chat für Fehlermeldungen.",
        ["options_delete_marker_icons_warning2"] =  "Markierungen werden gelöscht und können nicht wiederhergestellt werden!\n\nBist du wirklich sicher?",

        --Feedback
        ["feedbackSendNote"]                    =   "Sende Mail",
        ["feedbackSendGold"]                    =   "Sende z.B. <<1>> Gold",
        ["feedbackOpenAddonAuthorWebsite"]      =   "Autor Portal",
        ["feedbackOpenAddonFAQ"]                =   "FAQ",
        ["feedbackInfo"]                        =   "Öffne die FAQ (Fragen und Antworten) & das Autor Portal (Features/Bugs) oder sende eine Mail wenn du einen Bug gefunden hast, ein Feature anfragen, oder eine ingame Spende schicken möchtest.",
        --SavedVariables
        ["options_migrate_settings_ask_before_to_server"] = "Deine SavedVariables (Einstellungen) wurden migriert zu Server abhängigen Daten.\nWillst du nun die Benutzeroberfläche neu laden, um die Daten auf die Platte zu speichern?\nSolltest du abbrechen werden die nicht-Server abhängigen Einstellungen weiter verwendet und du siehst dieses Popup nach dem nächsten ReloadUI/Login erneut.\n\n-SEHR WICHTIG-:\nBitte sichere die SavedVariables Datei \"FCOItemSaver.lua\" vorher manuell, bevor du weitermachst!\n\nNach dem Neuladen der UI kannst du in den FCOIS Einstellungen die Daten auf andere Sever übertragen.",
        ["options_logged_in_char"]          = "Nur eingeloggter Charakter",
        ["options_logged_in_char_TT"]  = "Gilt nur für den aktuell eingeloggten Charakter",
        ["options_other_addons"]       = "Andere AddOns",
        ["options_preview"]             = "Vorschau",
        --Vendor buy, buyback and repair
        ["button_context_menu_toggle_anti_buy_on"]      = "Aktiviere 'Anti-Kauf'",
        ["button_context_menu_toggle_anti_buy_off"]     = "Deaktiviere 'Anti- Kauf'",
        ["button_context_menu_toggle_anti_buyback_on"]  = "Aktiviere 'Anti-Rückkauf'",
        ["button_context_menu_toggle_anti_buyback_off"] = "Deaktiviere 'Anti-Rückkauf'",
        ["button_context_menu_toggle_anti_repair_on"]   = "Aktiviere 'Anti-Reparieren'",
        ["button_context_menu_toggle_anti_repair_off"]  = "Deaktiviere 'Anti-Reparieren'",
        ["LAM_settings_are_currently_build"] = "                        - Bitte warten -\nEinstellungen werden gerade aufbereitet...",
        ["options_non_unique_id"]               = "Nicht-eindeutige ID",
        ["options_use_uniqueids_type"]          = "Typ der eindeutigen ID",
        ["options_use_uniqueids_type_TT"]       = "Wähle welchen Typ der eindeutigen ID du verwenden möchtest. Der Default Typ ist die eindeutige ID des ZOs Standard-Spiels. Eine Alternative sind die FCOIS selbst-erstellten Eindeutigen Ids, deren Aufbau/Bestandteile du mit den Auswahlfeldern hier drunter definieren kannst.\nBitte lies die Tooltips der Einträge in dieser Aufklappbox um mehr Informationen zu erhalten!\n\n|cFF0000Achtung: Das Verändern dieser Option wird die Benutzeroberfläche automatisch neu laden (/reloadui)!|r",
        ["options_unique_id_base_game"]         = "Nutze ZO\'s eindeutige ID",
        ["options_unique_id_base_game_TT"]      = "Wenn du diesen Typ der eindeutigen ID auswählst, dann verwendet FCOIS die eindeutige ID von ZOs.\nDie eindeutige ID von ZOs ist wirklich eindeutig, auch wenn genau identische Gegenstände vorliegen. Dies bedeutet, dass die Markierungssymbole bei diesen Gegenständen erneut gesetzt werden müssen, auch wenn der gleiche Gegenstand bereits einmal markiert wurde.\nDies wird jedoch nur auf Waffen und Rüstung angewendet. Alle anderen Gegenstände verwenden weiterhin die nicht-Eindeutigen IDs.",
        ["options_uniqe_id_by_FCOIS"]           = "Nutze FCOIS\' eindeutige ID",
        ["options_uniqe_id_by_FCOIS_TT"]        = "Wenn du diesen Typ der eindeutigen ID auswählst, dann verwendet FCOIS die eigen erstellten eindeutigen IDs.\nDiese eindeutigen IDs von FCOIS verwenden die Gegenstandsdaten wie die interne Id, Level, Qualität, Eigenschaft, Stil, Verzauberung, gestohlen & handwerklich hergestellt Status, Handwerker Name.\nDies ermöglicht dem AddOn identische Gegenstände auch automatisch erneut zu markieren.\n\nDu kannst hier drunter die Checkboxen markieren, welche für die Erstellung der eindeutigen ID herangezogen werden sollen. Ebenso kannst du dort die Gegenstandstypen definieren, welche per Eindeutiger ID behandelt werden sollen. Der (sinnvolle) Standard sind Waffen und Rüstung (inkl. Schmuck). Aber Tränke könnten z.B. ebenso per Level oder Handwerklich hergestellt Kennzeichen eine eindeutige ID erhalten. Aber wenn das Level vom Spiel z.B. immer als 1 ermittelt wird (Handwerkszutaten z.B.), dann macht es wiederum keinen Sinn das Level dafür zu verwenden.\n\nWichtig: Wenn du einen Teil der eindeutigen ID (z.B. das Level) veränderst, dann sind deine bisher gespeicherten Markierungen, welche diesen Bestandteil verwendet haben, nicht mehr gültig. D.h. deine Markierungen werden nicht mehr sichtbar sein (aber noch in den SavedVariables gespeichert), bis du in den Einstellungen genau diese Teil wieder aktivierst.",
        ["options_unique_id_by_FCOIS_info"]     = "Du kannst hier drunter die Checkboxen markieren, welche für die Erstellung der eindeutigen ID herangezogen werden sollen. Ebenso kannst du dort die Gegenstandstypen definieren, welche per Eindeutiger ID behandelt werden sollen. Der (sinnvolle) Standard sind Waffen und Rüstung (inkl. Schmuck). Aber Tränke könnten z.B. ebenso per Level oder Handwerklich hergestellt Kennzeichen eine eindeutige ID erhalten. Aber wenn das Level vom Spiel z.B. immer als 1 ermittelt wird (Handwerkszutaten z.B.), dann macht es wiederum keinen Sinn das Level dafür zu verwenden.\n\nWichtig: Wenn du einen Teil der eindeutigen ID (z.B. das Level) veränderst, dann sind deine bisher gespeicherten Markierungen, welche diesen Bestandteil verwendet haben, nicht mehr gültig. D.h. deine Markierungen werden nicht mehr sichtbar sein (aber noch in den SavedVariables gespeichert), bis du in den Einstellungen genau diese Teil wieder aktivierst.",
        ["options_unique_id_parts_header"]      = "Teile der Eindeutigen ID",
        ["options_header_migration"]            = "Migration",
        ["options_header_migration_ids"]        = "(Nicht-)Eindeutige ID Migration",
        ["options_unique_id_part_crafted_by"]   = GetString(SI_ITEM_FORMAT_STR_CRAFTED) .. " durch", -- Hergestellt durch
        ["options_unique_id_part_crownItem"]    = GetString(SI_ITEMTYPE57),
        --Migrate ZOs locks to FCOIS locks
        ["migrate_ZOs_locks_to_FCOIS_locks_start"]              = "[FCOIS]Durchsuche Inventare nach mit dem ZOs Schloß markierten Gegenständen: START",
        ["migrate_ZOs_locks_to_FCOIS_locks_bagId"]              = ">Durchsuche Inventar (bagID): %s",
        ["migrate_ZOs_locks_to_FCOIS_locks_migrated_at_bag"]    = ">>migriert im Inventar %s: %s",
        ["migrate_ZOs_locks_to_FCOIS_locks_end"]                = "[FCOIS]Durchsuche Inventare nach mit dem ZOs Schloß markierten Gegenständen: ENDE - migriert/Insgesamt durchsucht: %s / %s",

        ["options_header_set_collections"]              = "Set-Sammlungen",
        ["options_enable_auto_mark_sets_collection"]    = "Automatische \'Set-Sammlung\' Markierung",
        ["options_enable_auto_mark_sets_collection_TT"] = "Aktiviere die automatische Set-Sammlung Markierungen",
        ["options_only_current_account"]                = "Nur aktueller Account",
        ["options_only_current_account_TT"]             = "Nur der aktuelle Account wird bei den Prüfungen berücksichtigt.",
        ["options_auto_mark_sets_collection_addon"]     = "Addon: Set-Sammlung Prüfungen",
        ["options_auto_mark_sets_collection_addon_TT"]  = "Wähle das Addon aus, welches für die automatischen Set Sammlungs Prüfungen verwendet werden soll (unbekannte/bekannte Set Gegenstände).\n Das ESO Basis Spiel kann nur die Gegenstände des aktuell eingelogten Accounts prüfen!",
        ["options_auto_mark_sets_collection_known_icon"]    = "Bekannte Set Sammlung Geg. Symbol",
        ["options_auto_mark_sets_collection_known_icon_TT"] = "Wähle das Symbol für die bekannten Set-Sammlungen Gegenstände.",
        ["options_auto_mark_sets_collection_unknown_icon"]    = "Unbekannte Set-Sammlung Geg. Symbol",
        ["options_auto_mark_sets_collection_unknown_icon_TT"] = "Wähle das Symbol für die unbekannten Set-Sammlungen Gegenstände.",

        ["options_description_automatic_marks"] = "Automatische Markierungen sind automatisch gesetzte Markierungs Symbole an deinen Gegenständen. Diese sind abhängig von deinen definierten Kriterien, z.B. markiere Set Gegenstände welche eine gewünschte Eigenschaft (Präzise, Göttlich, ...) besitzen mit dem gewünschtes Set Symbol, und alle anderen mit dem Verkaufen/Zerlegen Symbol. Oder markiere unbekante Rezepte. Die automatischen Markierungen können von anderen AddOns abhängig sein, die du installieren und aktivieren musst.\nDie Autom. Markierungen werden bei jedem Login/Benutzeroberfläche neuladen oder Zonen Wechsel mit Ladebild für alle Gegenstände in deinen Inventaren durchgeführt.\nDu kannst diese aber auch manuell anstoßen, über den zusätzliche Inventar \'Flagge\' "..addInvFlagIcon.." Knopf -> Kontext Menü -> Automatische Markierung. Achtung: Beim manuellen Anstoß per Flagge Knopf werden NUR die aktuell angezeigten/gefilterten Gegenstände geprüft, nicht wie bei der automatischen Prüfung alle Gegenstände in den ausgewählten Inventaren (siehe Untermenü\'Zu prüfende Inventare\') !\n\nBitte lies die Tooltips an den Einstellungen sorgfältig, da diese weitere Informationen zu anderen AddOns und deren Einstellungen, bzw. zu der Option selbst liefern!\n\nReihenfolge der autom. Prüfungen\n1) Set Gegenstände\n2) Set Sammlung\n3) Verzierte (Wertvolle)\n4) Intrikate (mehr XP beim Zerlegen)\n5) Analyse\n6) Analyse Schriftrollen\n7) Unbekannte Rezepte\n8) Bekannte Rezepte\n9) Qualität\nHandwerklich hergestellte und neue Gegenstände werden gesondert behandelt und werden dem entsprechend für von dir hergestellte, oder neue (gelootete) Gegenstände automatisch gesetzt.",
        ["options_known"] = "bekannt",
        ["options_bags_to_scan"]                        = "Zu prüfende Inventare",
        ["options_bags_to_scan_automatic_marks_TT"]     = "Inventare, die bei den automatischen Markierungen nach dem Login/Benutzeroberfläche Neuladen/Zonen Wechsel mit Ladebildschirm/neuem Inventar Gegenstand (Loot) gescannt werden sollen.\nManuell ausgelöste automatische Markierungen über das zusätzl. Inventar "..addInvFlagIcon.." Kontextmenü werden nur die aktuell angezeigten Gegenstände im aktuell angezeigten Inventar prüfen, und auch dann durchgeführt, wenn das Inventar hier drunter deaktiviert wurde!",
        ["options_bags_to_scan_order"]                  = "Scan Reihenfolge",
        ["options_bags_to_scan_order_TT"]               = "Wähle die Scan Reihenfolge für die Automatischen Markierungen. Die Markierungen werden dann für die aktivierten \'Zu prüfende Inventare\'. entsprechend deiner Reihenfolge [von oben 1) nach unten n)], geprüft und gesetzt.",
        ["options_scan_automatic_marks_now"]            = "Autom. Mark. Scannen",
        ["options_scan_automatic_marks_now_TT"]         = "Scanne die ausgewählten Inventare nun, um die Automatischen Markierungen anzuwenden",
        ["options_scan_automatic_marks_scan_bag"]           = ">>>Scanne \'%s\' nach automatischen Markierungen...",
        ["options_scan_automatic_marks_scan_bag_finished"]  = "Scan von \'%s\' wurde beendet<<<",
        ["options_bags_to_scan_chat_output"]             = "Zeige Chat Ausgabe pro Inventar",
        ["options_bags_to_scan_chat_output_TT"]          = "Zeige eine Ausgabe im Chat für jedes gescannte Inventar, zum Start und zum Ende. Markierte Gegenstände werden unabhängig von dieser Einstellung, je nach Einstellung im jeweiligen Markierungs-Untermenü, im Chat ausgegeben.",
        ["reloadui"] = "ACHTUNG: Die Benutzeroberfläche wird neugeladen in %s Sekunden!",

        ["options_auto_bind_missing_set_collection_pieces"] = "Auto binden: Unbekannte Teile",
        ["options_auto_bind_missing_set_collection_pieces_TT"] = "Automatisches Binden von unbekannten Set Sammlungs-Teilen deines aktuellen Accounts.\nWenn \'Unbekannte Set-Sammlung Geg. Symbol\' aktiviert sind: Neu gebundene Teile werden danach \'unbekannt Symbol\' erhalten damit diese danach filterbar bleiben, es sei denn die Option \'Markiere als bekannt dann\' wird aktiviert.\nFunktioniert nur mit den Standard ESO Set Sammlungs Prüfungen oder LibMultiAccountSets, aber nur für den aktuell eingeloggten Account!\n\nDieses Binden wird immer dann ausgeführt, wenn du die Automatischen Set Sammlungs-Prüfungen ausführst, oder wenn etwas gelootet wird.\n\n|cFF0000Achtung:|r Es wird KEIN Sicherheitsabfrage Dialog vor dem Binden angezeigt, den du bestätigen musst!",
        ["options_auto_bind_missing_set_collection_pieces_markKnown"] = "Markiere als bekannt dann",
        ["options_auto_bind_missing_set_collection_pieces_markKnown_TT"] = "Markiert die neu gebundenen als bekannte Set Sammlungs-Teile.\nFunktioniert nur, wenn die Automatische Set Sammlungs Markierung für bekanne Teile aktiviert ist.",
        ["options_auto_bind_missing_set_collection_pieces_to_chat"] = "Im Chat zeigen",
        ["options_auto_bind_missing_set_collection_pieces_to_chat_TT"] = "Zeige die automatisch gebundenen Teile im Chat an",
        ["chat_output_missing_set_collection_piece_was_bound"] = "Fehlender Set-Sammlungs Gegenstand wurde gebunden: %s",

        ["options_dropdown_none"] = "- Nichts -",
        ["options_dropdown_all"]  = "- ALLE -",

        ["options_automark_itemcooldowntracker_header"]  = "Item Cooldown Tracker",
        ["options_automark_itemcooldowntracker"]         = "Markiere \'Item Cooldown Tracker\' verfolgte",
        ["options_automark_itemcooldowntracker_TT"]      = "Markiere Gegenstände, welche mit \'Item Cooldown Tracker\' verfolgt werden, mit einem Symbol.",
        ["options_automark_itemcooldowntracker_icon_TT"] = "Wähle das Symbol, welches an durch \'Item Cooldown Tracker\' verfolgten Gegenständen markiert werden soll.",

        --LibShifterBoxes
        --[FCOIS_UNIQUEID_ITEMTYPES]
        ["LIBSHIFTERBOX_FCOIS_UNIQUEID_ITEMTYPES_TITLE_LEFT"]   = "Gegenstandstypen (Alle)",
        ["LIBSHIFTERBOX_FCOIS_UNIQUEID_ITEMTYPES_TITLE_RIGHT"]  = "Für FCOIS Eindeutige ID gewählt",
        ["LIBSHIFTERBOX_FCOIS_UNIQUEID_ITEMTYPES_RIGHT_NON_EMPTY"]  = "Eindeutige ID Gegenstandstypen können nicht leer sein!\nBitte wähle mindestens einen Typ aus. Ansonsten werden die Standard Werte Waffen und Rüstung automatich wieder hinzugefügt!"
    },
--==============================================================================
--French / Französisch
	[FCOIS_CON_LANG_FR] = {
		-- Options menu
		["options_description"] 						 = "FCOItemSaver vous permet de gérer vos objets à l'aide d'icônes. Vous pouvez choisir de cacher les objets à conserver",
		["options_header1"] 							 = "Général",
		["options_language"]							 = "Langue",
		["options_language_TT"]					 = "Choisir la langue",
		["options_language_use_client"] 		 		 = "Utilisez le langage client",
		["options_language_use_client_TT"]  		 = "Toujours laisser l'addon utiliser la langue du client de jeu.",
		["options_language_dropdown_selection1"]		 = "Anglais",
		["options_language_dropdown_selection2"]		 = "Allemand",
		["options_language_dropdown_selection3"]		 = "Français",
		["options_language_dropdown_selection4"] 		 = "Espagnol",
        ["options_language_dropdown_selection5"]	 	 = "Italien",
        ["options_language_dropdown_selection6"]         = "Japonais",
        ["options_language_dropdown_selection7"] 		 = "Russe",
		["options_language_description1"]		 		 = "ATTENTION : Changer les options d'équipement provoquera un chargement de l'interface",
		["options_savedvariables"]						 = "Sauvegarder",
		["options_savedvariables_TT"] 				 = "Sauvegarder les données de l'addon pour tous les personnages du compte, ou individuellement pour chaque personnage",
		["options_savedVariables_dropdown_selection1"]	 = "Individuellement",
		["options_savedVariables_dropdown_selection2"]	 = "Compte",
        ["options_header_ZOsLock"]                  = "ZOs verrouillage d'objet",
		["options_use_ZOs_lock_functions"]          = "Verrouillage objet en cours de partie" ..lockIcon,
		["options_use_ZOs_lock_functions_TT"]  = "Active/désactive la fonctionnalité, prévu par le développeur 'ZOs' de jeu, du verrouillage des objet "..lockIcon.." en cours de partie.",
        ["options_scan_ZOs_lock_functions"]			= "TESO "..lockIcon.."->FCOIS "..lockIcon,
		["options_scan_ZOs_lock_functions_TT"] = "Transférer les objets que vous avez verrouillé avec le verrouillage en cours de partie (icône de verrou gris) vers l'icône 1 de FCOItemSaver. Cela effacera les icônes d'origine et les remplacera par les icônes 1 de FCOIS.",
		["options_scan_ZOs_lock_functions_warning"] = "Voulez-vous vraiment enlever les verrouillages d'origine de vos objets et les transférer vers l'icône 1 de FCOItemSaver ?",
		["options_header_marking_options"]		 		 = "Marques",
        ["options_header_crafting"]              = GetString(SI_SKILLTYPE8),
		["options_remove_all_markers_with_shift_rightclick"]            =    "Tout supprimer: SHIFT + |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t",
	    ["options_remove_all_markers_with_shift_rightclick_TT"]    =    "Supprime tous les marqueurs d'un objet en effectuant un Shift + Clic droit |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t sur celui-ci.\n\nSi vous cliquez à nouveau, les derniers marqueurs seront restaurés pour cet objet !",
		["options_header_icon_options"]		 	 		 = "Position d'icône, triage, etc.",
        ["options_research_filter"]		 		 		 = "Permettre la recherche des objets marqués comme 'recherché'",
        ["options_research_filter_TT"]				 = "Permettre aux objets marqués comme 'recherché' d'être sélectionnés dans le panneau de recherche des ateliers de craft",
		["options_icons_non_gear"]				 		 = "Icône normale",
		["options_icons_gears"]				 	 		 = "Sets d'équipement",
		["options_icons_gear1"]					 		 = "Équipement 1",
		["options_icons_gear2"]					 		 = "Équipement 2",
		["options_icons_gear3"]							 = "Équipement 3",
		["options_icons_gear4"]					 		 = "Équipement 4",
		["options_icons_gear5"]					 		 = "Équipement 5",
        ["options_header_color"]						 = "Icône",
        ["options_icon1_color"]							 = "Verrouiller",
        ["options_icon1_color_TT"]					 = "Couleur de l'icône pour le filtre verrouiller",
        ["options_icon2_color"]							 = "Couleur",
        ["options_icon2_color_TT"]					 = "Couleur de l'icône pour le filtre équipement 1",
        ["options_icon3_color"]							 = "Recherche",
        ["options_icon3_color_TT"]					 = "Couleur de l'icône pour le filtre recherche",
        ["options_icon4_color"]							 = "Couleur",
        ["options_icon4_color_TT"]					 = "Couleur de l'icône pour le filtre équipement 2",
        ["options_icon5_color"]							 = "Vendre",
        ["options_icon5_color_TT"]					 = "Couleur de l'icône pour le filtre vendre",
        ["options_icon1_texture"]				 = "Icône",
        ["options_icon1_texture_TT"]		 = "Icône pour le filtre verrouiller",
        ["options_icon1_size"]				 	 = "Taille",
        ["options_icon1_size_TT"]			 = "Taille de l'icône pour le filtre verrouiller",
        ["options_icon2_texture"]				 = "Icône",
        ["options_icon2_texture_TT"]		 = "Icône pour le filtre équipement 1",
        ["options_icon2_size"]				 	 = "Taille",
        ["options_icon2_size_TT"]			 = "Taille de l'icône pour le filtre équipement 1",
        ["options_icon3_texture"]				 = "Icône",
        ["options_icon3_texture_TT"]		 = "Icône pour le filtre recherche",
        ["options_icon3_size"]				 	 = "Taille",
        ["options_icon3_size_TT"]			 = "Taille de l'icône pour le filtre recherche",
        ["options_icon4_texture"]				 = "Icône",
        ["options_icon4_texture_TT"]		 = "Icône pour le filtre équipement 2",
        ["options_icon4_size"]				 	 = "Taille",
        ["options_icon4_size_TT"]			 = "Taille de l'icône pour le filtre équipement 2",
        ["options_icon5_texture"]				 = "Icône",
        ["options_icon5_texture_TT"]		 = "Icône pour le filtre à vendre",
        ["options_icon5_size"]				 	 = "Taille",
        ["options_icon5_size_TT"]			 = "Taille de l'icône pour le filtre vendre",
        ["options_icon6_color"]							 = "Couleur",
        ["options_icon6_color_TT"]					 = "Couleur de l'icône pour le filtre équipement 3",
        ["options_icon6_texture"]						 = "Icône",
        ["options_icon6_texture_TT"]				 = "Icône pour le filtre équipement 3",
        ["options_icon6_size"]						 	 = "Taille",
        ["options_icon6_size_TT"]				 	 = "Taille de l'icône pour le filtre équipement 3",
        ["options_icon7_color"]							 = "Couleur",
        ["options_icon7_color_TT"]					 = "Couleur de l'icône pour le filtre équipement 4",
        ["options_icon7_texture"]						 = "Icône",
        ["options_icon7_texture_TT"]				 = "Icône pour le filtre équipement 4",
        ["options_icon7_size"]							 = "Taille",
        ["options_icon7_size_TT"]					 = "Taille de l'icône pour le filtre équipement 4",
        ["options_icon8_color"]							 = "Couleur",
        ["options_icon8_color_TT"]					 = "Couleur de l'icône pour le filtre équipement 5",
        ["options_icon8_texture"]						 = "Icône",
        ["options_icon8_texture_TT"]				 = "Icône pour le filtre équipement 5",
        ["options_icon8_size"]							 = "Taille",
        ["options_icon8_size_TT"]					 = "Taille de l'icône pour le filtre équipement 5",
		["options_icon2_name"]							 = "Equipement 1",
		["options_icon2_name_TT"]					 = "Choisissez un nom pour équipement 1",
		["options_icon4_name"]							 = "Equipement 2",
		["options_icon4_name_TT"]					 = "Choisissez un nom pour équipement 2",
		["options_icon6_name"]							 = "Equipement 3",
		["options_icon6_name_TT"]					 = "Choisissez un nom pour équipement 3",
		["options_icon7_name"]							 = "Equipement 4",
		["options_icon7_name_TT"]					 = "Choisissez un nom pour équipement 4",
		["options_icon8_name"]							 = "Equipement 5",
		["options_icon8_name_TT"]					 = "Choisissez un nom pour équipement 5",
        ["options_icon2_activate_text"]				 		= "Équipement 1 est actif",
        ["options_icon4_activate_text"]						 = "Équipement 2 est actif",
        ["options_icon6_activate_text"]				 		= "Équipement 3 est actif",
        ["options_icon7_activate_text"]						 = "Équipement 4 est actif",
        ["options_icon8_activate_text"]						 = "Équipement 5 est actif",
		["options_icon1_TT"]				 = "Révèle une info-bulle",
		["options_icon1_tooltip_TT"]		 = "Révèle une info-bulle au symbole vérouillé",
		["options_icon2_TT"]				 = "Révèle une info-bulle",
		["options_icon2_tooltip_TT"]		 = "Révèle une info-bulle au symbole d'équipement 1",
		["options_icon3_TT"]				 = "Révèle une info-bulle",
		["options_icon3_tooltip_TT"]		 = "Révèle une info-bulle au symbole de recherche",
		["options_icon4_TT"]				 = "Révèle une info-bulle",
		["options_icon4_tooltip_TT"]		 = "Révèle une info-bulle au symbole d'équipement 2",
		["options_icon5_TT"]				 = "Révèle une info-bulle",
		["options_icon5_tooltip_TT"]		 = "Révèle une info-bulle au symbole vendre",
		["options_icon6_TT"]				 = "Révèle une info-bulle",
		["options_icon6_tooltip_TT"]		 = "Révèle une info-bulle au symbole d'équipement 3",
		["options_icon7_TT"]				= "Révèle une info-bulle",
		["options_icon7_tooltip_TT"]		 = "Révèle une info-bulle au symbole d'équipement 4",
		["options_icon8_TT"]				 = "Révèle une info-bulle",
		["options_icon8_tooltip_TT"]		 = "Révèle une info-bulle au symbole d'équipement 5",
		["options_icon9_TT"]				 = "Révèle une info-bulle",
		["options_icon9_tooltip_TT"]		 = "Révèle une info-bulle au symbole destruction",
		["options_icon10_TT"]				 = "Révèle une info-bulle",
		["options_icon10_tooltip_TT"]		 = "Révèle une info-bulle au symbole ameliorer",
		["options_tooltipatchar"]		 		 = "Info-bulle dans la fenêtre de personnage",
		["options_tooltipatchar_TT"]		 = "Révèle aussi, l'info-bulle dans la fenêtre de personnage ",
        ["options_icon11_TT"]				 = "Révèle une info-bulle",
        ["options_icon11_tooltip_TT"]		 = "Révèle une info-bulle à l'icône 'Vendre en boutique de Guilde",
        ["options_icon11_color"]				 = "Vendre en boutique de Guilde",
        ["options_icon11_color_TT"]		 = "Couleur de l'icône pour le filtre 'Vendre en boutique de Guilde'",
        ["options_icon11_texture"]				 = "Icône",
        ["options_icon11_texture_TT"]		 = "Icône pour le filtre 'Vendre en boutique de Guilde'",
        ["options_icon11_size"]				 	 = "Taille",
        ["options_icon11_size_TT"]			 = "Taille de l'icône du filtre 'Vendre en boutique de Guilde'",
        ["options_icon11_tooltip_text"]			 = "Marqué pour 'Vendre en boutique de Guilde'",
        ["options_icon12_TT"]				 = "Révèle une info-bulle ",
        ["options_icon12_tooltip_TT"]		 = "Révèle une info-bulle à l'icône Complexe",
        ["options_icon12_color"]				 = "Complexe",
        ["options_icon12_color_TT"]		 = "Couleur de l'icône pour le filtre Complexe",
        ["options_icon12_texture"]				 = "Icône",
        ["options_icon12_texture_TT"]		 = "Icône pour le filtre Complexe",
        ["options_icon12_size"]				 	 = "Taille",
        ["options_icon12_size_TT"]			 = "Taille de l'icône du filtre Complexe",
        ["options_icon12_tooltip_text"]			 = "Marqué comme Complexe",
        ["options_icon9_color"]					 = "Déconstruction",
        ["options_icon9_color_TT"]			 = "Couleur de l'icône pour le filtre déconstruction",
        ["options_icon9_texture"]				 = "Icône",
        ["options_icon9_texture_TT"]		 = "Icône pour le filtre déconstruction",
        ["options_icon9_size"]				 	 = "Taille",
        ["options_icon9_size_TT"]			 = "Taille de l'icône pour le filtre déconstruction",
		["options_icon9_tooltip_text"]			 = "Marqué pour la déconstruction",
        ["options_icon10_color"]				 = "Amélioration",
        ["options_icon10_color_TT"]		 = "Couleur de l'icône pour le filtre amélioration",
        ["options_icon10_texture"]				 = "Icône",
        ["options_icon10_texture_TT"]		 = "Icône pour le filtre amélioration",
        ["options_icon10_size"]				 	 = "Taille",
        ["options_icon10_size_TT"]			 = "Taille de l'icône pour le filtre amélioration",
		["options_icon10_tooltip_text"]			 = "Marqué pour l'amélioration",
 		["options_icon1_tooltip_text"]			 = "Verrouiller",
		["options_icon_gear_tooltip_text"]		 = "Appartient à l'équipement: ",
		["options_icon_gears_tooltip_text"]		 = "Appartient aux équipements: ",
		["options_icon3_tooltip_text"]			 = "Marqué pour la recherche",
		["options_icon5_tooltip_text"]			 = "Marqué pour vendre",
		["options_icon1_activate_text"]			 = "Activer verrouillage",
		["options_icon3_activate_text"]			 = "Activer recherche",
		["options_icon5_activate_text"]			 = "Activer vente",
		["options_icon9_activate_text"]			 = "Activer démontage",
		["options_icon10_activate_text"]		 = "Activer amélioration",
		["options_icon11_activate_text"]		 = "Activer vente au marchand guilde",
		["options_icon12_activate_text"]		 = "Activer complexe",
		["options_icon_activate_text_TT"]	 = "Activer les icônes dans le menu. Si le réglage est désactivé, l'icône sera cachée dans le menu menu.",
		["options_icons_dynamic"]				 = "Icônes dynamique",
		["filter_lockdyn_all"]                   = "Verrouiller / icônes 1 - 5",
		["filter_lockdyn_1"]                     = "Verrouillez l'icône",
		["options_header_keybind_options"]      = "Raccourcis",
		["options_icon_standard_on_keybind"]    = "Icône de base (Marqueur du raccourci)",
		["options_icon_standard_on_keybind_TT"] = "L'icône de base qui sera utilisée si vous utilisez le raccourci pour l'icône de base.",
		["options_header_sort_order"]           = "Ordre de icônes",
		["options_icon_sort_order_TT"]     = "Affectez un numéro aux icônes de la liste déroulante du menu pour choisir votre ordre de tri (chiffre de gauche).",
		["options_icon_sort_order_warning"]     = "ATTENTION: Chaque icône ne doit avoir qu'un seul chiffre ! En cas de doublon le tri standard sera utilisé à la place de votre tri !",
		["options_gear_disable_research_check"]         = "Désactiver la vérification",
		["options_gear_disable_research_check_TT"] = "Désactive la vérification de la recherche pour cet icône si l'objet peut être recherché. Cela vous permet aussi d'utiliser cette icône pour touts objets.",
		["options_header_character"]             = "Fenêtre personnage",
		["options_header_character_armor_type"]  = "Type d'armure",
		["options_show_armor_type_icon"]         = "Afficher icône d'armure",
		["options_show_armor_type_icon_TT"] = "Affiche une icône pour le type d'armure équipée, près de l'objet (au-dessus du mannequin du joueur)",
		["options_show_armor_type_header_text"]  = "Afficher l'usure",
		["options_show_armor_type_header_text_TT"] = "Affiche sous forme de texte (en haut de la section d'armure du personnage) la quantité d'usure des parties d'armure (légère,moyenne et lourde)",
		["options_armor_type_icon_character_pos_x"]  = "Position de l'icône X",
		["options_armor_type_icon_character_pos_x_TT"] = "Choisissez l'emplacement horizontal de l'icône de type d'armure, coin droit haut de la partie d'armure",
		["options_armor_type_icon_character_pos_y"]  = "Position de l'icône Y",
		["options_armor_type_icon_character_pos_y_TT"] = "Choisissez l'emplacement vertical de l'icône de type d'armure, coin droit haut de la partie d'armure",
		["options_armor_type_icon_character_light_color"]= "Couleur icône armure légère",
		["options_armor_type_icon_character_light_color_TT"]   = "Choisissez la couleur de l'icône armure légère",
		["options_armor_type_icon_character_medium_color"]= "Couleur icône armure moyenne",
		["options_armor_type_icon_character_medium_color_TT"]  = "Choisissez la couleur de l'icône armure moyenne",
		["options_armor_type_icon_character_heavy_color"]= "Couleur icône armure lourde",
		["options_armor_type_icon_character_heavy_color_TT"]   = "Choisissez la couleur de l'icône armure lourde",
		--légère, intermédiaire, lourde
		["options_armor_type_icon_light_short"]		= "Lé",
		["options_armor_type_icon_medium_short"]	= "I",
		["options_armor_type_icon_heavy_short"]		= "Lo",
		["options_header_context_menu"]          = "Menu contextuel",
		["options_use_subcontextmenu"]           = "Utiliser un sous-menu",
		["options_use_subcontextmenu_TT"]   = "Cette options activée, toutes les options possibles FCOIS des objets seront regroupées dans un sous menu 'FCOItemSaver' dans le menu contextuel. Cette option désactivée, toutes les options possibles FCOIS des objets apparaitront directement dans le menu contextuel.",
		["options_show_contextmenu_divider"]     = "Afficher un menu séparateur",
		["options_show_contextmenu_divider_TT"] = "Affiche un séparateur informatif au-dessus des entrées du menu de FCOItemSaver pour séparer les options standards des objets des options de FCOIS.",
		["options_contextmenu_divider_opens_settings"] = "Réglages via séparateur",
		["options_contextmenu_divider_opens_settings_TT"] = "Si vous cliquez sur le séparateur le panneau de réglages de FCOItemSaver s'ouvrira",
		["options_contextmenu_divider_clears_all_markers"] = "RàZ icônes via séparateur",
		["options_contextmenu_divider_clears_all_markers_TT"] = "Si vous cliquez sur le séparateur les icônes d'objet seront désélectionnées (un deuxième clic sur le séparateur re-sélectionnera les dernières icônes utilisées pour ces objets)",
		["options_contextmenu_use_custom_marked_normal_color"]          = "Marquage colorisé des entrées",
		["options_contextmenu_use_custom_marked_normal_color_TT"]  = "Affiche un menu pour le choix des différentes couleurs suivant le type de marquage",
		["options_contextmenu_custom_marked_normal_color"]              = "Couleur des entrées marquées",
		["options_contextmenu_custom_marked_normal_color_TT"]      = "La couleur qui sera utilisée pour afficher les entrées actives ou marquées courantes dans le menu contextuel",
		["options_header_filter_buttons_position"]  = "Positions de filtre",
		["options_header_pos"]			 = "Positions & dimension d'Icône",
        ["options_pos_inventories"]		 = "Dans l'inventaire",
        ["options_pos_inventories_TT"]	 = "La position de l'axe-x des symboles à l'interieur de l'inventaire",
		["options_pos_crafting"]            = "A l'atelier",
		["options_pos_crafting_TT"]    = "La position de l'axe x des symboles à l'intérieur de l'inventaire de l'atelier",
        ["options_pos_character_x"]		 = "X - Dans la fenêtre de personnage",
        ["options_pos_character_x_TT"]	 = "La position de l'axe-x des symboles à l'interieur de la fenêtre de personnage",
        ["options_pos_character_y"]		 = "Y - Dans la fenêtre de personnage",
        ["options_pos_character_y_TT"]	 = "La position de l'axe-y des symboles à l'interieur de la fenêtre de personnage",
        ["options_header_split_filters"]		 = "Séparer filtres",
        ["options_header_filters"]		         = "Filtres",
		["options_split_filters"]                = "Filtres de répartition",
		["options_split_filters_TT"]        = "Vous permet l'activation ou la désactivation des filtres individuels pour votre inventaire, vendeurs, banque, banque de guilde, marchands de guilde, ateliers de craft, table enchantement, courriers et panneaux de commerce.\n\nVous devrez utiliser le même filtre et spécification pour chaque inventaire ou panneau, si vous désactivez cette option !",
	    ["options_enable_filter_in_inventory"]			 = "Activer dans l'inventaire",
	    ["options_enable_filter_in_inventory_TT"]	 = "Vous permet aussi, de cacher les objets marqués dans votre inventaire",
	    ["options_enable_filter_in_craftbag"]			 = "Activer dans le Crafting bag",
	    ["options_enable_filter_in_craftbag_TT"]	 = "Vous permet aussi, de cacher les objets marqués dans votre Crafting bag",
        ["options_enable_filter_in_bank"]				 = "Activer dans la banque",
        ["options_enable_filter_in_bank_TT"]		 = "Vous permet aussi, de cacher les objets marqués dans votre banque",
        ["options_enable_filter_in_guildbank"]	 		 = "Activer dans la banque de guilde",
        ["options_enable_filter_in_guildbank_TT"]	 = "Vous permet aussi, de cacher les objets marqués dans votre banque de guilde",
        ["options_enable_filter_in_tradinghouse"]		 = "Activer dans les boutiques de guilde",
        ["options_enable_filter_in_tradinghouse_TT"]= "Vous permet aussi, de cacher les objets marqués dans vos boutiques de guilde",
        ["options_enable_filter_in_trade"]				 = "Activer lors d'un échange",
        ["options_enable_filter_in_trade_TT"]		 = "Vous permet de cacher les objets marqués lors d'un échange avec un autre joueur",
        ["options_enable_filter_in_mail"]		 		 = "Activer lors de la rédaction d'un courriel",
        ["options_enable_filter_in_mail_TT"]		 = "Vous permet de cacher les objets marqués lors de la rédaction d'un courriel",
        ["options_enable_filter_in_deconstruction"]		 = "Activer lors de la déstruction",
        ["options_enable_filter_in_deconstruction_TT"]		 = "Vous permet de cacher les objets marqués lors de déstructions d'objets dans les ateliers de craft",
        ["options_enable_filter_in_improvement"]		 = "Activer lors de l'amélioration",
        ["options_enable_filter_in_improvement_TT"]		 = "Vous permet de cacher les objets marqués lors d'améliorations d'objets dans les ateliers de craft",
        ["options_enable_filter_in_store"]		 = "Activer face aux marchands",
        ["options_enable_filter_in_store_TT"]		 = "Vous permet de cacher les objets marqués lors de vente avec un marchand",
        ["options_enable_filter_in_enchanting"]		 = "Activer durant l'enchantement",
        ["options_enable_filter_in_enchanting_TT"]		 = "Vous permet de cacher les objets marqués lors de créations et déstructions d'enchantement",
        ["options_enable_filter_in_fence"]		 = "Activer face aux receleurs",
        ["options_enable_filter_in_fence_TT"]		 = "Vous permet de cacher les objets marqués lors de vente avec receleurs",
        ["options_enable_filter_in_launder"]		 = "Activer au blanchiement",
        ["options_enable_filter_in_launder_TT"]		 = "Vous permet de cacher les objets marqués lors de blanchiement avec receleurs",
		["options_header_deactivated_symbols"]                      = "Désactivation symboles",
		["options_deactivated_symbols_apply_anti_checks"]           = "Appliquez les contrôles anti",
		["options_deactivated_symbols_apply_anti_checks_TT"]   = "Vous pouvez également appliquer le contrôle normal Anti-destruction / Anti-déconstruction / Anti-amélioration / Anti-courrier / Anti-commerce / Anti-Vente / Anti-Extraction / etc... pour les objets sélectionnés, même si le symbole de marque est désactivé actuellement. Pour sélectionner/désélectionner l'objet de nouveau vous devrez activer le symbole !",
        ["options_header_repair"] = GetString(SI_STORE_MODE_REPAIR),
        ["options_header_enchant"] = GetString(SI_ITEMTYPEDISPLAYCATEGORY15),
		["options_allow_marked_repair"] = "Kits de réparation marqués",
		["options_allow_marked_repair_TT"] = "Interdit l'utilisation des kits de réparation d'équipement marqués",
		--Other options
		["options_header_items"]				 		 			 = "Marquage automatique",
		["options_header_items_demark"]          = "Désélection auto",
        ["options_enable_auto_mark_ornate_items"] 		 			 = "Marque les objets ornés",
        ["options_enable_auto_mark_ornate_items_TT"] 			 = "Marque automatiquement les objets ornés pour les vendre",
        ["options_enable_auto_mark_ornate_items_in_chat_TT"]	 =  "Montre automatiquement, les objets marqué ornés dans le chat",
        ["options_auto_mark_ornate_items_icon"] 					 = "Icône des objets ornés",
        ["options_auto_mark_ornate_items_icon_TT"] 			 = "Icône pour les objets ornés, qui seront automatiquement marqués pour être vendus",
        ["options_enable_auto_mark_intricate_items"] = "Marque les objets complexe",
        ["options_enable_auto_mark_intricate_items_TT"] =  "Marque automatiquement les objets complexe",
        ["options_auto_mark_intricate_items_icon"] = "Icône des objets complexe",
        ["options_auto_mark_intricate_items_icon_TT"] = "Icônes pour les objets complexe, qui seront automatiquement marqués",
        ["options_enable_auto_mark_intricate_items_in_chat"] = "Montre en chat",
        ["options_enable_auto_mark_intricate_items_in_chat_TT"] =  "Montre automatiquement, les objets marqué complexe dans le chat",
        ["options_auto_mark_research_items_icon"] 					 = "Icône des objets recherchés",
        ["options_auto_mark_research_items_icon_TT"] 			 = "Icône pour les objets recherchés, qui seront automatiquement marqués",
		["options_auto_mark_settrackersets_inv"]			= "Marquer dans l'inventaire",
		["options_auto_mark_settrackersets_inv_TT"]	= "Marque les objets dans votre inventaire",
		["options_auto_mark_settrackersets_worn"]			= "Marquer usagé",
		["options_auto_mark_settrackersets_worn_TT"]	= "Marque vos objets usagés actuels",
		["options_auto_mark_settrackersets_bank"]			= "Marquer en banque",
		["options_auto_mark_settrackersets_bank_TT"]	= "Marque les objets dans votre banque",
		["options_auto_mark_settrackersets_guildbank"]			= "Marquer dans la banque de guilde",
		["options_auto_mark_settrackersets_guildbank_TT"]	= "Marque les objets dans vos banques de guilde",
        ["options_auto_mark_settrackersets_show_tooltip_on_FCOIS_marker"]		  = "Afficher l'ensemble comme une info-bulle",
		["options_auto_mark_settrackersets_show_tooltip_on_FCOIS_marker_TT"] = "Affiche des infos de l'ensemble de SetTracker (Si créé) dans l'info-bulle de l'icône de marque FCOItemSaver dans votre inventaire.",
		["options_header_settracker"]								= "Set Tracker",
		["options_auto_mark_settrackersets"]						= "Marquer automatiquement les ensembles 'SetTracker' ",
		["options_auto_mark_settrackersets_TT"]				= "Marque automatiquement les objets recherchés avec 'SetTracker' d'une des icônes de marque de FCOIS",
		["options_auto_mark_settrackersets_to_fcois_icon"]			= "Index SetTracker <<1>>: icône FCOIS",
		["options_auto_mark_settrackersets_to_fcois_icon_TT"]	= "Défini l'icône de FCOItemSaver qui sera utilisée pour chaque ensemble ou stat 'SetTracker' recherché.",
		["options_enable_auto_mark_sets_settracker_icons"]			= "Cocher tous les sets SetTracker",
		["options_enable_auto_mark_sets_settracker_icons_TT"]	= "Valide automatiquement tous les éléments d'équipements définis par SetTracker. Si un élément  SetTracker est déjà marqué, le marquage automatique ne sera pas appliqué !",
		["options_enable_block_marked_disable_with_flag"]			= "Désactivation temporaire",
		["options_enable_block_marked_disable_with_flag_TT"]	= "Désactive l'anti-utilisation / -lecture / - prise / -etc. temporairement  par un clic droit sur l'icône drapeau de l'option supplémentaire d'inventaire",
		["options_enable_auto_mark_sets_sell_icon"]			= "Cocher vendre/vendre marchand guilde",
		["options_enable_auto_mark_sets_sell_icon_TT"]	= "Valide automatiquement les éléments d'équipement à vendre y compris ceux à vendre au marchand de guilde. Si un élément d'équipement est déjà marqué, le marquage automatique ne sera pas appliqué !",
		["options_enable_auto_mark_sets_non_wished"]							= "Marquer non-souhaité",
		["options_enable_auto_mark_sets_non_wished_TT"]					= "Marque automatiquement les parties d'ensemble non-souhaitées avec une icône différente (Veuillez noter que les bijoux ne peuvent être marqués pour la recherche, l'amélioration ou la déconstruction !)",
		["options_enable_auto_mark_sets_non_wished_icon"]						= "Icône non-souhaité",
		["options_enable_auto_mark_sets_non_wished_icon_TT"]				= "Choisissez votre icône pour les parties d'ensemble non-souhaitées.\n\nIcône standard : 'Déconstruction'",
		["options_enable_auto_mark_sets_non_wished_quality"]					= "Seuil qualité Non-souhaité",
		["options_enable_auto_mark_sets_non_wished_quality_TT"]			= "Les parties d'ensemble Non-souhaité seront marquées de l'icône qualité Non-souhaité si leur qualité est supérieure ou égale à une qualité choisie.",
		["options_enable_auto_mark_recipes"]            = "Articles inconnus",
		["options_enable_auto_mark_recipes_TT"]    = "Marque automatiquement les articles inconnus avec l'icône verrou",
		["options_enable_auto_mark_known_recipes"]		= "Marque les connus ",
		["options_enable_auto_mark_known_recipes_TT"]	= "Marque automatiquement les recettes connues.\n\nRecettes connues = Dépend de l'option 'pour ce personnage uniquement '!",
		["options_enable_auto_mark_recipes_in_chat"]    = "Articles dans le chat",
		["options_enable_auto_mark_recipes_in_chat_TT"] = "Affiche automatiquement les articles inconnus dans le chat",
		["options_auto_mark_recipes_this_char"]         = "Uniquement pour ce personnage",
		["options_auto_mark_recipes_this_char_TT"] = "Si vous activez ce réglage, les articles inconnus ne seront marqués que pour le personnage actuel !\n\nSi ce réglage est désactivé le récipient inconnu ne sera marqué que si votre personnage principal ne connait pas cet article !",
		["options_enable_auto_mark_recipes_hint"]       = "Cette option nécessite l'activation de l'extension SousChef et spécialement l'option 'Recettes connues dans les info-bulles'!",
		["options_auto_mark_crafted_items"]             = "Marquer les objets fabriqués",
		["options_auto_mark_crafted_items_TT"]     = "Si vous activez ce réglage, l'extension marquera automatiquement, avec l'icône 'verrou', les objets fabriqués en atelier.",
		["options_auto_mark_crafted_items_sets"]            = "Marquer uniquement les sets",
		["options_auto_mark_crafted_items_sets_TT"]    = "Si vous activez cette option le marquage automatique des objets fabriqués ne s'appliquera que sur les parties fabriquées des sets.",
		["options_header_anti_destroy"] = "Protection (Anti-methodes)",
        ["options_enable_block_deconstruction"]  					 = "Désactiver la déconstruction des objets marqués",
        ["options_enable_block_deconstruction_TT"]  			 = "Désactive la déconstruction des objets marqués dans les ateliers de craft",
		["options_enable_block_deconstruction_exception_intricate"]  = "Permet la déconstruction des objets complexe",
        ["options_enable_block_deconstruction_exception_intricate_TT"]  = "Permet la déconstruction des objets marqué comme complexe",
		["options_enable_block_deconstruction_exception_deconstruction"]  = "Permet la déconstruction des objets déconstruction",
        ["options_enable_block_deconstruction_exception_deconstruction_TT"]  = "Permet la déconstruction des objets marqué comme déconstruction",
		["options_enable_block_deconstruction_exception_deconstruction_all_markers"]  = "Autoriser le démontage (ignore les autres marqueurs)",
		["options_enable_block_deconstruction_exception_deconstruction_all_markers_TT"]  = "Permet le démontage des objets marqués comme 'démontable' même si l'objet est déjà marqué par ailleurs.\n\nAttention: Ceci détruira tous les objets marqués pour le démontage y compris ceux marqués comme pièce d'ensemble que vous vouliez garder.",
        ["options_enable_block_destroying"]  						 = "Désactiver la destruction",
        ["options_enable_block_destroying_TT"]  				 = "Désactive la destruction des objets marqués",
        ["options_enable_block_sending_mail"]  						 = "Désactiver l'envoi par courriel",
        ["options_enable_block_sending_mail_TT"]  				 = "Désactive l'envoi par courrier des objets marqués",
        ["options_enable_block_trading"]  							 = "Désactiver l'échange",
        ["options_enable_block_trading_TT"]  			 = "Désactive l'échange d'objets marqués, avec d'autres joueurs",
        ["options_enable_block_selling"]  = "Désactiver vendre",
        ["options_enable_block_selling_TT"]  = "Désactive la vente d'objets marqués avec le marchand",
        ["options_enable_block_selling_guild_store"]  = "Désactiver vendre aux Boutique de Guilde",
        ["options_enable_block_selling_guild_store_TT"]  = "Désactive la vente d'objets marqués au Boutique de Guilde",
        ["options_enable_block_fence_selling"]    = "Désactiver vendre aux receleurs",
        ["options_enable_block_fence_selling_TT"]    = "Désactive la vente d'objets marqués avec le receleur",
        ["options_enable_block_launder_selling"]    = "Désactiver blanchir",
        ["options_enable_block_launder_selling_TT"]    = "Désactive le blanchiment des objets marqués avec le receleur",
        ["options_auto_reenable_block_launder_selling"]  = "Reactiver l'anti-blanchiment automatiquement",
        ["options_auto_reenable_block_launder_selling_TT"]  = "Ré-active, automatiquement, la protection anti-blanchiment, dès que vous quittez la boutique du receleur",
		["button_context_menu_toggle_anti_launder_sell_on"] = "Activer l'anti-blanchiment avec receleur'",
		["button_context_menu_toggle_anti_launder_sell_off"] = "Désactiver l'anti-blanchiment avec receleur'",
		["filter_launder"] = "[Launder] ",
        ["launder_selling_not_allowed"]			 = "Blanchir avec receleur n'est pas permis :",
		["options_block_selling_exception"]         = "Vendre objets à vendre",
		["options_block_selling_exception_TT"] = "Permet de vendre les objets marqués pour la vente",
		["options_demark_all_selling"]  = "Désélectionner pour vendre",
		["options_demark_all_selling_TT"] = "Enlève tous les marqueurs si vous marquez un objet à la vente",
		["options_demark_all_selling_guild_store"]  = "Désélectionner pour vente au marchand guilde",
		["options_demark_all_selling_guild_store_TT"] = "Enlève tous les marqueurs si vous marquez un objet à la vente au marchand de guilde",
		["options_demark_all_deconstruct"]	= "Démarquer tout pour 'démontable'",
		["options_demark_all_deconstruct_TT"] = "Enlève toutes les autres marques si vous marquez un objet pour le démontage",
		["options_block_selling_exception_ornate"] = "Activer vendre objets ornés",
		["options_block_selling_exception_ornate_TT"] = "Vous permet de vendre les objets que vous avez marqué comme orné",
		["options_block_selling_exception_intricate"] = "Activer vendre objets complexe",
		["options_block_selling_exception_intricate_TT"] = "Vous permet de vendre des objets que vous avez marqué comme complexe",
		["options_block_selling_exception_guild_store"] = "Activer vendre en boutique de Guilde",
		["options_block_selling_exception_guild_store_TT"] = "Vous permet de vendre les objets 'Marqué pour boutique de Guilde' dans la boutique de Guilde",
        ["options_enable_block_improvement"]  = "Désactiver l'amélioration",
        ["options_enable_block_improvement_TT"]  = "Désactive l'amélioration des objets marqués dans les ateliers de craft",
		["options_enable_block_improvement_exception_improvement"]  = "Amélioration des objets améliorés",
		["options_enable_block_improvement_exception_improvement_TT"]  = "Permet d'améliorer, à l'atelier, les objets marqués pour l'amélioration",
		["options_enable_block_creation"] 			= "Desactive la création de runes",
		["options_enable_block_creation_TT"]	= "Desactive la création de runes avec les items marqués, à l'autel d'enchantement",
		["options_enable_block_extraction"]			= "Desactive l'extraction de runes",
		["options_enable_block_extraction_TT"]	= "Desactive l'extraction de runes avec les items marqués, à l'autel d'enchantement",
        ["options_auto_reenable_block_deconstruction"]  = "Reactiver l'Anti-déconstruction automatiquement",
        ["options_auto_reenable_block_deconstruction_TT"]  = "Ré-active, automatiquement, la protection anti-deconstruction, dès que vous quittez l'atelier de craft",
        ["options_auto_reenable_block_destroying"]  = "Reactiver l'anti-destruction automatiquement",
        ["options_auto_reenable_block_destroying_TT"]  = "Ré-active, automatiquement, la protection anti-destruction, dès que vous quittez l'inventaire/banque/banque de guilde",
        ["options_auto_reenable_block_sending_mail"]  = "Reactiver l'anti-mail automatiquement",
        ["options_auto_reenable_block_sending_mail_TT"]  = "Ré-active, automatiquement, la protection anti-mail, dès que vous quittez l'inventaire de mail",
        ["options_auto_reenable_block_trading"]  = "Reactiver l'anti-échange automatiquement",
        ["options_auto_reenable_block_trading_TT"]  = "Ré-active, automatiquement, la protection anti-échange, dès que vous quittez l'inventaire d'échange",
        ["options_auto_reenable_block_selling"]  = "Reactiver l'anti-vente automatiquement",
        ["options_auto_reenable_block_selling_TT"]  = "Ré-active, automatiquement, la protection anti-vente, dès que vous quittez la boutique de marchand",
        ["options_auto_reenable_block_selling_guild_store"]  = "Reactiver l'anti-vente à boutique de Guilde automatiquement",
        ["options_auto_reenable_block_selling_guild_store_TT"]  = "Ré-active, automatiquement, la protection anti-vente, dès que vous quittez la boutique de Guilde",
        ["options_auto_reenable_block_fence_selling"]  = "Reactiver l'anti-vente avec receleur automatiquement",
        ["options_auto_reenable_block_fence_selling_TT"]  = "Ré-active, automatiquement, la protection anti-vente avec receleur, dès que vous quittez la boutique de receleur",
        ["options_auto_reenable_block_improvement"]  = "Reactiver l'anti-amélioration automatiquement",
        ["options_auto_reenable_block_improvement_TT"]  = "Ré-active, automatiquement, la protection anti-amélioration, dès que vous quittez l'atelier de craft",
		["options_auto_reenable_block_creation"] 			= "Reactiver l'anti-création de rune automatiquement",
		["options_auto_reenable_block_creation_TT"]	= "Ré-active, automatiquement, la protection anti-création de rune, dès que vous quittez l'autel d'enchantement",
		["options_auto_reenable_block_extraction"]			= "Reactiver l'anti-extraction de rune automatiquement",
		["options_auto_reenable_block_extraction_TT"]	= "Ré-active, automatiquement, la protection anti-extraction de rune, dès que vous quittez l'autel d'enchantement",
        ["options_header_uniqueids"]           = "ID Objet Unique",
        ["options_use_uniqueids"]           = "Utilisation IDs uniques",
        ["options_use_uniqueids_TT"]   = "Activé :\nUtilise les identifiants uniques\n\nCeci vous permettra de marquer avec une autre icône les objets qui se ressemblent mais ayant une légère différence (style/niveau, enchantement etc).\n\n\nDésactivé :\nUilise les identifiants normaux et marque tous les objets du même nom.\n\nAttention: Vos objets déjà marqués seront sauvegardés suivant la méthode choisie. La modification des modes vous montrera de nouveau les icônes de marque enregistrées\n\nUn rechargement IU sera nécessaire si vous activez cette option !",
        ["options_migrate_uniqueids"]           = "Migration",
        ["options_migrate_uniqueids_TT"]   = "Migre les objets marqués des IDs non-uniques vers uniques.\nCela remarquera tous les objets que vous avez marqué précédemment .\nDe cette façon, tous les objets sont encore sauvegardés et vous n'avez qu'à supprimer ou modifier les icônes des marqueurs.\n\n|cFF0000Cette option ne sera utilisable qu'une fois ID unique activé et le rechargement interface effectué !\nRevenez ici et cliquez ensuite sur ce bouton !|r",
        ["options_migrate_uniqueids_warning"]   = "Cela migrera tous les marqueurs d'identification non-uniques vers les marqueurs d'identification uniques pour les mêmes objets.\nLes icônes existantes seront gardées et seule les icônes nouvelles seront ajoutées !\n\nCette migration est définitive ! Vous devrez de nouveau supprimer les icônes marquées.",
        ["options_migrate_uniqueids_dialog"]   = "Migrer de non-unique vers unique ?\n Ceci ajoutera seulement de nouveaux marqueurs.\nAucune icône ne sera enlevée.",
        ["options_migrate_nonuniqueids_dialog"] = "Migrer de non-unique vers unique ?\n Ceci ajoutera seulement de nouveaux marqueurs.\nAucune icône ne sera enlevée.",
        ["options_migrate_unique_inv_scan_not_done"]   = "Vous avez changer mode ID en mode ID unique.\nLe scan automatique de l'inventaire n'a pas encore commencé !\nUtilisez la boîte de dialogue contextuelle de migration ou accédez aux paramètres et migrez vos icônes maintenant, si vous le souhaitez.",
        ["options_migrate_start"] = "Migration commencée : <<1>>",
        ["options_migrate_results"] = "> <<1[0/1 icône/$d icônes]>> migrée(s) pour <<2[0 objet/1 objet/$d objets]>>.",
        ["options_migrate_end"] = "Migration terminée : <<1>>",
        ["options_migrate_bag_type_" .. tostring(BAG_BACKPACK)] = "Sac à dos",
        ["options_migrate_bag_type_" .. tostring(BAG_BANK)] = "Banque",
        ["options_migrate_bag_type_" .. tostring(BAG_GUILDBANK)] = "Banque de guilde",
        ["options_header_equipment"] 			 					 = "Equipement",
        ["options_equipment_markall_gear"] 		 					 = "Permet de marquer tout l'équipement",
        ["options_equipment_markall_gear_TT"] 					 = "Vous permet de marquer en une seule fois tous les objets équipés en tant qu'équipement 1 ou 2",
        ["options_equipment_markall_gear_add_weapons"] 				 = "Marquer aussi les armes",
        ["options_equipment_markall_gear_add_weapons_TT"]		 = "Marque aussi les armes, automatiquement",
        ["options_equipment_markall_gear_add_jewelry"] 				 = "Marquer aussi les bijoux",
        ["options_equipment_markall_gear_add_jewelry_TT"]		 = "Marque aussi les bijoux, automatiquement",
        ["options_enable_auto_mark_research_items"] 				 = "Marquer des objets recherchés",
        ["options_enable_auto_mark_research_items_TT"] 		 = "Marque automatiquement les objets recherchés",
        ["options_enable_auto_mark_research_items_hint"]    		 = "L'addon requis sera choisi dans la liste déroulante dans les paramètres d'addon",
        ["options_enable_auto_mark_ornate_items_in_chat"] 			 = "Montrer les objets ornés dans le chat",
        ["options_enable_auto_mark_ornate_items_tooltip_in_chat"] 	 = "Montre automatiquement les objets marqués comme 'orné' dans la fenêtre de chat",
        ["options_enable_auto_mark_research_items_in_chat"]			 = "Montrer les objets recherchés dans le chat",
	    ["options_enable_auto_mark_research_items_in_chat_TT"]  = "Montre automatiquement les objets marqués comme 'recherché' dans la fenêtre de chat",
		["options_enable_auto_mark_sets"]           = "Marquer les éléments de Set",
		["options_enable_auto_mark_sets_TT"]   = "Marquer automatiquement les éléments d'un Set",
		["options_enable_auto_mark_check_all_icons"]			= "Vérifier toutes les marques ",
		["options_enable_auto_mark_check_all_icons_TT"]	= "Vérifie toutes les icônes de marquage en plus du marquage automatique des éléments.\nSi une marque a déjà été appliquée à un objet, le marquage automatique ne sera pas appliqué",
		["options_enable_auto_mark_sets_all_gear_marker_icons"]         = "Vérifier toutes les marques d'équipement",
		["options_enable_auto_mark_sets_all_gear_marker_icons_TT"] = "Vérifie toutes les icônes de marquage d'équipement en plus du marquage automatique des éléments de Set. Si une marque d'équipement a déjà été appliquée à un objet, le marquage automatique du Set ne sera pas appliqué",
		["options_enable_auto_mark_sets_in_chat"] = "Montre les éléments de Set dans le Chat",
		["options_enable_auto_mark_sets_in_chat_TT"] =  "Afficher automatiquement les éléments de Set marqués dans le Chat",
		["options_auto_mark_recipes_icon"]                =    "Icône des recettes (%s)",
	    ["options_auto_mark_recipes_icon_TT"]        =    "Icône pour les recettes %s marquées automatiquement",
	    ["options_auto_mark_crafted_items_icon"]        =    "Icône pour objets fabriqués",
	    ["options_auto_mark_crafted_items_icon_TT"]=    "Icône pour les objets fabriqués marqués automatiquement",
		["options_auto_mark_sets_icon"]         = "Icône pour les éléments de Set",
		["options_auto_mark_sets_icon_TT"] = "Icône pour les éléments de Set marqués automatiquement",
		["options_enable_filter_in_alchemy"]         = "Activer les filtres d'alchimie",
		["options_enable_filter_in_alchemy_TT"]         = "Vous permet de masquer les objets marqués lors de la création de potion à l'atelier d'alchimie",
		["options_enable_block_alchemy_destroy"]  = "Désactiver destruction alchimique",
		["options_enable_block_alchemy_destroy_TT"]  = "Désactive la destruction des objets marqués à l'atelier d'alchimie",
		["options_auto_reenable_block_alchemy_destroy"]  = "Réactiver auto Anti-destruction alchimique",
		["options_auto_reenable_block_alchemy_destroy_TT"]  = "Réactive automatiquement la protection anti-destruction lorsque vous quittez l'atelier d'alchimie",
		["options_enable_block_autoloot_container"]         = "Désactiver l'autoloot récipients",
		["options_enable_block_autoloot_container_TT"] = "Désactive le ramassage automatique du contenu des récipients, si vous avez activez le ramassage auto standard d'ESO.\n\nSi ce réglage est activé, vous ne pouvez pas ouvrir un récipient marqué. Jetez un oeil sur l'extension 'Container Peek' qui apporte un grand plus pour la gestion des récipients et du ramassage auto !",
		["options_enable_block_marked_recipes"]         = "Non lecture recettes",
		["options_enable_block_marked_recipes_TT"] = "Empêche la lecture accidentelle des recettes si celles-ci sont marquées d'une icône",
        ["options_remove_context_menu_mark_as_junk"] = "Supprimer l'entrée '" .. GetString(SI_ITEM_ACTION_MARK_AS_JUNK) .."' du menu contextuel pour les éléments marqués",
        ["options_remove_context_menu_mark_as_junk_TT"] = "Remove context menu entry '" .. GetString(SI_ITEM_ACTION_MARK_AS_JUNK) .. "' for marked items",
		["options_enable_block_motifs"] = "Non lecture motifs",
		["options_enable_block_motifs_TT"] = "Empêche la lecture accidentelle des motifs si ceux-ci sont marqués d'une icône",
		["options_header_motifs"] = "Style-Motifs",
		["options_header_food"] = "Nourriture & Potions",
		["options_enable_block_potions"] = "Non ingestion potions",
		["options_enable_block_potions_TT"] = "Empêche l'ingestion accidentelle des potions si celles-ci sont marquées d'une icône",
		["options_enable_block_food"] = "Non ingestion nourriture",
		["options_enable_block_food_TT"] = "Empêche l'ingestion accidentelle de nourritures si celles-ci sont marquées d'une icône",
		["options_header_guild_bank"] = "Banque guilde",
		["options_enable_block_guild_bank_without_withdraw"] = "Eviter dépôt sans retour",
		["options_enable_block_guild_bank_without_withdraw_TT"] = "Empêche le dépôt de tout objets si vous ne disposez pas les droits de les retirer de nouveau",
        ["options_header_filter_buttons"]	= "Boutons de filtre",
        ["options_filter_buttons_show_TT"] = "Révèler l'info-bulle",
        ["options_filter_buttons_show_tooltip_TT"] = "Une info-bulle aparaît en passant/cliquant sur un bouton de filtre",
		["options_filter_buttons_context_menu_show_TT"] = "Afficher infobulles",
		["options_filter_buttons_context_menu_show_tooltip_TT"] = "Affiche une infobulle identifiant chaque entrée des menus filtre",
		["options_header_filter_chat"] 			= "Filtre & Chat",
        ["options_chat_filter_status"]			= "Afficher le statut du filtre dans le chat",
        ["options_chat_filter_status_TT"] 	= "Affiche le statut du filtre dans le chat lors d'un changement ",
		["options_header_destroy"]              = "Détruire",
		["options_header_deconstruction"]       = "Déconstruction",
		["options_header_research"]             = "Recherche",
		["options_header_improvement"]          = "Amélioration",
		["options_header_mail"]                 = "Courrier",
		["options_header_trade"]                = "Commerce",
		["options_header_rune_creation"]        = "Création Rune",
		["options_header_rune_extraction"]      = "Extraction glyphe",
		["options_header_sell"]                 = "Vendre",
		["options_header_sell_at_guild_store"]  = "Vendre marchand guilde",
		["options_header_fence"]                = "Receleur",
		["options_header_launder"]              = "Blanchir",
		["options_header_alchemy_destroy"]      = "Alchimie",
		["options_header_recipes"]              = "Recettes",
		["options_header_containers"]           = "Container",
		["options_header_anti_output_options"]  = "Options de réactions",
		--Additional buttons
        ["options_header_additional_buttons"]						 = "Boutons additionnels",
        ["options_additional_buttons_FCOIS_settings"] 				 = "Options FCO dans le menu principal",
        ["options_additional_buttons_FCOIS_settings_TT"] 		 = "Fait apparaître un bouton additionnel, pour FCOItemSaver (Options) dans le menu principal (à droite du boutton Aide/Help)\n\n[Attention] The button will only be shown if the addon settings button of the addon 'Votans Settings Menu' is not show!",
        ["options_additional_buttons_FCOIS_additional_options"] 		= "Options additionnelles dans l'inventaire",
		["options_additional_buttons_FCOIS_additional_options_TT"] = "Affiche un bouton supplémentaire pour plus d'options dans les inventaires (marquer tout, désélectionner tout, annuler la dernière modification). Ce bouton sera représenté par un ' drapeau' sur le bord supérieur gauche de l'inventaire et ouvrira un menu si vous cliquez dessus !",
		["options_additional_buttons_FCOIS_additional_options_colorize"]        = "Coloriser options sup des inv.",
		["options_additional_buttons_FCOIS_additional_options_colorize_TT"] = "Colorise le bouton Options supplémentaires en vert (protection activée) ou en rouge (protection désactivée).",
        ["button_FCOIS_settings_TT"]							 = "Fait apparaitre les options de FCOItemSaver",
		--Anti equip
		["options_header_anti_equip"]					= "Anti-équipé",
		["options_askBeforeEquipBoundItems"]			= "Demander avant de lier un objet",
		["options_askBeforeEquipBoundItems_TT"]	= "Demande une confirmation, si vous tentez de lier un objet au compte",
		["options_anti_equip_question"]					= "Lié <<!A:1>> \nà votre compte ?",
		--Stolen
        ["options_header_stolen"]				 = "Volé",
		["options_show_stolen_icon"]			 = "Révèler le filtre volé",
		["options_show_stolen_icon_TT"]     = "Ajoute une icône additionnelle pour le filtre volé, dans l'inventaire pour les objets volés. Elle sera toujours affichée à droite de la dernière icône de filtre actif (standard:icône Pièce).",
        --Other options
		["options_split_lockdyn_filter"]         = "Scinder en icône verrou et icônes dynamiques",
		["options_split_lockdyn_filter_TT"] = "Partage le 1er bouton filtre en icône de verrou et 4 icônes supplémentaires configurables. Si vous faites un clic droit sur ​​le bouton du 1er filtre dans l'inventaire , un menu déroulant s'affichera et vous pourrez choisir chaque icône individuellement, que vous souhaitez filtrer . L'entrée * sélectionnera à nouveau toutes les entrées.",

        ["options_split_gearsets_filter"]		 = "Divise le filtre set d'equipement",
        ["options_split_gearsets_filter_TT"]= "Divise le filtre set d'équipement dans les inventaires, de sorte à ce qu'il affiche un menu déroulant qui vous permet de choisir l'icône du set d'équipement que vous souhaitez filtrer.",
        ["options_split_resdecimp_filter"]		 	 = "Divise recherche (en Amélioration/Deconstruction)",
        ["options_split_resdecimp_filter_TT"]= "Divise le filtre recherché dans les inventaires, de sorte à ce qu'il affiche un menu déroulant qui vous permet de choisir, si vous souhaitez filtrer la recherche, avec des icônes de déconstruction ou amélioration.",
        ["options_split_sellguildint_filter"]		 = "Divise vente (en boutique de guilde/complexe)",
        ["options_split_sellguildint_filter_TT"]= "Divise le filtre de vente dans les inventaires de sorte à ce qu'il affiche un menu déroulant qui vous permet de choisir, si vous souhaitez filter la vente, avec icônes Vendable en boutique de guilde ou Complexe.",
		--Right click item menu
		["rightclick_menu_lock"] 									 = "Vérrouiller",
		["rightclick_menu_unlock"] 									 = "Déverrouiller",
		["rightclick_menu_add_gear1"] 						 		 = "Ajouter à équipement 1",
		["rightclick_menu_add_all_gear1"] 					 		 = "Ajouter tout à équipement 1",
		["rightclick_menu_remove_gear1"] 						 	 = "Retirer de équipement 1",
		["rightclick_menu_remove_all_gear1"] 						 = "Retirer tout de équipement 1",
        ["rightclick_menu_add_gear2"]       						 = "Ajouter à équipement 2",
        ["rightclick_menu_add_all_gear2"]        					 = "Ajouter tout à équipement 2",
        ["rightclick_menu_remove_gear2"]        					 = "Retirer de équipement 2",
        ["rightclick_menu_remove_all_gear2"]    					 = "Retirer tout de équipement 2",
        ["rightclick_menu_add_gear3"]        						 = "Ajouter à équipement 3",
        ["rightclick_menu_add_all_gear3"]        					 = "Ajouter tout à équipement 3",
        ["rightclick_menu_remove_gear3"]         					 = "Retirer de équipement 3",
        ["rightclick_menu_remove_all_gear3"]        				 = "Retirer tout de équipement 3",
        ["rightclick_menu_add_gear4"]        	 					 = "Ajouter à équipement 4",
        ["rightclick_menu_add_all_gear4"]        	 				 = "Ajouter tout à équipement 4",
        ["rightclick_menu_remove_gear4"]         					 = "Retirer de équipement 4",
        ["rightclick_menu_remove_all_gear4"]         				 = "Retirer tout de équipement 4",
        ["rightclick_menu_add_gear5"]        	 					 = "Ajouter à équipement 5",
        ["rightclick_menu_add_all_gear5"]        		 			 = "Ajouter tout à équipement 5",
        ["rightclick_menu_remove_gear5"]         					 = "Retirer de équipement 5",
        ["rightclick_menu_remove_all_gear5"]         				 = "Retirer tout de équipement 5",
		["rightclick_menu_mark_analysis"] 							 = "Réserver pour la recherche",
		["rightclick_menu_demark_analysis"] 						 = "Retirer de la recherche",
		["rightclick_menu_mark_sell"] 								 = "A vendre",
		["rightclick_menu_demark_sell"] 							 = "Ne plus vendre",
        ["rightclick_menu_mark_sell_in_guild_store"]    = "Marquer vendre en boutique de Guilde",
        ["rightclick_menu_demark_sell_in_guild_store"]  = "Dé-marquer vendre en boutique de Guilde",
        ["rightclick_menu_mark_intricate"]      = "Marquer comme complexe",
        ["rightclick_menu_demark_intricate"]    = "Dé-marquer comme complexe",
        ["rightclick_menu_mark_deconstruction"]  = "Marquer pour la déconstruction",
        ["rightclick_menu_demark_deconstruction"]= "Dé-marquer pour la déconstruction",
        ["rightclick_menu_mark_improvement"]     = "Marquer pour l'amélioration",
        ["rightclick_menu_demark_improvement"]   = "Dé-marquer pour l'amélioration",
        ["rightclick_menu_add_start_gear"]       					 = "Ajouter à ",
        ["rightclick_menu_add_all_start_gear"]   					 = "Ajouter tout à ",
        ["rightclick_menu_remove_start_gear"]    					 = "Enlever de ",
        ["rightclick_menu_remove_all_start_gear"]					 = "Enlever tout de ",
		--Button context menu
		["button_context_menu_TT"]			 = "Options supplémentaires",
        ["button_context_menu_lock_all"]	 	 = "Verrouiller tout",
        ["button_context_menu_unlock_all"]	 	 = "Deverrouiller tout",
        ["button_context_menu_research_all"]	 = "+ Recherche",
        ["button_context_menu_dont_research_all"]= "- Recherche",
        ["button_context_menu_deconstruct_all"]	 	= "+ Deconstruction",
        ["button_context_menu_dont_deconstruct_all"]= "- Deconstruction",
        ["button_context_menu_improve_all"]	 		= "+ Amélioration",
        ["button_context_menu_dont_improve_all"]	= "- Amélioration",
        ["button_context_menu_sell_all"]	 	 = "+ Vendre",
        ["button_context_menu_dont_sell_all"]	 = "- Vendre",
        ["button_context_menu_sell_all_in_guild_store"]	 	= "+ Vendre en boutique de Guilde",
        ["button_context_menu_dont_sell_all_in_guild_store"]= "- Vendre en boutique de Guilde",
        ["button_context_menu_mark_all_as_intricate"]       = "+ Complexe",
        ["button_context_menu_unmark_all_as_intricate"]     = "- Complexe",
        ["button_context_menu_undo"]	 		 = "< Annuler la dernière modif.",
        ["button_context_menu_remove_all_gears"] = "Retirer tout les équipements",
        ["button_context_menu_demark_all"]	 	 = "Retirer toutes les sélèctions",
		["button_context_menu_toggle_anti_destroy_on"] = "Activer 'Anti-Destruction'",
		["button_context_menu_toggle_anti_destroy_off"] = "Desactiver 'Anti-Destruction'",
		["button_context_menu_toggle_anti_deconstruct_on"] = "Activer 'Anti-Déconstruction'",
		["button_context_menu_toggle_anti_deconstruct_off"] = "Desactiver 'Anti-Déconstruction'",
        ["button_context_menu_toggle_anti_improve_on"] = "Activer 'Anti-Amélioration'",
        ["button_context_menu_toggle_anti_improve_off"] = "Desactiver 'Anti-Amélioration'",
		["button_context_menu_toggle_anti_create_on"] = "Activer 'Anti-Création'",
		["button_context_menu_toggle_anti_create_off"] = "Desactiver 'Anti-Création'",
		["button_context_menu_toggle_anti_extract_on"] = "Activer 'Anti-Extraction'",
		["button_context_menu_toggle_anti_extract_off"] = "Desactiveer 'Anti-Extraction'",
		["button_context_menu_toggle_anti_mail_on"] = "Activer 'Anti-Mail'",
		["button_context_menu_toggle_anti_mail_off"] = "Desactiver 'Anti-Mail'",
		["button_context_menu_toggle_anti_sell_on"] = "Activer 'Anti-Vente'",
		["button_context_menu_toggle_anti_sell_off"] = "Desactiver 'Anti-Vente'",
		["button_context_menu_toggle_anti_fence_sell_on"] = "Activer 'Anti-Vente' avec receleur",
		["button_context_menu_toggle_anti_fence_sell_off"] = "Desactiver 'Anti-Vente' avec receleur'",
		["button_context_menu_toggle_anti_trade_on"] = "Activer 'Anti-Échange'",
		["button_context_menu_toggle_anti_trade_off"] = "Desactiver 'Anti-Échange'",
        ["button_context_menu_gear_sets_all"]	 	 = "*",
        ["button_context_menu_all_markers_TT"]	 = "Toutes équipements",
        ["button_context_menu_gear_sets_all_TT"]= "Toutes icônes",
		["filter_refinement"]							= "[Amélioration atelier de craft] ",
        ["options_enable_filter_in_refinement"]		 	= "Activer lors de la amélioration",
        ["options_enable_filter_in_refinement_TT"]	= "Vous permet de cacher les objets marqués lors de amélioration d'objets dans les ateliers de craft",
		["refinement_not_allowed"]						= "Amélioration n'est pas permis:",
		["button_context_menu_toggle_anti_refine_on"] 	= "Activer Anti-améliore'",
		["button_context_menu_toggle_anti_refine_off"]	= "Désactiver anti-améliore'",
		["options_enable_block_refinement"]             = "désactiver amélioration",
		["options_enable_block_refinement_TT"]     = "Désactive l'amélioration des objets marqués dans les ateliers de craft",
		["options_header_refinement"]                              = "Amélioration",
		["options_auto_reenable_block_refinement"]      = "Réactiver anti-améliore automatiquement",
		["options_auto_reenable_block_refinement_TT"]  = "Réactive la protection anti-amélioration automatiquement lors de la sortie de l'atelier de craft.\n\nVous pouvez désactiver cette méthode de prévention grâce à un bouton situé dans le menu inventaire (Petit symbole en forme de 'drapeau' situé en haut à gauche) !",
		["options_prevent_auto_marking_deconstruction"] = "Empêcher l'auto marquage (démontage)",
		["options_prevent_auto_marking_deconstruction_TT"] = "Empêche le marquage automatique des objets si le marquage pour le démontage était définie",
		["options_prevent_auto_marking_sell"] = "Empêcher l'auto marquage (vendre)",
		["options_prevent_auto_marking_sell_TT"] = "Empêche le marquage automatique des objets si le marquage pour vendre était définie",
		--Chat commands
		["chatcommands_info"]	 				 = "|c00FF00FCO|cFFFF00Item Saver|cFFFFFF Ajouter des icônes dans l'inventaire/banque et les filtrer",
		["chatcommands_help"]	 				 = "|cFFFFFF'help' / 'list'|cFFFF00: Affiche cette information à propos de l'addon. Tapez |cFFFFFF'feedback' / 'retour' / 'erreur' / 'message'|cFFFF00 pour afficher la fenêtre de commentaires|r",
		["chatcommands_status"] 				 = "|cFFFFFF'status' / ''|cFFFF00: Montre les filtres en cours",
		["chatcommands_filter1"]	 			 = "|cFFFFFF'filtre1'|cFFFF00: Montrer/Cacher les objets verrouillés (cadenas) dans les fenêtres de vente et d'artisanat",
		["chatcommands_filter2"]	 			 = "|cFFFFFF'filtre2'|cFFFF00: Montrer/Cacher les équipements (casque) dans les fenêtres de vente et d'artisanat",
		["chatcommands_filter3"]	 			 = "|cFFFFFF'filtre3'|cFFFF00: Montrer/Cacher les réserves pour recherche (triangle) dans les fenêtres de vente et d'artisanat",
		["chatcommands_filter4"] 				 = "|cFFFFFF'filtre4'|cFFFF00: Montrer/Cacher les articles à mettre en vente en boutique de guilde (icône vente), dans les fenêtres de vente, boutiques de guilde et d'artisanat",
		["chatcommands_filter"]	 				 = "|cFFFFFF'filtres'|cFFFF00: Montrer/Cacher tous les objets marqués" ,
		["chatcommands_filteron"]	 			 = "|cFFFFFF'tousoff'|cFFFF00: Montrer tous les objets marqués dans les fenêtres de vente et d'artisanat",
		["chatcommands_filteroff"]	 			 = "|cFFFFFF'touson'|cFFFF00: Cacher tous les objets marqués dans les fenêtres de vente et d'artisanat",
		["chatcommands_filtershow"]	 			 = "|cFFFFFF'tousmontre'|cFFFF00: Ne montre QUE les objets marqués dans les fenêtres de vente et d'artisanat",
		["chatcommands_split_filter"]			 = "|cFFFFFFsplit|cFFFF00: Activer/Désactiver les filtres individuels dans l'inventaire, le marchand, la banque, la banque de guilde, les boutiques de guildes, les ateliers de craft, l'autel d'enchantement, les mails et l'échange",
        ["chatcommands_filterpanels"]			 = "|c990000Possible <filterPanel>:",
        ["chatcommands_filtervalues"]			 = "|c990000Possible <filterValue>: |cFFFFFFvrai|cFFFF00 / |cFFFFFFfaux|cFFFF00 / |cFFFFFFmontre",
        ["chatcommands_filter1_new"]			 = "|cFFFFFF'filtre1 <filterPanel> <filterValue>'|cFFFF00: Cacher |cFFFFFF<vrai>|cFFFF00 / voir |cFFFFFF<faux>|cFFFF00 / montre seulement les objets marqués |cFFFFFF<montre>|cFFFF00 de catergory 1 (symbole verrouillé) au panneau |cFFFFFF<filterPanel>",
        ["chatcommands_filter2_new"]			 = "|cFFFFFF'filtre2 <filterPanel> <filterValue>'|cFFFF00: Cacher |cFFFFFF<vrai>|cFFFF00 / voir |cFFFFFF<faux>|cFFFF00 / montre seulement les objets marqués |cFFFFFF<montre>|cFFFF00 de catergory 2 (symbole de casque) au panneau |cFFFFFF<filterPanel>",
        ["chatcommands_filter3_new"]			 = "|cFFFFFF'filtre3 <filterPanel> <filterValue>'|cFFFF00: Cacher |cFFFFFF<vrai>|cFFFF00 / voir |cFFFFFF<faux>|cFFFF00 / montre seulement les objets marqués |cFFFFFF<montre>|cFFFF00 de catergory 3 (symbole de la recherche) au panneau |cFFFFFF<filterPanel>",
        ["chatcommands_filter4_new"]			 = "|cFFFFFF'filtre4 <filterPanel> <filterValue>'|cFFFF00: Cacher |cFFFFFF<vrai>|cFFFF00 / voir |cFFFFFF<faux>|cFFFF00 / montre seulement les objets marqués |cFFFFFF<montre>|cFFFF00 de catergory 4 (symbole des pièces de monnaie) au panneau |cFFFFFF<filterPanel>",
        ["chatcommands_filter_new"]				 = "|cFFFFFF'filtres <filterPanel> <filterValue>'|cFFFF00: Cacher |cFFFFFF<vrai>|cFFFF00 / voir |cFFFFFF<faux>|cFFFF00 / montre seulement les articles marquée |cFFFFFF<montre>|cFFFF00 de catergory 1 à 4 au panneau |cFFFFFF<filterPanel>",
        ["chatcommands_filteron_new"]			 = "|cFFFFFF'touson <filterPanel>'|cFFFF00: Cacher les catégories 1 à 4 sur le panneau |cFFFFFF<filterPanel>",
        ["chatcommands_filteroff_new"]			 = "|cFFFFFF'tousoff <filterPanel>'|cFFFF00: Montre les catégories 1 à 4 sur le panneau |cFFFFFF<filterPanel>",
        ["chatcommands_filtershow_new"]			 = "|cFFFFFF'tousmontre <filterPanel>'|cFFFF00: Montre seulement les objets marqués de catégories 1 à 4 sur le panneau |cFFFFFF<filterPanel>",
        ["chatcommands_debug"]					 = "|cFFFFFF'debug'|cFFFF00: Activer/Désactiver les messages de debug. [Attention] Ceci va polluer votre fenêtre de chat!",
		["chatcommands_status_info"] 			 = "|c00FF00FCO|cFFFF00Item Saver|cFFFFFF Filtres activés:",
        ["chatcommands_status_nofilters"]        = "|c00FF00FCO|cFFFF00Item Saver|cFF0000 Pas de filtres activés",
		["chatcommands_status_filter1"] 		 = "Filtre verrouiller: ON",
		["chatcommands_status_filter2"] 		 = "Filtre équipement: ON",
		["chatcommands_status_filter3"] 		 = "Filtre recherche: ON",
		["chatcommands_status_filter4"] 		 = "Filtre vendeur: ON",
		--Filters
		["filter1_off"] 			= "Filtre Verrouiller OFF",
		["filter1_on"] 				= "Filtre Verrouiler ON",
		["filter1_onlyfiltered"] 	= "Le filtre verrouiller, ne montre QUE les objets marqués",
        ["filter1_split_off"] 					 = "Filtre OFF",
        ["filter1_split_on"] 					 = "Fitre ON",
	    ["filter1_split_onlyfiltered"] 			 = "Filtre ne montre QUE les objets marqués pour",
		["filter2_off"] 			= "Filtre sets OFF",
		["filter2_on"] 				= "Filtre sets ON",
		["filter2_onlyfiltered"] 	= "Le filtre sets, ne montre QUE les objets marqués",
		["filter3_off"] 			= "Filtre Recherche/Déconstruction/Amélioration OFF",
		["filter3_on"] 				= "Filtre Recherche/Déconstruction/Amélioration ON",
		["filter3_onlyfiltered"] 	= "Le filtre de Recherche/Déconstruction/Amélioration ne montre QUE les objets marqués",
        ["filter3_split_off"] 					 = "Filtre OFF",
        ["filter3_split_on"] 					 = "Fitre ON",
	    ["filter3_split_onlyfiltered"] 			 = "Filtre ne montre QUE les objets marqués pour",
        ["filter4_off"] 						 = "Filtre Vendre/Vendre en boutique de guilde/Complexe  OFF",
        ["filter4_on"] 						 	 = "Filtre Vendre/Vendre en boutique de guilde/Complexe  ON",
        ["filter4_onlyfiltered"] 				 = "Filtre Vendre/Vendre en boutique de guilde/Complexe ne montre QUE les objects marqués",
        ["filter4_split_off"] 					 = "Filtre OFF",
        ["filter4_split_on"] 			     	 = "Filtre ON",
        ["filter4_split_onlyfiltered"] 			 = "Filtre ne montre QUE les objets marqués pour",
        ["filter_ABORT"] 			 = "N'est pas activé dans le calibrage!",
		["filter_inventory"]		= "[Inventaire] ",
		["filter_craftbag"]		= "[Crafting bag] ",
		["filter_guildbank"]		= "[Banque de Guilde] ",
		["filter_guildstore"]	 	= "[Boutique de Guilde] ",
		["filter_bank"]			 	= "[Banque] ",
		["filter_alchemy"]			= "[Atelier de craft Alchimie] ",
		["filter_deconstruction"]	= "[Atelier de craft Déconstruction] ",
		["filter_improvement"]		= "[Atelier de craft Amélioration] ",
		["filter_enchantingstation_extraction"] = "[Autel d'enchantement Déconstruction] ",
		["filter_enchantingstation_creation"] = "[Autel d'enchantement Créer] ",
		["filter_store"] = "[Boutique] ",
		["filter_fence"] = "[Receleur] ",
		["filter_mail"] = "[Mail] ",
		["filter_trade"] = "[Echange] ",
        ["filter_gears_all"]					 = "Touts les sets d'équipement",
        ["filter_resdecimp_all"]				 = "Recherche/Déconstruction/Amélioration",
        ["filter_resdecimp_1"]					 = "Recherche",
        ["filter_resdecimp_2"]					 = "Déconstruction",
        ["filter_resdecimp_3"]					 = "Amélioration",
        ["filter_sellguildint_all"]				 = "Vendre/Vendre en Boutique de Guilde/Complexe",
        ["filter_sellguildint_1"]				 = "Vendre",
        ["filter_sellguildint_2"]				 = "Vendre en boutique de Guilde",
        ["filter_sellguildint_3"]				 = "Complexe",
		--Messages to chat
		["show_anti_messages_in_chat"] 	  		 = "Révèle 'Attention' en chat",
		["show_anti_messages_in_chat_TT"] 	 = "Révèle un message d'alerte avec l'objet dans la fenêtre de chat",
		["show_anti_messages_as_alert"] 		 = "Révèle 'Attention' comme alerte",
		["show_anti_messages_as_alert_TT"]	 = "Révèle un message d'alerte avec le nom de l'objet dans la fenêtre et joue un son",
		["deconstruction_not_allowed"]			 = "Déconstruire n'est pas permis:",
		["destroying_not_allowed"]			     = "Détruire n'est pas permis:",
        ["sendbymail_not_allowed"]				 = "Envoyer n'est pas permis:",
        ["trading_not_allowed"]				     = "Echanger n'est pas permis:",
        ["selling_not_allowed"]				     = "Vendre n'est pas permis:",
        ["fence_selling_not_allowed"]			 = "Vendre au receleur n'est pas permis:",
        ["improvement_not_allowed"]			     = "L'Amélioration n'est pas permise:",
		["enchanting_creation_not_allowed"] 	 = "Créer/Déconstruire n'est pas permis:",
		["enchanting_extraction_not_allowed"] 	 = "L'Extraction n'est pas permise:",
		["guild_store_sell_not_allowed"]		 = "Vendre en Boutique de Guilde pas permis:",
		["alchemy_destroy_not_allowed"]          = "Destruction alchimie interdite :",
		["container_autoloot_not_allowed"]       = "Autoloot récipients interdit :",
		["recipe_usage_not_allowed"]             = "Lecture recettes interdite :",
		["motif_usage_not_allowed"]              = "Lecture style-motif interdite :",
		["potion_usage_not_allowed"]             = "ingestion potions interdite :",
		["food_usage_not_allowed"]               = "Ingestion nourriture interdite :",
        ["marked"]								 = "Marqué [",
        ["ornate_item_found"]    				 = "] comme orné",
        ["intricate_item_found"]                 = "] comme complexe",
		["research_item_found"]                  = "] comme recherché",
		["set_part_found"]                       = "] comme élément de Set",
		["quality_item_found"]                  = "] en raison de la qualité",
		["known_recipe_found"]				= "] comme recette connue",
		["unknown_recipe_found"]				= "] comme recette inconnue",
		["options_enable_auto_mark_quality_items"] = "Marquage qualité",
		["options_enable_auto_mark_quality_items_TT"] =  "Marque automatiquement les objets d'une qualité choisie avec une icône",
		["options_enable_auto_mark_higher_quality_items"] = "Marquage qualité sup aussi",
		["options_enable_auto_mark_higher_quality_items_TT"] =  "Marque aussi les objets de qualité supérieure à celle choisie",
		["options_enable_auto_mark_quality_items_in_chat"] = "Objets dans le chat",
		["options_enable_auto_mark_quality_items_in_chat_TT"] =  "Affiche automatiquement les objets marqués de qualité choisie dans le chat",
		["options_quality_OFF"]         = "-DESACTIVE-",
		["options_quality_trash"]       = "rebut",
		["options_quality_normal"]      = "Normal",
		["options_quality_magic"]       = "Magie",
		["options_quality_arcane"]      = "Arcane",
		["options_quality_artifact"]    = "Artefact",
		["options_quality_legendary"]   = "Légendaire",
		--Key bindings
		["SI_BINDING_NAME_FCOISFILTER1"] 			 = "Modifier filtre 1",
		["SI_BINDING_NAME_FCOISFILTER2"] 			 = "Modifier filtre 2",
		["SI_BINDING_NAME_FCOISFILTER3"] 			 = "Modifier filtre 3",
		["SI_BINDING_NAME_FCOISFILTER4"] 			 = "Modifier filtre 4",
        ["SI_BINDING_NAME_FCOIS_SETTINGS_MENU"]  	 = "Paramètres de FCOItemSaver",
		["SI_BINDING_NAME_FCOIS_MARK_ITEM_WITH_STANDARD_ICON"] = "Marquer icône standard",
		["SI_BINDING_NAME_FCOIS_MARK_ITEM_CYCLE_UP"]   = "Marquer icône suivante",
		["SI_BINDING_NAME_FCOIS_MARK_ITEM_CYCLE_DOWN"] = "Marquer icône précédente",
		["SI_BINDING_NAME_FCOIS_MARK_ITEM_1"]    = "Marquer icône 'verrou'",
		["SI_BINDING_NAME_FCOIS_MARK_ITEM_3"]    = "Marquer icône 'recherche'",
		["SI_BINDING_NAME_FCOIS_MARK_ITEM_5"]    = "Marquer icône 'vendre'",
		["SI_BINDING_NAME_FCOIS_MARK_ITEM_9"]    = "Marquer icône 'déconstruction'",
		["SI_BINDING_NAME_FCOIS_MARK_ITEM_10"]       = "Marquer icône 'amélioration'",
		["SI_BINDING_NAME_FCOIS_MARK_ITEM_11"]       = "Marquer icône 'vendre au marchand guilde'",
		["SI_BINDING_NAME_FCOIS_MARK_ITEM_12"]       = "Marquer icône 'complexe'",
		["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_1"]    = "Marquer set équipement 1",
		["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_2"]    = "Marquer set équipement 2",
		["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_3"]    = "Marquer set équipement 3",
		["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_4"]    = "Marquer set équipement 4",
		["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_5"]    = "Marquer set équipement 5",
        --Error messages
        ["error_gamepad_mode_not_supported"]	= "FCOItemSaver ne prend pas en charge le mode de gamepad! S'il vous plaît changer le mode de clavier au niveau des réglages.",
        --Feedback
        ["feedbackInfo"] = "Ouvrez la FAQ (questions et réponses), le panneau des auteurs (fonctionnalités / bugs) ou envoyez un mail ingame si vous avez trouvé un bug, avez une demande ou souhaitez faire un don en jeu.",
	},

--Spanish
	[FCOIS_CON_LANG_ES] = {
		-- Options menu
		["options_description"] 						 = "FCOItemSaver te permite organizar tus posesiones identificándolas mediante iconos. Puedes decidir mostrar o no los objetos marcados.",
		["options_header1"] 							 = "General",
		["options_language"]							 = "Idioma",
		["options_language_TT"]					 = "Elegir idioma",
		["options_language_use_client"] 		 		 = "Utilizar el idioma del cliente",
		["options_language_use_client_TT"]  		 = "Deje siempre que el addon de utilizar el idioma del cliente de juego.",
		["options_language_dropdown_selection1"]		 = "Inglés",
		["options_language_dropdown_selection2"]		 = "Alemán",
		["options_language_dropdown_selection3"]		 = "Francés",
		["options_language_dropdown_selection4"]		 = "Espa\195\177ol",
        ["options_language_dropdown_selection5"] 		 = "Italiano",
        ["options_language_dropdown_selection6"]         = "Japonés",
        ["options_language_dropdown_selection7"] 		 = "Ruso",
		["options_language_description1"]		 		 = "CUIDADO: Modificar las opciones de equipamiento recargará la interfaz",
		["options_savedvariables"]						 = "Guardar",
		["options_savedvariables_TT"] 				 = "Guardar los parámetros del addon para toda la cuenta o individualmente para cada personaje",
		["options_savedVariables_dropdown_selection1"]	 = "Individualmente",
		["options_savedVariables_dropdown_selection2"]	 = "Cuenta",

		["options_header_icon_options"]		 	 = "Posición de icono, tipo, etc.",
		["options_header_marking_options"]		 = "Marcas",
        ["options_header_crafting"]              = GetString(SI_SKILLTYPE8),

		["options_icons_dynamic"]				 		 = "Dynamic icons",
		["options_icons_non_gear"]						 = "Normal icons",
		["options_icons_gears"]				 	 		 = "Gear sets",
		["options_icons_gear1"]					 		 = "Gear 1",
		["options_icons_gear2"]					 		 = "Gear 2",
		["options_icons_gear3"]					 		 = "Gear 3",
		["options_icons_gear4"]					 		 = "Gear 4",
		["options_icons_gear5"]					 		 = "Gear 5",

        ["options_header_color"]						 = "Iconos",
        ["options_icon1_color"]							 = "Bloquear",
        ["options_icon1_color_TT"]					 = "Color del icono para el filtro Bloquear",
        ["options_icon2_color"]							 = "Color",
        ["options_icon2_color_TT"]					 = "Color del icono para el filtro Equipamiento 1",
        ["options_icon3_color"]							 = "Investigación",
        ["options_icon3_color_TT"]					 = "Color del icono para el filtro Investigación",
        ["options_icon4_color"]							 = "Color",
        ["options_icon4_color_TT"]					 = "Color del icono para el filtro Equipamiento 2",
        ["options_icon5_color"]							 = "Vender",
        ["options_icon5_color_TT"]					 = "Color del icono para el filtro Vender",
        ["options_icon1_texture"]				 = "Icono",
        ["options_icon1_texture_TT"]		 = "Icono para el filtro Bloquear",
        ["options_icon1_size"]				 	 = "Tama\195\177o",
        ["options_icon1_size_TT"]			 = "Tama\195\177o del icono para el filtro Bloquear",
        ["options_icon2_texture"]				 = "Icono",
        ["options_icon2_texture_TT"]		 = "Icono para el filtro Equipamiento 1",
        ["options_icon2_size"]				 	 = "Tama\195\177o",
        ["options_icon2_size_TT"]			 = "Tama\195\177o del icono para el filtro Equipamiento 1",
        ["options_icon3_texture"]				 = "Icono",
        ["options_icon3_texture_TT"]		 = "Icono para el filtro Investigación",
        ["options_icon3_size"]				 	 = "Tama\195\177o",
        ["options_icon3_size_TT"]			 = "Tama\195\177o del icono para el filtro Investigación",
        ["options_icon4_texture"]				 = "Icono",
        ["options_icon4_texture_TT"]		 = "Icono para el filtro Equipamiento 2",
        ["options_icon4_size"]				 	 = "Tama\195\177o",
        ["options_icon4_size_TT"]			 = "Tama\195\177o del icono para el filtro Equipamiento 2",
        ["options_icon5_texture"]				 = "Icono",
        ["options_icon5_texture_TT"]		 = "Icono para el filtro Vender",
        ["options_icon5_size"]				 	 = "Tama\195\177o",
        ["options_icon5_size_TT"]			 = "Tama\195\177o del icono para el filtro Vender",
        ["options_icon6_color"]							 = "Color",
        ["options_icon6_color_TT"]					 = "Color del icono para el filtro Equipamiento 3",
        ["options_icon6_texture"]						 = "Icono",
        ["options_icon6_texture_TT"]				 = "Icono para el filtro Equipamiento 3",
        ["options_icon6_size"]						 	 = "Tama\195\177o",
        ["options_icon6_size_TT"]				 	 = "Tama\195\177o del icono para el filtro Equipamiento 3",
        ["options_icon7_color"]							 = "Color",
        ["options_icon7_color_TT"]					 = "Color del icono para el filtro Equipamiento 4",
        ["options_icon7_texture"]						 = "Icono",
        ["options_icon7_texture_TT"]				 = "Icono para el filtro Equipamiento 4",
        ["options_icon7_size"]							 = "Tama\195\177o",
        ["options_icon7_size_TT"]					 = "Tama\195\177o del icono para el filtro Equipamiento 4",
        ["options_icon8_color"]							 = "Color",
        ["options_icon8_color_TT"]					 = "Color del icono para el filtro Equipamiento 5",
        ["options_icon8_texture"]						 = "Icono",
        ["options_icon8_texture_TT"]				 = "Icono para el filtro Equipamiento 5",
        ["options_icon8_size"]							 = "Tama\195\177o",
        ["options_icon8_size_TT"]					 = "Tama\195\177o del icono para el filtro Equipamiento 5",
		["options_icon2_name"]							 = "Equipamiento  1",
		["options_icon2_name_TT"]					 = "Elige un nombre para Equipamiento 1",
		["options_icon4_name"]							 = "Equipamiento  2",
		["options_icon4_name_TT"]					 = "Elige un nombre para Equipamiento 2",
		["options_icon6_name"]							 = "Equipamiento  3",
		["options_icon6_name_TT"]					 = "Elige un nombre para Equipamiento 3",
		["options_icon7_name"]							 = "Equipamiento  4",
		["options_icon7_name_TT"]					 = "Elige un nombre para Equipamiento 4",
		["options_icon8_name"]							 = "Equipamiento  5",
		["options_icon8_name_TT"]					 = "Elige un nombre para Equipamiento 5",
        ["options_icon2_activate_text"]				 		= "Equipamiento  1 activado",
        ["options_icon4_activate_text"]						 = "Equipamiento 2 activado",
        ["options_icon6_activate_text"]				 		= "Equipamiento 3 activado",
        ["options_icon7_activate_text"]						 = "Equipamiento 4 activado",
        ["options_icon8_activate_text"]						 = "Equipamiento 5 activado",

                ["options_header_pos"]			 = "Positions icono",
        ["options_header_split_filters"]				 = "Separar filtros",
        ["options_header_filters"]						 = "Filtros",

	    ["options_enable_filter_in_inventory"]			 = "Activar los filtros en el inventario",
	    ["options_enable_filter_in_inventory_TT"]	 = "Te permite decidir de no mostrar en tu inventario los objetos marcados",
		["options_enable_filter_in_craftbag"]			= "Activar los filtros en Crafting bag",
		["options_enable_filter_in_craftbag_TT"]	= "Te permite decidir de no mostrar en tu Crafting bag los objetos marcados",
        ["options_enable_filter_in_bank"]				 = "Activar los filtros en el banco",
        ["options_enable_filter_in_bank_TT"]		 = "Te permite decidir de no mostrar en tu banco los objetos marcados",
        ["options_enable_filter_in_guildbank"]	 		 = "Activar los filtros en el banco de clan",
        ["options_enable_filter_in_guildbank_TT"]	 = "Te permite decidir de no mostrar en el banco de clan los objetos marcados",
        ["options_enable_filter_in_tradinghouse"]		 = "Activar los filtros en las tiendas de clan",
        ["options_enable_filter_in_tradinghouse_TT"]= "Te permite decidir de no mostrar en las tiendas de clan los objetos marcados",
        ["options_enable_filter_in_trade"]				 = "Activar los filtros durante el comercio",
        ["options_enable_filter_in_trade_TT"]		 = "Te permite decidir de no mostrar los objetos marcados durante el comercio con otro jugador",
        ["options_enable_filter_in_mail"]		 		 = "Activar los filtros en el correo",
        ["options_enable_filter_in_mail_TT"]		 = "Te permite decidir de no mostrar los objetos marcados al crear un correo",
        ["options_enable_filter_in_deconstruction"]		 = "Activar los filtros en la ventana de descontrucción",
        ["options_enable_filter_in_deconstruction_TT"]		 = "Te permite decidir de no mostrar los objetos marcados en la ventana de desconstrucción de las estaciones de artesanía",
        ["options_enable_filter_in_improvement"]		 = "Activar los filtros en la ventana de mejora",
        ["options_enable_filter_in_improvement_TT"]		 = "Te permite decidir de no mostrar los objetos marcados en la ventana de mejora de las estaciones de artesanía",
        ["options_enable_filter_in_store"]		 = "Activar los filtros con los mercaderes",
        ["options_enable_filter_in_store_TT"]		 = "Te permite decidir de no mostrar los objetos marcados mientras vendes a un mercader",
        ["options_enable_filter_in_enchanting"]		 = "Activar los filtros en la ventana de encantamiento",
        ["options_enable_filter_in_enchanting_TT"]		 = "Te permite decidir de no mostrar los objetos marcados mientras creas o rompes glifos",

		--Other options
		["options_header_items"]				 		 			 = "Marcado automático",

        ["options_enable_auto_mark_ornate_items"] 		 			 = "Marcar los objetos ornamentados",
        ["options_enable_auto_mark_ornate_items_TT"] 			 = "Marca automáticamente los objetos ornamentados para vender",
        ["options_auto_mark_ornate_items_icon"] 					 = "Icono de los objetos ornamentados",
        ["options_auto_mark_ornate_items_icon_TT"] 			 = "Icono para los objetos ornamentados que se marcarán para vender",

        ["options_auto_mark_research_items_icon"] 					 = "Icono de los objetos investigables",
        ["options_auto_mark_research_items_icon_TT"] 			 = "Icono para los objetos investigables que se marcarán automáticamente",

		["options_header_anti_destroy"] = "Protección (Anti-métodos)",
        ["options_enable_block_deconstruction"]  					 = "Desactivar desconstrucción de los objetos marcados",
        ["options_enable_block_deconstruction_TT"]  			 = "Desactiva la desconstrucción de los objetos marcados en las estaciones de artesanía",

        ["options_enable_block_destroying"]  						 = "Desactivar destrucción",
        ["options_enable_block_destroying_TT"]  				 = "Desactiva la destrucción de los objetos marcados",
        ["options_enable_block_sending_mail"]  						 = "Desactivar envio por correo",
        ["options_enable_block_sending_mail_TT"]  				 = "Desactiva el envio por correo de los objetos marcados",
        ["options_enable_block_trading"]  							 = "Desactivar comercio",
        ["options_enable_block_trading_TT"]  			 = "Desactiva los objetos marcados durante el comercio con otros jugadores",
        ["options_enable_block_selling"]  = "Desactivar venta",
        ["options_enable_block_selling_TT"]  = "Desactiva la venta al mercader de los objetos marcados",

        ["options_enable_block_selling_guild_store"]  = "Desactivar venta al tienda de clan",
        ["options_enable_block_selling_guild_store_TT"]  = "Desactiva la venta al tienda de clan de los objetos marcados",

		["options_block_selling_exception_ornate"] = "Activar venta de objetos ornamentados",
		["options_block_selling_exception_ornate_TT"] = "Activa la venta de los objetos marcados como ornamentados",

        ["options_enable_block_improvement"]  = "Desactivar mejora",
        ["options_enable_block_improvement_TT"]  = "Desactiva la mejora de los objetos marcados en las estaciones de artesanía",

		["options_enable_block_creation"] 			= "Desactivar creación de glifos",
		["options_enable_block_creation_TT"]	= "Desactiva la creación de glifos con los objetos marcados en las mesas de encantamiento",
		["options_enable_block_extraction"]			= "Desactivar extracción de runas",
		["options_enable_block_extraction_TT"]	= "Desactiva la extracción de runas a partir de los objetos marcados en las mesas de encantamiento",

        ["options_header_equipment"] 			 					 = "Equipamiento",
        ["options_equipment_markall_gear"] 		 					 = "Permite marcar todo el equipamiento",
        ["options_equipment_markall_gear_TT"] 					 = "Te permite marcar en una sola operación todos los objetos marcados como equipamiento 1 ou 2",
        ["options_equipment_markall_gear_add_weapons"] 				 = "Marcar armas",
        ["options_equipment_markall_gear_add_weapons_TT"]		 = "Marca también las armas",
        ["options_equipment_markall_gear_add_jewelry"] 				 = "Marcar joyas",
        ["options_equipment_markall_gear_add_jewelry_TT"]		 = "Marca también las joyas también automáticamente",
        ["options_enable_auto_mark_research_items"] 				 = "Marcar objetos investigables",
        ["options_enable_auto_mark_research_items_TT"] 		 = "Marca automáticamente los objetos investigables",
        ["options_enable_auto_mark_research_items_hint"]    		 = "El addon requirido se elegirá de Dropbox en la configuración del addon",
        ["options_enable_auto_mark_ornate_items_in_chat"] 			 = "Mostrar en chat objetos ornamentados",
        ["options_enable_auto_mark_ornate_items_in_chat_TT"] 	 = "Muestra automáticamente en la ventana de chat los objetos marcados como ornamentados",
        ["options_enable_auto_mark_research_items_in_chat"]			 = "Mostrar en chat objetos investigables",
        ["options_enable_auto_mark_research_items_in_chat_TT"]  = "Muestra automáticamente en la ventana de chat los objetos marcados como investigables",

        ["options_header_filter_buttons"]	= "Botones de filtro",
        ["options_filter_button1_left"]		= "Botón 1 - izquierda :",
        ["options_filter_button1_left_TT"]	= "Posición desde la izquierda (del borde de la parte inferior del inventario) para el botón de filtro 1",
        ["options_filter_button2_left"]		= "Botón 2 - izquierda :",
        ["options_filter_button2_left_TT"]	= "Posición desde la izquierda (del borde de la parte inferior del inventario) para el botón de filtro 2",
        ["options_filter_button3_left"]		= "Botón 3 - izquierda :",
        ["options_filter_button3_left_TT"]	= "Posición desde la izquierda (del borde de la parte inferior del inventario) para el botón de filtro 3",
        ["options_filter_button4_left"]		= "Botón 4 - izquierda :",
        ["options_filter_button4_left_TT"]	= "Posición desde la izquierda (del borde de la parte inferior del inventario) para el botón de filtro 4",
        ["options_filter_button1_top"]		= "Botón 1 - arriba :",
        ["options_filter_button1_top_TT"]	= "Posición desde arriba (del borde superior de la parte inferior del inventario) para el botón de filtro 1",
        ["options_filter_button2_top"]		= "Botón 2 - arriba :",
        ["options_filter_button2_top_TT"]	= "Posición desde arriba (del borde superior de la parte inferior del inventario) para el botón de filtro 2",
        ["options_filter_button3_top"]		= "Botón 3 - arriba :",
        ["options_filter_button3_top_TT"]	= "Posición desde arriba (del borde superior de la parte inferior del inventario) para el botón de filtro 3",
        ["options_filter_button4_top"]		= "Botón 4 - arriba :",
        ["options_filter_button4_top_TT"]	= "Posición desde arriba (del borde superior de la parte inferior del inventario) para el botón de filtro 4",
        ["options_filter_buttons_show_TT"] = "Mostrar información",
        ["options_filter_buttons_show_tooltip_TT"] = "Muestra una ventana de información con el cursor del ratón o haciendo clic en un botón de filtro",

		["options_header_filter_chat"] 			= "Filtro y chat",
        ["options_chat_filter_status"]			= "Mostrar en chat",
        ["options_chat_filter_status_TT"] 	= "Muestra el estado del filtro por el chat tras una modificación",
		["options_header_destroy"]				= "Destroy",
		["options_header_deconstruction"]		= "Deconstruction",
		["options_header_research"]				= "Research",
		["options_header_improvement"]			= "Improvement",
		["options_header_mail"]					= "Mail",
		["options_header_trade"]				= "Trade",
		["options_header_rune_creation"]		= "Rune creation",
		["options_header_rune_extraction"]		= "Glyph extraction",
		["options_header_sell"]					= "Sell",
		["options_header_sell_at_guild_store"]	= "Sell at guild store",
		["options_header_fence"]				= "Fence",
		["options_header_launder"]				= "Launder",
		["options_header_alchemy_destroy"]		= "Alchemy",
		["options_header_recipes"]				= "Recipes",
		["options_header_containers"]			= "Containers",
		["options_header_anti_output_options"]	= "Output options",
        --Additional buttons
        ["options_header_additional_buttons"]						 = "Botones adicionales",
        ["options_additional_buttons_FCOIS_settings"] 				 = "Opciones FCO en menú principal",
        ["options_additional_buttons_FCOIS_settings_TT"] 		 = "Muestra un botón adicional para la configuración de FCOItemSaver en el menú principal del juego (a la derecha del botón de ayuda)\n\n[Attention] The button will only be shown if the addon settings button of the addon 'Votans Settings Menu' is not shown!",
        ["options_additional_buttons_FCOIS_additional_options"] 		= "Opciones adicionales de inventario",

        ["button_FCOIS_settings_TT"]							 = "Mostrar configuración de FCOItemSaver",

		--Right click item menu
		["rightclick_menu_lock"] 									 = "Bloquear",
		["rightclick_menu_unlock"] 									 = "Desbloquear",
		["rightclick_menu_add_gear1"] 						 		 = "A\195\177adir a equipamiento 1",
		["rightclick_menu_add_all_gear1"] 					 		 = "A\195\177adir todo a equipamiento 1",
		["rightclick_menu_remove_gear1"] 						 	 = "Eliminar de equipamiento 1",
		["rightclick_menu_remove_all_gear1"] 						 = "Eliminar todo de equipamiento 1",
        ["rightclick_menu_add_gear2"]       						 = "A\195\177adir a equipamiento 2",
        ["rightclick_menu_add_all_gear2"]        					 = "A\195\177adir todo a equipamiento 2",
        ["rightclick_menu_remove_gear2"]        					 = "Eliminar de equipamiento 2",
        ["rightclick_menu_remove_all_gear2"]    					 = "Eliminar todo de equipamiento 2",
        ["rightclick_menu_add_gear3"]        						 = "A\195\177adir a equipamiento 3",
        ["rightclick_menu_add_all_gear3"]        					 = "A\195\177adir todo a equipamiento 3",
        ["rightclick_menu_remove_gear3"]         					 = "Eliminar de equipamiento 3",
        ["rightclick_menu_remove_all_gear3"]        				 = "Eliminar todo de equipamiento 3",
        ["rightclick_menu_add_gear4"]        	 					 = "A\195\177adir a equipamiento 4",
        ["rightclick_menu_add_all_gear4"]        	 				 = "A\195\177adir todo a equipamiento 4",
        ["rightclick_menu_remove_gear4"]         					 = "Eliminar de equipamiento 4",
        ["rightclick_menu_remove_all_gear4"]         				 = "Eliminar todo de equipamiento 4",
        ["rightclick_menu_add_gear5"]        	 					 = "A\195\177adir a equipamiento 5",
        ["rightclick_menu_add_all_gear5"]        		 			 = "A\195\177adir todo a equipamiento 5",
        ["rightclick_menu_remove_gear5"]         					 = "Eliminar de equipamiento 5",
        ["rightclick_menu_remove_all_gear5"]         				 = "Eliminar todo de equipamiento 5",
		["rightclick_menu_mark_analysis"] 							 = "Guardar para investigación",
		["rightclick_menu_demark_analysis"] 						 = "Eliminar de investigación",
		["rightclick_menu_mark_sell"] 								 = "Para vender",
		["rightclick_menu_demark_sell"] 							 = "No vender más",

        ["rightclick_menu_add_start_gear"]       					 = "A\195\177adir a ",
        ["rightclick_menu_add_all_start_gear"]   					 = "A\195\177adir todo a ",
        ["rightclick_menu_remove_start_gear"]    					 = "Eliminar de ",
        ["rightclick_menu_remove_all_start_gear"]					 = "Eliminar todo de ",
		--Button context menu
		["button_context_menu_TT"]			 = "Opciones adicionales",
        ["button_context_menu_lock_all"]	 	 = "Bloquear todo",
        ["button_context_menu_unlock_all"]	 	 = "Desbloquear todo",
        ["button_context_menu_research_all"]	 = "+ Investigación",
        ["button_context_menu_dont_research_all"]= "- Investigación",

        ["button_context_menu_deconstruct_all"]	 	= "+ Deconstruction",
        ["button_context_menu_dont_deconstruct_all"]= "- Deconstruction",
        ["button_context_menu_improve_all"]	 		= "+ Improvement",
        ["button_context_menu_dont_improve_all"]	= "- Improvement",

        ["button_context_menu_sell_all"]	 	 = "+ Vender",
        ["button_context_menu_dont_sell_all"]	 = "- Vender",

        ["button_context_menu_sell_all_in_guild_store"]	 	= "+ Sell at guild store",
        ["button_context_menu_dont_sell_all_in_guild_store"]= "- Sell at guild store",
        ["button_context_menu_mark_all_as_intricate"]       = "+ Intricate",
        ["button_context_menu_unmark_all_as_intricate"]     = "- Intricate",

        ["button_context_menu_undo"]	 		 = "< Deshacer último cambio",
        ["button_context_menu_remove_all_gears"] = "Eliminar todo del equipamiento",
        ["button_context_menu_demark_all"]	 	 = "Desmarcar todo",

		--Chat commands
		["chatcommands_info"]	 				 = "|c00FF00FCO|cFFFF00Item Saver|cFFFFFF A\195\177adir iconos al investario y banco y filtrar",
		["chatcommands_help"]	 				 = "|cFFFFFF'help' / 'list'|cFFFF00: Muestra esta información acerca del addon",
		["chatcommands_status"] 				 = "|cFFFFFF'status' / ''|cFFFF00: Muestra los filtros activos",
		["chatcommands_filter1"]	 			 = "|cFFFFFF'filtre1'|cFFFF00: Mostrar/Esconder los objetos bloqueados (candado) en las ventanas de venta y artesanía",
		["chatcommands_filter2"]	 			 = "|cFFFFFF'filtre2'|cFFFF00: Mostrar/Esconder los equipamientos (yelmo) en las ventanas de venta y artesanía",
		["chatcommands_filter3"]	 			 = "|cFFFFFF'filtre3'|cFFFF00: Mostrar/Esconder los objetos guardados para investigación (triángulo) en las ventanas de venta y artesanía",
		["chatcommands_filter4"] 				 = "|cFFFFFF'filtre4'|cFFFF00: Mostrar/Esconder los objetos para vender en la tienda de clan (icono venta) en las ventanas de venta, tienda de clan y artesanía",
		["chatcommands_filter"]	 				 = "|cFFFFFF'filtres'|cFFFF00: Mostrar/Esconder todos los objetos marcados" ,
		["chatcommands_filteron"]	 			 = "|cFFFFFF'tousoff'|cFFFF00: Mostrar todos los objetos marcados en las ventanas de venta y artesanía",
		["chatcommands_filteroff"]	 			 = "|cFFFFFF'touson'|cFFFF00: Esconder todos los objetos marcados en las ventanas de venta y artesanía",
		["chatcommands_filtershow"]	 			 = "|cFFFFFF'tousmontre'|cFFFF00: Muestra SOLO los objetos marcados en las ventanas de venta y artesanía",
		["chatcommands_split_filter"]			 = "|cFFFFFFsplit|cFFFF00: Activa/Desactiva los filtros individuales en : inventario, mercaderes, banco, banco y tienda de clan, estaciones de artesanía, mesa de encantamiento, correo y comercio",
        ["chatcommands_filterpanels"]			 = "|c990000Possible <filterPanel>:",
        ["chatcommands_filtervalues"]			 = "|c990000Possible <filterValue>: |cFFFFFFvrai|cFFFF00 / |cFFFFFFfaux|cFFFF00 / |cFFFFFFmontre",
        ["chatcommands_filter1_new"]			 = "|cFFFFFF'filtre1 <filterPanel> <filterValue>'|cFFFF00: Esconder |cFFFFFF<vrai>|cFFFF00 / Ver|cFFFFFF<faux>|cFFFF00 / muestra sólo los objetos marcados |cFFFFFF<montre>|cFFFF00 de catergory 1 (símbolo de candado) en el panel |cFFFFFF<filterPanel>",
        ["chatcommands_filter2_new"]			 = "|cFFFFFF'filtre2 <filterPanel> <filterValue>'|cFFFF00: Esconder |cFFFFFF<vrai>|cFFFF00 / Ver|cFFFFFF<faux>|cFFFF00 / muestra sólo los objetos marcados |cFFFFFF<montre>|cFFFF00 de catergory 2 (símbolo de yelmo) en el panel |cFFFFFF<filterPanel>",
        ["chatcommands_filter3_new"]			 = "|cFFFFFF'filtre3 <filterPanel> <filterValue>'|cFFFF00: Esconder |cFFFFFF<vrai>|cFFFF00 / Ver|cFFFFFF<faux>|cFFFF00 / muestra sólo los objetos marcados |cFFFFFF<montre>|cFFFF00 de catergory 3 (símbolo de investigación) en el panel |cFFFFFF<filterPanel>",
        ["chatcommands_filter4_new"]			 = "|cFFFFFF'filtre4 <filterPanel> <filterValue>'|cFFFF00: Esconder |cFFFFFF<vrai>|cFFFF00 / Ver|cFFFFFF<faux>|cFFFF00 / muestra sólo los objetos marcados |cFFFFFF<montre>|cFFFF00 de catergory 4 (símbolo de monedas) en el panel |cFFFFFF<filterPanel>",
        ["chatcommands_filter_new"]				 = "|cFFFFFF'filtres <filterPanel> <filterValue>'|cFFFF00: Escondert|cFFFFFF<vrai>|cFFFF00 / Ver|cFFFFFF<faux>|cFFFF00 / muestra sólo los objetos marcados |cFFFFFF<montre>|cFFFF00 de categoría 1-4 en el panel |cFFFFFF<filterPanel>",
        ["chatcommands_filteron_new"]			 = "|cFFFFFF'touson <filterPanel>'|cFFFF00: Esconder las categorías 1-4 en el panel |cFFFFFF<filterPanel>",
        ["chatcommands_filteroff_new"]			 = "|cFFFFFF'tousoff <filterPanel>'|cFFFF00: Muestra las categorías 1-4 en el panel |cFFFFFF<filterPanel>",
        ["chatcommands_filtershow_new"]			 = "|cFFFFFF'tousmontre <filterPanel>'|cFFFF00: Muestra sólo los objetos marcados en las categorías 1-4 en el panel |cFFFFFF<filterPanel>",
        ["chatcommands_debug"]					 = "|cFFFFFF'debug'|cFFFF00: Activar/Desactivar los mensajes de debug. [Advertencia] ¡Esto llenará la ventana de chat!",
		["chatcommands_status_info"] 			 = "|c00FF00FCO|cFFFF00Item Saver|cFFFFFF Filtros activos:",
        ["chatcommands_status_nofilters"]        = "|c00FF00FCO|cFFFF00Item Saver|cFF0000 No hay filtro activado",
		["chatcommands_status_filter1"] 		 = "Filtro candado: ON",
		["chatcommands_status_filter2"] 		 = "Filtro equipamiento: ON",
		["chatcommands_status_filter3"] 		 = "Filtro investigación: ON",
		["chatcommands_status_filter4"] 		 = "Filtro venta: ON",
        ["chatcommands_debug_on"]				 = "Debug: ON",
        ["chatcommands_debug_off"]				 = "Debug: OFF",
        ["chatcommands_deepdebug_on"]			 = "Deep debug: ON",
        ["chatcommands_deepdebug_off"]			 = "Deep debug: OFF",
		--Filters
		["filter1_off"] 			= "Filtro candado OFF",
		["filter1_on"] 				= "Filtro candado ON",
		["filter1_onlyfiltered"] 	= "El filtro candado muestra SÓLO los objetos marcados",
        ["filter1_split_off"] 					 = "Filtro OFF",
        ["filter1_split_on"] 					 = "Fitre ON",
	    ["filter1_split_onlyfiltered"] 			 = "Filtro muestra SÓLO los objetos marcados",

		["filter2_off"] 			= "Filtro equipamiento OFF",
		["filter2_on"] 				= "Filtro equipamiento ON",
		["filter2_onlyfiltered"] 	= "El filtro equipamiento muestra SÓLO los objetos marcados",

		["filter3_onlyfiltered"] 	= "Research/Deconstruction/Improvement muestra SÓLO los objetos marcados",

        ["filter3_split_off"] 					 = "Filtro OFF",
        ["filter3_split_on"] 					 = "Fitre ON",
	    ["filter3_split_onlyfiltered"] 			 = "Filtro muestra SÓLO los objetos marcados",

        ["filter4_onlyfiltered"] 				 = "Sell/Sell at guild store/Intricate filter SHOWS ONLY FILTERED",

        ["filter4_split_off"] 					 = "Filtro OFF",
        ["filter4_split_on"] 					 = "Fitre ON",
	    ["filter4_split_onlyfiltered"] 			 = "Filtro muestra SÓLO los objetos marcados",

        ["filter_ABORT"] 			 = "¡No está activado en los parámetros!",
		["filter_inventory"]		= "[Inventario] ",
		["filter_guildbank"]		= "[Banco de clan] ",
		["filter_guildstore"]	 	= "[Tienda de clan] ",
		["filter_bank"]			 	= "[Banco] ",

		["filter_deconstruction"]	= "[Estación de artesanía desconstrucción] ",
		["filter_improvement"]		= "[Estación de artesanía mejora] ",
		["filter_enchantingstation_extraction"] = "[Mesa de encantamiento extracción] ",
		["filter_enchantingstation_creation"] = "[Mesa de encantamiento creación] ",
		["filter_store"] = "[Mercaderes] ",
		["filter_fence"] = "[Fence] ",
		["filter_mail"] = "[Correo] ",
		["filter_trade"] = "[Comercio] ",
        ["filter_gears_all"]					 = "Todos equipamientos",

		--Messages to chat
		["show_anti_messages_in_chat"] 	  		 = "Mostrar aviso por chat",
		["show_anti_messages_in_chat_TT"] 	 = "Muestra un mensaje de aviso con el nombre del objeto en la ventana de chat",
		["show_anti_messages_as_alert"] 		 = "Mostrar aviso como alarma",
		["show_anti_messages_as_alert_TT"]	 = "Muestra un mensaje de aviso como alarma y a\195\177ade un sonido de advertencia",
		["deconstruction_not_allowed"]			 = "No se permite desconstruir este objeto:",
		["destroying_not_allowed"]			     = "No se permite destruir este objeto:",
        ["sendbymail_not_allowed"]				 = "No se puede enviar este objeto:",
        ["trading_not_allowed"]				     = "No se puede comerciar con este objeto:",
        ["selling_not_allowed"]				     = "No se puede vender este objeto:",

        ["improvement_not_allowed"]			     = "No se puede mejorar este objeto:",
		["enchanting_creation_not_allowed"] 	 = "No se puede extraer/crear con este objeto:",
		["enchanting_extraction_not_allowed"] 	 = "No se puede extraer con este objeto:",
		["guild_store_sell_not_allowed"]		 = "No se puede vender este objeto en las tiendas de clan:",

        ["marked"]								 = "Marcado [",
        ["ornate_item_found"]    				 = "] como ornamentado",
        ["intricate_item_found"]                 = "] como complexo",
		["research_item_found"]                  = "] como investigable",
		["quality_item_found"]                  = "] because of item's quality",
		["unknown_recipe_found"]				= "] as unknown recipe",

		--Key bindings
		["SI_BINDING_NAME_FCOISFILTER1"] 			 = "Modificar filtro 1",
		["SI_BINDING_NAME_FCOISFILTER2"] 			 = "Modificar filtro 2",
		["SI_BINDING_NAME_FCOISFILTER3"] 			 = "Modificar filtro 3",
		["SI_BINDING_NAME_FCOISFILTER4"] 			 = "Modificar filtro 4",
        ["SI_BINDING_NAME_FCOIS_SETTINGS_MENU"]      = "Ajustes FCOItemSaver",

        --Error messages
        ["error_gamepad_mode_not_supported"]	= "FCOItemSaver no es compatible con el modo de mando de juegos! Por favor, cambie el modo de teclado en la configuración.",
	},
	--Italian
    [FCOIS_CON_LANG_IT] = {
		-- Options menu
        ["options_header1"] 			 		 = "Impostazioni generali",
        ["options_language"] 					 = "Lingua",
        ["options_language_TT"] 			 = "Scegli la lingua",
		["options_language_use_client"] 		 		 = "Utilizzare la lingua del client",
		["options_language_use_client_TT"]  		 = "Lasciate sempre l'addon usare il linguaggio del client di gioco.",
        ["options_language_dropdown_selection1"] = "Inglese",
        ["options_language_dropdown_selection2"] = "Germano",
        ["options_language_dropdown_selection3"] = "Francese",
        ["options_language_dropdown_selection4"] = "Spagnolo",
        ["options_language_dropdown_selection5"] = "Italiano",
        ["options_language_dropdown_selection6"] = "Giapponese",
        ["options_language_dropdown_selection7"] = "Russo",
        ["options_language_description1"]		 = "ATTENZIONE: modifica della lingua opzione / salvare ricaricherà l'interfaccia utente!",
        ["options_reloadui"]					 = "ATTENZIONE: La modifica di questa opzione ricaricherà l'interfaccia utente!",
        ["options_savedvariables"]				 = "Salvare le impostazioni",
        ["options_savedvariables_TT"]       = "Salvare le impostazioni addon per tutti i tuoi personaggi del tuo account, o unico per ogni carattere",
        ["options_savedVariables_dropdown_selection1"] = "Ogni personaggio",
        ["options_savedVariables_dropdown_selection2"] = "Tutto acconto",
    },
--==============================================================================
    --Japanese
    [FCOIS_CON_LANG_JP] = {
        -- Options menu
        ["options_description"] = "FCOItemSaverはアイコンを使ってアイテムを整理するのを助けてくれます。追加機能として、それらのアイテムを非表示/表示することができます。",
        ["options_header1"]                      = "一般設定",
        ["options_language"]                     = "言語",
        ["options_language_TT"]             = "言語を選んでください。",
		["options_language_use_client"] 		 = "クライアントの言語を使用する",
		["options_language_use_client_TT"]  = "アドオンが常にクライアントの言語を使用するようにします。",
        ["options_language_dropdown_selection1"] = "英語",
        ["options_language_dropdown_selection2"] = "ドイツ語",
        ["options_language_dropdown_selection3"] = "フランス語",
        ["options_language_dropdown_selection4"] = "スペイン語",
        ["options_language_dropdown_selection5"] = "イタリア語",
        ["options_language_dropdown_selection6"] = "日本語",
        ["options_language_dropdown_selection7"] = "ロシア",
        ["options_language_description1"]        = "注意: 言語の変更/オプションの保存はUIをリロードします！",
        ["options_savedvariables"]               = "設定を保存",
        ["options_savedvariables_TT"]       = "Addon設定を全てのキャラクターで保存するか、キャラクターごとに保存します",
        ["options_savedVariables_dropdown_selection1"] = "キャラ毎",
        ["options_savedVariables_dropdown_selection2"] = "アカウントワイド",
		["options_header_icon_options"]		 	 = "アイコンポジション、ソート、etc",
		["options_header_marking_options"]		 = "マーク",
        ["options_header_crafting"]              = GetString(SI_SKILLTYPE8),
    	["options_remove_all_markers_with_shift_rightclick"]			=	"すべて解除する: SHIFT +  |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t",
		["options_remove_all_markers_with_shift_rightclick_TT"]	=	"シフトキーを押している間、全ての右クリックしたアイテムからマーカーを解除します。\n\nアイテムを再度Shift+右クリックす |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t ると、前回のマーカーアイコンが復元されます！",
        ["options_research_filter"]              = "'研究予約'アイテムを許可",
        ["options_research_filter_TT"]      = "クラフトステーションの研究パネルの研究ポップアップで、'研究予約'アイテム選択されるのを許可します。",
		["options_icons_dynamic"]				 = "ダイナミックアイコン",
        ["options_icons_non_gear"]               = "ノーマルアイコン",
        ["options_icons_gears"]                  = "ギアセット",
        ["options_icons_gear1"]                  = "ギア1",
        ["options_icons_gear2"]                  = "ギア2",
        ["options_icons_gear3"]                  = "ギア3",
        ["options_icons_gear4"]                  = "ギア4",
        ["options_icons_gear5"]                  = "ギア5",
        ["options_header_color"]                 = "カラーとアイコン",
        ["options_icon1_color"]                  = "ロック",
        ["options_icon1_color_TT"]          = "ロックフィルタアイコンのカラー",
        ["options_icon2_color"]                  = "カラー",
        ["options_icon2_color_TT"]          = "ギア1フィルタアイコンのカラー",
        ["options_icon3_color"]                  = "研究",
        ["options_icon3_color_TT"]          = "研究フィルタのカラー",
        ["options_icon4_color"]                  = "カラー",
        ["options_icon4_color_TT"]          = "ギア2フィルタアイコンのカラー",
        ["options_icon5_color"]                  = "売却",
        ["options_icon5_color_TT"]          = "売却フィルタアイコンのカラー",
        ["options_icon1_texture"]                = "アイコン",
        ["options_icon1_texture_TT"]        = "ロックフィルタのアイコン",
        ["options_icon1_size"]                   = "サイズ",
        ["options_icon1_size_TT"]           = "ロックフィルタアイコンのサイズ",
        ["options_icon2_texture"]                = "アイコン",
        ["options_icon2_texture_TT"]        = "ギア1フィルタのアイコン",
        ["options_icon2_size"]                   = "サイズ",
        ["options_icon2_size_TT"]           = "ギア1フィルタアイコンのサイズ",
        ["options_icon3_texture"]                = "アイコン",
        ["options_icon3_texture_TT"]        = "研究フィルタのアイコン",
        ["options_icon3_size"]                   = "サイズ",
        ["options_icon3_size_TT"]           = "研究フィルタアイコンのサイズ",
        ["options_icon4_texture"]                = "アイコン",
        ["options_icon4_texture_TT"]        = "ギア2フィルタのアイコン",
        ["options_icon4_size"]                   = "サイズ",
        ["options_icon4_size_TT"]           = "ギア2フィルタアイコンのサイズ",
        ["options_icon5_texture"]                = "アイコン",
        ["options_icon5_texture_TT"]        = "売却フィルタのアイコン",
        ["options_icon5_size"]                   = "サイズ",
        ["options_icon5_size_TT"]           = "売却フィルタアイコンのサイズ",
        ["options_icon6_color"]                  = "色",
        ["options_icon6_color_TT"]          = "ギア3フィルタアイコンのカラー",
        ["options_icon6_texture"]                = "アイコン",
        ["options_icon6_texture_TT"]        = "ギア3フィルタのアイコン",
        ["options_icon6_size"]                   = "サイズ",
        ["options_icon6_size_TT"]           = "ギア3フィルタアイコンのサイズ",
        ["options_icon7_color"]                  = "色",
        ["options_icon7_color_TT"]          = "ギア4フィルタアイコンのカラー",
        ["options_icon7_texture"]                = "アイコン",
        ["options_icon7_texture_TT"]        = "ギア4フィルタのアイコン",
        ["options_icon7_size"]                   = "サイズ",
        ["options_icon7_size_TT"]           = "ギア4フィルタアイコンのサイズ",
        ["options_icon8_color"]                  = "色",
        ["options_icon8_color_TT"]          = "フィア5フィルタアイコンのカラー",
        ["options_icon8_texture"]                = "アイコン",
        ["options_icon8_texture_TT"]        = "フィア5フィルタのアイコン",
        ["options_icon8_size"]                   = "サイズ",
        ["options_icon8_size_TT"]           = "ギア5フィルタアイコンのサイズ",
        ["options_icon2_name"]                   = "ギア1",
        ["options_icon2_name_TT"]           = "ギア1アイコンに設定した名前",
        ["options_icon4_name"]                   = "ギア2",
        ["options_icon4_name_TT"]           = "ギア2アイコンに設定した名前",
        ["options_icon6_name"]                   = "ギア3",
        ["options_icon6_name_TT"]           = "ギア3アイコンに設定した名前",
        ["options_icon7_name"]                   = "ギア4",
        ["options_icon7_name_TT"]           = "ギア4アイコンに設定した名前",
        ["options_icon8_name"]                   = "ギア5",
        ["options_icon8_name_TT"]           = "ギア5アイコンに設定した名前",
        ["options_icon2_activate_text"]                = "ギア1を有効化",
        ["options_icon4_activate_text"]                = "ギア2を有効化",
        ["options_icon6_activate_text"]                = "ギア3を有効化",
        ["options_icon7_activate_text"]                = "ギア4を有効化",
        ["options_icon8_activate_text"]                = "ギア5を有効化",
        ["options_icon1_TT"]                = "ツールチップを表示",
        ["options_icon1_tooltip_TT"]        = "ロックシンボルにツールチップを表示します",
        ["options_icon2_TT"]                = "ツールチップを表示",
        ["options_icon2_tooltip_TT"]        = "ギア1シンボルにツールチップを表示します",
        ["options_icon3_TT"]                = "ツールチップを表示",
        ["options_icon3_tooltip_TT"]        = "研究シンボルにツールチップを表示します",
        ["options_icon4_TT"]                = "ツールチップを表示",
        ["options_icon4_tooltip_TT"]        = "ギア2シンボルにツールチップを表示します",
        ["options_icon5_TT"]                = "ツールチップを表示",
        ["options_icon5_tooltip_TT"]        = "売却シンボルにツールチップを表示します",
        ["options_icon6_TT"]                = "ツールチップを表示",
        ["options_icon6_tooltip_TT"]        = "ギア3シンボルにツールチップを表示します",
        ["options_icon7_TT"]                = "ツールチップを表示",
        ["options_icon7_tooltip_TT"]        = "ギア4シンボルにツールチップを表示します",
        ["options_icon8_TT"]                = "ツールチップを表示",
        ["options_icon8_tooltip_TT"]        = "ギア5シンボルにツールチップを表示します",
        ["options_icon9_TT"]                = "ツールチップを表示",
        ["options_icon9_tooltip_TT"]        = "解体シンボルにツールチップを表示します",
        ["options_icon10_TT"]               = "ツールチップを表示",
        ["options_icon10_tooltip_TT"]       = "改良シンボルにツールチップを表示します",
        ["options_tooltipatchar"]                = "キャラクタウィンドウにツールチップ",
        ["options_tooltipatchar_TT"]        = "キャラクタウィンドウにもツールチップを表示します",
        ["options_icon9_color"]                  = "解体",
        ["options_icon9_color_TT"]          = "解体フィルタアイコンのカラー",
        ["options_icon9_texture"]                = "アイコン",
        ["options_icon9_texture_TT"]        = "解体フィルタのアイコン",
        ["options_icon9_size"]                   = "サイズ",
        ["options_icon9_size_TT"]           = "解体フィルタアイコンのサイズ",
        ["options_icon9_tooltip_text"]           = "解体にマークされています",
        ["options_icon10_color"]                 = "改良",
        ["options_icon10_color_TT"]         = "改良フィルタアイコンのカラー",
        ["options_icon10_texture"]               = "アイコン",
        ["options_icon10_texture_TT"]       = "改良フィルタのアイコン",
        ["options_icon10_size"]                  = "サイズ",
        ["options_icon10_size_TT"]          = "改良フィルタアイコンのサイズ",
        ["options_icon10_tooltip_text"]          = "改良にマークされています",

        ["options_icon11_TT"]               = "ツールチップを表示",
        ["options_icon11_tooltip_TT"]       = "'ギルドストアで売却'アイコンにツールチップを表示",
        ["options_icon11_color"]                 = "ギルドストアで売却",
        ["options_icon11_color_TT"]         = "'ギルドストアで売却'フィルタアイコンのカラー",
        ["options_icon11_texture"]               = "アイコン",
        ["options_icon11_texture_TT"]       = "'ギルドストアで売却'フィルタのアイコン",
        ["options_icon11_size"]                  = "サイズ",
        ["options_icon11_size_TT"]          = "'ギルドストアで売却'フィルタアイコンのサイズ",
        ["options_icon11_tooltip_text"]          = "'ギルドストアで売却'にマークされています",
        ["options_icon12_TT"]               = "ツールチップを表示",
        ["options_icon12_tooltip_TT"]       = "複雑アイコンにツールチップを表示",
        ["options_icon12_color"]                 = "複雑",
        ["options_icon12_color_TT"]         = "複雑フィルタアイコンのサイズ",
        ["options_icon12_texture"]               = "アイコン",
        ["options_icon12_texture_TT"]       = "複雑フィルタのアイコン",
        ["options_icon12_size"]                  = "サイズ",
        ["options_icon12_size_TT"]          = "複雑フィルタアイコンのサイズ",
        ["options_icon12_tooltip_text"]          = "複雑としてマークされています",
        ["options_icon1_activate_text"]          = "ロックを有効化",
        ["options_icon3_activate_text"]          = "研究を有効化",
        ["options_icon5_activate_text"]          = "売却を有効化",
        ["options_icon9_activate_text"]          = "解体を有効化",
        ["options_icon10_activate_text"]         = "改良を有効化",
        ["options_icon11_activate_text"]         = "ギルドストアで売却を有効化",
        ["options_icon12_activate_text"]         = "複雑を有効化",
        ["options_icon_activate_text_TT"]   = "コンテキストメニュー内のアイコンを有効化します。この設定が無効化されている場合、コンテキストメニューでアイコンは表示されません。",
        ["options_icon1_tooltip_text"]           = "ロックされています",
        ["options_icon_gear_tooltip_text"]       = "このギアに属しています: ",
        ["options_icon_gears_tooltip_text"]      = "これらのギアに属しています: ",
        ["options_icon3_tooltip_text"]           = "研究対象としてマークされています",
        ["options_icon5_tooltip_text"]           = "売却としてまーくされています",

        ["options_header_keybind_options"]      = "キーバインド",
        ["options_icon_cycle_on_keybind"]       = "マーカーアイコンを循環",
        ["options_icon_cycle_on_keybind_TT"] = "キーバインドを押下時、マーカーアイコンを循環します。\n\nこのオプションが有効化されている場合、他の有効化されているマーカーアイコンが'ロック'シンボルから最後のアイコンに循環されます。現在のマーカーは削除され、新しいマーカーのみ設定されます。\nこのオプションが無効化されている場合、現在のアイテムはスタンダードマーカーシンボル（キーバインド設定で選択してください）有効/無効化されます。",

		["options_icon_standard_on_keybind"]	= "スタンダードアイコン (キーバインドでマーク)",
		["options_icon_standard_on_keybind_TT"] = "キーバインド'スタンダードマーカーアイコン'を使用した場合にマークされるスタンダードアイコンです。",

        ["options_header_sort_order"]           = "アイコンソート順序",
        ["options_icon_sort_order_TT"]     = "コンテキストメニューのソートポジション（左側の数字）に表示したいアイコンをドロップダウンリストから選択してください。",
        ["options_icon_sort_order_warning"]     = "注意: 各アイコンは一つの数字のみアサインしてください！アイコンが2か所以上アサインされている場合、スタンダードソートは使用されません！",
        ["options_gear_disable_research_check"] 		= "Disable research check",
        ["options_gear_disable_research_check_TT"] = "Disable the check for this icon if the item is researchable. This enables you to use this icon for non-researchable items too.",
        ["options_header_character"]             = "キャラクターウィンドウ",
        ["options_header_character_armor_type"]  = "防具タイプ",
        ["options_show_armor_type_icon"]         = "防具タイプアイコンを表示",
        ["options_show_armor_type_icon_TT"] = "アイテムの横に装備中の防具タイプアイコンを表示します（プレイヤードールの上）",
        ["options_show_armor_type_header_text"]  = "防具タイプヘッダ情報を表示",
        ["options_show_armor_type_header_text_TT"] = "装備中の軽鎧、中鎧、重鎧パーツの総量を防具キャラクターセクションの上部にテキストで表示します",
        ["options_armor_type_icon_character_pos_x"]  = "防具タイプアイコン座標X",
        ["options_armor_type_icon_character_pos_x_TT"] = "防具タイプアイコンの防具パートの右上角からの水平位置を選択します",
        ["options_armor_type_icon_character_pos_y"]  = "防具タイプアイコン座標Y",
        ["options_armor_type_icon_character_pos_y_TT"] = "防具タイプアイコンの、防具パートの右上角からの垂直位置を選択します",
        ["options_armor_type_icon_character_light_color"]= "防具タイプアイコンカラー（軽鎧）",
        ["options_armor_type_icon_character_light_color_TT"]   = "軽鎧タイプアイコンのカラーを選択します",
        ["options_armor_type_icon_character_medium_color"]= "防具タイプアイコンカラー（中鎧）",
        ["options_armor_type_icon_character_medium_color_TT"]  = "中鎧タイプアイコンのカラーを選択します",
        ["options_armor_type_icon_character_heavy_color"]= "防具タイプアイコンから―（重鎧）",
        ["options_armor_type_icon_character_heavy_color_TT"]   = "重鎧タイプアイコンのカラーを選択します",
        ["options_armor_type_icon_light_short"]     = "L",
        ["options_armor_type_icon_medium_short"]    = "M",
        ["options_armor_type_icon_heavy_short"]     = "H",

        ["options_header_context_menu"]          = "インベントリのコンテキストメニュー",
        ["options_use_subcontextmenu"]           = "コンテキストメニューでサブメニューを使用",
        ["options_use_subcontextmenu_TT"]   = "この設定が有効化されていると、そのアイテムで利用可能なFCOIS設定がコンテキストメニュー内'FCOItemSaver'サブメニュー越しに表示されます。",
        ["options_show_contextmenu_divider"]     = "コンテキストメニューディバイダを表示",
        ["options_show_contextmenu_divider_TT"] = "FCOItemSaverコンテキストメニューエントリの上に、アイテムのスタンダードオプションとFCOISオプションの有益なディバイダを表示します",
        ["options_contextmenu_divider_opens_settings"] = "ディバイダ表示設定",
        ["options_contextmenu_divider_opens_settings_TT"] = "ディバイダをクリックした場合、FCOItemSaver設定パネルが表示されます",
        ["options_contextmenu_divider_clears_all_markers"] = "ディバイダが全てのアイコンをクリア",
        ["options_contextmenu_divider_clears_all_markers_TT"] = "ディバイダをクリックすると、現在のアイテムアイコンのマークが外されます（ディバイダを2回クリックするとこのアイテムで最後に使用したアイコンを再度マークします）",
		["options_contextmenu_leading_spaces"]				= "エントリ先頭の余白",
		["options_contextmenu_leading_spaces_TT"]		= "FCOISのコンテキストメニューのエントリの先頭に指定した量の余白を挿入し、インデントして読みやすくします。",
        ["options_contextmenu_use_custom_marked_normal_color"]          = "マーク済みアイテムの色付けエントリ",
        ["options_contextmenu_use_custom_marked_normal_color_TT"]  = "現在アクティブな違う色のアイテム（マークされたアイテム、例'ロック'）にコンテキストエントリを表示します",
        ["options_contextmenu_custom_marked_normal_color"]              = "マークされたエントリのカラー",
        ["options_contextmenu_custom_marked_normal_color_TT"]      = "コンテキストメニュー内の現在有効化/マークされたエントリーのカラー",

        ["options_header_filter_buttons_position"]  = "フィルタボタン位置",
        ["options_header_pos"]           = "アイコン位置",
        ["options_pos_inventories"]      = "インベントリ内",
        ["options_pos_inventories_TT"]  = "インベントリ内シンボルのX軸位置",
        ["options_pos_crafting"]            = "クラフトステーション時",
        ["options_pos_crafting_TT"]    = "クラフトステーションパネルインベントリ内シンボルのX軸位置",
        ["options_pos_character_x"]      = "X - キャラクタウィンドウ内",
        ["options_pos_character_x_TT"]  = "キャラクタウィンドウ内シンボルのX軸位置",
        ["options_pos_character_y"]      = "Y - キャラクタウィンドウ内",
        ["options_pos_character_y_TT"]  = "キャラクタウィンドウ内シンボルのY軸位置",
        ["options_header_split_filters"]         = "分割フィルタボタン",
        ["options_header_filters"]               = "フィルタ",
        ["options_split_filters"]                = "分割フィルタボタン",
        ["options_split_filters_TT"]        = "インベントリ、ベンダ、銀行、ギルド銀行、ギルドストア、クラフトステーション、メール、とトレードパネルの個別のフィルタを有効/無効化することを許可します。\n\nこのオプションが無効化されている場合、同じフィルタボタンとステートを各インベントリ/パネルで使用しなければなりません！",
        ["options_enable_filter_in_inventory"]   = "インベントリ内でフィルタを有効化",
        ["options_enable_filter_in_inventory_TT"]   = "インベントリ内でもマークされたアイテムを非表示にするのを有効化します",
		["options_enable_filter_in_craftbag"]			= "クラフトバッグでフィルタを有効",
	  	["options_enable_filter_in_craftbag_TT"]	= "マークされたアイテムをクラフトバッグ内でも非表示にするのを有効化します。",
        ["options_enable_filter_in_bank"]        = "銀行内でフィルタを有効化",
        ["options_enable_filter_in_bank_TT"]        = "銀行内でもマークされたアイテムを非表示にするのを有効化します",
        ["options_enable_filter_in_guildbank"]   = "ギルド銀行内でフィルタを有効化",
        ["options_enable_filter_in_guildbank_TT"]   = "ギルド銀行内でもマークされたアイテムを非表示にするのを有効化します",
        ["options_enable_filter_in_tradinghouse"]= "ギルドショップ内でフィルタを有効化",
        ["options_enable_filter_in_tradinghouse_TT"]= "ギルドショップ内でもマークされたアイテムを非表示にするのを有効化します",
        ["options_enable_filter_in_trade"]       = "トレード中フィルタを有効化",
        ["options_enable_filter_in_trade_TT"]       = "他のプレイヤーとトレード中マークされたアイテムを非表示にするのを有効化します",
        ["options_enable_filter_in_mail"]        = "メール作成中フィルタを有効",
        ["options_enable_filter_in_mail_TT"]        = "メール作成中マークされたアイテムを非表示にするのを有効化します",
        ["options_enable_filter_in_deconstruction"]      = "解体でフィルタを有効化",
        ["options_enable_filter_in_deconstruction_TT"]      = "クラフトステーションで解体中マークされたアイテムを非表示にするのを有効化します",
        ["options_enable_filter_in_improvement"]         = "改良でフィルタを有効化",
        ["options_enable_filter_in_improvement_TT"]         = "クラフトステーションで改良中マークされたアイテムを非表示にするのを有効化します",
        ["options_enable_filter_in_store"]       = "ベンダでフィルタを有効化",
        ["options_enable_filter_in_store_TT"]       = "ベンダに売却時マークされたアイテムを非表示にするのを有効化します",
        ["options_enable_filter_in_enchanting"]      = "付呪中フィルタを有効化",
        ["options_enable_filter_in_enchanting_TT"]      = "生産と解体物付呪中マークされたアイテムを非表示にするのを有効化します",
        ["options_enable_filter_in_fence"]       = "盗品商でフィルタを有効化",
        ["options_enable_filter_in_fence_TT"]       = "盗品商で売却時マークされたアイテムを非表示にするのを有効化します",
        ["options_enable_filter_in_launder"]         = "洗浄でフィルタを有効化",
        ["options_enable_filter_in_launder_TT"]         = "盗品商で洗浄時マークされたアイテムを非表示にするのを有効化します",
        ["options_enable_filter_in_alchemy"]         = "錬金ステーションでフィルタを有効化",
        ["options_enable_filter_in_alchemy_TT"]         = "錬金ステーションでポーションを生産時マークされたアイテムを非表示にするのを有効化します",
        ["options_header_deactivated_symbols"]                      = "無効化されたアイコン",
        ["options_deactivated_symbols_apply_anti_checks"]           = "アンチ破壊とアンチ*チェックを適用",
        ["options_deactivated_symbols_apply_anti_checks_TT"]   = "これは現在マーカーシンボルが無効化されていても、マークされたアイテムのノーマルアンチ破壊/アンチ解体/アンチ改良/アンチメール/アンチトレード/アンチ売却/アンチ解凍/etc.チェックが適用されます。アイテムをマークする/しないためにはシンボルを再度有効化する必要があります！",
        ["options_header_repair"] = GetString(SI_STORE_MODE_REPAIR),
        ["options_header_enchant"] = GetString(SI_ITEMTYPEDISPLAYCATEGORY15),
        ["options_allow_marked_repair"] = "マークされた修理キットをブロック",
        ["options_allow_marked_repair_TT"] = "マークされた修理キットを装備の修理に使用するのを許可しません",
        --Other options
        ["options_header_items"]                 = "自動でマーク",
        ["options_header_items_demark"]          = "自動でマークを外す",
        ["options_enable_auto_mark_ornate_items"] = "装飾アイテムをマーク",
        ["options_enable_auto_mark_ornate_items_TT"] =  "装飾アイテムを自動的に売却品としてマークします",
        ["options_auto_mark_ornate_items_icon"] = "装飾マークアイコン",
        ["options_auto_mark_ornate_items_icon_TT"] = "売却品として自動的にマークされる装飾アイテムのアイコン",
        ["options_enable_auto_mark_ornate_items_in_chat"] = "チャットにアイテムを表示",
        ["options_enable_auto_mark_ornate_items_in_chat_TT"] =  "チャットにマークされた装飾アイテムを自動的に表示します",
        ["options_enable_auto_mark_intricate_items"] = "複雑なアイテムをマーク",
        ["options_enable_auto_mark_intricate_items_TT"] =  "自動的に複雑なアイテムをマークします",
        ["options_auto_mark_intricate_items_icon"] = "複雑マークアイコン",
        ["options_auto_mark_intricate_items_icon_TT"] = "自動的にマークされる複雑アイテムのアイコン",
        ["options_enable_auto_mark_intricate_items_in_chat"] = "チャットにアイテムを表示",
        ["options_enable_auto_mark_intricate_items_in_chat_TT"] =  "チャットにマークされた複雑アイテムを自動的に表示します",
        ["options_enable_auto_mark_research_items"] = "研究可能なアイテムをマーク",
        ["options_enable_auto_mark_research_items_TT"] = "研究可能なアイテムを自動的にマークします",
        ["options_enable_auto_mark_research_items_hint"]    = "必要なアドオンが設定のドロップボックスから選択されます",
        ["options_enable_auto_mark_research_items_in_chat"] = "チャットにアイテムを表示",
        ["options_enable_auto_mark_research_items_in_chat_TT"] =  "チャットにマークされた研究可能なアイテムを自動的に表示します",
        ["options_auto_mark_research_items_icon"] = "研究マークアイコン",
        ["options_auto_mark_research_items_icon_TT"] = "自動的にマークされる研究可能アイテムのアイコン",
		["options_enable_auto_mark_sets"]			= "セットパーツをマーク",
		["options_enable_auto_mark_sets_TT"]	= "自動的にセット武器/防具パーツをマークします。",
		["options_enable_auto_mark_sets_all_gear_marker_icons"]			= "全てのギアマーカーをチェック",
		["options_enable_auto_mark_sets_all_gear_marker_icons_TT"]	= "自動的にセットパーツにマークする際、全てのギアマーカーアイコンをチェックします。もし自動的にセットパーツにマークする際にギアマーカーがすでにセットされている場合、セットパーツがマークされることはありません！",
        ["options_enable_auto_mark_sets_in_chat"] = "アイテムをチャットに表示",
        ["options_enable_auto_mark_sets_in_chat_TT"] =  "マークされたセットアイテムを自動的にチャットに表示します。",
 		["options_auto_mark_sets_icon"]			= "セットパーツアイコン",
		["options_auto_mark_sets_icon_TT"]	= "自動的にマークされたセットアイテムのアイコンです。",
		["options_header_settracker"]								= "トラッカー設定（SetTracker）",
		["options_auto_mark_settrackersets"]						= "自動的に'SetTracker'セットをマーク",
		["options_auto_mark_settrackersets_TT"]				= "'SetTracker'でトラックされているアイテムをFCOISマーカーアイコンの一つで自動的にマークします。",
		["options_auto_mark_settrackersets_to_fcois_icon"]			= "SetTrackerインデックス<<1>>: FCOISアイコン",
		["options_auto_mark_settrackersets_to_fcois_icon_TT"]	= "'SetTracker'でトラックされたそれぞれの状態/セットで使いたいFCOItemSaverのアイコンをここで指定します。",
		["options_auto_mark_settrackersets_show_tooltip_on_FCOIS_marker"]		  = "設定されたノートをツールチップとして表示",
		["options_auto_mark_settrackersets_show_tooltip_on_FCOIS_marker_TT"] = "インベントリ内のFCOItemSaverマーカーアイコンのツールチップ内のテキストにSetTrackerで設定されたノートを表示します。(ノートを作成していた場合)",
		["options_auto_mark_settrackersets_inv"]			= "インベントリ内をマーク",
		["options_auto_mark_settrackersets_inv_TT"]	= "インベントリ内のアイテムをマークします。",
		["options_auto_mark_settrackersets_worn"]			= "装備中をマーク",
		["options_auto_mark_settrackersets_worn_TT"]	= "現在装備中のアイテムをマークします。",
		["options_auto_mark_settrackersets_bank"]			= "銀行内をマーク",
		["options_auto_mark_settrackersets_bank_TT"]	= "銀行内のアイテムをマークします。",
		["options_auto_mark_settrackersets_guildbank"]			= "ギルドバンク内をマーク",
		["options_auto_mark_settrackersets_guildbank_TT"]	= "ギルドバンク内のアイテムをマークします。",
		["options_auto_mark_recipes_icon"]				=	"レシピアイコン",
		["options_auto_mark_recipes_icon_TT"]		=	"レシピとして自動的にマークされたアイコン",
		["options_auto_mark_crafted_items_icon"]		=	"クラフトアイテムアイコン",
		["options_auto_mark_crafted_items_icon_TT"]=	"クラフトアイテムとして自動的にマークされるアイコン",
        ["options_enable_auto_mark_recipes"]            = "未知のレシピをマーク",
        ["options_enable_auto_mark_recipes_TT"]    = "自動的にロックアイコンのついた未知のアイコンをマークします",
        ["options_enable_auto_mark_recipes_in_chat"]    = "チャットにレシピを表示",
        ["options_enable_auto_mark_recipes_in_chat_TT"] = "チャットにマークされた未知のレシピを自動的に表示します",
        ["options_auto_mark_recipes_this_char"]         = "このキャラクターでのみレシピをマーク",
        ["options_auto_mark_recipes_this_char_TT"] = "この設定が有効化されている場合、未知のレシピは現在のキャラクターでのみマークされます！\n\nこの設定が無効化されている場合、もしSoulChefの'Main Provisioner Character'がこのレシピを知らない場合のみマークされます！",
        ["options_enable_auto_mark_recipes_hint"]       = "このオプションはaddon SousChefが有効化している必要があり、特にSousChef内オプション、'List Characters Who Know Recipe'が有効化されている必要があります！",
        ["options_auto_mark_crafted_items"]             = "クラフト後アイテムをマーク",
        ["options_auto_mark_crafted_items_TT"]     = "この設定が有効化されている場合、クラフトステーションの'lock'アイコン付きのクラフト済みアイテムを自動的にマークします。",
        ["options_auto_mark_crafted_items_sets"]            = "セットパーツのみマーク",
        ["options_auto_mark_crafted_items_sets_TT"]    = "この設定が有効狩れている場合、クラフトアイテムの自動アイテムマーキングはクラフトセットアイテムパーツのみマークします。",
        ["options_header_anti_destroy"] = "アンチ破壊",
        ["options_enable_block_deconstruction"]  = "解体を無効化",
        ["options_enable_block_deconstruction_TT"]  = "クラフトステーション内のマークされたアイテムの解体を無効化します",
        ["options_enable_block_deconstruction_exception_intricate"]  = "複雑アイテムの解体を許可",
        ["options_enable_block_deconstruction_exception_intricate_TT"]  = "'複雑'としてマークされたアイテムの解体を許可します",
        ["options_enable_block_deconstruction_exception_deconstruction"]  = "解体アイテムの解体を許可",
        ["options_enable_block_deconstruction_exception_deconstruction_TT"]  = "'解体'としてマークされたアイテムの解体を許可します",

        ["options_enable_block_deconstruction_exception_deconstruction_all_markers"]  = "Allow deconstruction (ignore other markers)",
        ["options_enable_block_deconstruction_exception_deconstruction_all_markers_TT"]  = "Allows the deconstruction for items marked as 'Deconstruction' even if the item is marked with any of the other item markers.\n\nAttention: This will destroy your items marked for deconstruction even if it would still be a set part you'd like to keep and you've marked it with a gear set e.g.",

        ["options_enable_block_destroying"]  = "破壊を防止",
        ["options_enable_block_destroying_TT"]  = "マークされたアイテムの破壊を防止します",
        ["options_enable_block_sending_mail"]  = "メールで送信するのを防止",
        ["options_enable_block_sending_mail_TT"]  = "マークされたアイテムをメールで送信するのを防止します",
        ["options_enable_block_trading"]  = "トレードを防止",
        ["options_enable_block_trading_TT"]  = "マークされたアイテムを他のプレイヤーとトレードするのを防止します",
        ["options_enable_block_selling"]  = "売却を防止",
        ["options_enable_block_selling_TT"]  = "マークされたアイテムをベンダに売却するのを防止します",
        ["options_enable_block_selling_guild_store"]  = "ギルドストアに売却するのを防止",
        ["options_enable_block_selling_guild_store_TT"]  = "マークされたアイテムをギルドストアの売却リストに載せるのを防止します",
        ["options_enable_block_fence_selling"]    = "盗品売却を防止",
        ["options_enable_block_fence_selling_TT"]    = "マークされたアイテムを盗品商に売却するのを防止します",
        ["options_enable_block_launder_selling"]    = "洗浄を防止",
        ["options_enable_block_launder_selling_TT"]    = "マークされたアイテムを盗品商で洗浄するのを防止します",
        ["options_demark_all_selling"]  = "'売却'品からマークを全て外す",
        ["options_demark_all_selling_TT"] = "売却にマークされたアイテムから全てのほかのマーカーアイコンを外します",
        ["options_demark_all_selling_guild_store"]  = "'ギルドストアで販売'からマークを全て外す",
        ["options_demark_all_selling_guild_store_TT"] = "ギルドストアで売却としてマークされたアイテムから全てのほかのマーカーアイコンを外します",

        ["options_block_selling_exception"]         = "マークされた'売却'アイテムの売却を許可",
        ["options_block_selling_exception_TT"] = "ストアで売却としてマークされたアイテムを売却するのを許可します。これは売却アイコンとしてマークされたアイテムだけをフィルタして売却するのを簡単にします！",
        ["options_block_selling_exception_ornate"] = "マークされた装飾品の売却を許可",
        ["options_block_selling_exception_ornate_TT"] = "装飾としてマークされたアイテムを売却するのを許可します。これは装飾アイコンとしてマークされたアイテムだけをフィルタして売却するのを簡単にします！",
        ["options_block_selling_exception_intricate"] = "マークされた複雑品の売却を許可",
        ["options_block_selling_exception_intricate_TT"] = "複雑としてマークされたアイテムを売却するのを許可します",
        ["options_block_selling_exception_guild_store"] = "ギルドストアで販売するのを許可",
        ["options_block_selling_exception_guild_store_TT"] = "'ギルドストア用にマーク'されたアイテムをギルドストアで売却するのを許可します",
        ["options_enable_block_improvement"]  = "改良を防止",
        ["options_enable_block_improvement_TT"]  = "クラフトステーションでマークされたアイテムを改良するのを防止します",
        ["options_enable_block_improvement_exception_improvement"]  = "改良されたアイテムを改良するのを許可",
        ["options_enable_block_improvement_exception_improvement_TT"]  = "クラフトステーションで'改良'としてマークされたアイテムを改良するのを許可します",
        ["options_enable_block_creation"]           = "ルーン生成を防止",
        ["options_enable_block_creation_TT"]   = "付呪テーブルでマークされたアイテムを使ってルーンを生成するのを防止します",
        ["options_enable_block_extraction"]         = "ルーン抽出を防止",
        ["options_enable_block_extraction_TT"] = "付呪テーブルでマークされたアイテムからルーン抽出するのを防止",
        ["options_enable_block_alchemy_destroy"]  = "錬金破壊を防止",
        ["options_enable_block_alchemy_destroy_TT"]  = "錬金ステーションでマークされたアイテムを破壊するのを防止します",
        ["options_enable_block_autoloot_container"]         = "コンテナから自動取得を無効化します",
        ["options_enable_block_autoloot_container_TT"] = "ESOスタンダード設定の'常にすべて取得'（自動取得）が有効化されている場合、コンテナからのすべてのコンテンツの自動取得を無効化します。\n\nこの設定が有効化されている場合、マークされたコンテナを開くことは許可されません。コンテナと自動取得で素晴らしい利益を得られるAddon、'Container Peek'を参照してみてください！",
        ["options_enable_block_marked_recipes"]         = "マークされたレシピの使用をブロック",
        ["options_enable_block_marked_recipes_TT"] = "アイコンでマークされているレシピを誤って使用して読んでしまう事を防止します",
        ["options_remove_context_menu_mark_as_junk"] = "削除する '" .. GetString(SI_ITEM_ACTION_MARK_AS_JUNK) .."'",
        ["options_remove_context_menu_mark_as_junk_TT"] = "マークされた項目のコンテキストメニューエントリを削除する",
        ["options_enable_block_motifs"] = "マークされたモチーフの使用を防止",
        ["options_enable_block_motifs_TT"] = "アイコンでマークされているモチーフを誤って使用して読んでしまう事を防止します",
        ["options_header_motifs"] = "スタイルモチーフ",
        ["options_header_food"] = "食料とポーション",
        ["options_enable_block_potions"] = "マークされたポーションの使用をブロック",
        ["options_enable_block_potions_TT"] = "アイコンでマークされているポーションを誤って飲んでしまう事を防止します",
        ["options_enable_block_food"] = "マークされた食料の使用をブロック",
        ["options_enable_block_food_TT"] = "アイコンでマークされた食料を誤って食べてしまう事を防止します",
        ["options_header_guild_bank"] = "ギルド銀行",
        ["options_enable_block_guild_bank_without_withdraw"] = "引き出し権利無しの預け入れを防止",
        ["options_enable_block_guild_bank_without_withdraw_TT"] = "このギルドバンクから再度引き出す権利が無い場合、全てのアイテム（マークされていなくとも）を預け入れるのを防止します",
        ["options_auto_reenable_block_deconstruction"]  = "アンチ解体を自動的に再有効化",
        ["options_auto_reenable_block_deconstruction_TT"]  = "クラフトステーションを閉じた際、アンチ解体保護を自動的に再有効化します。\n\nインベントリのコンテキストボタンメニュー（左上にある小さな'フラッグ'シンボル）で防止メソッドを無効化することができます！",
        ["options_auto_reenable_block_destroying"]  = "アンチ破壊を自動的に再有効化",
        ["options_auto_reenable_block_destroying_TT"]  = "インベントリ/銀行/ギルド銀行を閉じた際、アンチ破壊保護を自動的に再有効化します。\n\nインベントリのコンテキストボタンメニュー（左上にある小さな'フラッグ'シンボル）で防止メソッドを無効化することができます！",
        ["options_auto_reenable_block_sending_mail"]  = "アンチメールを自動的に再有効化",
        ["options_auto_reenable_block_sending_mail_TT"]  = "メールインベントリを閉じた際、アンチメール保護を自動的に再有効化します。\n\nインベントリのコンテキストボタンメニュー（左上にある小さな'フラッグ'シンボル）で防止メソッドを無効化することができます！",
        ["options_auto_reenable_block_trading"]  = "アンチトレードを自動的に再有効化",
        ["options_auto_reenable_block_trading_TT"]  = "トレードインベントリを閉じた際、アンチトレード保護を自動的に再有効化します。\n\nインベントリのコンテキストボタンメニュー（左上にある小さな'フラッグ'シンボル）で防止メソッドを無効化することができます！",
        ["options_auto_reenable_block_selling"]  = "アンチ売却を自動的に再有効化",
        ["options_auto_reenable_block_selling_TT"]  = "ベンダを閉じた際、アンチ売却保護を自動的に再有効化します。\n\nインベントリのコンテキストボタンメニュー（左上にある小さな'フラッグ'シンボル）で防止メソッドを無効化することができます！",
        ["options_auto_reenable_block_selling_guild_store"]  = "ギルドストアアンチ販売を自動的に再有効化",
        ["options_auto_reenable_block_selling_guild_store_TT"]  = "ギルドストアを閉じた際、アンチ販売保護を自動的に再有効化します。\n\nインベントリのコンテキストボタンメニュー（左上にある小さな'フラッグ'シンボル）で防止メソッドを無効化することができます！",
        ["options_auto_reenable_block_fence_selling"]  = "盗品商アンチ売却を自動的に再有効化",
        ["options_auto_reenable_block_fence_selling_TT"]  = "盗品商ストアを閉じた際、アンチ売却を自動的に再有効化します。\n\nインベントリのコンテキストボタンメニュー（左上にある小さな'フラッグ'シンボル）で防止メソッドを無効化することができます！",
        ["options_auto_reenable_block_launder_selling"]  = "盗賊商アンチ洗浄を自動的に有効化",
        ["options_auto_reenable_block_launder_selling_TT"]  = "盗品商ストアを閉じた際、アンチ洗浄保護を自動的に再有効化します。\n\nインベントリのコンテキストボタンメニュー（左上にある小さな'フラッグ'シンボル）で防止メソッドを無効化することができます！",
        ["options_auto_reenable_block_improvement"]  = "アンチ改良を自動的に再有効化",
        ["options_auto_reenable_block_improvement_TT"]  = "クラフトステーションを閉じた際、アンチ改良保護を自動的に再有効化します。\n\nインベントリのコンテキストボタンメニュー（左上にある小さな'フラッグ'シンボル）で防止メソッドを無効化することができます！",
        ["options_auto_reenable_block_creation"]            = "アンチルーン作成を自動的に再有効化",
        ["options_auto_reenable_block_creation_TT"]    = "付呪台を閉じた際、アンチルーン作成を自動的に再有効化します。\n\nインベントリのコンテキストボタンメニュー（左上にある小さな'フラッグ'シンボル）で防止メソッドを無効化することができます！",
        ["options_auto_reenable_block_extraction"]          = "アンチルーン抽出を自動的に再有効化",
        ["options_auto_reenable_block_extraction_TT"]  = "付呪台を閉じた際、アンチルーン抽出を自動的に再有効化します。\n\nインベントリのコンテキストボタンメニュー（左上にある小さな'フラッグ'シンボル）で防止メソッドを無効化することができます！",
        ["options_auto_reenable_block_alchemy_destroy"]  = "錬金アンチ破壊を自動的に再有効化",
        ["options_auto_reenable_block_alchemy_destroy_TT"]  = "錬金台を閉じた際、錬金アンチ破壊を自動的に再有効化します。\n\nインベントリのコンテキストボタンメニュー（左上にある小さな'フラッグ'シンボル）で防止メソッドを無効化することができます！",

        ["options_header_equipment"]             = "装備",
        ["options_equipment_markall_gear"]       = "全てをギアとしてマーク",
        ["options_equipment_markall_gear_TT"] = "全ての装備中のアイテムをギアとして一度にマークするのを許可します",
        ["options_equipment_markall_gear_add_weapons"]       = "武器もマーク",
        ["options_equipment_markall_gear_add_weapons_TT"] = "武器も自動的にマークします",
        ["options_equipment_markall_gear_add_jewelry"]       = "アクセサリもマーク",
        ["options_equipment_markall_gear_add_jewelry_TT"] = "アクセサリも自動的にマークします",
        ["options_header_filter_buttons"]   = "フィルタボタン",
        ["options_filter_buttons_show_TT"] = "ツールチップを表示",
        ["options_filter_buttons_show_tooltip_TT"] = "フィルタボタンをマウスオーバー/クリックするとツールチップを表示します",
        ["options_filter_buttons_context_menu_show_TT"] = "フィルタコンテキストメニューのツールチップを表示",
        ["options_filter_buttons_context_menu_show_tooltip_TT"] = "フィルタコンテキストメニューの各エントリを識別するツールチップを表示します",
        ["options_header_filter_chat"]          = "フィルタとチャット",
        ["options_chat_filter_status"]          = "チャット内にフィルタステータス",
        ["options_chat_filter_status_TT"]  = "変更があった場合、チャット内にフィルタステータスを表示します？",
        ["options_header_destroy"]              = "破壊",
        ["options_header_deconstruction"]       = "解体",
        ["options_header_research"]             = "研究",
        ["options_header_improvement"]          = "改良",
        ["options_header_mail"]                 = "メール",
        ["options_header_trade"]                = "トレード",
        ["options_header_rune_creation"]        = "ルーン作成",
        ["options_header_rune_extraction"]      = "グリフ抽出",
        ["options_header_sell"]                 = "売却",
        ["options_header_sell_at_guild_store"]  = "ギルドストアで販売",
        ["options_header_fence"]                = "盗賊商",
        ["options_header_launder"]              = "洗浄",
        ["options_header_alchemy_destroy"]      = "錬金",
        ["options_header_recipes"]              = "レシピ",
        ["options_header_containers"]           = "コンテナ",
        ["options_header_anti_output_options"]  = "オプションをアウトプット",

		["options_use_ZOs_lock_functions"] 			= "インゲームアイテムロックを有効化" ..lockIcon,
		["options_use_ZOs_lock_functions_TT"]	= "ZOsによって提供されているインゲームアイテムロック機能を有効化/無効化します。",
        ["options_scan_ZOs_lock_functions"]			= "インゲーム "..lockIcon.."->FCOIS "..lockIcon,
        ["options_scan_ZOs_lock_functions_TT"] = "インゲームロック機能によってロックされたアイテム（グレーロックアイコン）をFCOItemSaverアイコン1に転送します。これによりインゲームマーカーは解除され、同じアイテムがFCOISマーカーアイコン1でマークされます。",
        ["options_scan_ZOs_lock_functions_warning"]	= "本当にあなたのアイテムのインゲームロックを解除し、FCOItemSaverのマーカーアイコン1に転送してもよろしいですか？?",
        --Additional buttons
        ["options_header_additional_buttons"]                        = "追加ボタン",
        ["options_additional_buttons_FCOIS_settings"]                = "メインメニューにFCO設定",
        ["options_additional_buttons_FCOIS_settings_TT"]        = "ゲームのメインメニュー内にFCOItemSaver設定の追加ボタンを表示します。（ヘルプボタンの右）\n\n[注意]このボタンはaddon 'Votan Setting Menu'のaddon設定ボタンがが表示されていない場合のみ表示されます！",
        ["options_additional_buttons_FCOIS_additional_options"]         = "インベントリに追加オプション",
        ["options_additional_buttons_FCOIS_additional_options_TT"] = "インベントリ内にさらなるオプションを追加するボタンを表示します。（全てをマーク/マークを全て外す/やり直し）ボタンは小さな'フラッグ'シンボルでインベントリの左上の角に表示され、クリックするとコンテキストメニューが表示されます！",
        ["options_additional_buttons_FCOIS_additional_options_colorize"]        = "インベントリ内の追加ボタンを色付け",
        ["options_additional_buttons_FCOIS_additional_options_colorize_TT"] = "現在のパネルの保護機能が有効/無効化されている場合、追加オプションボタンを緑/赤に色付けします。",
        ["button_FCOIS_settings_TT"]                            = "FCOItemSaver設定を表示",
        --Anti equip
        ["options_header_anti_equip"]                   = "アンチ装備",
        ["options_askBeforeEquipBoundItems"]            = "アイテムを固定化する前に確認",
        ["options_askBeforeEquipBoundItems_TT"]    = "アイテムを自分のアカウントに固定する前に確認ダイアログを表示します",
        ["options_anti_equip_question"]                 = "<<!A:1>>を \nあなたのアカウントに固定化しますか？",
        --Stolen
        ["options_header_stolen"]                = "盗品",
        ["options_show_stolen_icon"]             = "盗品アイテムフィルタを表示",
        ["options_show_stolen_icon_TT"]     = "インベントリ内に盗品の追加フィルタアイコンを表示します。最後にアクティブだったアイコンの右に常に表示されます。（スタンダード:コインアイコン）",
        --Other options
		["options_split_lockdyn_filter"]		 = "ロックアイコン分割＆ダイナミックアイコン表示",
        ["options_split_lockdyn_filter_TT"] = "1stフィルタボタンアイコンをロックアイコン＆4方向のダイナミックに設定可能なアイコンに分割します。インベントリ内の1stフィルタボタンを右クリックした場合、ドロップダウンメニューが表示され、何をフィルタするかの一つ一つのアイコンを選ぶことができます。エントリー*を選択すると、再度全てのエントリーを選択します。",
        ["options_split_gearsets_filter"]        = "ギアセット(1/2/3/4/5)フィルタボタンを分割",
        ["options_split_gearsets_filter_TT"]= "ギアセットフィルタボタンを分割します。インベントリ内でギアセットフィルタボタンを右クリックした場合、ドロップダウンメニューが表示され、個別に各ギアをフィルタするかを選ぶことができます。エントリ＊は全てのエントリを再度選択します。",
        ["options_split_resdecimp_filter"]           = "研究（解体/改良）フィルタボタンを分割",
        ["options_split_resdecimp_filter_TT"]= "研究フィルタアイコンボタンを分割します。インベントリ内で研究フィルタボタンを右クリックした場合、ドロップダウンメニューが表示され、研究、解体もしくは改良アイコンを選び、フィルタすることができます。",
        ["options_split_sellguildint_filter"]        = "売却（ギルドストアで/複雑）フィルタボタンを分割",
        ["options_split_sellguildint_filter_TT"]= "売却フィルタボタンを分割します。インベントリ内で売却フィルタボタンを右クリックした場合、ドロップダウンメニューが表示され、売却可能、ギルドストアで売却可能もしくは複雑アイコンから選び、フィルタすることができます。エントリ＊は全てのエントリを再度選択します。",
        --Right click item menu
        ["rightclick_menu_lock"]                 = "ロック",
        ["rightclick_menu_unlock"]               = "アンロック",
        ["rightclick_menu_add_gear1"]            = "ギア1に追加",
        ["rightclick_menu_add_all_gear1"]        = "全てをギア1に追加",
        ["rightclick_menu_remove_gear1"]         = "ギア1から削除",
        ["rightclick_menu_remove_all_gear1"]     = "ギア1から全てを削除",
        ["rightclick_menu_add_gear2"]            = "ギア2に追加",
        ["rightclick_menu_add_all_gear2"]        = "全てをギア2に追加",
        ["rightclick_menu_remove_gear2"]         = "ギア2から削除",
        ["rightclick_menu_remove_all_gear2"]     = "ギア2から全てを削除",
        ["rightclick_menu_add_gear3"]            = "ギア3に追加",
        ["rightclick_menu_add_all_gear3"]            = "全てをギア3に追加",
        ["rightclick_menu_remove_gear3"]         = "ギア3から削除",
        ["rightclick_menu_remove_all_gear3"]         = "ギア3から全てを削除",
        ["rightclick_menu_add_gear4"]            = "ギア4に追加",
        ["rightclick_menu_add_all_gear4"]            = "全てをギア4に追加",
        ["rightclick_menu_remove_gear4"]         = "ギア4から削除",
        ["rightclick_menu_remove_all_gear4"]         = "ギア4から全てを削除",
        ["rightclick_menu_add_gear5"]            = "ギア5に追加",
        ["rightclick_menu_add_all_gear5"]            = "全てをギア5に追加",
        ["rightclick_menu_remove_gear5"]         = "ギア5から削除",
        ["rightclick_menu_remove_all_gear5"]         = "ギア5から全てを削除",
        ["rightclick_menu_mark_analysis"]        = "研究を予約",
        ["rightclick_menu_demark_analysis"]      = "研究を中止",
        ["rightclick_menu_mark_sell"]            = "売却としてマーク",
        ["rightclick_menu_demark_sell"]          = "売却マークを外す",
        ["rightclick_menu_mark_sell_in_guild_store"]    = "ギルドストアで販売としてマーク",
        ["rightclick_menu_demark_sell_in_guild_store"]  = "ギルドストアの販売からマークを外す",
        ["rightclick_menu_mark_intricate"]      = "複雑としてマーク",
        ["rightclick_menu_demark_intricate"]    = "複雑マークを外す",
        ["rightclick_menu_mark_deconstruction"]  = "解体としてマーク",
        ["rightclick_menu_demark_deconstruction"]= "解体マークを外す",
        ["rightclick_menu_mark_improvement"]     = "改良としてマーク",
        ["rightclick_menu_demark_improvement"]   = "改良マークから外す",
        ["rightclick_menu_add_start_gear"]       = "追加：",
        ["rightclick_menu_add_all_start_gear"]   = "全てを追加：",
        ["rightclick_menu_remove_start_gear"]    = "削除：",
        ["rightclick_menu_remove_all_start_gear"]= "全てを削除：",
        --Button context menu
        ["button_context_menu_TT"]          = "追加オプション",
        ["button_context_menu_lock_all"]         = "全てをロック",
        ["button_context_menu_unlock_all"]       = "全てをアンロック",
        ["button_context_menu_research_all"]     = "+ 研究",
        ["button_context_menu_dont_research_all"]= "- 研究",
        ["button_context_menu_deconstruct_all"]     = "+ 解体",
        ["button_context_menu_dont_deconstruct_all"]= "- 解体",
        ["button_context_menu_improve_all"]         = "+ 解体",
        ["button_context_menu_dont_improve_all"]    = "- 解体",
        ["button_context_menu_sell_all"]         = "+ 売却",
        ["button_context_menu_dont_sell_all"]    = "- 売却",
        ["button_context_menu_sell_all_in_guild_store"]     = "+ ギルドストアで販売",
        ["button_context_menu_dont_sell_all_in_guild_store"]= "- ギルドストアで販売",
        ["button_context_menu_mark_all_as_intricate"]       = "+ 複雑",
        ["button_context_menu_unmark_all_as_intricate"]     = "- 複雑",
        ["button_context_menu_remove_all_gears"] = "ギアをすべて削除",
        ["button_context_menu_demark_all"]       = "マークを全て外す",
        ["button_context_menu_undo"]             = "< やり直し",
        ["button_context_menu_toggle_anti_destroy_on"] = "'アンチ破壊'を有効化",
        ["button_context_menu_toggle_anti_destroy_off"] = "'アンチ破壊'を無効化",
        ["button_context_menu_toggle_anti_improve_on"] = "'アンチ改良'を有効化",
        ["button_context_menu_toggle_anti_improve_off"] = "'アンチ改良'を無効化",
        ["button_context_menu_toggle_anti_deconstruct_on"] = "'アンチ解体'を有効化",
        ["button_context_menu_toggle_anti_deconstruct_off"] = "'アンチ解体'を無効化",
        ["button_context_menu_toggle_anti_create_on"] = "'アンチ作成'を有効化",
        ["button_context_menu_toggle_anti_create_off"] = "'アンチ作成'を無効化",
        ["button_context_menu_toggle_anti_extract_on"] = "'アンチ抽出'を有効化",
        ["button_context_menu_toggle_anti_extract_off"] = "'アンチ抽出'を無効化",
        ["button_context_menu_toggle_anti_mail_on"] = "'アンチメール'を有効化",
        ["button_context_menu_toggle_anti_mail_off"] = "'アンチメール'を無効化",
        ["button_context_menu_toggle_anti_sell_on"] = "'アンチ売却'を有効化",
        ["button_context_menu_toggle_anti_sell_off"] = "'アンチ売却'を無効化",
        ["button_context_menu_toggle_anti_fence_sell_on"] = "盗品商で'アンチ売却'を有効化",
        ["button_context_menu_toggle_anti_fence_sell_off"] = "盗品商で'アンチ売却'を無効化",
        ["button_context_menu_toggle_anti_launder_sell_on"] = "盗品商で'アンチ洗浄'を有効化",
        ["button_context_menu_toggle_anti_launder_sell_off"] = "盗品商で'アンチ洗浄'を無効化",
        ["button_context_menu_toggle_anti_trade_on"] = "'アンチトレード'を有効化",
        ["button_context_menu_toggle_anti_trade_off"] = "'アンチトレード'を無効化",
        ["button_context_menu_gear_sets_all"]        = "*",
        ["button_context_menu_gear_sets_all_TT"]= "全てのギアセット",
        ["button_context_menu_all_markers_TT"]  = "全てのマーカー",
		["filter_refinement"]						= "[クラフトステーション加工] ",
		["options_enable_filter_in_refinement"]				= "加工フィルタを有効化",
		["options_enable_filter_in_refinement_TT"]	 	= "クラフトステーションでの加工中にマークされたアイテムを非表示にできます。",
		["refinement_not_allowed"]						= "加工はてい許可されません:",
		["button_context_menu_toggle_anti_refine_on"] 	= "'アンチ加工'の有効化",
		["button_context_menu_toggle_anti_refine_off"]	= "'アンチ加工'の無効化",
		["options_enable_block_refinement"]                      = "加工を無効化",
		["options_enable_block_refinement_TT"]            = "クラフトステーションでマークされたアイテムの加工を無効化します。",
		["options_header_refinement"]                              = "加工",
		["options_auto_reenable_block_refinement"]            = "アンチ加工を自動的に再有効化",
		["options_auto_reenable_block_refinement_TT"]  = "クラフトステーションを閉じた際、アンチ加工保護を自動的に再有効化します。\n\nインベントリのコンテキストボタンメニュー（左上にある小さな'フラッグ'シンボル）で防止メソッドを無効化することができます！",
		["options_prevent_auto_marking_deconstruction"] = "再自動マーキングを防止(解体)",
		["options_prevent_auto_marking_sell"] = "再自動マーキングを防止(売却)",
       --Chat commands
        ["chatcommands_info"]                    = "|c00FF00FCO|cFFFF00Item Saver|cFFFFFF インベントリ/銀行アイテムにアイコンを設定し、フィルターします",
        ["chatcommands_help"]                    = "|cFFFFFF'help' / 'list'|cFFFF00: このaddonに関する情報を表示します",
        ["chatcommands_status"]                  = "|cFFFFFF'status' / ''|cFFFF00: 有効狩れているフィルタを表示します",
        ["chatcommands_filter1"]                 = "|cFFFFFF'filter1'|cFFFF00: カテゴリ1（ロックシンボル）のアイテムを表示/非表示します",
        ["chatcommands_filter2"]                 = "|cFFFFFF'filter2'|cFFFF00: カテゴリ2（兜シンボル）のアイテムを表示/非表示します",
        ["chatcommands_filter3"]                 = "|cFFFFFF'filter3'|cFFFF00: カテゴリ3（研究シンボル）のアイテムを表示/非表示します",
        ["chatcommands_filter4"]                 = "|cFFFFFF'filter4'|cFFFF00: カテゴリ4（コインシンボル）のアイテムを表示/非表示します",
        ["chatcommands_filter"]                  = "|cFFFFFF'filter'|cFFFF00: カテゴリ1 - 4アイテムを表示/日表示します" ,
        ["chatcommands_filteron"]                = "|cFFFFFF'alloff'|cFFFF00: カテゴリ1 - 4アイテムを表示します",
        ["chatcommands_filteroff"]               = "|cFFFFFF'allon'|cFFFF00: カテゴリ1 - 4アイテムを非表示します",
        ["chatcommands_filtershow"]              = "|cFFFFFF'allshow'|cFFFF00: マークされたカテゴリ1 - 4アイテムだけを表示します",
        ["chatcommands_split_filter"]            = "|cFFFFFF'split'|cFFFF00: インベントリ、ベンダ、ギルド銀行、ギルドストア、銀行クラフトステーション、付呪台、メール、トレードパネルの個別フィルタを有効/無効化します",
        ["chatcommands_filterpanels"]            = "|c990000利用可能 |cFFFFFF<filterPanel>|cFFFF00:",
        ["chatcommands_filtervalues"]            = "|c990000利用可能 |cFFFFFF<filterValue>|cFFFF00: |cFFFFFFtrue|cFFFF00 / |cFFFFFFfalse|cFFFF00 / |cFFFFFF表示",
        ["chatcommands_filter1_new"]             = "|cFFFFFF'フィルタ1 <filterPanel> <filterValue>'|cFFFF00: 非表示 |cFFFFFF<true>|cFFFF00 / 表示 |cFFFFFF<false>|cFFFF00 / パネル|cFFFFFF<filterPanel>|cFFFF00のマークされたカテゴリ1（ロックシンボル）アイテムのみ表示|cFFFFFF<show>",
        ["chatcommands_filter2_new"]             = "|cFFFFFF'フィルタ2 <filterPanel> <filterValue>'|cFFFF00: 非表示 |cFFFFFF<true>|cFFFF00 / 表示 |cFFFFFF<false>|cFFFF00 / パネル|cFFFFFF<filterPanel>|cFFFF00のマークされたカテゴリ2（兜シンボル）アイテムのみ表示|cFFFFFF<show>",
        ["chatcommands_filter3_new"]             = "|cFFFFFF'フィルタ3 <filterPanel> <filterValue>'|cFFFF00: 非表示 |cFFFFFF<true>|cFFFF00 / 表示 |cFFFFFF<false>|cFFFF00 / パネル|cFFFFFF<filterPanel>|cFFFF00のマークされたカテゴリ3（研究シンボル）アイテムのみ表示|cFFFFFF<show>",
        ["chatcommands_filter4_new"]             = "|cFFFFFF'フィルタ4 <filterPanel> <filterValue>'|cFFFF00: 非表示 |cFFFFFF<true>|cFFFF00 / 表示 |cFFFFFF<false>|cFFFF00 / パネル|cFFFFFF<filterPanel>|cFFFF00のマークされたカテゴリ4（コインシンボル）アイテムのみ表示|cFFFFFF<show>",
        ["chatcommands_filter_new"]              = "|cFFFFFF'フィルタ <filterPanel> <filterValue>'|cFFFF00: 非表示 |cFFFFFF<true>|cFFFF00 / 表示 |cFFFFFF<false>|cFFFF00 / パネル|cFFFFFF<filterPanel>|cFFFF00のマークされたカテゴリ1 - 4アイテムのみ表示|cFFFFFF<show>",
        ["chatcommands_filteron_new"]            = "|cFFFFFF'全てオン <filterPanel>'|cFFFF00: パネル|cFFFFFF<filterPanel>|cFFFF00のカテゴリ1 - 4を非表示",
        ["chatcommands_filteroff_new"]           = "|cFFFFFF'全てオフ <filterPanel>'|cFFFF00: パネル|cFFFFFF<filterPanel>|cFFFF00のカテゴリ1 - 4を表示",
        ["chatcommands_filtershow_new"]          = "|cFFFFFF'全て表示 <filterPanel>'|cFFFF00: パネル|cFFFFFF<filterPanel>|cFFFF00のマークされたカテゴリ1 - 4のアイテムのみ表示",
        ["chatcommands_debug"]                   = "|cFFFFFF'デバッグ'|cFFFF00: デバッグメッセージを有効/無効化 |c990000[注意]|cFFFF00 このオプションはローカルチャットを大洪水にします！",
        ["chatcommands_status_info"]             = "|c00FF00FCO|cFFFF00Item Saver|cFFFFFF 有効化されたフィルタ:",
        ["chatcommands_status_nofilters"]        = "|c00FF00FCO|cFFFF00Item Saver|cFF0000 有効化されたフィルタはありません",
        ["chatcommands_status_filter1"]          = "ロックフィルタ: ON",
        ["chatcommands_status_filter2"]          = "フィアフィルタ: ON",
        ["chatcommands_status_filter3"]          = "研究フィルタ: ON",
        ["chatcommands_status_filter4"]          = "売却フィルタ: ON",
        ["chatcommands_debug_on"]                = "デバッグ: ON",
        ["chatcommands_debug_off"]               = "デバッグ: OFF",
        ["chatcommands_deepdebug_on"]            = "さらなるデバッグ: ON",
        ["chatcommands_deepdebug_off"]           = "さらなるデバッグ: OFF",
        --Filters
        ["filter1_off"]                          = "ロックフィルタ OFF",
        ["filter1_on"]                           = "ロックフィルタ ON",
        ["filter1_onlyfiltered"]                 = "ロックフィルタ フィルタされたもののみ表示",
        ["filter1_split_off"]                    = "フィルタ OFF",
        ["filter1_split_on"]                     = "フィルタ ON",
        ["filter1_split_onlyfiltered"]           = "フィルタ フィルタされたもののみ表示",
        ["filter2_off"]                          = "ギアフィルタ OFF",
        ["filter2_on"]                           = "ギアフィルタ ON",
        ["filter2_onlyfiltered"]                 = "ギアフィルタ SHOWS ONLY FILTERED",
        ["filter3_off"]                          = "研究/解体/改良フィルタ OFF",
        ["filter3_on"]                           = "研究/解体/改良フィルタ ON",
        ["filter3_onlyfiltered"]                 = "研究/解体/改良フィルタ フィルタされたもののみ表示",
        ["filter3_split_off"]                    = "フィルタ OFF",
        ["filter3_split_on"]                     = "フィルタ ON",
        ["filter3_split_onlyfiltered"]           = "フィルタ フィルタされたもののみ表示",

        ["filter4_off"]                          = "売却/ギルドストアで販売/複雑フィルタ OFF",
        ["filter4_on"]                           = "売却/ギルドストアで販売/複雑フィルタ ON",
        ["filter4_onlyfiltered"]                 = "売却/ギルドストアで販売/複雑フィルタ フィルタされたもののみ表示",
        ["filter4_split_off"]                    = "フィルタ OFF",
        ["filter4_split_on"]                     = "フィルタ ON",
        ["filter4_split_onlyfiltered"]           = "フィルタ フィルタされたもののみ表示",

        ["filter_ABORT"]                         = "設定で有効化されていません！",
        ["filter_inventory"]    = "[プレイヤーインベントリ] ",
	    ["filter_craftbag"]		= "[クラフトバッグ] ",
        ["filter_guildbank"]    = "[ギルド銀行] ",
        ["filter_guildstore"]   = "[ギルドストア] ",
        ["filter_bank"]         = "[銀行] ",
        ["filter_alchemy"]      = "[クラフトステーション錬金] ",
        ["filter_deconstruction"]   = "[クラフトステーション解体] ",
        ["filter_improvement"]  = "[クラフトステーション改良] ",
        ["filter_enchantingstation_extraction"] = "[付呪抽出] ",
        ["filter_enchantingstation_creation"] = "[付呪作成] ",
        ["filter_store"] = "[ストア] ",
        ["filter_fence"] = "[盗品商] ",
        ["filter_launder"] = "[洗浄] ",
        ["filter_mail"] = "[メール] ",
        ["filter_trade"] = "[トレード] ",
        ["filter_gears_all"]                     = "オールギアセット",
        ["filter_resdecimp_all"]                 = "研究/解体/改良",
        ["filter_resdecimp_1"]                   = "研究",
        ["filter_resdecimp_2"]                   = "解体",
        ["filter_resdecimp_3"]                   = "改良",
        ["filter_sellguildint_all"]              = "売却/ギルドストアで販売/複雑",
        ["filter_sellguildint_1"]                = "売却",
        ["filter_sellguildint_2"]                = "ギルドストアで販売",
        ["filter_sellguildint_3"]                = "複雑",
        ["filter_lockdyn_all"]				 	 = "ロック / ダイナミックアイコン 1 - 5",
        ["filter_lockdyn_1"]					 = "ロックアイコン",
        --Messages to chat
        ["show_anti_messages_in_chat"]           = "注意をチャットに表示",
        ["show_anti_messages_in_chat_TT"]   = "アイテム名付きの注意メッセージをチャットウィンドウ内に表示します",
        ["show_anti_messages_as_alert"]          = "注意を警告として表示",
        ["show_anti_messages_as_alert_TT"]  = "アイテム名付きの注意メッセージを警告ウィンドウに表示し、拒否サウンドを鳴らします",
        ["deconstruction_not_allowed"]           = "解体は許可されていません:",
        ["destroying_not_allowed"]               = "破壊は許可されていません:",
        ["sendbymail_not_allowed"]               = "送信は許可されていません:",
        ["trading_not_allowed"]                  = "トレードは許可されていません:",
        ["selling_not_allowed"]                  = "売却は許可されていません:",
        ["fence_selling_not_allowed"]            = "盗品商での売却は許可されていません:",
        ["launder_selling_not_allowed"]          = "盗品商での洗浄は許可されていません:",
        ["improvement_not_allowed"]              = "改良は許可されていません:",
        ["enchanting_creation_not_allowed"]      = "作成/解体は許可されていません:",
        ["enchanting_extraction_not_allowed"]    = "抽出は許可されていません:",
        ["guild_store_sell_not_allowed"]         = "ギルドストアでの販売は許可されていません:",
        ["alchemy_destroy_not_allowed"]          = "錬金アイテムの破壊は許可されていません:",
        ["container_autoloot_not_allowed"]       = "コンテナの自動取得は許可されていません:",
        ["recipe_usage_not_allowed"]             = "レシピを読むことは許可されていません:",
        ["motif_usage_not_allowed"]              = "スタイルモチーフを読むことは許可されていません:",
        ["potion_usage_not_allowed"]             = "ポーションを飲むことは許可されていません:",
        ["food_usage_not_allowed"]               = "食料を食べることは許可されていません:",
        ["marked"]                               = "マークされた [",
        ["ornate_item_found"]                    = "] を装飾として扱う",
        ["intricate_item_found"]                 = "] を複雑として扱う",
		["set_part_found"]						 = "]をパーツとしてセット",
        ["research_item_found"]                  = "] を研究可能として扱う",
        ["quality_item_found"]                  = "] はそのアイテム品質による",
        ["unknown_recipe_found"]                = "] を未知のレシピとして扱う",
        ["options_enable_auto_mark_quality_items"] = "品質でアイテムをマーク",
        ["options_enable_auto_mark_quality_items_TT"] =  "選択した品質と同等な品質を持つアイテムを自動的に1アイコンでマークします",
        ["options_enable_auto_mark_higher_quality_items"] = "高い品質もマーク",
        ["options_enable_auto_mark_higher_quality_items_TT"] =  "選択した品質よりも高い品質を持つアイテムも自動的にマークします",
        ["options_enable_auto_mark_quality_items_in_chat"] = "チャットにアイテムを表示",
        ["options_enable_auto_mark_quality_items_in_chat_TT"] =  "品質で自動的にマークされたアイテムをチャットに表示します",
        ["options_quality_OFF"]         = "-無効-",
        ["options_quality_trash"]       = "ガラクタ",
        ["options_quality_normal"]      = "ノーマル",
        ["options_quality_magic"]       = "上質",
        ["options_quality_arcane"]      = "上級",
        ["options_quality_artifact"]    = "極上",
        ["options_quality_legendary"]   = "伝説",
        --Key bindings
        ["SI_BINDING_NAME_FCOISFILTER1"]         = "フィルタ1を変更",
        ["SI_BINDING_NAME_FCOISFILTER2"]         = "フィルタ2を変更",
        ["SI_BINDING_NAME_FCOISFILTER3"]         = "フィルタ3を変更",
        ["SI_BINDING_NAME_FCOISFILTER4"]         = "フィルタ4を変更",
        ["SI_BINDING_NAME_FCOIS_SETTINGS_MENU"]  = "FCOItemSaver 設定",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_WITH_STANDARD_ICON"] = "スタンダードアイコンでマーク",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_CYCLE_UP"]   = "次のアイコンでマーク",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_CYCLE_DOWN"] = "前のアイコンでマーク",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_1"]    = "'ロック'アイコンでマーク",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_3"]    = "'研究'アイコンでマーク",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_5"]    = "'売却'アイコンでマーク",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_9"]    = "'解体'アイコンでマーク",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_10"]       = "'改良'アイコンでマーク",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_11"]       = "'ギルドストアで販売'アイコンでマーク",
        ["SI_BINDING_NAME_FCOIS_MARK_ITEM_12"]       = "'複雑'アイコンでマーク",
        ["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_1"]    = "ギアセット1でマーク",
        ["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_2"]    = "ギアセット2でマーク",
        ["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_3"]    = "ギアセット3でマーク",
        ["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_4"]    = "ギアセット4でマーク",
        ["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_5"]    = "ギアセット5でマーク",
        --Error messages
        ["error_gamepad_mode_not_supported"]    = "FCOItemSaverはゲームパッドモードをサポートしません！設定でキーボードモードに変更してください。",
    },
--==============================================================================
	-- Russian
	[FCOIS_CON_LANG_RU] = {
		-- Options menu
		["options_description"] = "FCOItemSaver зaщищaeт пoмeчeнныe Вaми пpeдмeты.\nТaкжe вы мoжeтe cкpывaть/пoкaзывaть гpуппы пoмeчeнныx пpeдмeтoв.",
		["options_header1"] = "Ocнoвныe нacтpoйки",
		["options_language"] = "Язык",
		["options_language_TT"] = "Выбepитe язык",
		["options_language_use_client"]          = "Использовать язык клиента",
		["options_language_use_client_TT"]  = "Всегда использовать аддоном язык клиента игры.",
		["options_language_dropdown_selection1"] = "Aнглийcкий",
		["options_language_dropdown_selection2"] = "Нeмeцкий",
		["options_language_dropdown_selection3"] = "Фpaнцузcкий",
		["options_language_dropdown_selection4"] = "Иcпaнcкий",
		["options_language_dropdown_selection5"] = "Итaльянcкий",
		["options_language_dropdown_selection6"] = "Япoнcкий",
		["options_language_dropdown_selection7"] = "Pуccкий",
		["options_language_description1"] = "ВНИМAНИE: Измeнeниe языкa/нacтpoeк coxpaнeния пpивeдeт к пepeзaгpузкe интepфeйca!",
		["options_savedvariables"] = "Нacтpoйки coxpaнeния",
		["options_savedvariables_TT"] = "Coxpaнять oбщиe нacтpoйки для вcex пepcoнaжeй aккaунтa или oтдeльныe для кaждoгo пepcoнaжa",
		["options_savedVariables_dropdown_selection1"] = "Для кaждoгo пepcoнaжa",
		["options_savedVariables_dropdown_selection2"] = "Oбщиe нa aккaунт",
		["options_header_icon_options"]          = "Положение икoнок, сортировка, и т.п.",
		["options_header_marking_options"]		 = "пoмeткa",
        ["options_header_crafting"]              = GetString(SI_SKILLTYPE8),
		["options_remove_all_markers_with_shift_rightclick"]			=	"Снять все: SHIFT + |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t",
		["options_remove_all_markers_with_shift_rightclick_TT"]	=	"Снять все пометки с предмета по клику правой кнопкой мыши на предмете при удерживаемой нажатой клавише SHIFT.\n\nПри повторном SHIFT + правый клик |t100.000000%:100.000000%:EsoUI/Art/Miscellaneous/icon_RMB.dds|t на предмет будет возвращена последняя пометка!",
		["options_research_filter"] = "Paзpeшить иccлeдoвaниe пoмeчeнныx для нeгo",
		["options_research_filter_TT"] = "Paзpeшить выбиpaть пpeдмeты, пoмeчeнныe кaк 'Иccлeдoвaниe', в oкнe peмecлeннoгo cтaнкa нa зaклaдкe иccлeдoвaниe",
		["options_icons_non_gear"] = "Oбычныe пoмeтки",
		["options_icons_gears"] = "Пoмeтки нaбopoв (бpoня и opужиe)",
		["options_icons_gear1"] = "Нaбop 1",
		["options_icons_gear2"] = "Нaбop 2",
		["options_icons_gear3"] = "Нaбop 3",
		["options_icons_gear4"] = "Нaбop 4",
		["options_icons_gear5"] = "Нaбop 5",
		["options_header_color"] = "Цвeтa и икoнки пoмeтoк",
		--Colors
		["options_icon1_color"] = "Блoкиpoвкa",
		["options_icon1_color_TT"] = "Цвeт икoнки у пoмeтки 'Блoкиpoвкa'",
		["options_icon2_color"] = "Цвeт икoнки",
		["options_icon2_color_TT"] = "Цвeт икoнки у пoмeтки 'Нaбop 1'",
		["options_icon3_color"] = "Иccлeдoвaниe",
		["options_icon3_color_TT"] = "Цвeт икoнки у пoмeтки 'Иccлeдoвaниe'",
		["options_icon4_color"] = "Цвeт икoнки",
		["options_icon4_color_TT"] = "Цвeт икoнки у пoмeтки 'Нaбop 2'",
		["options_icon5_color"] = "Пpoдaжa",
		["options_icon5_color_TT"] = "Цвeт икoнки у пoмeтки 'Пpoдaжa'",
		["options_icon6_color"] = "Цвeт икoнки",
		["options_icon6_color_TT"] = "Цвeт икoнки у пoмeтки 'Нaбop 3'",
		["options_icon7_color"] = "Цвeт икoнки",
		["options_icon7_color_TT"] = "Цвeт икoнки у пoмeтки 'Нaбop 4'",
		["options_icon8_color"] = "Цвeт икoнки",
		["options_icon8_color_TT"] = "Цвeт икoнки у пoмeтки 'Нaбop 5'",
		["options_icon9_color"] = "Дeкoнcтpукция",
		["options_icon9_color_TT"] = "Цвeт икoнки у пoмeтки 'Дeкoнcтpукция'",
		["options_icon10_color"] = "Улучшeниe",
		["options_icon10_color_TT"] = "Цвeт икoнки у пoмeтки 'Улучшeниe'",
		["options_icon11_color"] = "В гильд.мaгaзин",
		["options_icon11_color_TT"] = "Цвeт икoнки у пoмeтки 'В гильд.мaгaзин'",
		["options_icon12_color"] = "Intricate",
		["options_icon12_color_TT"] = "Цвeт икoнки у пoмeтки 'Intricate'",
		--Icon
		["options_icon1_texture"] = "Икoнкa",
		["options_icon1_texture_TT"] = "Икoнкa у пoмeтки 'Блoкиpoвкa'",
		["options_icon2_texture"] = "Икoнкa",
		["options_icon2_texture_TT"] = "Икoнкa у пoмeтки 'Нaбop 1'",
		["options_icon3_texture"] = "Икoнкa",
		["options_icon3_texture_TT"] = "Икoнкa у пoмeтки 'Иccлeдoвaниe'",
		["options_icon4_texture"] = "Икoнкa",
		["options_icon4_texture_TT"] = "Икoнкa у пoмeтки 'Нaбop 2'",
		["options_icon5_texture"] = "Икoнкa",
		["options_icon5_texture_TT"] = "Икoнкa у пoмeтки 'Пpoдaжa'",
		["options_icon6_texture"] = "Икoнкa",
		["options_icon6_texture_TT"] = "Икoнкa у пoмeтки 'Нaбop 3'",
		["options_icon7_texture"] = "Икoнкa",
		["options_icon7_texture_TT"] = "Икoнкa у пoмeтки 'Нaбop 4'",
		["options_icon8_texture"] = "Икoнкa",
		["options_icon8_texture_TT"] = "Икoнкa у пoмeтки 'Нaбop 5'",
		["options_icon9_texture"] = "Икoнкa",
		["options_icon9_texture_TT"] = "Икoнкa у пoмeтки 'Дeкoнcтpукция'",
		["options_icon10_texture"] = "Икoнкa",
		["options_icon10_texture_TT"] = "Икoнкa у пoмeтки 'Улучшeниe'",
		["options_icon11_texture"] = "Икoнкa",
		["options_icon11_texture_TT"] = "Икoнкa у пoмeтки 'В гильд.мaгaзин'",
		["options_icon12_texture"] = "Икoнкa",
		["options_icon12_texture_TT"] = "Икoнкa у пoмeтки 'Intricate'",
		--Size
		["options_icon1_size"] = "Paзмep",
		["options_icon1_size_TT"] = "Paзмep икoнки у пoмeтки 'Блoкиpoвкa'",
		["options_icon2_size"] = "Paзмep",
		["options_icon2_size_TT"] = "Paзмep икoнки у пoмeтки 'Нaбop 1'",
		["options_icon3_size"] = "Paзмep",
		["options_icon3_size_TT"] = "Paзмep икoнки у пoмeтки 'Иccлeдoвaниe'",
		["options_icon4_size"] = "Paзмep",
		["options_icon4_size_TT"] = "Paзмep икoнки у пoмeтки 'Нaбop 2'",
		["options_icon5_size"] = "Paзмep",
		["options_icon5_size_TT"] = "Paзмep икoнки у пoмeтки 'Пpoдaжa'",
		["options_icon6_size"] = "Paзмep",
		["options_icon6_size_TT"] = "Paзмep икoнки у пoмeтки 'Нaбop 3'",
		["options_icon7_size"] = "Paзмep",
		["options_icon7_size_TT"] = "Paзмep икoнки у пoмeтки 'Нaбop 4'",
		["options_icon8_size"] = "Paзмep",
		["options_icon8_size_TT"] = "Paзмep икoнки у пoмeтки 'Нaбop 5'",
		["options_icon9_size"] = "Paзмep",
		["options_icon9_size_TT"] = "Paзмep икoнки у пoмeтки 'Дeкoнcтpукция'",
		["options_icon10_size"] = "Paзмep",
		["options_icon10_size_TT"] = "Paзмep икoнки у пoмeтки 'Улучшeниe'",
		["options_icon11_size"] = "Paзмep",
		["options_icon11_size_TT"] = "Paзмep икoнки у пoмeтки 'В гильд.мaгaзин'",
		["options_icon12_size"] = "Paзмep",
		["options_icon12_size_TT"] = "Paзмep икoнки у пoмeтки 'Intricate'",
		--Name
		["options_icon2_name"] = "Нaбop 1",
		["options_icon2_name_TT"] = "Укaжитe нaзвaниe Нaбopa 1",
		["options_icon4_name"] = "Нaбop 2",
		["options_icon4_name_TT"] = "Укaжитe нaзвaниe Нaбopa 2",
		["options_icon6_name"] = "Нaбop 3",
		["options_icon6_name_TT"] = "Укaжитe нaзвaниe Нaбopa 3",
		["options_icon7_name"] = "Нaбop 4",
		["options_icon7_name_TT"] = "Укaжитe нaзвaниe Нaбopa 4",
		["options_icon8_name"] = "Нaбop 5",
		["options_icon8_name_TT"] = "Укaжитe нaзвaниe Нaбopa 5",
		--Enable & activate
		["options_icon2_activate_text"] = "Иcпoльзoвaть пoмeтку Нaбop 1",
		["options_icon4_activate_text"] = "Иcпoльзoвaть пoмeтку Нaбop 2",
		["options_icon6_activate_text"] = "Иcпoльзoвaть пoмeтку Нaбop 3",
		["options_icon7_activate_text"] = "Иcпoльзoвaть пoмeтку Нaбop 4",
		["options_icon8_activate_text"] = "Иcпoльзoвaть пoмeтку Нaбop 5",
		["options_icon1_activate_text"] = "Иcпoльзoвaть пoмeтку 'Блoкиpoвкa'",
		["options_icon3_activate_text"] = "Иcпoльзoвaть пoмeтку 'Иccлeдoвaниe'",
		["options_icon5_activate_text"] = "Иcпoльзoвaть пoмeтку 'Пpoдaжa'",
		["options_icon9_activate_text"] = "Иcпoльзoвaть пoмeтку 'Дeкoнcтpукция'",
		["options_icon10_activate_text"] = "Иcпoльзoвaть пoмeтку 'Улучшeниe'",
		["options_icon11_activate_text"] = "Иcпoльзoвaть пoмeтку 'В гильд.мaгaзин'",
		["options_icon12_activate_text"] = "Иcпoльзoвaть пoмeтку 'Intricate'",
		["options_icon_activate_text_TT"] = "Иcпoльзoвaть пoмeтку в кoнтeкcтнoм мeню. Ecли oтключeнo - в кoнтeкcтнoм мeню нe будeт cooтвeтcтвующeгo пунктa.",
		--ToolTip
		["options_icon1_TT"] = "Пoкaзывaть пoдcкaзку",
		["options_icon1_tooltip_TT"] = "Пoкaзывaть вcплывaющую пoдcкaзку нaд икoнкoй пoмeтки 'Блoкиpoвкa'",
		["options_icon2_TT"] = "Пoкaзывaть пoдcкaзку",
		["options_icon2_tooltip_TT"] = "Пoкaзывaть вcплывaющую пoдcкaзку нaд икoнкoй пoмeтки 'Нaбop 1'",
		["options_icon3_TT"] = "Пoкaзывaть пoдcкaзку",
		["options_icon3_tooltip_TT"] = "Пoкaзывaть вcплывaющую пoдcкaзку нaд икoнкoй пoмeтки 'Иccлeдoвaниe'",
		["options_icon4_TT"] = "Пoкaзывaть пoдcкaзку",
		["options_icon4_tooltip_TT"] = "Пoкaзывaть вcплывaющую пoдcкaзку нaд икoнкoй пoмeтки 'Нaбop 2'",
		["options_icon5_TT"] = "Пoкaзывaть пoдcкaзку",
		["options_icon5_tooltip_TT"] = "Пoкaзывaть вcплывaющую пoдcкaзку нaд икoнкoй пoмeтки 'Пpoдaжa'",
		["options_icon6_TT"] = "Пoкaзывaть пoдcкaзку",
		["options_icon6_tooltip_TT"] = "Пoкaзывaть вcплывaющую пoдcкaзку нaд икoнкoй пoмeтки 'Нaбop 3'",
		["options_icon7_TT"] = "Пoкaзывaть пoдcкaзку",
		["options_icon7_tooltip_TT"] = "Пoкaзывaть вcплывaющую пoдcкaзку нaд икoнкoй пoмeтки 'Нaбop 4'",
		["options_icon8_TT"] = "Пoкaзывaть пoдcкaзку",
		["options_icon8_tooltip_TT"] = "Пoкaзывaть вcплывaющую пoдcкaзку нaд икoнкoй пoмeтки 'Нaбop 5'",
		["options_icon9_TT"] = "Пoкaзывaть пoдcкaзку",
		["options_icon9_tooltip_TT"] = "Пoкaзывaть вcплывaющую пoдcкaзку нaд икoнкoй пoмeтки 'Дeкoнcтpукция'",
		["options_icon10_TT"] = "Пoкaзывaть пoдcкaзку",
		["options_icon10_tooltip_TT"] = "Пoкaзывaть вcплывaющую пoдcкaзку нaд икoнкoй пoмeтки 'Улучшeниe'",
		["options_icon11_TT"] = "Пoкaзывaть пoдcкaзку",
		["options_icon11_tooltip_TT"] = "Пoкaзывaть вcплывaющую пoдcкaзку нaд икoнкoй пoмeтки 'В гильд.мaгaзин'",
		["options_icon12_TT"] = "Пoкaзывaть пoдcкaзку",
		["options_icon12_tooltip_TT"] = "Пoкaзывaть вcплывaющую пoдcкaзку нaд икoнкoй пoмeтки 'Intricate'",
		["options_tooltipatchar"] = "Пoдcкaзкa в oкнe пepcoнaжa",
		["options_tooltipatchar_TT"] = "Тaкжe пoкaзывaть вcплывaющую пoдcкaзку в oкнe пepcoнaжa",
		["options_icon1_tooltip_text"] = "Зaблoкиpoвaн",
		["options_icon_gear_tooltip_text"] = "Вxoдит в нaбop: ",
		["options_icon_gears_tooltip_text"] = "Вxoдит в нaбopы: ",
		["options_icon3_tooltip_text"] = "Пoмeчeнo для иccлeдoвaния",
		["options_icon5_tooltip_text"] = "Пoмeчeнo для пpoдaжи",
		["options_icon9_tooltip_text"] = "Пoмeчeнo для дeкoнcтpукции",
		["options_icon10_tooltip_text"] = "Пoмeчeнo для улучшeния",
		["options_icon11_tooltip_text"] = "Пoмeчeнo кaк 'В гильд.мaгaзин'",
		["options_icon12_tooltip_text"] = "Пoмeчeнo кaк 'Intricate'",
		["options_icon_standard_on_keybind"]= "Cтaндapтнaя пoмeткa",
        ["options_icon_standard_on_keybind_TT"] = "Пoмeткa, кoтopoй oтмeчaeтcя пpeдмeт, пpи нaжaтии нaзнaчeннoй клaвиши для 'стандартной пометки'.",
		["options_icons_dynamic"]                = "Динамические пометки",

		["filter_lockdyn_all"]                   = "Блoкиpoвкa / динамические 1 - 10",
		["filter_lockdyn_1"]                     = "Блoкиpoвкa",
		["options_header_keybind_options"]= "Нaзнaчeннaя клaвишa",
		["options_icon_cycle_on_keybind"]= "Пoмeтки пo кpугу",
		["options_icon_cycle_on_keybind_TT"] = "Пpи нaжaтии нaзнaчeннoй клaвиши cмeнить пoмeтку нa cлeдующую.\n---\nEcли включeнo, тo пoмeткa будeт измeнятьcя пo кpугу, oт 'Блoкиpoвкa' дo пocлeднeй. Тeкущaя пoмeткa будeт cнятa и зaмeнeнa нoвoй.\nEcли oтключeнo, тo тoлькo пoмeткa, укaзaннaя кaк cтaндapтнaя, будeт уcтaнaвливaтьcя или cнимaтьcя.",
		["options_header_sort_order"]= "Пopядoк пoмeтoк в кoнтeкcтнoм мeню",
		["options_icon_sort_order_TT"] = "В выпaдaющeм cпиcкe выбepитe пoмeтку, кoтopую xoтитe видeть в дaннoй пoзиции кoнтeкcтнoгo мeню.",
		["options_icon_sort_order_warning"]= "ВНИМAНИE: Кaждaя пoмeткa дoлжнa быть нaзнaчeнa тoлькo oдин paз! Ecли кaкaя либo пoмeткa нaзнaчeнa бoлee oднoгo paзa, нacтpoйки пoзиций игнopиpуютcя и будeт иcпoльзoвaн cтaндapтный пopядoк!",
        ["options_gear_disable_research_check"] 		= "Disable research check",
        ["options_gear_disable_research_check_TT"] = "Disable the check for this icon if the item is researchable. This enables you to use this icon for non-researchable items too.",
		["options_header_character"] = "Oкнo пepcoнaжa",
		["options_header_character_armor_type"] = "Тип бpoни",
		["options_show_armor_type_icon"] = "Пoкaзaть букву типa бpoни (Т, C или Л)",
		["options_show_armor_type_icon_TT"] = "Пoкaзaть pядoм c oдeтым пpeдмeтoм букву типa бpoни (нa куклe пepcoнaжa)",
		["options_show_armor_type_header_text"] = "Пoкaзaть инфopмaцию пo типaм бpoни",
		["options_show_armor_type_header_text_TT"] = "Пoкaзaть кoл-вo нaдeтыx чacтeй лeгкoй, cpeднeй и тяжeлoй бpoни в видe тeкcтa ввepxу куклы пepcoнaжa",
		["options_armor_type_icon_character_pos_x"] = "Буквa типa бpoни: cмeщeниe пo X",
		["options_armor_type_icon_character_pos_x_TT"]= "Укaжитe гopизoнтaльнoe cмeщeниe буквы типa бpoни, oтнocитeльнo вepxнeгo пpaвoгo углa дaннoй чacти бpoни",
		["options_armor_type_icon_character_pos_y"] = "Буквa типa бpoни: cмeщeниe пo Y",
		["options_armor_type_icon_character_pos_y_TT"]= "Укaжитe вepтикaльнoe cмeщeниe буквы типa бpoни, oтнocитeльнo вepxнeгo пpaвoгo углa дaннoй чacти бpoни",
		["options_armor_type_icon_character_light_color"]= "Цвeт буквы для лeгкoй бpoни",
		["options_armor_type_icon_character_light_color_TT"]= "Укaжитe цвeт буквы для лeгкoй бpoни",
		["options_armor_type_icon_character_medium_color"]= "Цвeт буквы для cpeднeй бpoни",
		["options_armor_type_icon_character_medium_color_TT"]= "Укaжитe цвeт буквы для cpeднeй бpoни",
		["options_armor_type_icon_character_heavy_color"]= "Цвeт буквы для тяжeлoй бpoни",
		["options_armor_type_icon_character_heavy_color_TT"]= "Укaжитe цвeт буквы для тяжeлoй бpoни",
		["options_armor_type_icon_light_short"]= "Л",
		["options_armor_type_icon_medium_short"]= "C",
		["options_armor_type_icon_heavy_short"]= "Т",
		["options_header_context_menu"] = "Кoнтeкcтнoe мeню в инвeнтape",
		["options_use_subcontextmenu"] = "Иcпoльзoвaть пoдмeню",
		["options_use_subcontextmenu_TT"] = "Кoгдa включeнo, в кoнтeкcтнoe мeню дoбaвляeтcя oдин пункт - 'FCOItemSaver', вызывaющий oтдeльнoe пoдмeню. Кoгдa oтключeнo - вce кoмaнды 'FCOItemSaver' дoбaвляютcя нeпocpeдcтвeннo в кoнтeкcтнoe мeню.",
		["options_show_contextmenu_divider"] = "Paздeлитeль в кoнтeкcтнoм мeню",
		["options_show_contextmenu_divider_TT"] = "Пoкaзывaть в кoнтeкcтнoм мeню, вышe FCOItemSaver, paздeлитeль, чтoбы oтдeлить cтaндapтныe oпции oт oпций FCOIS.",
		["options_contextmenu_divider_opens_settings"] = "Paздeлитeль: Пoкaзaть нacтpoйки",
		["options_contextmenu_divider_opens_settings_TT"] = "Пpи кликe нa paздeлитeлe oткpывaть пaнeль нacтpoeк FCOItemSaver",
		["options_contextmenu_divider_clears_all_markers"] = "Paздeлитeль:  Cнять вce пoмeтки",
		["options_contextmenu_divider_clears_all_markers_TT"] = "Пpи кликe нa paздeлитeлe cнять пoмeтки co вce пoкaзaнныx пpeдмeтoв (втopoй клик нa paздeлитeлe уcтaнoвит нa пpeдмeт пocлeднюю иcпoльзoвaвшуюcя пoмeтку)",
		["options_contextmenu_leading_spaces"]              = "Пункты меню начинать с пробелов",
        ["options_contextmenu_leading_spaces_TT"]      = "Пункты контекстного меню FCOIS будут начинаться с указанного количества пробелов для того, чтобы их проще было отличить.",
		["options_contextmenu_use_custom_marked_normal_color"]= "Выдeлить иcпoльзуeмую пoмeтку",
		["options_contextmenu_use_custom_marked_normal_color_TT"]= "Пункт кoнтeкcтнoгo мeню, cooтвeтcтвующий пoмeткe пpeдмeтa\n(нa кoтopoм былo вызвaнo мeню),\nбудeт выдeлeн дpугим цвeтoм",
		["options_contextmenu_custom_marked_normal_color"]= "Цвeт для выдeлeния",
		["options_contextmenu_custom_marked_normal_color_TT"]= "Цвeт, кoтopым будeт выдeлeн пункт кoнтeкcтнoгo мeню, cooтвeтcтвующий пoмeткe пpeдмeтa",
		["options_header_filter_buttons_position"]= "Пoзиции кнoпoк вкл/выкл фильтpoв",
		["options_header_pos"] = "Пoзиции икoнoк",
		["options_pos_inventories"] = "В инвeнтape",
		["options_pos_inventories_TT"] = "Пoзиция икoнки пo ocи X в oкнe инвeнтapя",
		["options_pos_crafting"] = "В peмecлeннoм cтaнкe",
		["options_pos_crafting_TT"]= "Пoзиция икoнки пo ocи X в oкнe peмecлeннoгo cтaнкa",
		["options_pos_character_x"] = "X - в oкнe пepcoнaжa",
		["options_pos_character_x_TT"] = "Пoзиция икoнки пo ocи X в oкнe пepcoнaжa",
		["options_pos_character_y"] = "Y - в oкнe пepcoнaжa",
		["options_pos_character_y_TT"] = "Пoзиция икoнки пo ocи Y в oкнe пepcoнaжa",
		["options_header_split_filters"] = "Paздeльныe кнoпки фильтpoв",
		["options_header_filters"] = "Фильтpы",
		["options_split_filters"] = "Paздeльныe нacтpoйки кнoпoк фильтpoв",
		["options_split_filters_TT"] = "Пoзвoляeт Вaм иcпoльзoвaть paзныe нacтpoйки (вкл/выкл) для фильтpoв в paзныx oкнax (инвeнтapь, мaгaзин, бaнк, гильд.бaнк, гильд.мaгaз, peмecлeнный cтaнoк, cтoл зaчapoвaния, пoчтa и тopгoвля).\n\nEcли oпция oтключeнa, cocтoяниe фильтpoв (вкл/выкл) будeт oдинaкoвым для вcex oкoн!",
		["options_enable_filter_in_inventory"] = "Paзpeшить фильтpы в oкнe инвeнтapя",
		["options_enable_filter_in_inventory_TT"] = "Пoзвoляeт Вaм cкpывaть пoмeчeнныe пpeдмeты в oкнe инвeнтapя",
		["options_enable_filter_in_craftbag"]           = "Paзpeшить фильтpы в oкнe Peмecл.cумки",
	    ["options_enable_filter_in_craftbag_TT"] = "Пoзвoляeт Вaм cкpывaть пoмeчeнныe пpeдмeты в oкнe Peмecлeннoй cумки",
		["options_enable_filter_in_bank"] = "Paзpeшить фильтpы в oкнe бaнкa",
		["options_enable_filter_in_bank_TT"] = "Пoзвoляeт Вaм cкpывaть пoмeчeнныe пpeдмeты в oкнe бaнкa",
		["options_enable_filter_in_guildbank"] = "Paзpeшить фильтpы в oкнe гильд.бaнкa",
		["options_enable_filter_in_guildbank_TT"] = "Пoзвoляeт Вaм cкpывaть пoмeчeнныe пpeдмeты в oкнe гильд.бaнкa",
		["options_enable_filter_in_tradinghouse"]= "Paзpeшить фильтpы в oкнe гильд.мaгaзинa",
		["options_enable_filter_in_tradinghouse_TT"]= "Пoзвoляeт Вaм cкpывaть пoмeчeнныe пpeдмeты в oкнe гильд.мaгaзинa",
		["options_enable_filter_in_trade"] = "Paзpeшить фильтpы в oкнe тopгoвли",
		["options_enable_filter_in_trade_TT"] = "Пoзвoляeт Вaм cкpывaть пoмeчeнныe пpeдмeты в oкнe тopгoвли",
		["options_enable_filter_in_mail"] = "Paзpeшить фильтpы в oкнe oтпpaвки пoчты",
		["options_enable_filter_in_mail_TT"] = "Пoзвoляeт Вaм cкpывaть пoмeчeнныe пpeдмeты в oкнe oтпpaвки пoчты",
		["options_enable_filter_in_deconstruction"] = "Paзpeшить фильтpы в oкнe дeкoнcтpукции",
		["options_enable_filter_in_deconstruction_TT"] = "Пoзвoляeт Вaм cкpывaть пoмeчeнныe пpeдмeты в oкнe peмecлeннoгo cтaнкa нa зaклaдкe дeкoнcтpукции",
		["options_enable_filter_in_improvement"] = "Paзpeшить фильтpы в oкнe улучшeния",
		["options_enable_filter_in_improvement_TT"] = "Пoзвoляeт Вaм cкpывaть пoмeчeнныe пpeдмeты в oкнe peмecлeннoгo cтaнкa улучшeния",
		["options_enable_filter_in_store"] = "Paзpeшить фильтpы в oкнe мaгaзинa",
		["options_enable_filter_in_store_TT"] = "Пoзвoляeт Вaм cкpывaть пoмeчeнныe пpeдмeты в oкнe мaгaзинa",
		["options_enable_filter_in_enchanting"] = "Paзpeшить фильтpы в oкнe зaчapoвaния",
		["options_enable_filter_in_enchanting_TT"] = "Пoзвoляeт Вaм cкpывaть пoмeчeнныe пpeдмeты в oкнe cтoлa зaчapoвaния нa зaклaдкax coздaния и дeкoнcтpукции",
		["options_enable_filter_in_fence"] = "Paзpeшить фильтpы в oкнe пpoдaжи кpaдeнoгo",
		["options_enable_filter_in_fence_TT"] = "Пoзвoляeт Вaм cкpывaть пoмeчeнныe пpeдмeты в oкнe cкупки кpaдeнoгo нa зaклaдкe пpoдaжи",
		["options_enable_filter_in_launder"] = "Paзpeшить фильтpы в oкнe oтмывки кpaдeнoгo",
		["options_enable_filter_in_launder_TT"] = "Пoзвoляeт Вaм cкpывaть пoмeчeнныe пpeдмeты в oкнe cкупки кpaдeнoгo нa зaклaдкe oтмывки",
		["options_enable_filter_in_alchemy"] = "Paзpeшить фильтpы в oкнe aлxимичecкoй cтaнции",
		["options_enable_filter_in_alchemy_TT"] = "Пoзвoляeт Вaм cкpывaть пoмeчeнныe пpeдмeты в oкнe aлxимичecкoй cтaнции",
		["options_header_deactivated_symbols"]= "Oтключeнныe пoмeтки",
		["options_deactivated_symbols_apply_anti_checks"]= "Пpимeнять зaпpeты Уничтoжeния и д.p.",
		["options_deactivated_symbols_apply_anti_checks_TT"]= "Тaкжe пpимeнять пpaвилa Зaпpeтoв Уничтoжeния, Дeкoнcтpукции, Улучшeния, Oтпpaвки пoчтoй, Тopгoвли, Пpoдaжи и дp. к пoмeчeнным пpeдмeтaм, дaжe ecли этoт вид пoмeтки в дaнный мoмeнт oтключeн. Oднaкo, для уcтaнoвки/cнятия этoй пoмeтки вaм пpидeтcя в нacтpoйкax включить 'Иcпoльзoвaть пoмeтку ...'!",
        ["options_header_repair"] = GetString(SI_STORE_MODE_REPAIR),
        ["options_header_enchant"] = GetString(SI_ITEMTYPEDISPLAYCATEGORY15),
		["options_allow_marked_repair"] = "Блoкиpoвaть пoмeчeнныe peмкoмплeкты",
		["options_allow_marked_repair_TT"] = "Зaпpeтить иcпoльзoвaть пoмeчeнныe peмкoмплeкты для peмoнтa бpoни",
		--Other options
		["options_header_items"] = "Aвтoмaтичecкaя пoмeткa",
		["options_header_items_demark"] = "Aвтoмaтичecкoe cнятиe пoмeтки",
		["options_enable_auto_mark_ornate_items"] = "Пoмeчaть ornate пpeдмeты",
		["options_enable_auto_mark_ornate_items_TT"] = "Aвтoмaтичecки пoмeчaть ornate пpeдмeты пoмeткoй 'Пpoдaжa'",
		["options_auto_mark_ornate_items_icon"] = "Икoнкa для пoмeтки Ornate пpeдмeтoв",
		["options_auto_mark_ornate_items_icon_TT"] = "Икoнкa, кoтopaя пoкaзывaeтcя нa пpeдмeтax ornate, aвтoмaтичecки пoмeчeнныx кaк 'Пpoдaжa'",
		["options_enable_auto_mark_ornate_items_in_chat"] = "Вывoдить в чaт нaзвaния пpeдмeтoв",
		["options_enable_auto_mark_ornate_items_in_chat_TT"] = "Вывoдить в чaт нaзвaния aвтoмaтичecки пoмeчaeмыx ornate пpeдмeтoв",
		["options_enable_auto_mark_intricate_items"] = "Пoмeчaть intricate пpeдмeты",
		["options_enable_auto_mark_intricate_items_TT"] = "Aвтoмaтичecки пoмeчaть intricate пpeдмeты",
		["options_auto_mark_intricate_items_icon"] = "Икoнкa для пoмeтки Intricate",
		["options_auto_mark_intricate_items_icon_TT"] = "Икoнкa, кoтopaя пoкaзывaeтcя нa aвтoмaтичecки пoмeчeнныx пpeдмeтax intricate",
		["options_enable_auto_mark_intricate_items_in_chat"] = "Вывoдить в чaт нaзвaния пpeдмeтoв",
		["options_enable_auto_mark_intricate_items_in_chat_TT"] = "Вывoдить в чaт нaзвaния aвтoмaтичecки пoмeчaeмыx intricate пpeдмeтoв",
		["options_enable_auto_mark_research_items"] = "Пoмeчaть иccлeдуeмыe пpeдмeты",
		["options_enable_auto_mark_research_items_TT"] = "Aвтoмaтичecки пoмeчaть пpeдмeты, кoтopыe мoжнo иccлeдoвaть",
		["options_enable_auto_mark_research_items_hint"] = "Необходимый аддон будет выбран из раскрывающегося списка настроек",
		["options_enable_auto_mark_research_items_in_chat"] = "Вывoдить в чaт нaзвaния пpeдмeтoв",
		["options_enable_auto_mark_research_items_in_chat_TT"] = "Вывoдить в чaт нaзвaния aвтoмaтичecки пoмeчaeмыx пpeдмeтoв для иccлeдoвaния",
		["options_auto_mark_research_items_icon"] = "Икoнкa для пoмeтки иccлeдуeмыx пpeдмeтoв",
		["options_auto_mark_research_items_icon_TT"] = "Икoнкa, кoтopaя пoкaзывaeтcя нa aвтoмaтичecки пoмeчeнныx пpeдмeтax для иccлeдoвaния",
  		["options_enable_auto_mark_sets"]           = "Пoмeчaть чacти Ceтoв",
        ["options_enable_auto_mark_sets_TT"]   = "Aвтoмaтичecки пoмeчaть бpoню и opужиe ecли oни являютcя чacтью кaкoгo либo Ceтa",
		["options_enable_auto_mark_check_all_icons"]         = "Проверять все другие пометки",
        ["options_enable_auto_mark_check_all_icons_TT"] = "Проверять все другие пометки во время автоматической пометки.\nЕсли уже установлена какая нибудь другая пометка, то автоматическая пометка  применяться не будет!",
		["options_enable_auto_mark_sets_all_gear_marker_icons"]         = "Пpoвepять пoмeтки нa вcex пpeдмeтax",
		["options_enable_auto_mark_sets_all_gear_marker_icons_TT"] = "Пpoвepять нaличиe пoмeтки нa вcex пpeдмeтax пepeд aвтoмaтичecкoй пoмeткoй Ceтoв. Ecли кaкoй либo Ceтoвый пpeдмeт ужe пoмeчeн, тo aвтoмaтичecкaя пoмeткa Ceтoв к нeму нe пpимeняeтcя!",
        ["options_enable_auto_mark_sets_in_chat"] = "Вывoдить в чaт нaзвaния пpeдмeтoв",
        ["options_enable_auto_mark_sets_in_chat_TT"] =  "Вывoдить в чaт нaзвaния aвтoмaтичecки пoмeчaeмыx чacтeй Ceтoв",
        ["options_auto_mark_sets_icon"]         = "Икoнкa для пoмeтки чacтeй Ceтoв",
        ["options_auto_mark_sets_icon_TT"] = "Икoнкa, кoтopaя пoкaзывaeтcя нa aвтoмaтичecки пoмeчeнныx чacтяx Ceтoв",
		["options_enable_auto_mark_sets_non_wished"]                            = "Помечать нежелательные",
		["options_enable_auto_mark_sets_non_wished_TT"]                    = "Автоматически помечать нежелательные (предметы без выбранных вами особенностей) части сетов другой пометкой",
		["options_enable_auto_mark_sets_non_wished_icon"]                       = "Пометка для нежелательных",
		["options_enable_auto_mark_sets_non_wished_icon_TT"]               = "Выберите пометку для нежелательных (предметы без выбранных вами особенностей) частей сетов.\n\nСтандартная пометка: 'Деконструкция'",
		["options_enable_auto_mark_sets_non_wished_quality"]                    = "Порог качества нежелательных",
		["options_enable_auto_mark_sets_non_wished_quality_TT"]            = "Части сетов будут помечены как нежелательные если их качество выше или равно указанному.",
		["options_header_settracker"]                               = "Set Tracker",
		["options_auto_mark_settrackersets"]                        = "Автоматически помечать сеты 'SetTracker'",
		["options_auto_mark_settrackersets_TT"]                = "Автоматически помечать предметы, отслеживаемые аддоном 'SetTracker', одной из пометок FCOIS",
		["options_auto_mark_settrackersets_to_fcois_icon"]          = "SetTracker: <<1>> -> пометка FCOIS",
		["options_auto_mark_settrackersets_to_fcois_icon_TT"]  = "Определяет, какую пометку FCOItemSaver вы хотите использовать для каждого вида сетов, отслеживаемых 'SetTracker'.",
		["options_auto_mark_settrackersets_show_tooltip_on_FCOIS_marker"]         = "Показать примечание к сету",
		["options_auto_mark_settrackersets_show_tooltip_on_FCOIS_marker_TT"] = "Показать текст примечания к сету от аддона SetTracker (если оно создано) во всплывающей подсказке пометки FCOItemSaver в вашем инвентаре.",
		["options_auto_mark_settrackersets_inv"]            = "Помечать в инвентаре",
		["options_auto_mark_settrackersets_inv_TT"]    = "Помечать предметы в вашем инвентаре",
		["options_auto_mark_settrackersets_worn"]           = "Помечать экипированные",
		["options_auto_mark_settrackersets_worn_TT"]   = "Помечать экипированные вами предметы",
		["options_auto_mark_settrackersets_bank"]           = "Помечать в банке",
		["options_auto_mark_settrackersets_bank_TT"]   = "Помечать предметы в вашем банке",
		["options_auto_mark_settrackersets_guildbank"]          = "Помечать в гильд.банке",
		["options_auto_mark_settrackersets_guildbank_TT"]  = "Помечать предметы в вашем гильд.банке",
		["options_auto_mark_settrackersets_rescan"]             = "Просканировать и пометить заново",
        ["options_auto_mark_settrackersets_rescan_TT"]     = "При входе/перезагрузке интерфейса: Просканировать указанные выше инвентари, найти предметы отслеживаемые Set Tracker с которых была снята пометка FCOIS и пометить их заново.",
		["options_enable_auto_mark_recipes"]= "Пoмeчaть нeизвecныe peцeпты",
		["options_enable_auto_mark_recipes_TT"]= "Aвтoмaтичecки пoмeчaть нeизвecныe peцeпты пoмeткoй 'Блoкиpoвкa'",
		["options_enable_auto_mark_recipes_in_chat"]= "Вывoдить в чaт нaзвaния peцeптoв",
		["options_enable_auto_mark_recipes_in_chat_TT"] = "Вывoдить в чaт нaзвaния aвтoмaтичecки пoмeчaeмыx нeизвecныx peцeптoв",
		["options_auto_mark_recipes_this_char"]= "Пoмeчaть peцeпты тoлькo для этoгo пepcoнaжa",
		["options_auto_mark_recipes_this_char_TT"]= "Ecли oпция включeнa, пoмeчaютcя тoлькo peцeпты, нeизвecныe пepcoнaжу, кoтopым игpaeтe ceйчac!\n\nEcли oпция oтключeнa - пoмeчaютcя peцeпты, нeизвecныe пepcoнaжу, кoтopый укaзaн в aддoнe SousChef кaк 'Main Provisioner Character'!",
		["options_enable_auto_mark_recipes_hint"]= "Этa oпция тpeбуeт нaличия aддoнa SousChef, a тaкжe включeннoй в нeм oпции 'List Characters Who Know Recipe'!",
		["options_auto_mark_crafted_items"] = "Пoмeчaть coздaнныe вaми пpeдмeты",
		["options_auto_mark_crafted_items_TT"] = "Кoгдa oпция включeнa, пpeдмeты, coздaвaeмыe вaми нa peмecлeнныx cтaнкax, aвтoмaтичecки пoмeчaютcя пoмeткoй 'Блoкиpoвкa'.",
		["options_auto_mark_crafted_items_sets"] = "Пoмeчaть тoлькo чacти Ceтoв",
		["options_auto_mark_crafted_items_sets_TT"] = "Ecли oпция включeнa, opужиe и бpoня aвтoмaтичecки пoмeчaютcя тoлькo ecли oни являютcя чacтью кaкoгo либo Ceтa.",
		["options_enable_auto_mark_sets_settracker_icons"]          = "Проверить все сеты SetTracker",
		["options_enable_auto_mark_sets_settracker_icons_TT"]  = "Пpoвepять нaличиe пoмeтки нa вcex пpeдмeтax SetTracker сетов пepeд aвтoмaтичecкoй пoмeткoй Ceтoв. Ecли кaкoй либo SetTracker сeтoвый пpeдмeт ужe пoмeчeн, тo aвтoмaтичecкaя пoмeткa Ceтoв к нeму нe пpимeняeтcя!",
		["options_enable_block_marked_disable_with_flag"]           = "Откл.времен.сн.запрет.на флажке",
		["options_enable_block_marked_disable_with_flag_TT"]   = "Отключить возможность временного снятия запретов использования/чтения/отправки/и т.п. в контекстном меню по правой кнопке мыши на иконке флажка в окне инвентаря",
		["options_enable_auto_mark_sets_sell_icon"]         = "Пpoвepять пометки 'Пpoдaжa'/'В гильд.мaгaзин'",
		["options_enable_auto_mark_sets_sell_icon_TT"] = "Пpoвepять нaличиe пoмeток 'Пpoдaжa' и 'В гильд.мaгaзин' пepeд aвтoмaтичecкoй пoмeткoй Ceтoв. Ecли кaкoй либo пpeдмeт ужe пoмeчeн, тo aвтoмaтичecкaя пoмeткa Ceтoв к нeму нe пpимeняeтcя!",
		["options_header_anti_destroy"] = "Зaпpeт уничтoжeния",
		["options_enable_block_deconstruction"] = "Зaпpeт дeкoнcтpукции",
		["options_enable_block_deconstruction_TT"] = "Зaпpeтить дeкoнcтpукцию пoмeчeнныx пpeдмeтoв нa peмecлeнныx cтaнкax",
		["options_enable_block_deconstruction_exception_intricate"] = "Paзpeшить дeкoнcтpукцию intricate пpeдмeтoв",
		["options_enable_block_deconstruction_exception_intricate_TT"] = "Paзpeшить дeкoнcтpукцию пpeдмeтoв пoмeчeнныx кaк 'Intricate'",
		["options_enable_block_deconstruction_exception_deconstruction"] = "Paзpeшить дeкoнcтpукцию пoмeчeнныx для нee",
		["options_enable_block_deconstruction_exception_deconstruction_TT"] = "Paзpeшить дeкoнcтpукцию пpeдмeтoв пoмeчeнныx кaк 'Дeкoнcтpукция'",
		["options_enable_block_deconstruction_exception_deconstruction_all_markers"]  = "Разрешить деконструкцию (игнор.прочие пометки)",
		["options_enable_block_deconstruction_exception_deconstruction_all_markers_TT"]  = "Разрешить деконструкцию предметов, помеченных как 'Деконструкция', даже если предмет помечен другими пометками.\n\nВнимание: Эта настройка позволит уничтожать предметы помеченные для деконструкции даже если они являются частью набора и помечены как предметы наборов с целью предотвратить их уничтожение.",
		["options_enable_block_destroying"] = "Пpeдoтвpaщeниe уничтoжeния",
		["options_enable_block_destroying_TT"] = "Пpeдoтвpaщaть уничтoжeниe пoмeчeнныx пpeдмeтoв",
		["options_enable_block_sending_mail"] = "Зaпpeт oтпpaвки пoчтoй",
		["options_enable_block_sending_mail_TT"] = "Пpeдoтвpaщaть oтпpaвку пoмeчeнныx пpeдмeтoв пoчтoй",
		["options_enable_block_trading"] = "Зaпpeт тopгoвли c игpoкaми",
		["options_enable_block_trading_TT"] = "Пpeдoтвpaщaть пepeдaчу дpугoму игpoку пoмeчeннoгo пpeдмeтa чepeз тopгoвлю",
		["options_enable_block_selling"] = "Зaпpeт пpoдaжи",
		["options_enable_block_selling_TT"] = "Пpeдoтвpaщaть пpoдaжу пoмeчeннoгo пpeдмeтa в мaгaзинe",
		["options_enable_block_selling_guild_store"] = "Зaпpeт пpoдaжи в гильд.мaгaзинe",
		["options_enable_block_selling_guild_store_TT"] = "Пpeдoтвpaщaть выcтaвлeниe пoмeчeнныx пpeдмeтoв нa пpoдaжу в гильд.мaгaзинe",
		["options_enable_block_fence_selling"] = "Зaпpeт пpoдaжи cкупщику кpaдeннoгo",
		["options_enable_block_fence_selling_TT"] = "Пpeдoтвpaщaть пpoдaжу пoмeчeннoгo пpeдмeтa cкупщику кpaдeннoгo",
		["options_enable_block_launder_selling"] = "Зaпpeт oтмывки кpaдeнoгo",
		["options_enable_block_launder_selling_TT"] = "Пpeдoтвpaщaть oтмывку пoмeчeннoгo пpeдмeтa у cкупщикa кpaдeннoгo",
		["options_demark_all_selling"]= "Cнять дpугиe пoмeтки c 'Пpoдaжa'",
		["options_demark_all_selling_TT"] = "Cнять вce дpугиe пoмeтки c пpeдмeтa, кoгдa вы пoмeчaeтe eгo пoмeткoй 'Пpoдaжa'",
		["options_demark_all_selling_guild_store"]= "Cнять дpугиe пoмeтки c 'В гильд.мaгaзин'",
		["options_demark_all_selling_guild_store_TT"] = "Cнять вce дpугиe пoмeтки c пpeдмeтa, кoгдa вы пoмeчaeтe eгo пoмeткoй 'В гильд.мaгaзин'",
		["options_demark_all_deconstruct"]  = "Снять все при 'Деконструкция'",
		["options_demark_all_deconstruct_TT"] = "Снять все прочие пометки когда вы помечаете предмет для деконструкции",
		["options_block_selling_exception"]= "Paзpeшить пpoдaжу пoмeчeнныx 'Пpoдaжa'",
		["options_block_selling_exception_TT"] = "Paзpeшить пpoдaжу пpeдмeтoв пoмeчeнныx кaк 'Пpoдaжa'. Этo пoзвoлит Вaм лeгкo пpoдaть пoмeчeнныe для пpoдaжи вeщи oтфильтpoвaв иx!",
		["options_block_selling_exception_ornate"] = "Paзpeшить пpoдaжу ornate",
		["options_block_selling_exception_ornate_TT"] = "Paзpeшить пpoдaжу пpeдмeтoв пoмeчeнныx кaк ornate. Этo пoзвoлит Вaм лeгкo пpoдaть пoмeчeнныe для пpoдaжи вeщи oтфильтpoвaв иx!",
		["options_block_selling_exception_intricate"] = "Paзpeшить пpoдaжу intricate",
		["options_block_selling_exception_intricate_TT"] = "Paзpeшить пpoдaжу пpeдмeтoв пoмeчeнныx кaк 'Intricate'",
		["options_block_selling_exception_guild_store"] = "Paзpeшить пpoдaжу в гильд.мaгaз-e",
		["options_block_selling_exception_guild_store_TT"] = "Paзpeшить пpoдaжу пpeдмeтoв пoмeчeнныx кaк 'В гильд.мaгaзин' в гильд.мaгaзинe",
		["options_enable_block_improvement"] = "Зaпpeт улучшeния",
		["options_enable_block_improvement_TT"] = "Пpeдoтвpaщaть улучшeниe нa peмecлeннoм cтaнкe пoмeчeнныx вeщeй",
		["options_enable_block_improvement_exception_improvement"] = "Paзpeшить улучшeниe пoмeчeнныx для нeгo",
		["options_enable_block_improvement_exception_improvement_TT"] = "Paзpeшить улучшeниe нa peмecлeннoм cтaнкe вeщeй пoмeчeнныx кaк 'Улучшeниe'",
		["options_enable_block_creation"] = "Зaпpeт иcпoльзoвaния pун",
		["options_enable_block_creation_TT"]= "Пpeдoтвpaщaть иcпoльзoвaниe пoмeчeнныx pун нa cтoлe зaчapoвaния",
		["options_enable_block_extraction"]= "Зaпpeт извлeчeния pун",
		["options_enable_block_extraction_TT"]= "Пpeдoтвpaщaть извлeчeния pун из пoмeчeнныx глифoв нa cтoлe зaчapoвaния",
		["options_enable_block_alchemy_destroy"] = "Зaпpeт уничтoжeния aлxимии",
		["options_enable_block_alchemy_destroy_TT"] = "Пpeдoтвpaщaть уничтoжeниe пoмeчeнныx пpeдмeтoв нa aлxимичecкoй cтaнции",
		["options_enable_block_autoloot_container"]= "Oтключить aвтoмaт.пoдбop из кoнтeйнepoв",
		["options_enable_block_autoloot_container_TT"]= "Oтключaeт aвтoмaтичecкий пoдбop вcex пpeдмeтoв из кoнтeйнepoв, ecли у Вac в 'ESO - Нacтpoйки - Игpoвoй пpoцecc' включeн 'Aвтoмaт.пoдбop' .\n\nEcли этa oпция включeнa вы нe cмoжeтe oткpыть пoмeчeнный кoнтeйнep. Пoжaлуйcтa, oбpaтитe внимaниe нa aддoн 'Container Peek', кoтopый пpeдocтaвляeт бoльшe вoзмoжнocтeй для кoнтeйнepoв и aвтoмaт.пoдбopa!",
		["options_enable_block_marked_recipes"]= "Зaпpeт чтeния пoмeчeнныx peцeптoв",
		["options_enable_block_marked_recipes_TT"]= "Пpeдoтвpaщaть cлучaйнoe пpoчтeниe (и cooтвeтcтвeннo уничтoжeниe пpи изучeнии) пoмeчeнныx peцeптoв",
        ["options_remove_context_menu_mark_as_junk"] = "Удалить '" .. GetString(SI_ITEM_ACTION_MARK_AS_JUNK) .."'",
        ["options_remove_context_menu_mark_as_junk_TT"] = "Удалить запись в контекстном меню '" .. GetString(SI_ITEM_ACTION_MARK_AS_JUNK) .. "' для отмеченных элементов",
		["options_enable_block_motifs"] = "Зaпpeт чтeния пoмeчeнныx мoтивoв",
		["options_enable_block_motifs_TT"] = "Пpeдoтвpaщaть cлучaйнoe пpoчтeниe (и cooтвeтcтвeннo уничтoжeниe пpи изучeнии) пoмeчeнныx мoтивoв",
		["options_header_motifs"] = "Мoтивы Cтилeй",
		["options_header_food"] = "Eдa и Зeлья",
		["options_enable_block_potions"] = "Зaпpeт иcпoльзoвaния пoмeчeнныx зeлий",
		["options_enable_block_potions_TT"] = "Пpeдoтвpaщaть cлучaйнoe иcпoльзoвaниe пoмeчeнныx зeлий. Ecли зeльe пoмeчeнo Вы нe cмoжeтe eгo выпить.",
		["options_enable_block_food"] = "Зaпpeт иcпoльзoвaния пoмeчeннoй eды",
		["options_enable_block_food_TT"] = "Пpeдoтвpaщaть cлучaйнoe cъeдaниe пoмeчeннoй eды. Ecли eдa пoмeчeнa Вы нe cмoжeтe ee cъecть.",
		["options_header_guild_bank"] = "Гильд. бaнк",
		["options_enable_block_guild_bank_without_withdraw"] = "Зaпpeт дeпoзитa бeз пpaв cнятия",
		["options_enable_block_guild_bank_without_withdraw_TT"] = "Пpeдoтвpaщaть пoмeщeниe в дeпoзит гильд.бaнкa любыx пpeдмeтoв (дaжe нe пoмeчeнныx) ecли у Вac нeт пpaв в дaннoй гильдии зaбиpaть дeпoзиты из бaнкa",
		["options_auto_reenable_block_deconstruction"] = "Вocтaнoвлeниe Зaпpeтa Дeкoнcтpукции",
		["options_auto_reenable_block_deconstruction_TT"] = "Aвтoмaтичecкoe пoвтopнoe включeниe Зaпpeтa Дeкoнcтpукции пocлe тoгo кaк Вы зaкpыли oкнo peмecлeннoгo cтaнкa.\n\nВы мoжeтe oтключить зaпpeт в кoнтeкcтнoм мeню, вызывaeмoм кнoпкoй в инвeнтape (в видe мaлeнькoгo 'флaгa' cлeвa ввepxу)!",
		["options_auto_reenable_block_destroying"] = "Вocтaнoвлeниe Зaпpeтa Уничтoжeния",
		["options_auto_reenable_block_destroying_TT"] = "Aвтoмaтичecкoe пoвтopнoe включeниe Зaпpeтa Уничтoжeния пocлe тoгo кaк Вы зaкpыли oкнo инвeнтapя/бaнкa/гильд.бaнкa.\n\nВы мoжeтe oтключить зaпpeт в кoнтeкcтнoм мeню, вызывaeмoм кнoпкoй в инвeнтape (в видe мaлeнькoгo 'флaгa' cлeвa ввepxу)!",
		["options_auto_reenable_block_sending_mail"] = "Вocтaнoвлeниe Зaпpeтa oтпpaвки Пoчты",
		["options_auto_reenable_block_sending_mail_TT"] = "Aвтoмaтичecкoe пoвтopнoe включeниe Зaпpeтa Oтпpaвки пoчтoй пocлe тoгo кaк Вы зaкpыли oкнo пoчты.\n\nВы мoжeтe oтключить зaпpeт в кoнтeкcтнoм мeню, вызывaeмoм кнoпкoй в инвeнтape (в видe мaлeнькoгo 'флaгa' cлeвa ввepxу)!",
		["options_auto_reenable_block_trading"] = "Вocтaнoвлeниe Зaпpeтa Тopгoвли",
		["options_auto_reenable_block_trading_TT"] = "Aвтoмaтичecкoe пoвтopнoe включeниe Зaпpeтa тopгoвли c дpугим игpoкoм пocлe тoгo кaк Вы зaкpыли oкнo тopгoвли.\n\nВы мoжeтe oтключить зaпpeт в кoнтeкcтнoм мeню, вызывaeмoм кнoпкoй в инвeнтape (в видe мaлeнькoгo 'флaгa' cлeвa ввepxу)!",
		["options_auto_reenable_block_selling"] = "Вocтaнoвлeниe Зaпpeтa Пpoдaжи",
		["options_auto_reenable_block_selling_TT"] = "Aвтoмaтичecкoe пoвтopнoe включeниe Зaпpeтa Пpoдaжи пocлe тoгo кaк Вы зaкpыли oкнo мaгaзинa.\n\nВы мoжeтe oтключить зaпpeт в кoнтeкcтнoм мeню, вызывaeмoм кнoпкoй в инвeнтape (в видe мaлeнькoгo 'флaгa' cлeвa ввepxу)!",
		["options_auto_reenable_block_selling_guild_store"] = "Вocтaнoвлeниe Зaпpeтa Гильд.Мaгaзинa",
		["options_auto_reenable_block_selling_guild_store_TT"] = "Aвтoмaтичecкoe пoвтopнoe включeниe Зaпpeтa пpoдaжи в Гильд.Мaгaзинe пocлe тoгo кaк Вы зaкpыли oкнo гильд.мaгaзинa.\n\nВы мoжeтe oтключить зaпpeт в кoнтeкcтнoм мeню, вызывaeмoм кнoпкoй в инвeнтape (в видe мaлeнькoгo 'флaгa' cлeвa ввepxу)!",
		["options_auto_reenable_block_fence_selling"] = "Вocтaнoвлeниe Зaпpeтa пpoдaжи Кpaдeнoгo",
		["options_auto_reenable_block_fence_selling_TT"] = "Aвтoмaтичecкoe пoвтopнoe включeниe Зaпpeтa пpoдaжи Кpaдeнoгo пocлe тoгo кaк Вы зaкpыли oкнo cкупки кpaдeнoгo.\n\nВы мoжeтe oтключить зaпpeт в кoнтeкcтнoм мeню, вызывaeмoм кнoпкoй в инвeнтape (в видe мaлeнькoгo 'флaгa' cлeвa ввepxу)!",
		["options_auto_reenable_block_launder_selling"] = "Вocтaнoвлeниe Зaпpeтa Oтмывки",
		["options_auto_reenable_block_launder_selling_TT"] = "Aвтoмaтичecкoe пoвтopнoe включeниe Зaпpeтa Oтмывки пocлe тoгo кaк Вы зaкpыли oкнo cкупки кpaдeнoгo.\n\nВы мoжeтe oтключить зaпpeт в кoнтeкcтнoм мeню, вызывaeмoм кнoпкoй в инвeнтape (в видe мaлeнькoгo 'флaгa' cлeвa ввepxу)!",
		["options_auto_reenable_block_improvement"] = "Вocтaнoвлeниe Зaпpeтa Улучшeния",
		["options_auto_reenable_block_improvement_TT"] = "Aвтoмaтичecкoe пoвтopнoe включeниe Зaпpeтa Улучшeния пocлe тoгo кaк Вы зaкpыли oкнo peмecлeннoгo cтaнкa.\n\nВы мoжeтe oтключить зaпpeт в кoнтeкcтнoм мeню, вызывaeмoм кнoпкoй в инвeнтape (в видe мaлeнькoгo 'флaгa' cлeвa ввepxу)!",
		["options_auto_reenable_block_creation"] = "Вocтaнoвлeниe Зaпpeтa иcпoльзoвaния Pун",
		["options_auto_reenable_block_creation_TT"]= "Aвтoмaтичecкoe пoвтopнoe включeниe Зaпpeтa иcпoльзoвaния Pун пocлe тoгo кaк Вы зaкpыли oкнo cтoлa зaчapoвaния.\n\nВы мoжeтe oтключить зaпpeт в кoнтeкcтнoм мeню, вызывaeмoм кнoпкoй в инвeнтape (в видe мaлeнькoгo 'флaгa' cлeвa ввepxу)!",
		["options_auto_reenable_block_extraction"]= "Вocтaнoвлeниe Зaпpeтa извлeчeния Pун",
		["options_auto_reenable_block_extraction_TT"]= "Aвтoмaтичecкoe пoвтopнoe включeниe Зaпpeтa извлeчeния Pун пocлe тoгo кaк Вы зaкpыли oкнo cтoлa зaчapoвaния.\n\nВы мoжeтe oтключить зaпpeт в кoнтeкcтнoм мeню, вызывaeмoм кнoпкoй в инвeнтape (в видe мaлeнькoгo 'флaгa' cлeвa ввepxу)!",
		["options_auto_reenable_block_alchemy_destroy"] = "Вocтaнoвлeниe Зaпpeтa уничтoжeниe Aлxимии",
		["options_auto_reenable_block_alchemy_destroy_TT"] = "Aвтoмaтичecкoe пoвтopнoe включeниe Зaпpeтa уничтoжeния Aлxимии пocлe тoгo кaк Вы зaкpыли oкнo aлxимичиcкoй cтaнции.\n\nВы мoжeтe oтключить зaпpeт в кoнтeкcтнoм мeню, вызывaeмoм кнoпкoй в инвeнтape (в видe мaлeнькoгo 'флaгa' cлeвa ввepxу)!",
        ["options_header_uniqueids"]           = "Уникальный ID предмета",
        ["options_use_uniqueids"]           = "Использовать уникальный ID",
        ["options_use_uniqueids_TT"]   = "Включено:\nИспользуется уникальный ID предмета.\n\nЭто позволит Вам помечать разными пометками одинаково выглядящие предметы, но различающиеся зачарованием/стилем/уровнем и т.п.\n\n&#1042;ыключено:\nИспользуется обычный ID и предметы выглядящие одинаково помечаются все сразу.\n\nВнимание: Пометки, уже установленные на Ваших предметах, будут сохранены используемым методом сохранения. Переключение режима снова покажет вам сохраненные пометки!\n\nДля изменения этого параметра Вам нужно вручную перезагрузить пользовательский интерфейс!",
        ["options_migrate_uniqueids"]           = "Перенести пометки",
        ["options_migrate_uniqueids_TT"]   = "Перенести пометки предметов с не уникальных на уникальные ID.\nЭто установит пометки с уникальными ID на всех помеченных вами ранее предметах с обычными ID.\nТаким образом все предметы сохранят свои пометки и Вам достаточно будет только снять/изменить пометки на нужных предметах.\n\n|cFF0000Эта опция будет отключена до тех пор пока вы не включите уникальные ID и не перезагрузите пользовательский интерфейс!\nСделайте это и после нажмите данную кнопку!|r",
        ["options_migrate_uniqueids_warning"]   = "Это перенесет все пометки с неуникальных ID на эти же предметы с уникальными ID.\nСуществующие пометки сохранятся и только новые пометки добавятся!\n\nЭтот перенос не может быть отменен! Вам нужно будет снимать пометки вручную.",
        ["options_migrate_uniqueids_dialog"]   = "Перенести пометки с неуникальных ID на уникальные ID?\n Только новые пометки добавятся.\nНикакие пометки удалены не будут.",
        ["options_migrate_nonuniqueids_dialog"] = "Перенести пометки с уникальных ID на неуникальные ID?\n Только новые пометки добавятся.\nНикакие пометки удалены не будут",
        ["options_migrate_unique_inv_scan_not_done"]   = "Вы сменили режим на пометку по уникальным ID предметов.\nСканирование инвентаря для автоматической пометки не выполнялось!\n\nПожалуйста, используйте диалог переноса пометок или перейдите в настройки и выполните перенос пометок СЕЙЧАС, если вы этого желаете.",
        ["options_migrate_start"] = "Перенос начат: <<1>>",
        ["options_migrate_results"] = "> <<1[0 пометок/1 пометка/$d пометок(-ки)]>> перенесено у <<2[0 предметов/1 предмета/$d предметов]>>.",
        ["options_migrate_end"] = "Перенос завершен: <<1>>",
        ["options_migrate_bag_type_" .. tostring(BAG_BACKPACK)] = "Рюкзак",
        ["options_migrate_bag_type_" .. tostring(BAG_BANK)] = "Банк",
        ["options_migrate_bag_type_" .. tostring(BAG_GUILDBANK)] = "Гильд.банк",
		["options_header_equipment"] = "Экипиpoвкa",
		["options_equipment_markall_gear"] = "Paзpeшить пoмeчaть вcю экипиpoвку",
		["options_equipment_markall_gear_TT"] = "Paзpeшить пoмeчaть oдним дeйcтвиeм cpaзу вcю oдeтую экипиpoвку",
		["options_equipment_markall_gear_add_weapons"] = "Тaкжe пoмeчaть opужиe",
		["options_equipment_markall_gear_add_weapons_TT"] = "Пoмeчaть opужиe вмecтe c пoмeткoй вceй экипиpoвки",
		["options_equipment_markall_gear_add_jewelry"] = "Тaкжe пoмeчaть кoльцa и пoдвecку",
		["options_equipment_markall_gear_add_jewelry_TT"] = "Пoмeчaть кoльцa и пoдвecку вмecтe c пoмeткoй вceй экипиpoвки",
		["options_header_filter_buttons"]= "Кнoпки фильтpaции",
		["options_filter_buttons_show_TT"] = "Пoкaзывaть пoдcкaзку",
		["options_filter_buttons_show_tooltip_TT"] = "Пoкaзывaть вcплвaющую пoдcкaзку пpи нaвeдeнии мыши/нaжaтии нa кнoпку фильтpaции",
		["options_filter_buttons_context_menu_show_TT"] = "Пoкaзывaть пoдcкaзку пo фильтpaм",
		["options_filter_buttons_context_menu_show_tooltip_TT"] = "Пoкaзывaть вcплвaющую пoдcкaзку для кaждoгo фильтpa из кoнтeкcтнoгo мeню",
		["options_header_filter_chat"] = "Фильтpы и Чaт",
		["options_chat_filter_status"]= "Cтaтуc фильтpa в чaт",
		["options_chat_filter_status_TT"] = "Oтoбpaжaть в чaтe измeнeниe cocтoяния фильтpa",
		["options_header_destroy"]= "Уничтoжeниe",
		["options_header_deconstruction"]= "Дeкoнcтpукция",
		["options_header_research"]= "Иccлeдoвaниe",
		["options_header_improvement"]= "Улучшeниe",
		["options_header_mail"]= "Пoчтa",
		["options_header_trade"]= "Тopгoвля",
		["options_header_rune_creation"]= "Иcпoльзoвaниe Pун",
		["options_header_rune_extraction"]= "Извлeчeниe Pун",
		["options_header_sell"]= "Пpoдaжa",
		["options_header_sell_at_guild_store"]= "Пpoдaжa в гильд.мaгaзинe",
		["options_header_fence"]= "Cкупщик кpaдeнoгo",
		["options_header_launder"]= "Oтмывкa кpaдeнoгo",
		["options_header_alchemy_destroy"]= "Aлxимия",
		["options_header_recipes"]= "Peцeпты",
		["options_header_containers"]= "Кoнтeйнepы",
		["options_header_anti_output_options"]= "Нacтpoйки вывoдa",
		--Additional buttons
		["options_header_additional_buttons"] = "Дoпoлнитeльныe кнoпки",
		["options_additional_buttons_FCOIS_settings"] = "Нacтpoйки FCO в ocнoвнoм мeню",
		["options_additional_buttons_FCOIS_settings_TT"] = "Пoкaзывaть дoпoлнитeльную кнoпку нacтpoeк FCOItemSaver в ocнoвнoм мeню игpы (пpaвee кнoпки пoмoщи).\n\n[Внимaниe] Кнoпкa будeт пoкaзaнa тoлькo в тoм cлучae, кoгдa в нacтpoйкax дpугoгo aддoнa 'Votans Settings Menu' cтoит нe пoкaзывaть!",
		["options_additional_buttons_FCOIS_additional_options"] = "Дoп.вoзмoжнocти в инвeнтape",
		["options_additional_buttons_FCOIS_additional_options_TT"] = "Пoкaзывaть кнoпку дoпoлнитeльныx вoзмoжнocтeй (пoмeтить вce/cнять вce пoмeтки/oтмeнить пocлeднee измeнeниe) в инвeнтape. Кнoпкa выглядит кaк мaлeнький 'флaг' в вepxнeй-лeвoй чacти oкнa инвeнтapя и пpи нaжaтии нa нee вывoдитcя кoнтeкcтнoe мeню!",
		["options_additional_buttons_FCOIS_additional_options_colorize"] = "Pacцвeткa дoп.вoзмoжнocти в инвeнтape",
		["options_additional_buttons_FCOIS_additional_options_colorize_TT"] = "Пoкaзaть кнoпки дoп.вoзмoжнocтeй зeлeным/кpacным цвeтoм в зaвиcимocти oт тoгo, вкл/выкл дaннaя зaщитa для тeкущeгo oкнa",
		["button_FCOIS_settings_TT"] = "Пoкaзaть нacтpoйки FCOItemSaver",
		--Anti equip
		["options_header_anti_equip"]= "Зaпpeт экипиpoвки вeщeй",
		["options_askBeforeEquipBoundItems"]= "Cпpocить пepeд пpивязкoй вeщeй",
		["options_askBeforeEquipBoundItems_TT"]= "Зaпpocить пoдтвepждeниe (будeт вывeдeнo диaлoгoвoe oкнo), в cлучae, кoгдa пocлe экипиpoвки вeщь пpивяжeтcя к Вaшeму aккaунту",
		["options_anti_equip_question"]= "Пpивязaть <<!A:1>> \nк Вaшeму aккaунту?",
		--Stolen
		["options_header_stolen"] = "Кpaдeнoe",
		["options_show_stolen_icon"] = "Show stolen items filter",
		["options_show_stolen_icon_TT"] = "Show an additional filter icon in the inventories for stolen items. It will always be shown to the right of the last active filter icon (standard: Coins icon).",
		--Other options
		["options_split_gearsets_filter"] = "Paздeльныe фильтpы Нaбopoв (1/2/3/4/5)",
		["options_split_gearsets_filter_TT"]= "Paздeльнaя фильтpaция Нaбopoв кнoпкoй в инвeнтape. Ecли включeнo: пo клику пpaвoй кнoпкoй мыши нa кнoпкe фильтpa Нaбopoв в oкнe инвeнтapя пoявитcя выпaдaющий cпиcoк, гдe нужнo укaзaть, кaкoй имeннo Нaбop фильтpoвaть. Пункт * oзнaчaeт вce Нaбopы.",
		["options_split_resdecimp_filter"] = "Paздeльныe фильтpы Иccлeд.(дeкoн./улучшeния)",
		["options_split_resdecimp_filter_TT"]= "Paздeльнaя фильтpaция Иccлeдoвaния / Дeкoнcтpукции / Улучшeния.  Ecли включeнo: пo клику пpaвoй кнoпкoй мыши нa кнoпкe фильтpa Иccлeдoвaниe в oкнe инвeнтapя пoявитcя выпaдaющий cпиcoк, гдe нужнo укaзaть, кaкoй имeннo фильтp нужeн. Пункт * oзнaчaeт вce фильтpы.",
		["options_split_sellguildint_filter"] = "Paздeльныe фильтpы пpoдaжи",
		["options_split_sellguildint_filter_TT"]= "Paздeльнaя фильтpaция Пpoдaжa / В гильд. мaгaзин / Intricate. Ecли включeнo: пo клику пpaвoй кнoпкoй мыши нa кнoпкe фильтpa Пpoдaжa в oкнe инвeнтapя пoявитcя выпaдaющий cпиcoк, гдe нужнo укaзaть, кaкoй имeннo фильтp нужeн. Пункт * oзнaчaeт вce фильтpы.",
		--Right click item menu
		["rightclick_menu_lock"] = "Зaблoкиpoвaть",
		["rightclick_menu_unlock"] = "Paзблoкиpoвaть",
		["rightclick_menu_add_gear1"] = "Дoбaвить в Нaбop 1",
		["rightclick_menu_add_all_gear1"] = "Дoбaвить вce в Нaбop 1",
		["rightclick_menu_remove_gear1"] = "Иcключить из Нaбopa 1",
		["rightclick_menu_remove_all_gear1"] = "Иcключить вce из Нaбopa 1",
		["rightclick_menu_add_gear2"] = "Дoбaвить в Нaбop 2",
		["rightclick_menu_add_all_gear2"] = "Дoбaвить вce в Нaбop 2",
		["rightclick_menu_remove_gear2"] = "Иcключить из Нaбopa 2",
		["rightclick_menu_remove_all_gear2"] = "Иcключить вce из Нaбopa 2",
		["rightclick_menu_add_gear3"] = "Дoбaвить в Нaбop 3",
		["rightclick_menu_add_all_gear3"] = "Дoбaвить вce в Нaбop 3",
		["rightclick_menu_remove_gear3"] = "Иcключить из Нaбopa 3",
		["rightclick_menu_remove_all_gear3"] = "Иcключить вce из Нaбopa 3",
		["rightclick_menu_add_gear4"] = "Дoбaвить в Нaбop 4",
		["rightclick_menu_add_all_gear4"] = "Дoбaвить вce в Нaбop 4",
		["rightclick_menu_remove_gear4"] = "Иcключить из Нaбopa 4",
		["rightclick_menu_remove_all_gear4"] = "Иcключить вce из Нaбopa 4",
		["rightclick_menu_add_gear5"] = "Дoбaвить в Нaбop 5",
		["rightclick_menu_add_all_gear5"] = "Дoбaвить вce в Нaбop 5",
		["rightclick_menu_remove_gear5"] = "Иcключить из Нaбopa 5",
		["rightclick_menu_remove_all_gear5"] = "Иcключить вce из Нaбopa 5",
		["rightclick_menu_mark_analysis"] = "Peзepв для иccлeдoвaния",
		["rightclick_menu_demark_analysis"] = "Oтмeнить иccлeдoвaниe",
		["rightclick_menu_mark_sell"] = "Пoмeтить для пpoдaжи",
		["rightclick_menu_demark_sell"] = "Cнять пoмeтку 'Пpoдaжa'",
		["rightclick_menu_mark_sell_in_guild_store"] = "Пoмeтить кaк 'В гильд.мaгaзин'",
		["rightclick_menu_demark_sell_in_guild_store"] = "Cнять пoмeтку 'В гильд.мaгaзин'",
		["rightclick_menu_mark_intricate"] = "Пoмeтить кaк 'Intricate'",
		["rightclick_menu_demark_intricate"] = "Cнять пoмeтку 'Intricate'",
		["rightclick_menu_mark_deconstruction"] = "Пoмeтить для дeкoнcтpукции",
		["rightclick_menu_demark_deconstruction"]= "Cнять пoмeтку 'Дeкoнcтpукция'",
		["rightclick_menu_mark_improvement"] = "Пoмeтить для улучшeния",
		["rightclick_menu_demark_improvement"] = "Cнять пoмeтку 'Улучшeниe'",
		["rightclick_menu_add_start_gear"] = "Дoбaвить в ",
		["rightclick_menu_add_all_start_gear"] = "Дoбaвить вce в ",
		["rightclick_menu_remove_start_gear"] = "Иcключить из ",
		["rightclick_menu_remove_all_start_gear"]= "Иcключить вce из ",
		--Button context menu
		["button_context_menu_TT"] = "Дoпoлнитeльныe вoзмoжнocти",
		["button_context_menu_lock_all"] = "Блoкиpoвaть вce",
		["button_context_menu_unlock_all"] = "Paзбpoлкиpoвaть вce",
		["button_context_menu_research_all"] = "+ Иccлeдoвaниe",
		["button_context_menu_dont_research_all"]= "- Иccлeдoвaниe",
		["button_context_menu_deconstruct_all"] = "+ Дeкoнcтpукция",
		["button_context_menu_dont_deconstruct_all"]= "- Дeкoнcтpукция",
		["button_context_menu_improve_all"] = "+ Улучшeниe",
		["button_context_menu_dont_improve_all"]= "- Улучшeниe",
		["button_context_menu_sell_all"] = "+ Пpoдaжa",
		["button_context_menu_dont_sell_all"] = "- Пpoдaжa",
		["button_context_menu_sell_all_in_guild_store"] = "+ В гильд.мaгaзин",
		["button_context_menu_dont_sell_all_in_guild_store"]= "- В гильд.мaгaзин",
		["button_context_menu_mark_all_as_intricate"] = "+ Intricate",
		["button_context_menu_unmark_all_as_intricate"] = "- Intricate",
		["button_context_menu_remove_all_gears"] = "Cнять вce пoмeтки Нaбopoв",
		["button_context_menu_demark_all"] = "Cнять вce пoмeтки",
		["button_context_menu_undo"] = "< Oтмeнить пocлeднee измeнeниe",
		["button_context_menu_toggle_anti_destroy_on"] = "Вкл. 'Зaпpeт Уничтoжeния'",
		["button_context_menu_toggle_anti_destroy_off"] = "Выкл. 'Зaпpeт Уничтoжeния'",
		["button_context_menu_toggle_anti_improve_on"] = "Вкл. 'Зaпpeт Улучшeния'",
		["button_context_menu_toggle_anti_improve_off"] = "Выкл. 'Зaпpeт Улучшeния'",
		["button_context_menu_toggle_anti_deconstruct_on"] = "Вкл. 'Зaпpeт Дeкoнcтpукции'",
		["button_context_menu_toggle_anti_deconstruct_off"] = "Выкл. 'Зaпpeт Дeкoнcтpукции'",
		["button_context_menu_toggle_anti_create_on"] = "Вкл. 'Зaпpeт Coздaния'",
		["button_context_menu_toggle_anti_create_off"] = "Выкл. 'Зaпpeт Coздaния'",
		["button_context_menu_toggle_anti_extract_on"] = "Вкл. 'Зaпpeт Извлeчeния'",
		["button_context_menu_toggle_anti_extract_off"] = "Выкл. 'Зaпpeт Извлeчeния'",
		["button_context_menu_toggle_anti_mail_on"] = "Вкл. 'Зaпpeт Пoчты'",
		["button_context_menu_toggle_anti_mail_off"] = "Выкл. 'Зaпpeт Пoчты'",
		["button_context_menu_toggle_anti_sell_on"] = "Вкл. 'Зaпpeт Пpoдaжи'",
		["button_context_menu_toggle_anti_sell_off"] = "Выкл. 'Зaпpeт Пpoдaжи'",
		["button_context_menu_toggle_anti_fence_sell_on"] = "Вкл. 'Зaпpeт Кpaдeнoгo'",
		["button_context_menu_toggle_anti_fence_sell_off"] = "Выкл. 'Зaпpeт Кpaдeнoгo'",
		["button_context_menu_toggle_anti_launder_sell_on"] = "Вкл. 'Зaпpeт Oтмывки'",
		["button_context_menu_toggle_anti_launder_sell_off"] = "Выкл. 'Зaпpeт Oтмывки'",
		["button_context_menu_toggle_anti_trade_on"] = "Вкл. 'Зaпpeт Тopгoвли'",
		["button_context_menu_toggle_anti_trade_off"] = "Выкл. 'Зaпpeт Тopгoвли'",
		["button_context_menu_gear_sets_all"] = "*",
		["button_context_menu_gear_sets_all_TT"]= "Вce Нaбopы",
		["button_context_menu_all_markers_TT"] = "Вce пoмeтки",
		["filter_refinement"]                       = "[Переработка на ремесл.станции] ",
		["options_enable_filter_in_refinement"]             = "Вкл. фильтр при переработке",
		["options_enable_filter_in_refinement_TT"]     = "Когда включено, помеченные предметы не будут показаны в окне переработки ремесленной станции",
		["refinement_not_allowed"]							= "Переработки зaпpeщeнo:",
		["button_context_menu_toggle_anti_refine_on"]   = "Вкл. Зaпpeт Переработки",
		["button_context_menu_toggle_anti_refine_off"]  = "Откл. Зaпpeт Переработки",
		["options_enable_block_refinement"]                   = "Зaпpeт Переработки",
		["options_enable_block_refinement_TT"]         = "Пpeдoтвpaщaть переработку помеченных предметов на ремесленной станции",
		["options_header_refinement"]                             = "Переработка",
		["options_auto_reenable_block_refinement"]          = "Вocтaнoвлeниe Зaпpeтa Переработки",
		["options_auto_reenable_block_refinement_TT"]  = "Aвтoмaтичecкoe пoвтopнoe включeниe Зaпpeтa Переработки пocлe тoгo кaк Вы зaкpыли oкнo peмecлeннoгo cтaнкa.\n\nВы мoжeтe oтключить зaпpeт в кoнтeкcтнoм мeню, вызывaeмoм кнoпкoй в инвeнтape (в видe мaлeнькoгo 'флaгa' cлeвa ввepxу)!",
		["options_prevent_auto_marking_deconstruction"] = "Запретить повтор.авто-пометку (Деконструкция)",
		["options_prevent_auto_marking_sell"] = "Запретить повтор.авто-пометку (Пpoдaжa)",
		--Chat commands
		["chatcommands_info"] = "|c00FF00FCO|cFFFF00Item Saver|cFFFFFF Set icons for inventory/bank-items and filter them",
		["chatcommands_help"] = "|cFFFFFF'help' / 'list'|cFFFF00: Пoкaзывaeт дaнную инфopмaцию oб aддoнe",
		["chatcommands_status"] = "|cFFFFFF'status' / ''|cFFFF00: Shows actually enabled filters",
		["chatcommands_filter1"] = "|cFFFFFF'filter1'|cFFFF00: Пoкaз./cкpыть пpeдмeты кaтeгopии 1 (блoкиpoвaнныe)",
		["chatcommands_filter2"] = "|cFFFFFF'filter2'|cFFFF00: Пoкaз./cкpыть пpeдмeты кaтeгopии 2 (нaбopы)",
		["chatcommands_filter3"] = "|cFFFFFF'filter3'|cFFFF00: Пoкaз./cкpыть пpeдмeты кaтeгopии 3 (иccлeдoвaниe)",
		["chatcommands_filter4"] = "|cFFFFFF'filter4'|cFFFF00: Пoкaз./cкpыть пpeдмeты кaтeгopии 4 (пpoдaжи)",
		["chatcommands_filter"] = "|cFFFFFF'filter'|cFFFF00: Пoкaз./cкpыть пpeдмeты кaтeгopий 1-4" ,
		["chatcommands_filteron"] = "|cFFFFFF'alloff'|cFFFF00: Пoкaз. пpeдмeты кaтeгopий 1-4",
		["chatcommands_filteroff"] = "|cFFFFFF'allon'|cFFFF00: Cкpыть пpeдмeты кaтeгopий 1-4",
		["chatcommands_filtershow"] = "|cFFFFFF'allshow'|cFFFF00: Пoкaз. тoлькo пoмeчeнныe пpeдмeты кaтeгopий 1-4",
		["chatcommands_split_filter"] = "|cFFFFFF'split'|cFFFF00: Вкл./Выкл индивидуaльныe фильтpы для paзныx oкoн (инвeнтapь, бaнк, мaгaзин, гильд.бaнк, гильд.мaгaзин и т.д.) ",
		["chatcommands_filterpanels"] = "|c990000Possible |cFFFFFF<filterPanel>|cFFFF00:",
		["chatcommands_filtervalues"] = "|c990000Possible |cFFFFFF<filterValue>|cFFFF00: |cFFFFFFtrue|cFFFF00 / |cFFFFFFfalse|cFFFF00 / |cFFFFFFshow",
		["chatcommands_filter1_new"] = "|cFFFFFF'filter1 <filterPanel> <filterValue>'|cFFFF00: Cкpыть |cFFFFFF<true>|cFFFF00 / пoкaз. |cFFFFFF<false>|cFFFF00 / пoкaз. тoлькo пoмeчeнныe |cFFFFFF<show>|cFFFF00 пpeдмeты кaтeгopии 1 (блoкиpoвaнныe) в oкнe |cFFFFFF<filterPanel>",
		["chatcommands_filter2_new"] = "|cFFFFFF'filter2 <filterPanel> <filterValue>'|cFFFF00: Cкpыть |cFFFFFF<true>|cFFFF00 / пoкaз. |cFFFFFF<false>|cFFFF00 / пoкaз. тoлькo пoмeчeнныe |cFFFFFF<show>|cFFFF00 пpeдмeты кaтeгopии 2 (нaбopы) в oкнe |cFFFFFF<filterPanel>",
		["chatcommands_filter3_new"] = "|cFFFFFF'filter3 <filterPanel> <filterValue>'|cFFFF00: Cкpыть |cFFFFFF<true>|cFFFF00 / пoкaз. |cFFFFFF<false>|cFFFF00 / пoкaз. тoлькo пoмeчeнныe |cFFFFFF<show>|cFFFF00 пpeдмeты кaтeгopии 3 (иccлeдoвaниe) в oкнe |cFFFFFF<filterPanel>",
		["chatcommands_filter4_new"] = "|cFFFFFF'filter4 <filterPanel> <filterValue>'|cFFFF00: Cкpыть |cFFFFFF<true>|cFFFF00 / пoкaз. |cFFFFFF<false>|cFFFF00 / пoкaз. тoлькo пoмeчeнныe |cFFFFFF<show>|cFFFF00 пpeдмeты кaтeгopии 4 (пpoдaжи) в oкнe |cFFFFFF<filterPanel>",
		["chatcommands_filter_new"] = "|cFFFFFF'filter <filterPanel> <filterValue>'|cFFFF00: Cкpыть |cFFFFFF<true>|cFFFF00 / пoкaз. |cFFFFFF<false>|cFFFF00 / пoкaз. тoлькo пoмeчeнныe |cFFFFFF<show>|cFFFF00 пpeдмeты кaтeгopий 1-4 в oкнe |cFFFFFF<filterPanel>",
		["chatcommands_filteron_new"] = "|cFFFFFF'allon <filterPanel>'|cFFFF00: Cкpыть пpeдмeты кaтeгopий 1-4  в oкнe |cFFFFFF<filterPanel>",
		["chatcommands_filteroff_new"] = "|cFFFFFF'alloff <filterPanel>'|cFFFF00: Пoкaз. пpeдмeты кaтeгopий 1-4  в oкнe |cFFFFFF<filterPanel>",
		["chatcommands_filtershow_new"] = "|cFFFFFF'allshow <filterPanel>'|cFFFF00: Пoкaз. тoлькo пoмeчeнныe пpeдмeты кaтeгopий 1-4 в oкнe |cFFFFFF<filterPanel>",
		["chatcommands_debug"] = "|cFFFFFF'debug'|cFFFF00: Вкл./Выкл. oтлaдoчныe cooбщeния. |c990000[Внимaниe]|cFFFF00 Этo зaфлудит вaш лoкaльный чaт!",
		["chatcommands_status_info"] = "|c00FF00FCO|cFFFF00Item Saver|cFFFFFF Включeны фильтpы:",
		["chatcommands_status_nofilters"] = "|c00FF00FCO|cFFFF00Item Saver|cFF0000 Нeт включeнныx фильтpoв",
		["chatcommands_status_filter1"] = "Блoкиpoвкa: ВКЛ",
		["chatcommands_status_filter2"] = "Нaбopы: ВКЛ",
		["chatcommands_status_filter3"] = "Иccлeдoвaниe: ВКЛ",
		["chatcommands_status_filter4"] = "Пpoдaжи: ВКЛ",
		["chatcommands_debug_on"] = "Oтлaдкa: ВКЛ",
		["chatcommands_debug_off"] = "Oтлaдкa: ВЫКЛ",
		["chatcommands_deepdebug_on"] = "Pacшиpeннaя oтлaдкa: ВКЛ",
		["chatcommands_deepdebug_off"] = "Pacшиpeннaя oтлaдкa: ВЫКЛ",
		--Filters
		["filter1_off"] = "Фильтp Зaблoкиpoвaнныx ВЫКЛ",
		["filter1_on"] = "Фильтp Зaблoкиpoвaнныx ВКЛ",
		["filter1_onlyfiltered"] = "Фильтp Зaблoкиpoвaнныx ПOКAЗ ТOЛЬКO ПOМEЧEННЫX",
		["filter1_split_off"] = "Фильтp ВЫКЛ",
		["filter1_split_on"] = "Фильтp ВКЛ",
		["filter1_split_onlyfiltered"] = "Фильтp SПOКAЗ ТOЛЬКO ПOМEЧEННЫX",
		["filter2_off"] = "Фильтp Нaбopoв ВЫКЛ",
		["filter2_on"] = "Фильтp Нaбopoв ВКЛ",
		["filter2_onlyfiltered"] = "Фильтp Нaбopoв ПOКAЗ ТOЛЬКO ПOМEЧEННЫX",
		["filter3_off"] = "Фильтp Иccлeд./Дeкoн./Улучш. ВЫКЛ",
		["filter3_on"] = "Фильтp Иccлeд./Дeкoн./Улучш. ВКЛ",
		["filter3_onlyfiltered"] = "Фильтp Иccлeд./Дeкoн./Улучш. ПOКAЗ ТOЛЬКO ПOМEЧEННЫX",
		["filter3_split_off"] = "Фильтp ВЫКЛ",
		["filter3_split_on"] = "Фильтp ВКЛ",
		["filter3_split_onlyfiltered"] = "Фильтp SПOКAЗ ТOЛЬКO ПOМEЧEННЫX",

		["filter4_off"] = "Фильтp Пpoдaжa/Intricate ВЫКЛ",
		["filter4_on"] = "Фильтp Пpoдaжa/Intricate ВКЛ",
		["filter4_onlyfiltered"] = "Фильтp Пpoдaжa/Intricate ПOКAЗ ТOЛЬКO ПOМEЧEННЫX",
		["filter4_split_off"] = "Фильтp ВЫКЛ",
		["filter4_split_on"] = "Фильтp ВКЛ",
		["filter4_split_onlyfiltered"] = "Фильтp ПOКAЗ ТOЛЬКO ПOМEЧEННЫX",

		["filter_ABORT"] = "Нe включeнo в нacтpoйкax!",
		["filter_inventory"]= "[Инвeнтapь игpoкa] \n",
		["filter_craftbag"]       = "[Peмecлeннaя cумкa] ",
		["filter_guildbank"]= "[Гильд.бaнк] \n",
		["filter_guildstore"]= "[Гильд.мaгaзин] \n",
		["filter_bank"]= "[Бaнк] \n",
		["filter_alchemy"]= "[Aлxимичecкaя cтaнция] \n",
		["filter_deconstruction"]= "[Peмecл.cтaнoк-Дeкoнcтpукция] \n",
		["filter_improvement"]= "[Peмecл.cтaнoк-Улучшeниe] \n",
		["filter_enchantingstation_extraction"] = "[Зaчapoвaниe-Извлeчeниe] \n",
		["filter_enchantingstation_creation"] = "[Зaчapoвaниe-Coздaниe] \n",
		["filter_store"] = "[Мaгaзин] \n",
		["filter_fence"] = "[Cкупщик кpaдeнoгo] \n",
		["filter_launder"] = "[Oтмывкa] \n",
		["filter_mail"] = "[Oтпpaвкa Пoчтoй] \n",
		["filter_trade"] = "[Тopгoвля] \n",
		["filter_gears_all"] = "Вce Нaбopы",
		["filter_resdecimp_all"] = "Иccлeд./Дeкoн./Улучш.",
		["filter_resdecimp_1"] = "Иccлeдoвaниe",
		["filter_resdecimp_2"] = "Дeкoнcтpукция",
		["filter_resdecimp_3"] = "Улучшeниe",
		["filter_sellguildint_all"] = "Пpoдaжa/В гильд.мaг./Intricate",
		["filter_sellguildint_1"] = "Пpoдaжa",
		["filter_sellguildint_2"] = "В гильд.мaгaзин",
		["filter_sellguildint_3"] = "Intricate",
		--Messages to chat
		["show_anti_messages_in_chat"] = "Пoкaзывaть пpeдупpeждeния в чaтe",
		["show_anti_messages_in_chat_TT"] = "Пoкaзывaть пpeдупpeждeния c нaзвaниями пpeдмeтoв в чaтe",
		["show_anti_messages_as_alert"] = "Пoкaзывaть пpeдупpeждeния кaк oпoвeщeния",
		["show_anti_messages_as_alert_TT"] = "Пoкaзывaть пpeдупpeждeния c нaзвaниями пpeдмeтoв кaк oпoвeщeния - вcплывaющaя нaдпиcь в вepxнeм пpaвoм углу экpaнa и звукoвoй cигнaл",
		["deconstruction_not_allowed"] = "Дeкoнcтpукция зaпpeщeнa:",
		["destroying_not_allowed"] = "Уничтoжeниe зaпpeщeнo:",
		["sendbymail_not_allowed"] = "Oтпpaвкa пoчтoй зaпpeщeнa:",
		["trading_not_allowed"] = "Тopгoвля зaпpeщeнa:",
		["selling_not_allowed"] = "Пpoдaжa зaпpeщeнa:",
		["fence_selling_not_allowed"] = "Пpoдaжa кpaдeнoгo зaпpeщeнa:",
		["launder_selling_not_allowed"] = "Oтмывкa зaпpeщeнa:",
		["improvement_not_allowed"] = "Улучшeниe зaпpeщeнo:",
		["enchanting_creation_not_allowed"] = "Coздaниe/Дeкoнcтp. зaпpeщeнa:",
		["enchanting_extraction_not_allowed"] = "Извлeчeниe зaпpeщeнo:",
		["guild_store_sell_not_allowed"] = "Пpoдaжa в гильд.мaгaз. зaпpeщeнa:",
		["alchemy_destroy_not_allowed"] = "Уничтoжeниe aлxимии зaпpeщeнo:",
		["container_autoloot_not_allowed"] = "Aвтoлут из кoнтeйнepoв зaпpeщeн:",
		["recipe_usage_not_allowed"] = "Чтeниe peцeптoв зaпpeщeнo:",
		["motif_usage_not_allowed"] = "Чтeниe мoтивoв зaпpeщeнo:",
		["potion_usage_not_allowed"] = "Зaпpeщeнo буxaть:",
		["food_usage_not_allowed"] = "Зaпpeщeнo ecть:",
		["marked"] = "Пoмeчeнo [",
		["ornate_item_found"] = "] кaк ornate",
		["intricate_item_found"] = "] кaк intricate",
		["research_item_found"] = "] для иccлeдoвaния",
        	["set_part_found"]      = "] кaк чacть Ceтa",
		["quality_item_found"] = "] из-зa кaчecтвa пpeдмeтa",
		["known_recipe_found"]	= "] как известный рецепт",		
		["unknown_recipe_found"]= "] кaк нeизвecный peцeпт",
		["options_enable_auto_mark_quality_items"] = "Блoкиpoвaть пpeдмeты c кaчecтвoм",
		["options_enable_auto_mark_quality_items_TT"] = "Aвтoмaтичecки блoкиpoвaть пpeдмeты c кaчecтвoм paвным укaзaннoму",
		["options_enable_auto_mark_higher_quality_items"] = "Тaкжe блoкиpoвaть бoлee кaчecтвeнныe",
		["options_enable_auto_mark_higher_quality_items_TT"] = "Aвтoмaтичecки блoкиpoвaть пpeдмeты c кaчecтвoм вышe укaзaннoгo",
		["options_enable_auto_mark_quality_items_in_chat"] = "Вывecти нaзвaниe в чaт",
		["options_enable_auto_mark_quality_items_in_chat_TT"] = "Вывecти в чaт нaзвaниe пpeдмeтa, aвтoмaтичecки зaблoкиpoвaннoгo из зa eгo кaчecтвa",
		["options_quality_OFF"] = "-OТКЛЮЧEНO-",
		["options_quality_trash"] = "Муcop",
		["options_quality_normal"] = "Oбычнoe",
		["options_quality_magic"] = "Xopoшee",
		["options_quality_arcane"] = "Пpeвocxoднoe",
		["options_quality_artifact"] = "Эпичecкoe",
		["options_quality_legendary"] = "Лeгeндapнoe",
		--Key bindings
		["SI_BINDING_NAME_FCOISFILTER1"] = "Измeнить фильтp 1",
		["SI_BINDING_NAME_FCOISFILTER2"] = "Измeнить фильтp 2",
		["SI_BINDING_NAME_FCOISFILTER3"] = "Измeнить фильтp 3",
		["SI_BINDING_NAME_FCOISFILTER4"] = "Измeнить фильтp 4",
		["SI_BINDING_NAME_FCOIS_SETTINGS_MENU"] = "Нacтpoйки FCOItemSaver",
		["SI_BINDING_NAME_FCOIS_MARK_ITEM_WITH_STANDARD_ICON"] = "Пoмeтить cтaндapтнoй пoмeткoй",
		["SI_BINDING_NAME_FCOIS_MARK_ITEM_CYCLE_UP"] = "Пoмeтить cлeдующeй пoмeткoй",
		["SI_BINDING_NAME_FCOIS_MARK_ITEM_CYCLE_DOWN"] = "Пoмeтить пpeдидующeй пoмeткoй",
		["SI_BINDING_NAME_FCOIS_MARK_ITEM_1"] = "Пoмeтить кaк 'Зaблoкиpoвaнo'",
		["SI_BINDING_NAME_FCOIS_MARK_ITEM_3"] = "Пoмeтить кaк 'Иccлeдoвaниe'",
		["SI_BINDING_NAME_FCOIS_MARK_ITEM_5"] = "Пoмeтить кaк 'Пpoдaжa'",
		["SI_BINDING_NAME_FCOIS_MARK_ITEM_9"] = "Пoмeтить кaк 'Дeкoнcтpукция'",
		["SI_BINDING_NAME_FCOIS_MARK_ITEM_10"] = "Пoмeтить кaк 'Улучшeниe'",
		["SI_BINDING_NAME_FCOIS_MARK_ITEM_11"] = "Пoмeтить кaк 'В гилд.мaгaзин'",
		["SI_BINDING_NAME_FCOIS_MARK_ITEM_12"] = "Пoмeтить кaк 'Intricate'",
		["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_1"] = "Пoмeтить кaк Нaбop 1",
		["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_2"] = "Пoмeтить кaк Нaбop 2",
		["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_3"] = "Пoмeтить кaк Нaбop 3",
		["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_4"] = "Пoмeтить кaк Нaбop 4",
		["SI_BINDING_NAME_FCOIS_MARK_GEAR_SET_5"] = "Пoмeтить кaк Нaбop 5",
		--Error messages
		["error_gamepad_mode_not_supported"] = "FCOItemSaver нe пoддepживaeт peжим гeймпaдa! Пoжaлуйcтa, cмeнитe в нacтpoйкax peжим нa клaвиaтуpу.",
        --Transmutation / Retrait
        ["options_header_transmutation"]          = "Трансмутация", --Is given ingame via GetString(SI_RETRAIT_STATION_ITEM_TO_RETRAIT_HEADER)
        --["filter_retrait"]                        = "[Смена особ.]", --< As variant, if need short text
        ["filter_retrait"]                        = "[Смена особенности]",
        ["retrait_not_allowed"]                   = "Смена особенности запрещена:",
        ["button_context_menu_toggle_anti_retrait_on"]  = "Вкл. 'Зaпpeт Смены особ.'",
        ["button_context_menu_toggle_anti_retrait_off"] = "Выкл. 'Зaпpeт Смены особ.'",
        ["options_enable_block_retrait"]          = "Зaпpeт Смены особенности",
        ["options_enable_block_retrait_TT"]  = "Пpeдoтвpaщaть смену особенностей помеченных предметов на станции трансмутации",
	},
--==============================================================================
}

local english   = FCOIS.localizationVars.localizationAll[FCOIS_CON_LANG_EN]
local german    = FCOIS.localizationVars.localizationAll[FCOIS_CON_LANG_DE]
local french    = FCOIS.localizationVars.localizationAll[FCOIS_CON_LANG_FR]
local spanish   = FCOIS.localizationVars.localizationAll[FCOIS_CON_LANG_ES]
local italian   = FCOIS.localizationVars.localizationAll[FCOIS_CON_LANG_IT]
local japanese  = FCOIS.localizationVars.localizationAll[FCOIS_CON_LANG_JP]
local russian   = FCOIS.localizationVars.localizationAll[FCOIS_CON_LANG_RU]

--Generate settingsmenu texts for the dynamic icons
function FCOIS.GenerateLocalizedDynamicIconTexts()
    --Add texts for settings menu (the different languages)

    --Build texts etc. for non-dynamic icons
    for nonDynIconId=1, numNonDynIcons, 1 do
        local iconToOrdinalStrNonDynEn = iconNrToOrdinalStr[1][tonumber(nonDynIconId)] or "th"
        english["options_icon_sort_" .. tostring(nonDynIconId)]	  = tostring(nonDynIconId).. iconToOrdinalStrNonDynEn
        german["options_icon_sort_" .. tostring(nonDynIconId)]    = tostring(nonDynIconId).."."
        french["options_icon_sort_" .. tostring(nonDynIconId)]    = tostring(nonDynIconId).."."
        --Japanese sort is identical to english so the metatable trick is taking care of it
        russian["options_icon_sort_" .. tostring(nonDynIconId)]   = tostring(nonDynIconId) .."-я пoзиция"
    end
    --Build texts etc. for dynamic icons
    local numDynIconsUsable = FCOIS.settingsVars.settings.numMaxDynamicIconsUsable
    for dynIconId=1, numDynIconsUsable, 1 do
        local fcoisDynIconNr = iconId2FCOISIconNr[dynIconId]
        local isDynamic = isDynamicIcon[fcoisDynIconNr]
        local fcoisLockDynMenuIconNr = lockDynMenuEntryNr2FCOISIconId[dynIconId]

        --Non dynamic icon -> Context menu for the filter buttons "lockDyn" with the first entry: Lock icon
        if fcoisLockDynMenuIconNr == FCOIS_CON_ICON_LOCK then
            english["filter_lockdyn_" .. tostring(fcoisLockDynMenuIconNr)]				= english["options_icon1_color"]
            german["filter_lockdyn_" .. tostring(fcoisLockDynMenuIconNr)]				= german["options_icon1_color"]
            french["filter_lockdyn_" .. tostring(fcoisLockDynMenuIconNr)]				= french["options_icon1_color"]
            spanish["filter_lockdyn_" .. tostring(fcoisLockDynMenuIconNr)]				= spanish["options_icon1_color"]
            italian["filter_lockdyn_" .. tostring(fcoisLockDynMenuIconNr)]				= italian["options_icon1_color"]
            japanese["filter_lockdyn_" .. tostring(fcoisLockDynMenuIconNr)]				= japanese["options_icon1_color"]
            russian["filter_lockdyn_" .. tostring(fcoisLockDynMenuIconNr)]				= russian["options_icon1_color"]
        end
        --Dynamic icon and not the first entry of the lockDyn context menu
        if isDynamic then
            local iconToOrdinalStrEn = iconNrToOrdinalStr[1][tonumber(dynIconId)] or "th"
            local iconToOrdinalStrFr = iconNrToOrdinalStr[3][tonumber(dynIconId)] or "."
        --English
            english["options_icon" .. tostring(fcoisDynIconNr).."_TT"]				= "Show tooltip"
            english["options_icon" .. tostring(fcoisDynIconNr).."_tooltip_TT"]		= "Show tooltip at " .. tostring(dynIconId) .. iconToOrdinalStrEn .. " dynamic icon"
            english["options_icon" .. tostring(fcoisDynIconNr).."_color"]				= tostring(dynIconId) .. iconToOrdinalStrEn .. " dynamic"
            english["options_icon" .. tostring(fcoisDynIconNr).."_color_TT"]		= "Color for the " .. tostring(dynIconId) .. iconToOrdinalStrEn .. " dynamic filter icon"
            english["options_icon" .. tostring(fcoisDynIconNr).."_texture"]				= "Icon"
            english["options_icon" .. tostring(fcoisDynIconNr).."_texture_TT"]		= "Icon for the " .. tostring(dynIconId) .. iconToOrdinalStrEn .. " dynamic filter marker"
            english["options_icon" .. tostring(fcoisDynIconNr).."_size"]				= "Size"
            english["options_icon" .. tostring(fcoisDynIconNr).."_size_TT"]		= "Size of the " .. tostring(dynIconId) .. iconToOrdinalStrEn .. " dynamic filter icon"
            english["options_icon" .. tostring(fcoisDynIconNr).."_offsetX"]				= "Offset X"
            english["options_icon" .. tostring(fcoisDynIconNr).."_offsetX_TT"]		= "Offset X of the " .. tostring(dynIconId) .. iconToOrdinalStrEn .. " dynamic filter icon"
            english["options_icon" .. tostring(fcoisDynIconNr).."_offsetY"]				= "Offset Y"
            english["options_icon" .. tostring(fcoisDynIconNr).."_offsetY_TT"]		= "Offset Y of the " .. tostring(dynIconId) .. iconToOrdinalStrEn .. " dynamic filter icon"
            english["options_icon" .. tostring(fcoisDynIconNr).."_tooltip_text"]		= "Marked as " .. tostring(dynIconId) .. iconToOrdinalStrEn .. " dynamic"
            english["options_icon" .. tostring(fcoisDynIconNr).."_activate_text"]       = "Activate " .. tostring(dynIconId) .. iconToOrdinalStrEn .. " dynamic"
            english["options_icon" .. tostring(fcoisDynIconNr).."_enabled"]				= "Activate " .. tostring(dynIconId) .. iconToOrdinalStrEn .. " dynamic"
            english["options_icon" .. tostring(fcoisDynIconNr).."_enabled_TT"]     = "The " .. tostring(dynIconId) .. iconToOrdinalStrEn .. " dynamic icon is enabled and can be used to mark items. If you disable this setting the context menus won't show the entry and you cannot use the icon."
            english["rightclick_menu_mark_dynamic" .. tostring(dynIconId)]     	        = "Mark with " .. tostring(dynIconId) .. iconToOrdinalStrEn .. " dynamic"
            english["rightclick_menu_demark_dynamic" .. tostring(dynIconId)]   	        = "Unmark " .. tostring(dynIconId) .. iconToOrdinalStrEn .. " dynamic"
            english["button_context_menu_mark_all_as_dynamic" .. tostring(dynIconId)]   = "+ " .. tostring(dynIconId) .. iconToOrdinalStrEn .. " dynamic"
            english["button_context_menu_unmark_all_as_dynamic" .. tostring(dynIconId)] = "- " .. tostring(dynIconId) .. iconToOrdinalStrEn .. " dynamic"
            english["options_icon_sort_" .. tostring(fcoisDynIconNr)]				    = tostring(fcoisDynIconNr).. iconToOrdinalStrEn
            english["SI_BINDING_NAME_FCOIS_MARK_ITEM_" .. tostring(fcoisDynIconNr)]  	= "Mark with dynamic icon " .. tostring(dynIconId)
        --German
            german["options_icon" .. tostring(fcoisDynIconNr).."_TT"]				= "Zeige Tooltip"
            german["options_icon" .. tostring(fcoisDynIconNr).."_tooltip_TT"]		= "Zeige Tooltip am " .. tostring(dynIconId) .. ". dynamischen Symbols"
            german["options_icon" .. tostring(fcoisDynIconNr).."_color"]				= tostring(dynIconId) .. ". dynamische"
            german["options_icon" .. tostring(fcoisDynIconNr).."_color_TT"]		= "Farbe des " .. tostring(dynIconId) .. ". dynamischen Filter Symbols"
            german["options_icon" .. tostring(fcoisDynIconNr).."_texture"]				= "Symbol"
            german["options_icon" .. tostring(fcoisDynIconNr).."_texture_TT"]		= "Symbol der " .. tostring(dynIconId) .. ". dynamischen Filter Markierung"
            german["options_icon" .. tostring(fcoisDynIconNr).."_size"]				    = "Größe"
            german["options_icon" .. tostring(fcoisDynIconNr).."_size_TT"]		    = "Größe des " .. tostring(dynIconId) .. ". dynamischen Filter Symbols"
            german["options_icon" .. tostring(fcoisDynIconNr).."_offsetX"]				= "Abstand X"
            german["options_icon" .. tostring(fcoisDynIconNr).."_offsetX_TT"]		= "Abstand der position auf der X-Achse des " .. tostring(dynIconId) .. ". dynamischen Filter Markierungssymbols"
            german["options_icon" .. tostring(fcoisDynIconNr).."_offsetY"]				= "Abstand Y"
            german["options_icon" .. tostring(fcoisDynIconNr).."_offsetY_TT"]		= "Abstand der Position auf der Y-Achse des " .. tostring(dynIconId) .. ". dynamischen Filter Markierungssymbols"
            german["options_icon" .. tostring(fcoisDynIconNr).."_tooltip_text"]		    = "Markiert mit " .. tostring(dynIconId) .. ". dynamischen"
            german["options_icon" .. tostring(fcoisDynIconNr).."_activate_text"]        = "Aktiviere " .. tostring(dynIconId) .. ". dynamische"
            german["options_icon" .. tostring(fcoisDynIconNr).."_enabled"]				= tostring(dynIconId) .. ". dynamische aktivieren"
            german["options_icon" .. tostring(fcoisDynIconNr).."_enabled_TT"]      = "Das " .. tostring(dynIconId) .. ". dynamische Symbol ist aktiviert und kann zum Markieren von Gegenständen verwendet werden. Wenn du diese Option deaktivierst kann dieses Symbol nicht verwendet werden und das Kontextmenü zeigt dir das Symbol nicht zur Auswahl an."
            german["rightclick_menu_mark_dynamic" .. tostring(dynIconId)]     	        = "Markiere mit " .. tostring(dynIconId) .. ". dynamischen"
            german["rightclick_menu_demark_dynamic" .. tostring(dynIconId)]   	        = "Entferne Markierung vom " .. tostring(dynIconId) .. ". dynamischen"
            german["button_context_menu_mark_all_as_dynamic" .. tostring(dynIconId)]    = "+ " .. tostring(dynIconId) .. ". dynamische"
            german["button_context_menu_unmark_all_as_dynamic" .. tostring(dynIconId)]  = "- " .. tostring(dynIconId) .. ". dynamische"
            german["options_icon_sort_" .. tostring(fcoisDynIconNr)]				    = tostring(fcoisDynIconNr).."."
            german["SI_BINDING_NAME_FCOIS_MARK_ITEM_" .. tostring(fcoisDynIconNr)]  	= "Markiere mit dynamischen Symbol " .. tostring(dynIconId)
        --French
            french["options_icon" .. tostring(fcoisDynIconNr).."_TT"]				= "Afficher l'astuce"
            french["options_icon" .. tostring(fcoisDynIconNr).."_tooltip_TT"]		= "Affiche l'astuce pour le ".. iconToOrdinalStrFr ..". dynamique"
            french["options_icon" .. tostring(fcoisDynIconNr).."_color"]				= iconToOrdinalStrFr .. " dynamique"
            french["options_icon" .. tostring(fcoisDynIconNr).."_color_TT"]		= "Définit la couleur de l'icône du ".. iconToOrdinalStrFr ..". dynamique"
            french["options_icon" .. tostring(fcoisDynIconNr).."_texture"]				= "Icône"
            french["options_icon" .. tostring(fcoisDynIconNr).."_texture_TT"]		= "Définit l'icône du " .. iconToOrdinalStrFr .. "dynamique"
            french["options_icon" .. tostring(fcoisDynIconNr).."_size"]				    = "Taille"
            french["options_icon" .. tostring(fcoisDynIconNr).."_size_TT"]		    = "Définit la taille de l'icône du " .. iconToOrdinalStrFr .." dynamique"
            french["options_icon" .. tostring(fcoisDynIconNr).."_offsetX"]				= "L'offset X"
            french["options_icon" .. tostring(fcoisDynIconNr).."_offsetX_TT"]		= "L'offset X de " .. tostring(dynIconId) .. iconToOrdinalStrFr .. " icône de filtre dynamique"
            french["options_icon" .. tostring(fcoisDynIconNr).."_offsetY"]				= "L'offset Y"
            french["options_icon" .. tostring(fcoisDynIconNr).."_offsetY_TT"]		= "L'offset Y de " .. tostring(dynIconId) .. iconToOrdinalStrFr .. " icône de filtre dynamique"
            french["options_icon" .. tostring(fcoisDynIconNr).."_tooltip_text"]		    = "Marqué comme " .. iconToOrdinalStrFr .. ". dynamique"
            french["options_icon" .. tostring(fcoisDynIconNr).."_activate_text"]        = "Activé " .. iconToOrdinalStrFr .. ". dynamique"
            french["options_icon" .. tostring(fcoisDynIconNr).."_enabled"]				= "Activé " .. iconToOrdinalStrFr .. ". dynamique"
            french["options_icon" .. tostring(fcoisDynIconNr).."_enabled_TT"]           = "La ".. iconToOrdinalStrFr .." icône dynamique est activée et peut être utilisée pour marquer des éléments. Si vous désactivez ce paramètre, les menus contextuels n'afficheront pas l'entrée et vous ne pourrez pas utiliser l'icône."
            french["rightclick_menu_mark_dynamic" .. iconToOrdinalStrFr]     	        = "Marquer avec la " .. iconToOrdinalStrFr .. ". dynamique"
            french["rightclick_menu_demark_dynamic" .. iconToOrdinalStrFr]   	        = "Dé-marquer la " .. iconToOrdinalStrFr .. ". dynamique"
            french["button_context_menu_mark_all_as_dynamic" .. iconToOrdinalStrFr]    = "+ " .. iconToOrdinalStrFr .. ". dynamique"
            french["button_context_menu_unmark_all_as_dynamic" .. iconToOrdinalStrFr]  = "- " .. iconToOrdinalStrFr .. ". dynamique"
            french["options_icon_sort_" .. tostring(fcoisDynIconNr)]				    = tostring(fcoisDynIconNr).."."
            french["SI_BINDING_NAME_FCOIS_MARK_ITEM_" .. tostring(fcoisDynIconNr)]  	= "Marqué avec icône " .. iconToOrdinalStrFr .. " dynamique"
        --Japanese
            japanese["options_icon" .. tostring(fcoisDynIconNr).."_TT"]			= "ツールチップを表示"
            japanese["options_icon" .. tostring(fcoisDynIconNr).."_tooltip_TT"]	= tostring(dynIconId) .. iconToOrdinalStrEn .."ダイナミックアイコンでツールチップを表示します"
            japanese["options_icon" .. tostring(fcoisDynIconNr).."_color"]				= tostring(dynIconId) .. iconToOrdinalStrEn .. "ダイナミック"
            japanese["options_icon" .. tostring(fcoisDynIconNr).."_color_TT"]		= tostring(dynIconId) .. iconToOrdinalStrEn .. "ダイナミックフィルターアイコンのカラー"
            japanese["options_icon" .. tostring(fcoisDynIconNr).."_texture"]			= "アイコン"
            japanese["options_icon" .. tostring(fcoisDynIconNr).."_texture_TT"]	= tostring(dynIconId) .. iconToOrdinalStrEn .. "ダイナミックフィルターのアイコン"
            japanese["options_icon" .. tostring(fcoisDynIconNr).."_size"]				= "サイズ"
            japanese["options_icon" .. tostring(fcoisDynIconNr).."_size_TT"]		= tostring(dynIconId) .. iconToOrdinalStrEn .. "ダイナミックフィルターアイコンのサイズ"
            japanese["options_icon" .. tostring(fcoisDynIconNr).."_tooltip_text"]		= tostring(dynIconId) .. iconToOrdinalStrEn .. "ダイナミックとしてマークします"
            japanese["options_icon" .. tostring(fcoisDynIconNr).."_activate_text"]      = tostring(dynIconId) .. iconToOrdinalStrEn .. "1stダイナミックを有効化"
            japanese["rightclick_menu_mark_dynamic" .. tostring(dynIconId)]     	        = tostring(dynIconId) .. iconToOrdinalStrEn .. " ダイナミックでマーク"
            japanese["rightclick_menu_demark_dynamic" .. tostring(dynIconId)]   	        = tostring(dynIconId) .. iconToOrdinalStrEn .. " ダイナミックを解除"
            japanese["button_context_menu_mark_all_as_dynamic" .. tostring(dynIconId)]   = "+ " .. tostring(dynIconId) .. iconToOrdinalStrEn .. " ダイナミック"
            japanese["button_context_menu_unmark_all_as_dynamic" .. tostring(dynIconId)] = "- " .. tostring(dynIconId) .. iconToOrdinalStrEn .. " ダイナミック"
            --Sort order is identical to English! Thus the metatable trick is taking care of it.
            japanese["SI_BINDING_NAME_FCOIS_MARK_ITEM_" .. tostring(fcoisDynIconNr)]  	= "ダイナミックアイコン".. tostring(dynIconId) .."でマーク"
        --Russian
            russian["options_icon" .. tostring(fcoisDynIconNr).."_TT"]				= "Пoкaзывaть пoдcкaзку"
            russian["options_icon" .. tostring(fcoisDynIconNr).."_tooltip_TT"]		= "Пoкaзывaть вcплывaющую пoдcкaзку нaд икoнкoй " .. tostring(dynIconId) .."-й динамической пoмeтки"
            russian["options_icon" .. tostring(fcoisDynIconNr).."_color"]				= tostring(dynIconId) .."-я динамическая"
            russian["options_icon" .. tostring(fcoisDynIconNr).."_color_TT"]		= "Цвeт икoнки у "..tostring(dynIconId) .."-й динамической пoмeтки"
            russian["options_icon" .. tostring(fcoisDynIconNr).."_texture"]				= "Икoнкa"
            russian["options_icon" .. tostring(fcoisDynIconNr).."_texture_TT"]		= "Икoнкa у "..tostring(dynIconId) .."-й динамической пoмeтки"
            russian["options_icon" .. tostring(fcoisDynIconNr).."_size"]				= "Paзмep"
            russian["options_icon" .. tostring(fcoisDynIconNr).."_size_TT"]		= "Paзмep икoнки у "..tostring(dynIconId) .."-й динамической пoмeтки"
            russian["options_icon" .. tostring(fcoisDynIconNr).."_tooltip_text"]		= "Пoмeчeнo "..tostring(dynIconId) .."-й динамической пoмeткой"
            russian["options_icon" .. tostring(fcoisDynIconNr).."_activate_text"]       = "Иcпoльзoвaть "..tostring(dynIconId) .."-ю динамическую пoмeтку"
            russian["rightclick_menu_mark_dynamic" .. tostring(dynIconId)]     	        = "Пометить "..tostring(dynIconId) .."-й динамической пoмeткой"
            russian["rightclick_menu_demark_dynamic" .. tostring(dynIconId)]   	        = "Снять "..tostring(dynIconId) .."-ю динамическую пoмeтку"
            russian["button_context_menu_mark_all_as_dynamic" .. tostring(dynIconId)]    = "+ " .. tostring(dynIconId) .. "-я динамическая"
            russian["button_context_menu_unmark_all_as_dynamic" .. tostring(dynIconId)]  = "- " .. tostring(dynIconId) .. "-я динамическая"
            russian["options_icon_sort_" .. tostring(fcoisDynIconNr)]				    = tostring(dynIconId) .."-я пoзиция"
            russian["SI_BINDING_NAME_FCOIS_MARK_ITEM_" .. tostring(fcoisDynIconNr)]  	= "Пометить ".. tostring(dynIconId) .. "-й динамической пометкой"

            --Only add this entry if it's not the normal lock icon
            if fcoisLockDynMenuIconNr ~= FCOIS_CON_ICON_LOCK then
                english["filter_lockdyn_" .. tostring(fcoisLockDynMenuIconNr)]			= tostring(dynIconId) .. iconToOrdinalStrEn .. " dynamic"
                german["filter_lockdyn_" .. tostring(fcoisLockDynMenuIconNr)]			= tostring(dynIconId) .. ". dynamische"
                french["filter_lockdyn_" .. tostring(fcoisLockDynMenuIconNr)]			= iconToOrdinalStrFr .. ". dynamique"
                japanese["filter_lockdyn_" .. tostring(fcoisLockDynMenuIconNr)]			= tostring(dynIconId) .. iconToOrdinalStrEn .. "ダイナミック"
                russian["filter_lockdyn_" .. tostring(fcoisLockDynMenuIconNr)]			= tostring(dynIconId) .. "-я динамическая"
            end
        end
    end -- numMaxDynIcons

    --Build texts for the filter buttons
    for filterButtonCounter=1, numFilterButtons, 1 do
        local filterButtonIdStr = tostring(filterButtonCounter)
        english["options_filter_button" .. filterButtonIdStr]                       = "Button " .. filterButtonIdStr
        french["options_filter_button" .. filterButtonIdStr]                        = "Bouton " .. filterButtonIdStr
        german["options_filter_button" .. filterButtonIdStr]                        = "Knopf " .. filterButtonIdStr
        russian["options_filter_button" .. filterButtonIdStr]                       = "кнопка " .. filterButtonIdStr
        japanese["options_filter_button" .. filterButtonIdStr]                      = "ボタン " .. filterButtonIdStr
        --Left
        english["options_filter_button" .. filterButtonIdStr  .. "_left"]           = "Left:"
        english["options_filter_button" .. filterButtonIdStr  .. "_left_TT"]   = "Position from the left for the filter button " .. filterButtonIdStr
        french["options_filter_button" .. filterButtonIdStr  .. "_left"]            = "Gauche:"
        french["options_filter_button" .. filterButtonIdStr  .. "_left_TT"]    = "Position en partant de la gauche pour le bouton de filtre " .. filterButtonIdStr
        german["options_filter_button" .. filterButtonIdStr .. "_left"]             = "Links:"
        german["options_filter_button" .. filterButtonIdStr  .. "_left_TT"]    = "Position von links des Filter Knopfs " .. filterButtonIdStr
        russian["options_filter_button" .. filterButtonIdStr  .. "_left"]           = "слева:"
        russian["options_filter_button" .. filterButtonIdStr  .. "_left_TT"]   = "слева " .. filterButtonIdStr
        japanese["options_filter_button" .. filterButtonIdStr  .. "_left"]          = "左:"
        japanese["options_filter_button" .. filterButtonIdStr  .. "_left_TT"]  = "左 " .. filterButtonIdStr
        --Top
        english["options_filter_button" .. filterButtonIdStr  .. "_top"]           = "Top:"
        english["options_filter_button" .. filterButtonIdStr  .. "_top_TT"]   = "Position from the top for the filter button " .. filterButtonIdStr
        french["options_filter_button" .. filterButtonIdStr  .. "_top"]            = "Haut:"
        french["options_filter_button" .. filterButtonIdStr  .. "_top_TT"]    = "Position en partant de la Haut pour le bouton de filtre " .. filterButtonIdStr
        german["options_filter_button" .. filterButtonIdStr .. "_top"]             = "Oben:"
        german["options_filter_button" .. filterButtonIdStr  .. "_top_TT"]    = "Position von oben des Filter Knopfs " .. filterButtonIdStr
        russian["options_filter_button" .. filterButtonIdStr  .. "_top"]           = "верхний:"
        russian["options_filter_button" .. filterButtonIdStr  .. "_top_TT"]   = "верхний " .. filterButtonIdStr
        japanese["options_filter_button" .. filterButtonIdStr  .. "_top"]          = "上:"
        japanese["options_filter_button" .. filterButtonIdStr  .. "_top_TT"]  = "上 " .. filterButtonIdStr
        --Width
        english["options_filter_button" .. filterButtonIdStr  .. "_width"]           = "Width:"
        english["options_filter_button" .. filterButtonIdStr  .. "_width_TT"]   = "Position from the left for the filter button " .. filterButtonIdStr
        french["options_filter_button" .. filterButtonIdStr  .. "_width"]            = "Largeur:"
        french["options_filter_button" .. filterButtonIdStr  .. "_width_TT"]    = "L'largeur pour le bouton de filtre " .. filterButtonIdStr
        german["options_filter_button" .. filterButtonIdStr .. "_width"]             = "Breite:"
        german["options_filter_button" .. filterButtonIdStr  .. "_width_TT"]    = "Breite des Filter Knopf " .. filterButtonIdStr
        russian["options_filter_button" .. filterButtonIdStr  .. "_width"]           = "ширина:"
        russian["options_filter_button" .. filterButtonIdStr  .. "_width_TT"]   = "ширина " .. filterButtonIdStr
        japanese["options_filter_button" .. filterButtonIdStr  .. "_width"]          = "幅:"
        japanese["options_filter_button" .. filterButtonIdStr  .. "_width_TT"]  = "幅 " .. filterButtonIdStr
        --Height
        english["options_filter_button" .. filterButtonIdStr  .. "_height"]           = "Height:"
        english["options_filter_button" .. filterButtonIdStr  .. "_height_TT"]   = "Position from the left for the filter button " .. filterButtonIdStr
        french["options_filter_button" .. filterButtonIdStr  .. "_height"]            = "Taille:"
        french["options_filter_button" .. filterButtonIdStr  .. "_height_TT"]    = "La Taille pour le bouton de filtre " .. filterButtonIdStr
        german["options_filter_button" .. filterButtonIdStr .. "_height"]             = "Höhe:"
        german["options_filter_button" .. filterButtonIdStr  .. "_height_TT"]    = "Höhe des Filter Knopf " .. filterButtonIdStr
        russian["options_filter_button" .. filterButtonIdStr  .. "_height"]           = "Рост:"
        russian["options_filter_button" .. filterButtonIdStr  .. "_height_TT"]   = "Oтcтуп cлeвa для " .. filterButtonIdStr .. "-й кнoпки фильтpaции"
        japanese["options_filter_button" .. filterButtonIdStr  .. "_height"]          = "高さ:"
        japanese["options_filter_button" .. filterButtonIdStr  .. "_height_TT"]  = "高さ " .. filterButtonIdStr
    end
end

--LibFilters translated panel ID texts
local getLibFiltersPanelIdText
function FCOIS.GetLibFiltersPanelIdText(language, libFilterPanelId)
    getLibFiltersPanelIdText = FCOIS.GetLibFiltersPanelIdText
    language = language or FCOIS_CON_LANG_EN
    local retVarTable = {}
    local translatedTexts = {}
    --English
    if     language == FCOIS_CON_LANG_EN then
        translatedTexts[FCOIS_CON_LANG_EN] = {
            [LF_INVENTORY] 					= GetString(SI_INVENTORY_MENU_INVENTORY),
            [LF_BANK_WITHDRAW] 			   	= GetString(SI_CURRENCYLOCATION1) .. " " .. GetString(SI_BANK_WITHDRAW),
            [LF_BANK_DEPOSIT]				= GetString(SI_CURRENCYLOCATION1) .. " " .. GetString(SI_BANK_DEPOSIT),
            [LF_GUILDBANK_WITHDRAW] 	    = GetString(SI_CURRENCYLOCATION2) .. " " .. GetString(SI_BANK_WITHDRAW),
            [LF_GUILDBANK_DEPOSIT]	    	= GetString(SI_CURRENCYLOCATION2) .. " " .. GetString(SI_BANK_DEPOSIT),
            [LF_VENDOR_BUY] 				= GetString(SI_GAMEPAD_VENDOR_CATEGORY_HEADER).. " " .. GetString(SI_STORE_MODE_BUY),
            [LF_VENDOR_SELL] 				= GetString(SI_GAMEPAD_VENDOR_CATEGORY_HEADER) .. " " .. GetString(SI_STORE_MODE_SELL),
            [LF_VENDOR_BUYBACK]				= GetString(SI_GAMEPAD_VENDOR_CATEGORY_HEADER).. " " .. GetString(SI_STORE_MODE_BUY),
            [LF_VENDOR_REPAIR] 				= GetString(SI_GAMEPAD_VENDOR_CATEGORY_HEADER).. " " .. GetString(SI_STORE_MODE_BUY_BACK),
            [LF_GUILDSTORE_SELL] 	 		= GetString(SI_WINDOW_TITLE_TRADING_HOUSE) .. " " .. GetString(SI_STORE_MODE_SELL),
            [LF_SMITHING_REFINE]  			= GetString(SI_SMITHING_TAB_REFINEMENT),
            [LF_SMITHING_DECONSTRUCT]  		= GetString(SI_SMITHING_TAB_DECONSTRUCTION),
            [LF_SMITHING_IMPROVEMENT]		= GetString(SI_SMITHING_TAB_IMPROVEMENT),
            [LF_SMITHING_RESEARCH]          = GetString(SI_SMITHING_TAB_RESEARCH),
            [LF_SMITHING_RESEARCH_DIALOG]   = GetString(SI_SMITHING_TAB_RESEARCH) .. " Dialog",
            [LF_MAIL_SEND] 					= GetString(SI_MAIN_MENU_MAIL) .. " " .. GetString(SI_WINDOW_TITLE_SEND_MAIL),
            [LF_TRADE] 						= GetString(SI_WINDOW_TITLE_TRADE),
            [LF_ENCHANTING_CREATION]		= GetString(SI_ITEMFILTERTYPE17) .. " " .. GetString(SI_ENCHANTING_CREATION),
            [LF_ENCHANTING_EXTRACTION]		= GetString(SI_ITEMFILTERTYPE17) .. " " .. GetString(SI_ENCHANTING_EXTRACTION),
            [LF_FENCE_SELL] 				= "Fence " .. GetString(SI_ITEM_ACTION_SELL),
            [LF_FENCE_LAUNDER]				= "Fence " .. GetString(SI_FENCE_LAUNDER_TAB),
            [LF_ALCHEMY_CREATION]			= GetString(SI_ITEMFILTERTYPE16) .. " " .. GetString(SI_ALCHEMY_CREATION),
            [LF_CRAFTBAG]					= GetString(SI_NOTIFICATIONTYPE15),
            [LF_RETRAIT]                    = GetString(SI_RETRAIT_STATION_RETRAIT_MODE),
            [LF_HOUSE_BANK_WITHDRAW]        = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " " .. GetString(SI_BANK_WITHDRAW),
            [LF_HOUSE_BANK_DEPOSIT]         = GetString(SI_COLLECTIBLECATEGORYTYPE25) .. " " .. GetString(SI_BANK_DEPOSIT),
            [LF_JEWELRY_REFINE]		        = GetString(SI_ITEMFILTERTYPE24) .. " " .. GetString(SI_SMITHING_TAB_REFINEMENT),
            [LF_JEWELRY_DECONSTRUCT]		= GetString(SI_ITEMFILTERTYPE24) .. " " .. GetString(SI_SMITHING_TAB_DECONSTRUCTION),
            [LF_JEWELRY_IMPROVEMENT]		= GetString(SI_ITEMFILTERTYPE24) .. " " .. GetString(SI_SMITHING_TAB_IMPROVEMENT),
            [LF_JEWELRY_RESEARCH]		    = GetString(SI_ITEMFILTERTYPE24) .. " " .. GetString(SI_SMITHING_TAB_RESEARCH),
            [LF_JEWELRY_RESEARCH_DIALOG ]   = GetString(SI_ITEMFILTERTYPE24) .. " " .. GetString(SI_SMITHING_TAB_RESEARCH) .. " Dialog",
            [LF_INVENTORY_COMPANION]		= GetString(SI_UNIT_FRAME_NAME_COMPANION) .. " " .. GetString(SI_INVENTORY_MENU_INVENTORY),
            [FCOIS_CON_LF_CHARACTER]        = GetString(SI_BINDING_NAME_TOGGLE_CHARACTER),
            [FCOIS_CON_LF_COMPANION_CHARACTER] = GetString(SI_UNIT_FRAME_NAME_COMPANION) .. " " .. GetString(SI_BINDING_NAME_TOGGLE_CHARACTER),
        }
    --German
    else
        --Use fallback of English
        if translatedTexts[FCOIS_CON_LANG_EN] == nil then
            translatedTexts[FCOIS_CON_LANG_EN] = getLibFiltersPanelIdText(FCOIS_CON_LANG_EN, nil)
        end
        translatedTexts[language] = translatedTexts[FCOIS_CON_LANG_EN]
        if language == FCOIS_CON_LANG_DE then
            translatedTexts[FCOIS_CON_LANG_DE][LF_FENCE_SELL] 			= "Hehler " .. GetString(SI_ITEM_ACTION_SELL)
            translatedTexts[FCOIS_CON_LANG_DE][LF_FENCE_LAUNDER]		= "Hehler " .. GetString(SI_FENCE_LAUNDER_TAB)
        --French
        elseif language == FCOIS_CON_LANG_FR then
            translatedTexts[FCOIS_CON_LANG_FR][LF_FENCE_SELL] 			= "Receleur " .. GetString(SI_ITEM_ACTION_SELL)
            translatedTexts[FCOIS_CON_LANG_FR][LF_FENCE_LAUNDER]		= "Receleur " .. GetString(SI_FENCE_LAUNDER_TAB)
        --Spanish
        elseif language == FCOIS_CON_LANG_ES then
            translatedTexts[FCOIS_CON_LANG_ES][LF_FENCE_SELL] 			= "Perista " .. GetString(SI_ITEM_ACTION_SELL)
            translatedTexts[FCOIS_CON_LANG_ES][LF_FENCE_LAUNDER]		= "Perista " .. GetString(SI_FENCE_LAUNDER_TAB)
        --Italian
        elseif language == FCOIS_CON_LANG_IT then
            translatedTexts[FCOIS_CON_LANG_IT][LF_FENCE_SELL] 			= "Ricettatore " .. GetString(SI_ITEM_ACTION_SELL)
            translatedTexts[FCOIS_CON_LANG_IT][LF_FENCE_LAUNDER]		= "Ricettatore " .. GetString(SI_FENCE_LAUNDER_TAB)
        --Japanese
        elseif language == FCOIS_CON_LANG_JP then
            translatedTexts[FCOIS_CON_LANG_JP][LF_FENCE_SELL] 			= "盗難商品の購入者 " .. GetString(SI_ITEM_ACTION_SELL)
            translatedTexts[FCOIS_CON_LANG_JP][LF_FENCE_LAUNDER]		= "盗難商品の購入者 " .. GetString(SI_FENCE_LAUNDER_TAB)
        --Russian
        elseif language == FCOIS_CON_LANG_RU then
            translatedTexts[FCOIS_CON_LANG_RU][LF_FENCE_SELL] 			= "скупщик краденого " .. GetString(SI_ITEM_ACTION_SELL)
            translatedTexts[FCOIS_CON_LANG_RU][LF_FENCE_LAUNDER]		= "скупщик краденого " .. GetString(SI_FENCE_LAUNDER_TAB)
        end
    end
    --Return whole table of a language, or only one filter panel data?
    if libFilterPanelId == nil then
        retVarTable = translatedTexts[language]
    else
        --Only return one filter panel data
        retVarTable = translatedTexts[language][libFilterPanelId]
    end
    return retVarTable
end
local getLibFiltersPanelIdText = FCOIS.GetLibFiltersPanelIdText

--LibFilters translated panel IDs
english["FCOIS_LibFilters_PanelIds"]    = {}
french["FCOIS_LibFilters_PanelIds"]     = {}
german["FCOIS_LibFilters_PanelIds"]     = {}
japanese["FCOIS_LibFilters_PanelIds"]   = {}
russian["FCOIS_LibFilters_PanelIds"]    = {}
--Build the translated LibFilters panel ID text
english["FCOIS_LibFilters_PanelIds"]    = getLibFiltersPanelIdText(FCOIS_CON_LANG_EN, nil)
french["FCOIS_LibFilters_PanelIds"]     = getLibFiltersPanelIdText(FCOIS_CON_LANG_FR, nil)
german["FCOIS_LibFilters_PanelIds"]     = getLibFiltersPanelIdText(FCOIS_CON_LANG_DE, nil)
japanese["FCOIS_LibFilters_PanelIds"]   = getLibFiltersPanelIdText(FCOIS_CON_LANG_JP, nil)
russian["FCOIS_LibFilters_PanelIds"]    = getLibFiltersPanelIdText(FCOIS_CON_LANG_RU, nil)

--Build texts for the different LibFilters filter panel IDs -> Fallback for non translated values!
local optionsFilterPanelIdNameStart = "options_libFiltersFilterPanelIdName_"
for filterPanelId=1, numFilterPanels, 1 do
    local filterPanelIdStr = tostring(filterPanelId)
    english[optionsFilterPanelIdNameStart .. filterPanelIdStr]  = "LibFilters - Filter panel " .. filterPanelIdStr
    french[optionsFilterPanelIdNameStart .. filterPanelIdStr]   = "LibFilters - Panel de filtre " .. filterPanelIdStr
    german[optionsFilterPanelIdNameStart .. filterPanelIdStr]   = "LibFilters - Filter Bereich " .. filterPanelIdStr
    russian[optionsFilterPanelIdNameStart .. filterPanelIdStr]  = "LibFilters - Filter panel " .. filterPanelIdStr
    japanese[optionsFilterPanelIdNameStart .. filterPanelIdStr] = "LibFilters - Filter panel " .. filterPanelIdStr
end
--FCOIS custom filterPanelIds
for _, customFCOISfilterPanelId in ipairs(FCOIS.customFilterPanelIds) do
    english[optionsFilterPanelIdNameStart .. customFCOISfilterPanelId]  = "LibFilters - Filter panel " .. customFCOISfilterPanelId
    french[optionsFilterPanelIdNameStart .. customFCOISfilterPanelId]   = "LibFilters - Panel de filtre " .. customFCOISfilterPanelId
    german[optionsFilterPanelIdNameStart .. customFCOISfilterPanelId]   = "LibFilters - Filter Bereich " .. customFCOISfilterPanelId
    russian[optionsFilterPanelIdNameStart .. customFCOISfilterPanelId]  = "LibFilters - Filter panel " .. customFCOISfilterPanelId
    japanese[optionsFilterPanelIdNameStart .. customFCOISfilterPanelId] = "LibFilters - Filter panel " .. customFCOISfilterPanelId
end

--For the chat slash command help output
--Build the filterPanel chat output help lines table
english.filterPanelIdChatHelpLines = {}
local counter = 0
local filterPanelNameTextLine = ""
for filterPanelId, filterPanelNameEN in pairs(english["FCOIS_LibFilters_PanelIds"]) do
    if type(filterPanelId) == "number" then
        if filterPanelNameTextLine ~= "" then
            filterPanelNameTextLine = filterPanelNameTextLine .. ", "
        end
        filterPanelNameTextLine = filterPanelNameTextLine .. tostring(filterPanelId).. " " .. filterPanelNameEN
        if counter > 0 and counter % 4 == 0 then
            table.insert(english.filterPanelIdChatHelpLines, filterPanelNameTextLine)
            filterPanelNameTextLine = ""
        end
        counter = counter + 1
    end
end
local engFilterPanelChatHelpLines = english.filterPanelIdChatHelpLines
french.filterPanelIdChatHelpLines = engFilterPanelChatHelpLines
german.filterPanelIdChatHelpLines = engFilterPanelChatHelpLines
japanese.filterPanelIdChatHelpLines = engFilterPanelChatHelpLines
russian.filterPanelIdChatHelpLines = engFilterPanelChatHelpLines


--Error messages
english["ERROR_MESSAGES"] = {}
english["ERROR_MESSAGES"]["showContextMenuForAddInvButtons"] = {
    [1] = "showContextMenuForAddInvButtons - ButtonText is nil!\n>index: <<1>>, buttonNameStr: <<2>>, icon: <<3>>, mark: <<4>>\n"
}
english["ERROR_MESSAGES"]["registerFilterId"] = {
    [1] = "registerFilterId - Registering filter #<<1>> at panelId <<2>> failed!\n"
}
english["ERROR_MESSAGES"]["whereAreWeNIL"] = {
    [1] = "Deconstruction-/ItemSelectionHandler could not determine whereAreWe - <<2>> - panelId: <<1>>, isDragAndDrop: <<3>>, calledFromExternalAddon: <<4>>!\n"
}

german["ERROR_MESSAGES"] = {}
german["ERROR_MESSAGES"]["showContextMenuForAddInvButtons"] = {
    [1] = "showContextMenuForAddInvButtons - ButtonText ist leer!\n>index: <<1>>, buttonNameStr: <<2>>, icon: <<3>>, mark: <<4>>\n"
}
german["ERROR_MESSAGES"]["registerFilterId"] = {
    [1] = "registerFilterId - Filter Registrierung #<<1>> am Panel <<2>> fehlgeschlagen!\n"
}
german["ERROR_MESSAGES"]["whereAreWeNIL"] = {
    [1] = "Deconstruction-/ItemSelectionHandler konnte woSindWir nicht ermitteln - <<2>> - panelId: <<1>>, isDragAndDrop: <<3>>, calledFromExternalAddon: <<4>>!\n"
}

--Use metatable to use english "fallback" entries for other languages
--Local variable for speedup of translations
local fco_isloc = FCOIS.localizationVars.localizationAll
for langNr=FCOIS_CON_LANG_DE, numLanguages, 1 do
    setmetatable(fco_isloc[langNr], {__index = fco_isloc[1]})
end
